C---------------------------------------------------------------------
      subroutine coeff_3(nx,ny,nz,charm,x,y,z,pil,listx,listy,listz,
     .                     iterms,comat,order)
CFPP$ EXPAND (getcircmx,getcircmy,getcircmz,special_test) 
        implicit none
        include 'terms.inc'
        integer nx,ny,nz
        real*8 charm(nx,ny,nz)
        integer iterms,pil
        integer maxt
        parameter(maxt=10)
        real*8 listx(pil),listy(pil),listz(pil)
        real*8 dx,dy,dz,x(nx),y(ny),z(nz)
        real*8 comat(iterms,iterms+4,pil) 
        real*8 mat(i40,i40)
        integer order,iuterms(i40),juterms(i40),kuterms(i40),ipvt(i40)
        integer i,j,k,ip,jp,kp,upnts,iwa,jwa,kwa,l
        integer ii,jj,kk,get_val,first_time,maxtries
        integer it,cx,cy,cz,spc1,spc2,spc3
        integer dm(9,9,9),maxc,d18,d20,d21
        integer siyz,sjyz,skyz,sixy,sjxy,skxy,sixz,sjxz,skxz
        integer siy2,sjy2,sky2
        integer ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        common /k/ ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        common /sc/ sixy,sjxy,skxy,sixz,sjxz,skxz,siyz,sjyz,skyz
     .             ,siy2,sjy2,sky2
        common /d/ d18,d20,d21
        real*8 xx,yy,zz,xn,yn,zn,sgn
        real*8 dxa(sz),dya(sz),dza(sz),sa(sz),dxtc,dytc,dztc
        integer ia(sz),ja(sz),ka(sz),ias,jas,kas
        integer rulcx(i40),rulcy(i40),rulcz(i40)
        real*8 ruldx(i40),ruldy(i40),ruldz(i40)
        integer ifail,urgent,xyzurgent,yzurg,xyurg,xzurg,idum,ur2
        integer disi,maxpil
        parameter (maxpil=4000)
        logical pmdebug,debug
         parameter ( debug = .false. , pmdebug = .false. )
         integer indexkeep(sz),indexk2(sz)
         logical indexcode,ik2
        
      if (pmdebug) open(80,file='matrix.dat')

      if ((iterms*(iterms+4)*pil).gt.coeffsize) then
         write(0,*) '***Too many points, try again***'
         stop
      end if

      call rulc(rulcx,rulcy,rulcz,iterms)

      dx = abs( x(2)-x(1) )
      dy = abs( y(2)-y(1) )
      dz = abs( z(2)-z(1) )

      call getrules(dx,dy,dz,rulcx,rulcy,rulcz,
     .               ruldx,ruldy,ruldz,iterms,maxc)

      do 100 l=1,pil

C         write(6,*) l
         call zero()
         maxtries = 0
         indexcode = .false.
         ik2 = .false.
         if (xyzurgent.eq.1) 
     .       call getrules(dx,dy,dz,rulcx,rulcy,rulcz,
     .                     ruldx,ruldy,ruldz,iterms,maxc)

         yzurg = 0
         xyurg = 0
         xzurg = 0
         spc1 = 0
         spc2 = 0
         spc3 = 0

         xn = listx(l)
         yn = listy(l)
         zn = listz(l)
         ii = get_val(xn,x,nx)
         jj = get_val(yn,y,ny)
         kk = get_val(zn,z,nz)
         call find_ijk(ii,jj,kk,nx,ny,nz,maxc,charm,i,j,k,ik2,indexk2)

50       continue

         maxtries = maxtries + 1
         if (maxtries.gt.maxt) then
            call err('Error code 1, maxt > maxtries')
            stop 
         end if

         urgent=0
         ur2 = 0
         xyzurgent=0
         first_time=1

         xx = x(i)
         yy = y(j)
         zz = z(k)

         call get_arrays(i,j,k,upnts,sa,ia,ja,ka,charm,dxa,dya,dza,
     .                   nx,ny,nz,x,y,z,xn,yn,zn,order)

         call sort(upnts,sa,ia,ja,ka,dxa,dya,dza,indexcode,indexkeep)

         call zero_dm(maxc,dm,iterms)

         do 200 ip=1,iterms
150         continue
            do 300 jp=1,upnts 
            if (ia(jp).lt.0) goto 300

               if (ip.eq.1.and.(ia(jp).ne.i.or.ja(jp).ne.j.or.
     .             ka(jp).ne.k)) goto 300

               dxtc = abs(dxa(jp) + (xn-xx) ) + dx/100.0e0
               dytc = abs(dya(jp) + (yn-yy) ) + dy/100.0e0
               dztc = abs(dza(jp) + (zn-zz) ) + dz/100.0e0

               if (dxtc.lt.ruldx(ip).or.dytc.lt.ruldy(ip).or.
     .             dztc.lt.ruldz(ip) ) goto 300 

               if ((rulcx(ip).eq.0.or.rulcy(ip).eq.0.or.
     1              rulcz(ip).eq.0).and.
     2            (dxtc.gt.dx.and.dytc.gt.dy.and.dztc.gt.dz)) goto 300 

               iwa = maxc - ( i - ia(jp) )
               jwa = maxc - ( j - ja(jp) )
               kwa = maxc - ( k - ka(jp) )

               if (first_time.eq.0.and.(ip.le.4)) then
                  idum = abs(ias-iwa)+abs(jas-jwa)+abs(kas-kwa)
                  if (idum.gt.1) goto 300 
               end if


               call getcircmx(cx,dm,maxc,
     .                        iwa,jwa,kwa,iterms,order)


               if (cx.lt.1+rulcx(ip)) goto 300 
                     
               call getcircmy(cy,dm,maxc,
     .                        iwa,jwa,kwa,iterms,order)

               if (cy.lt.1+rulcy(ip)) goto 300 

               call getcircmz(cz,dm,maxc,
     .                        iwa,jwa,kwa,iterms,order)

               if (cz.lt.1+rulcz(ip)) goto 300 

               if (iterms.gt.10.and.ur2.eq.0) then
                   call special_test(iterms,rulcx,rulcy,rulcz,
     1                        ip,iwa,jwa,kwa,ia,ja,ka,i,j,k,jp,
     2                        nx,ny,nz,charm,dm,urgent,order,
     3                        yzurg,xyurg,xzurg,upnts,maxc,it,ur2) 
                   if (it.eq.1) goto 300
               else
                   ur2=1
                   call special_test(iterms,rulcx,rulcy,rulcz,
     1                         ip,iwa,jwa,kwa,ia,ja,ka,i,j,k,jp,
     2                         nx,ny,nz,charm,dm,urgent,order,
     3                         yzurg,xyurg,xzurg,upnts,maxc,it,ur2) 
                   if (it.eq.1) goto 300
               end if
               
999            dm(iwa,jwa,kwa) = 1

               if (first_time.eq.1) then
                  
                  ias = iwa
                  jas = jwa
                  kas = kwa
                  first_time=0
               endif

               call upmat(nx,iterms,mat,ip,jp,dxa,dya,dza,
     .                    ia,ja,ka,iuterms,juterms,kuterms)

               if (ip.eq.18.and.d18.eq.0) then
                  ksixy=sixy
                  ksjxy=sjxy
                  kskxy=skxy
                  d18=1
               else if (ip.eq.20.and.d20.eq.0) then
                  ksixz=sixz
                  ksjxz=sjxz
                  kskxz=skxz
                  d20 = 1
               else if (ip.eq.21.and.d21.eq.0) then
                  ksiyz=siyz
                  ksjyz=sjyz
                  kskyz=skyz
                  d21 = 1
               end if
    
               ia(jp) = -99999
               goto 200

300         continue

				call flowmark('point300')
            if (xyzurgent.eq.1) then
               call err('Error code 2, xyzurgent') 
               stop
            end if

            if (ip.eq.23) then

               call changecxy(iterms,rulcx,rulcy,rulcz
     .                       ,ruldx,ruldy,ruldz,dx,dy,dz)
               call zero()
               xyzurgent=1
               goto 50

            else if (ip.eq.31.or.ip.eq.35) then

               ksixz = 0
               ksjxz = 0
               kskxz = 0
               d20 = 0
               yzurg=1
               goto 50

            else if (ip.eq.29.or.ip.eq.33) then

               xyurg=1
               goto 50

            else if (ip.eq.30.or.ip.eq.34) then

               xzurg=1
               goto 50

            end if 

             
            if (urgent.eq.0) then
               urgent = 1
               goto 150
            else
               if (ip.eq.17.or.ip.eq.18) then
                  spc1 = 1
                  if (spc2.eq.0) sixz=0 
                  if (spc3.eq.0) siyz=0
               else if (ip.eq.19.or.ip.eq.20) then
                  spc2 = 1
                  if (spc1.eq.0) sixy=0
                  if (spc3.eq.0) siyz=0
               else if (ip.eq.21.or.ip.eq.22) then
                  spc3 = 1
                  if (spc1.eq.0) sixy=0
                  if (spc2.eq.0) sixz=0
               end if
                   
               goto 50
            end if
				call flowmark(0)
200      continue


         call flowmark('sgefa')
         call sgefa(mat,i40,iterms,ipvt,ifail)
         call flowmark(0)

         if (ifail.ne.0) then
            call err('Error code 3, singular matrix') 
            stop
         end if

         write(6,*) l,maxtries
         call copy_ba(iterms,mat,iuterms,juterms,kuterms,
     .                ipvt,comat,pil,l)
100   continue

      return
      end 
