c Made by Scott Klasky .....
c modified the 2D version starting on January 5,1993.....

        subroutine coeff3d(nx,ny,nz,charm,x,y,z,pil,listx,listy,listz,
     .                     order,comat)
        include 'terms.inc'
        integer order,nx,ny,nz
        real*8     charm(nx,ny,nz)
        integer iterms,pil
        real*8     listx(pil),listy(pil),listz(pil)
        real*8     dx,dy,dz,x(nx),y(ny),z(nz)
        real*8     comat(*)
        call coeff_3(nx,ny,nz,charm,x,y,z,pil,listx,listy,listz,
     .               soc(order),comat,order)
        return
        end
c---------------------------------------------------------------------
      subroutine coeff_3(nx,ny,nz,charm,x,y,z,pil,listx,listy,listz,
     .                     iterms,comat,order)
cFPP$ EXPAND (getcircm)
        implicit none
        include 'terms.inc'
        integer nx,ny,nz
        real*8     charm(nx,ny,nz)
        integer iterms,pil
        integer maxt
        parameter(maxt=10)
        real*8     listx(pil),listy(pil),listz(pil)
        real*8     dx,dy,dz,x(nx),y(ny),z(nz)
        real*8     comat(iterms,iterms+4,pil)
        real*8     mat(i40,i40)
			real*8 small
		parameter (small=1.0e-09)
        integer order,iuterms(i40),juterms(i40),kuterms(i40),ipvt(i40)
c comat is 1-iterms is coeff matrix,next column is l number and last is ipvt
c last part of array is for each point in the list
c iterms is number of terms to use , i.e. 15 is 4th, 10 is 3rd order ...
        integer i,j,k,ip,jp,kp,upnts,iwa,jwa,kwa,l
        integer ii,jj,kk,get_val,first_time,maxtries
        integer it,cx,cy,cz,spc1,spc2,spc3
        integer testuv,testuuv,testxyz,testuuuv
        integer dm(9,9,9),maxc,d18,d20,d21
        integer siyz,sjyz,skyz,sixy,sjxy,skxy,sixz,sjxz,skxz
        integer siy2,sjy2,sky2
        integer ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        common /k/ ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        common /sc/ sixy,sjxy,skxy,sixz,sjxz,skxz,siyz,sjyz,skyz
     .             ,siy2,sjy2,sky2
        common /d/ d18,d20,d21
        real*8     xx,yy,zz,xn,yn,zn,sgn
        real*8     dxa(sz),dya(sz),dza(sz),sa(sz),dxtc,dytc,dztc
        integer ia(sz),ja(sz),ka(sz),ias,jas,kas
        integer rulcx(i40),rulcy(i40),rulcz(i40)
        real*8     ruldx(i40),ruldy(i40),ruldz(i40)
        integer ifail,urgent,xyzurgent,yzurg,xyurg,xzurg,idum,ur2
        integer disi,maxpil
        parameter (maxpil=4000)
        integer dmom(maxpil)
        real*8     mmoments(i40),smom(i40,maxpil)
        logical pmdebug,debug

        debug=.false.
        pmdebug=.false.
        if (pmdebug) open(80,file='matrix.dat')
C        open(99,file='stencil.dat')
C        open(98,file='stencil2.dat')

        if ((iterms*(iterms+4)*pil).gt.coeffsize) then
           write(0,*) '***Too many points, try again***'
           stop
        end if
        call rulc(rulcx,rulcy,rulcz,iterms)
c assume uniform grid so ...
        dx = abs( x(2)-x(1) )
        dy = abs( y(2)-y(1) )
        dz = abs( z(2)-z(1) )
        call getrules(dx,dy,dz,rulcx,rulcy,rulcz,
     .                ruldx,ruldy,ruldz,iterms,maxc)


        do 100 l=1,pil
c           write(6,*) l
        call zero()

        maxtries = 0
        if (xyzurgent.eq.1)
     .      call getrules(dx,dy,dz,rulcx,rulcy,rulcz,
     .                    ruldx,ruldy,ruldz,iterms,maxc)
        yzurg = 0
        xyurg = 0
        xzurg = 0
        spc1 = 0
        spc2 = 0
        spc3 = 0
50      continue
        maxtries = maxtries + 1
        if (maxtries.gt.maxt) then
           write(6,*) '****MAJOR ERROR ****'
           stop
        end if
         urgent=0
         ur2 = 0
         xyzurgent=0
         first_time=1
c get i and j values from list values
         xn = listx(l)
         yn = listy(l)
         zn = listz(l)
c now we need to get the coresponding i and j values ......
         ii = get_val(xn,x,nx)
         jj = get_val(yn,y,ny)
         kk = get_val(zn,z,nz)
c Now this point might be at a bad location we must check to make sure that
c it will be fine.......
c we will do this by seeing if we can get the maxc in each direction ....
         call find_ijk(ii,jj,kk,nx,ny,nz,maxc,charm,i,j,k)
         xx = x(i)
         yy = y(j)
         zz = z(k)
         call get_arrays(i,j,k,upnts,sa,ia,ja,ka,charm,dxa,dya,dza,
     .                   nx,ny,nz,x,y,z,xn,yn,zn)
c now sort this array according to sa ........
           call sort(upnts,sa,ia,ja,ka,dxa,dya,dza)
c array is now sorted, now set up circumference arrays
           call zero_dm(maxc,dm,iterms)

c now we have a set of rules for each of the terms ......

          do 200 ip=1,iterms
c now go through each point and then see if point obeys rules
150         continue
            do 300 jp=1,upnts
c now we center? point around boundary point... so
              if (ia(jp).lt.0) goto 300
c kick out if we used this point
              if (ip.eq.1.and.(ia(jp).ne.i.or.ja(jp).ne.j.or.
     .                         ka(jp).ne.k)) goto 300
c we want the first point to be the point thats on the list..
              dxtc = abs(dxa(jp) + (xn-xx) ) + dx/100.0e0
              dytc = abs(dya(jp) + (yn-yy) ) + dy/100.0e0
              dztc = abs(dza(jp) + (zn-zz) ) + dz/100.0e0
c we are we on the (2maxc-1)*(2maxc-1)*(2maxc-1)
c (i,j,k) is at (maxc,maxc,maxc) so ....
              iwa = maxc - ( i - ia(jp) )
              jwa = maxc - ( j - ja(jp) )
              kwa = maxc - ( k - ka(jp) )
c check circumference test ....
c determine cx and cy and cz,... note they must be connected points to add
c so they are a measure of the connected points ....


              if (first_time.eq.0.and.(ip.le.4)) then
c we must be only 1 off in ias,jas,kas
                 idum = abs(ias-iwa)+abs(jas-jwa)+abs(kas-kwa)
                 if (idum.gt.1) goto 300
              end if

c check dx and dy and dz test
              if (dxtc.ge.ruldx(ip).and.dytc.ge.ruldy(ip).and.
     .            dztc.ge.ruldz(ip) ) then
c one more test for straight derivatives....
c this was last test added due to center differencing off of a point that
c is not the closest to the point we are determining
                if ((rulcx(ip).eq.0.or.rulcy(ip).eq.0.or.
     1           rulcz(ip).eq.0).and.
     2           (dxtc.gt.dx.and.dytc.gt.dy.and.dztc.gt.dz)) goto 300


                 if (iwa.gt.0.and.jwa.gt.0.and.kwa.gt.0.and.
     .               iwa.le.2*maxc-1.and.jwa.le.2*maxc-1.and.
     .               kwa.le.2*maxc-1) then
                   call getcircm(cx,cy,cz,dm,maxc,
     .                           iwa,jwa,kwa,iterms,order)
                 else
                     cx = 0
                     cy = 0
                     cz = 0
                 end if

                 if (cx.ge.1+rulcx(ip).and.cy.ge.1+rulcy(ip).and.
     .               cz.ge.1+rulcz(ip) ) then


                   if (iterms.gt.10.and.(maxt-maxtries).ge.3.
     .                and.ur2.eq.0) then
                      call special_test(iterms,rulcx,rulcy,rulcz,ip,
     1                     iwa,jwa,kwa,ia,ja,ka,i,j,k,jp,
     2                     nx,ny,nz,charm,dm,urgent,order,
     3                     yzurg,xyurg,xzurg,upnts,maxc,it,ur2)
                       if (it.eq.1) goto 300
                   else
                      ur2=1
                      call special_test(iterms,rulcx,rulcy,rulcz,ip,
     1                     iwa,jwa,kwa,ia,ja,ka,i,j,k,jp,
     2                     nx,ny,nz,charm,dm,urgent,order,
     3                     yzurg,xyurg,xzurg,upnts,maxc,it,ur2)
                       if (it.eq.1) goto 300
                   end if

c this point is a good point, so update cx,cy and comat ....
999             dm(iwa,jwa,kwa) = 1

                if (first_time.eq.1) then
                   ias = iwa
                   jas = jwa
                   kas = kwa
                   first_time=0
                endif
c update matrix values ....
                call upmat(nx,iterms,mat,ip,jp,dxa,dya,dza,
     .                    ia,ja,ka,iuterms,juterms,kuterms)
c keep values of sixy,sixz,siyz when appropriate...
                if (ip.eq.18.and.d18.eq.0) then
                   ksixy=sixy
                   ksjxy=sjxy
                   kskxy=skxy
                   d18=1
                else if (ip.eq.20.and.d20.eq.0) then
                   ksixz=sixz
                   ksjxz=sjxz
                   kskxz=skxz
                   d20 = 1
                else if (ip.eq.21.and.d21.eq.0) then
                   ksiyz=siyz
                   ksjyz=sjyz
                   kskyz=skyz
                   d21 = 1
                end if

c now zero out this point in the array of ia,ja
                ia(jp) = -99999
                goto 200
               end if
            end if
300        continue
c if we made it here then we found no matches .....
             if (xyzurgent.eq.1) then
                 write(6,*) 'BIG ERROR'
                 stop
             end if
             if (ip.eq.23) then
C let's try to do the xxyy,xxzz,and yyzz points before this one ...
               call changecxy(iterms,rulcx,rulcy,rulcz
     .                        ,ruldx,ruldy,ruldz,dx,dy,dz)
               call zero()
               xyzurgent=1
               goto 50
             else if (ip.eq.31.or.ip.eq.35) then
c try this to see if it works ......
                ksixz = 0
                ksjxz = 0
                kskxz = 0
                d20 = 0
c thus we must pick a new yz point ...
                yzurg=1
                goto 50
             else if (ip.eq.29.or.ip.eq.33) then
                xyurg=1
                goto 50
             else if (ip.eq.30.or.ip.eq.34) then
                xzurg=1
                goto 50
             end if


             if (urgent.eq.0) then
               if (debug) then
                 write(6,*) '*****MAJOR ERROR.... WE CAN NOT MATCH ****'
                 write(6,*) 'TRYING URGENT TEST *****'
               end if
               urgent = 1
               goto 150
             else
               if (debug)
     .         write(6,*) '*****MAJOR ERROR.... WE CAN NOT MATCH ****'
               if (ip.eq.17.or.ip.eq.18) then
                  spc1 = 1
                  if (spc2.eq.0) sixz=0
                  if (spc3.eq.0) siyz=0
               else if (ip.eq.19.or.ip.eq.20) then
                  spc2 = 1
                  if (spc1.eq.0) sixy=0
                  if (spc3.eq.0) siyz=0
               else if (ip.eq.21.or.ip.eq.22) then
                  spc3 = 1
                  if (spc1.eq.0) sixy=0
                  if (spc2.eq.0) sixz=0
               end if

               goto 50
             end if
200        continue
c   now we have the matrices ....
           if (pmdebug) call printmat(iterms,mat,nx,
     .                iuterms,juterms,kuterms,l)
c           call moments(iterms,iuterms,juterms,kuterms,nx,mmoments)
c           call smoments(l,iterms,pil,mmoments,smom,disi,dmom,
c     .                   iuterms,juterms,kuterms,nx)


           call sgefa(mat,i40,iterms,ipvt,ifail)
           if (ifail.ne.0) then
              write(*,*) '*****ERROR with routine'
              stop
           end if
c now copy information into the 1 big array
           call copy_ba(iterms,mat,iuterms,juterms,kuterms,
     .                  ipvt,comat,pil,l)
100    continue
       if (debug) then
          do l=1,pil
             write(90,*) l
             do j=1,iterms
                do i=1,iterms
						 if (abs(comat(j,i,l)).lt.small) comat(j,i,l)=0.0e0
                   write(90,'(1P,e10.2,$)') comat(j,i,l)
                end do
			 if (abs(comat(j,iterms+1,l)).lt.small) comat(j,iterms+1,l)=0.0e0
			 if (abs(comat(j,iterms+2,l)).lt.small) comat(j,iterms+2,l)=0.0e0
			 if (abs(comat(j,iterms+3,l)).lt.small) comat(j,iterms+3,l)=0.0e0
			 if (abs(comat(j,iterms+4,l)).lt.small) comat(j,iterms+4,l)=0.0e0
                write(90,'(1P,d9.1,$)') comat(j,iterms+1,l)
                write(90,'(1P,d9.1,$)') comat(j,iterms+2,l)
                write(90,'(1P,d9.1,$)') comat(j,iterms+3,l)
                write(90,'(1P,d9.1)') comat(j,iterms+4,l)
             end do
          end do
       end if
c write out results for distinct stencils ....
C       write(99,*) 'Tabulations for different stencils'
C       write(99,*) 'There are ', disi, ' different stencils'
c       do l=1,disi
C          write(99,'(2i5,$)') l,dmom(l)
c          do i=7,12
C             write(99,'(f9.4,$)') smom(i,l)
c          end do
c          write(99,*)
c       end do

       return
       end

        subroutine sort(upnts,sa,ia,ja,ka,dxa,dya,dza)
        implicit none
        include 'terms.inc'
        integer usp,unpnts,upnts,uspnts,ip,jp,kp,il
        real*8     slarge
        real*8     dxa(upnts),dya(upnts),dza(upnts),sa(upnts)
        integer ia(upnts),ja(upnts),ka(upnts)
        real*8     tdxa(sz),tdya(sz),tdza(sz),tsa(sz)
        integer i,index(sz),tia(sz),tja(sz),tka(sz)


       do i=1,upnts
          index(i)=i
       end do

        call batcher(sa,index,upnts)
        do i=1,upnts
           tdxa(i) = dxa(index(i))
           tdya(i) = dya(index(i))
           tdza(i) = dza(index(i))
           tia(i) = ia(index(i))
           tja(i) = ja(index(i))
           tka(i) = ka(index(i))
       end do
        do i=1,upnts
           dxa(i) = tdxa(i)
           dya(i) = tdya(i)
           dza(i) = tdza(i)
           ia(i) = tia(i)
           ja(i) = tja(i)
           ka(i) = tka(i)
       end do
       return
       end
           real*8     function sgn(a)
           real*8     a
           if (a.gt.0.0e0) then
              sgn=1.0e0
           else if (a.lt.0.0e0) then
              sgn=-1.0e0
           else
              sgn=0.0e0
           end if
           return
           end

           integer function get_val(val,ar,n)
           integer i,j,k,n
           real*8     val,ar(n),diff,mindiff
           mindiff = 9999.99
           do i=1,n
              diff = abs(val-ar(i))
              if (diff.lt.mindiff) then
                 get_val=i
                 mindiff=diff
              end if
           end do
           return
           end


        subroutine getrules(dx,dy,dz,rulcx,rulcy,rulcz,
     .                      ruldx,ruldy,ruldz,iterms,maxc)
        implicit none
        include 'terms.inc'
        real*8     dx,dy,dz,ruldx(i40),ruldy(i40),ruldz(i40)
        integer rulcx(i40),rulcy(i40),rulcz(i40)
        integer i,iterms,maxc

        do i=1,iterms
           if (rulcx(i).gt.0) then
              ruldx(i)=dx
           else
              ruldx(i)=0.0e0
           end if
           if (rulcy(i).gt.0) then
              ruldy(i)=dy
           else
              ruldy(i)=0.0e00
           end if
           if (rulcz(i).gt.0) then
              ruldz(i)=dz
           else
              ruldz(i)=0.0e0
           end if
        end do

c define max circumferenc
        if (iterms.eq.4) then
           maxc=2
        else if (iterms.eq.10) then
           maxc=3
        else if (iterms.eq.20) then
           maxc=4
        else
           maxc=5
        end if

        return
        end

        subroutine getcircm(cx,cy,cz,dm,iterms,ip,jp,kp,iiterms,order)
        implicit none
        integer iiterms,iterms,i,j,k,ip,jp,kp
        integer order,cx,cy,cz,inum
        integer dm(9,9,9),maxc
        integer tdm(9,9,9)
        integer min,max

c copy info from dm into tdm
        inum = 2*order + 1

        do i=1,inum
           do j=1,inum
              do k=1,inum
                 tdm(i,j,k) = dm(i,j,k)
              end do
           end do
        end do
c now put point at ip,jp,kp set equal to 1
              tdm(ip,jp,kp) = 1

        cx = 0
        cy = 0
        cz = 0
c get circm in x and y and z directions ...
        do i=1,inum
           if (tdm(i,jp,kp).eq.1) then
              if (i.eq.inum) then
                 if (tdm(inum-1,jp,kp).eq.1) cx = cx + 1
              else if (i.eq.1) then
                 if (tdm(2,jp,kp).eq.1) cx = cx + 1
              else
                 if ((tdm(i-1,jp,kp).eq.1).or.(tdm(i+1,jp,kp).eq.1))
     .               cx=cx+1
              end if
           end if
        end do
        if (cx.eq.0) cx=1
        do i=1,inum
           if (tdm(ip,i,kp).eq.1) then
              if (i.eq.inum) then
                 if (tdm(ip,inum-1,kp).eq.1) cy = cy + 1
              else if (i.eq.1) then
                 if (tdm(ip,2,kp).eq.1) cy = cy + 1
              else
                 if (tdm(ip,i-1,kp).eq.1.or.tdm(ip,i+1,kp).eq.1) cy=cy+1
              end if
           end if
        end do
        if (cy.eq.0) cy=1
        do i=1,inum
           if (tdm(ip,jp,i).eq.1) then
              if (i.eq.inum) then
                 if (tdm(ip,jp,inum-1).eq.1) cz = cz + 1
              else if (i.eq.1) then
                 if (tdm(ip,jp,2).eq.1) cz = cy + 1
              else
                 if (tdm(ip,jp,i-1).eq.1.or.tdm(ip,jp,i+1).eq.1) cz=cz+1
              end if
           end if
        end do
        if (cz.eq.0) cz=1

        return
        end


        subroutine rulc(rulcx,rulcy,rulcz,iterms)
        implicit none
        include 'terms.inc'
        integer iterms,rulcx(i40),rulcy(i40),rulcz(i40)
c        rules for getting derivatives
c        mixed derivatives are at end of list .....
        if (iterms.lt.11) then
           rulcx(1) = 0
           rulcx(2) = 1
           rulcx(3) = 0
           rulcx(4) = 0
           rulcx(5) = 2
           rulcx(6) = 0
           rulcx(7) = 0
           rulcx(8) = 1
           rulcx(9) = 1
           rulcx(10) =0

           rulcy(1) = 0
           rulcy(2) = 0
           rulcy(3) = 1
           rulcy(4) = 0
           rulcy(5) = 0
           rulcy(6) = 2
           rulcy(7) = 0
           rulcy(8) = 1
           rulcy(9) = 0
           rulcy(10) =1

           rulcz(1) = 0
           rulcz(2) = 0
           rulcz(3) = 0
           rulcz(4) = 1
           rulcz(5) = 0
           rulcz(6) = 0
           rulcz(7) = 2
           rulcz(8) = 0
           rulcz(9) = 1
           rulcz(10) =1
        else if (iterms.lt.21) then
           rulcx(1) = 0
           rulcx(2) = 1
           rulcx(3) = 0
           rulcx(4) = 0
           rulcx(5) = 2
           rulcx(6) = 0
           rulcx(7) = 0
           rulcx(8) = 3
           rulcx(9) = 0
           rulcx(10) =0
           rulcx(11) =1
           rulcx(12) =1
           rulcx(13) =0
           rulcx(14) =2
           rulcx(15) =1
           rulcx(16) =2
           rulcx(17) =1
           rulcx(18) =0
           rulcx(19) =0
           rulcx(20) =1

           rulcy(1) = 0
           rulcy(2) = 0
           rulcy(3) = 1
           rulcy(4) = 0
           rulcy(5) = 0
           rulcy(6) = 2
           rulcy(7) = 0
           rulcy(8) = 0
           rulcy(9) = 3
           rulcy(10) =0
           rulcy(11) =1
           rulcy(12) =0
           rulcy(13) =1
           rulcy(14) =1
           rulcy(15) =2
           rulcy(16) =0
           rulcy(17) =0
           rulcy(18) =2
           rulcy(19) =1
           rulcy(20) =1

           rulcz(1) = 0
           rulcz(2) = 0
           rulcz(3) = 0
           rulcz(4) = 1
           rulcz(5) = 0
           rulcz(6) = 0
           rulcz(7) = 2
           rulcz(8) = 0
           rulcz(9) = 0
           rulcz(10) =3
           rulcz(11) =0
           rulcz(12) =1
           rulcz(13) =1
           rulcz(14) =0
           rulcz(15) =0
           rulcz(16) =1
           rulcz(17) =2
           rulcz(18) =1
           rulcz(19) =2
           rulcz(20) =1
        else
           rulcx(1) = 0
           rulcx(2) = 1
           rulcx(3) = 0
           rulcx(4) = 0
           rulcx(5) = 2
           rulcx(6) = 0
           rulcx(7) = 0
           rulcx(8) = 3
           rulcx(9) = 0
           rulcx(10) =0
           rulcx(11) =4
           rulcx(12) =0
           rulcx(13) =0
           rulcx(14) =1
           rulcx(15) =1
           rulcx(16) =0
           rulcx(17) =2
           rulcx(18) =1
           rulcx(19) =2
           rulcx(20) =1
           rulcx(21) =0
           rulcx(22) =0
           rulcx(23) =1
           rulcx(24) =3
           rulcx(25) =3
           rulcx(26) =1
           rulcx(27) =1
           rulcx(28) =0
           rulcx(29) =0
           rulcx(30) =2
           rulcx(31) =1
           rulcx(32) =1
           rulcx(33) =2
           rulcx(34) =2
           rulcx(35) =0

           rulcy(1) = 0
           rulcy(2) = 0
           rulcy(3) = 1
           rulcy(4) = 0
           rulcy(5) = 0
           rulcy(6) = 2
           rulcy(7) = 0
           rulcy(8) = 0
           rulcy(9) = 3
           rulcy(10) =0
           rulcy(11) =0
           rulcy(12) =4
           rulcy(13) =0
           rulcy(14) =1
           rulcy(15) =0
           rulcy(16) =1
           rulcy(17) =1
           rulcy(18) =2
           rulcy(19) =0
           rulcy(20) =0
           rulcy(21) =2
           rulcy(22) =1
           rulcy(23) =1
           rulcy(24) =1
           rulcy(25) =0
           rulcy(26) =3
           rulcy(27) =0
           rulcy(28) =3
           rulcy(29) =1
           rulcy(30) =1
           rulcy(31) =2
           rulcy(32) =1
           rulcy(33) =2
           rulcy(34) =0
           rulcy(35) =2

           rulcz(1) = 0
           rulcz(2) = 0
           rulcz(3) = 0
           rulcz(4) = 1
           rulcz(5) = 0
           rulcz(6) = 0
           rulcz(7) = 2
           rulcz(8) = 0
           rulcz(9) = 0
           rulcz(10) =3
           rulcz(11) =0
           rulcz(12) =0
           rulcz(13) =4
           rulcz(14) =0
           rulcz(15) =1
           rulcz(16) =1
           rulcz(17) =0
           rulcz(18) =0
           rulcz(19) =1
           rulcz(20) =2
           rulcz(21) =1
           rulcz(22) =2
           rulcz(23) =1
           rulcz(24) =0
           rulcz(25) =1
           rulcz(26) =0
           rulcz(27) =3
           rulcz(28) =1
           rulcz(29) =3
           rulcz(30) =1
           rulcz(31) =1
           rulcz(32) =2
           rulcz(33) =0
           rulcz(34) =2
           rulcz(35) =2
        end if
        return
        end


         subroutine find_ijk(ii,jj,kk,nx,ny,nz,maxc,charm,i,j,k)
         implicit none
         include 'terms.inc'
         integer ii,jj,kk,i,j,k,nx,ny,nz
         real*8     charm(nx,ny,nz)
         integer maxc
         integer rulsi(sz),rulsj(sz),rulsk(sz)
         integer inp,mini,minj,mink,maxi,maxj,maxk,idummy,ic
         real*8     rulsd(sz),dum1(sz),dum2(sz),dum3(sz)

         ic = 0

         do k = -6,6
            do i = -6,6
               do j = -6,6
                  ic = ic + 1
                  rulsi(ic) = i
                  rulsj(ic) = j
                  rulsk(ic) = k
                  rulsd(ic) = i**2 + j**2 + k**2
                  dum1(ic) = 0.0e0
                  dum2(ic) = 0.0e0
                  dum3(ic) = 0.0e0
               end do
            end do
         end do
            call sort(ic,rulsd,rulsi,rulsj,rulsk,dum1,dum2,dum3)

c 320 loop gets the i and j and kto center difference from ....
         do 320 inp = 1,sz
            i = ii + rulsi(inp)
            j = jj + rulsj(inp)
            k = kk + rulsk(inp)
                    if (i.lt.1) i=1
                    if (j.lt.1) j=1
                    if (k.lt.1) k=1
                    if (i.gt.nx) i=nx
                    if (j.gt.ny) i=ny
                    if (k.gt.nz) k=nz
            if (charm(i,j,k).eq.(0.0e0)) goto 320
C we can't center difference off of a undefined point!!!
            mini=i-maxc
            minj=j-maxc
            mink=k-maxc
            maxi=i+maxc
            maxj=j+maxc
            maxk=k+maxc
            if (mini.lt.1) mini = 1
            if (minj.lt.1) minj=1
            if (mink.lt.1) mink=1
            if (maxi.gt.nx) maxi=nx
            if (maxj.gt.ny) maxj=ny
            if (maxk.gt.nz) maxk=nz
C these lines were to make sure we don't check outside of arrays....
c now begin check .....
            ic = 0
            do idummy=mini,maxi
               if (charm(idummy,j,k).ne.(0.0e0)) ic=ic+1
            end do
            if (ic.lt.maxc) goto 320
c we need a new point in the i-direction for our stencil .....
            ic = 0
            do idummy=minj,maxj
               if (charm(i,idummy,k).ne.(0.0e0)) ic=ic+1
            end do
            if (ic.lt.maxc) goto 320
            ic = 0
            do idummy=mink,maxk
               if (charm(i,j,idummy).ne.(0.0e0)) ic=ic+1
            end do
            if (ic.lt.maxc) goto 320
c Well if we are here then we can center difference the x and y derivatives
c NOTE: we have not checked the mixed derivatives.. if something real*8     funny
c is going on then this will not work!!!!!!!!
            goto 325
320         continue
            write(6,*) '**MAJOR ERRORR**, CAN NOT GET I,J VALUE'
            stop
325         continue
c well if we are here then we should be able to work!!!!!!
            return
            end

        subroutine zero_dm(maxc,dm,iterms)
        implicit none
        include 'terms.inc'
        integer iterms,maxc,dm(9,9,9)
        integer ip,jp,kp
        do kp=1,2*maxc-1
          do jp=1,2*maxc-1
            do ip=1,2*maxc-1
              dm(ip,jp,kp) = 0
            end do
          end do
        end do
        return
        end

         subroutine get_arrays(i,j,k,upnts,sa,ia,ja,ka,charm,
     .                         dxa,dya,dza,nx,ny,nz,x,y,z,xn,yn,zn)
         implicit none
         include 'terms.inc'
         integer i,j,k,upnts,ia(sz),ja(sz),ka(sz)
         integer nx,ny,nz
         real*8     charm(nx,ny,nz)
         real*8     dxa(sz),dya(sz),dza(sz),sa(sz),x(nx),y(ny)
         real*8     z(nz),xn,yn,zn
         integer ip,jp,kp,mini,minj,mink,maxi,maxj,maxk
c so we are evaluating everything at the point (xn,yn,zn) ....
c so first point is at (xn+sx,yn+sy,zn+sz)
c now we must set up our list
           upnts = 0
           if ((j-4).lt.1) then
                minj=1
           else
                minj=j-4
           end if
           if ((i-4).lt.1) then
                mini=1
           else
                mini=i-4
           end if
           if ((k-4).lt.1) then
                mink=1
           else
                mink=k-4
           end if

           if ((j+4).gt.ny) then
                maxj=ny
           else
                maxj=j+4
           end if
           if ((i+4).gt.nx) then
                maxi=nx
           else
                maxi=i+4
           end if
           if ((k+4).gt.nz) then
                maxk=nz
           else
                maxk=k+4
           end if

           do kp=mink,maxk
            do jp=minj,maxj
              do ip=mini,maxi
                 if (charm(ip,jp,kp).ne.(0.0e0)) then
c this is a usable point so set up arrays for sa,dxa,dya,dza,ia,ja,ka
                    upnts = upnts + 1
                    ia(upnts) = ip
                    ja(upnts) = jp
                    ka(upnts) = kp
                    dxa(upnts) = x(ip) - xn
                    dya(upnts) = y(jp) - yn
                    dza(upnts) = z(kp) - zn
                    sa(upnts)=dxa(upnts)**2+dya(upnts)**2+dza(upnts)**2
                 end if
              end do
            end do
           end do
          return
          end

        subroutine zero()
        implicit none
        integer sixy,sjxy,skxy,sixz,sjxz,skxz,siyz,sjyz,skyz
        integer siy2,sjy2,sky2
        common /sc/ sixy,sjxy,skxy,sixz,sjxz,skxz,siyz,sjyz,skyz
     .             ,siy2,sjy2,sky2
        integer ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        common /k/ ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        integer d18,d20,d21
        common /d/ d18,d20,d21
        d18 = 0
        d20 = 0
        d21 = 0
        siy2 = 0
        sjy2 = 0
        sky2 = 0
        sixy = 0
        sjxy = 0
        skxy = 0
        sixz= 0
        sjxz= 0
        skxz= 0
        siyz= 0
        sjyz= 0
        skyz= 0
        ksixy = 0
        ksjxy = 0
        kskxy = 0
        ksixz= 0
        ksjxz= 0
        kskxz= 0
        ksiyz= 0
        ksjyz= 0
        kskyz= 0
        return
        end

      integer function testuv(iterms,ua,va,sa,jp,u1,u2,u3,maxc,
     .              nx,ny,nz,charm,dm,iwa,jwa,kwa,urgent,wt,order,ur2)
      implicit none
      include 'terms.inc'
      integer ip,ua(iterms),va(iterms),sa,jp,maxc,u1,u2,u3,iwa,jwa,kwa
      integer iterms,nx,ny,nz
      real*8     charm(nx,ny,nz)
      integer dm(9,9,9),order,ur2
      character*2 wt
c now u1 and u2 are changing , u3 is kept constant, look in u1,u2 plane
c local variables ...
      integer ucc(4),vcc(4),uuwa(4),vvwa(4),sswa,itestuv,igood,cuu,cvv
      integer css,urgent,uuu,vvv,sss
c check 4 surrouding points on a plane, the other variable is kept
c constant .....

          testuv = 0

          ucc(1) = ua(jp) + 1
          ucc(2) = ua(jp) - 1
          ucc(3) = ua(jp)
          ucc(4) = ua(jp)
          vcc(1) = va(jp)
          vcc(2) = va(jp)
          vcc(3) = va(jp) + 1
          vcc(4) = va(jp) - 1

          dm(iwa,jwa,kwa) = 1
          igood = 0

          sswa = maxc - (u3 - sa)
          do itestuv = 1,4
             uuwa(itestuv) = maxc - ( u1 - ucc(itestuv) )
             vvwa(itestuv) = maxc - ( u2 - vcc(itestuv) )
             if (urgent.eq.1) then
               if (wt.eq.'xy') then
                  if (dm(uuwa(itestuv),vvwa(itestuv),sswa).eq.1) then
c put point over more
                    if (itestuv.eq.1) uuwa(itestuv) = uuwa(itestuv)+1
                    if (itestuv.eq.2) uuwa(itestuv) = uuwa(itestuv)-1
                    if (itestuv.eq.3) vvwa(itestuv) = vvwa(itestuv)+1
                    if (itestuv.eq.4) vvwa(itestuv) = vvwa(itestuv)-1
                  end if
               else if (wt.eq.'xz') then
                  if (dm(uuwa(itestuv),sswa,vvwa(itestuv)).eq.1) then
c put point over more
                    if (itestuv.eq.1) uuwa(itestuv) = uuwa(itestuv)+1
                    if (itestuv.eq.2) uuwa(itestuv) = uuwa(itestuv)-1
                    if (itestuv.eq.3) vvwa(itestuv) = vvwa(itestuv)+1
                    if (itestuv.eq.4) vvwa(itestuv) = vvwa(itestuv)-1
                  end if
               else
                  if (dm(sswa,uuwa(itestuv),vvwa(itestuv)).eq.1) then
c put point over more
                    if (itestuv.eq.1) uuwa(itestuv) = uuwa(itestuv)+1
                    if (itestuv.eq.2) uuwa(itestuv) = uuwa(itestuv)-1
                    if (itestuv.eq.3) vvwa(itestuv) = vvwa(itestuv)+1
                    if (itestuv.eq.4) vvwa(itestuv) = vvwa(itestuv)-1
                  end if
               end if
             end if

          end do

          do itestuv = 1,4
             uuu = u1 - (maxc-uuwa(itestuv))
             vvv = u2 - (maxc-vvwa(itestuv))
             sss = u3 - (maxc-sswa)
             if (wt.eq.'xy') then
                if (charm(uuu,vvv,sss).ne.(0.0e0)) then
                   call getcircm(cuu,cvv,css,dm,maxc,
     .                  uuwa(itestuv),vvwa(itestuv),sswa,iterms,order)
                 end if
             else if (wt.eq.'xz') then
                if (charm(uuu,sss,vvv).ne.(0.0e0)) then
                   call getcircm(cuu,css,cvv,dm,maxc,
     .                  uuwa(itestuv),sswa,vvwa(itestuv),iterms,order)
                 end if
             else
                if (charm(sss,uuu,vvv).ne.(0.0e0)) then
                   call getcircm(css,cuu,cvv,dm,maxc,
     .                  sswa,uuwa(itestuv),vvwa(itestuv),iterms,order)
                 end if

             end if

             if (cuu.eq.3.and.cvv.eq.2) igood = igood + 1
             if (ur2.eq.0.and.cuu.eq.2.and.cvv.eq.3) igood = igood + 1
          end do
          if (igood.ne.2) then
           if (ur2.eq.1.and.igood.eq.1) return
             dm(iwa,jwa,kwa) = 0
c not a good point .....
             testuv=1
          end if
       return
       end

       subroutine upmat(nx,iterms,mat,ip,jp,dxa,dya,dza,ia,ja,ka,
     .                  iuterms,juterms,kuterms)
       implicit none
       include 'terms.inc'
       integer nx,iterms,ip,jp,kp,ia(sz),ja(sz),ka(sz)
       integer iuterms(i40),juterms(i40),kuterms(i40)
       real*8     mat(i40,i40),dxa(sz),dya(sz),dza(sz)
           mat(ip,1) = 1.0e0
           mat(ip,2) = dxa(jp)
           mat(ip,3) = dya(jp)
           mat(ip,4) = dza(jp)
           if (iterms.lt.10) goto 222
           mat(ip,5) = dxa(jp) * dxa(jp) * 0.5
           mat(ip,6) = dya(jp) * dya(jp) * 0.5
           mat(ip,7) = dza(jp) * dza(jp) * 0.50e0
           mat(ip,8) = dxa(jp) * dya(jp)
           mat(ip,9) = dxa(jp) * dza(jp)
           mat(ip,10)= dya(jp) * dza(jp)
           if (iterms.lt.20) goto 222
           mat(ip,11)= dxa(jp) * dxa(jp) * dxa(jp) /6.0e0
           mat(ip,12)= dya(jp) * dya(jp) * dya(jp) /6.0e0
           mat(ip,13)= dza(jp) * dza(jp) * dza(jp) /6.0e0
           mat(ip,14)= dxa(jp) * dxa(jp) * dya(jp) *0.5
           mat(ip,15)= dxa(jp) * dya(jp) * dya(jp) *0.5
           mat(ip,16)= dxa(jp) * dxa(jp) * dza(jp) *0.5
           mat(ip,17)= dxa(jp) * dza(jp) * dza(jp) *0.5
           mat(ip,18)= dya(jp) * dya(jp) * dza(jp) *0.5
           mat(ip,19)= dya(jp) * dza(jp) * dza(jp) *0.5
           mat(ip,20)= dxa(jp) * dya(jp) * dza(jp)
           if (iterms.lt.15) goto 222
           mat(ip,21)= dxa(jp) * dxa(jp) * dxa(jp) *dxa(jp)/24.0e0
           mat(ip,22)= dya(jp) * dya(jp) * dya(jp) *dya(jp)/24.0e0
           mat(ip,23)= dza(jp) * dza(jp) * dza(jp) *dza(jp)/24.0e0

           mat(ip,24)= dxa(jp) * dxa(jp) * dxa(jp) *dya(jp)/6.0e0
           mat(ip,25)= dxa(jp) * dxa(jp) * dxa(jp) *dza(jp)/6.0e0
           mat(ip,26)= dxa(jp) * dya(jp) * dya(jp) *dya(jp)/6.0e0
           mat(ip,27)= dxa(jp) * dza(jp) * dza(jp) *dza(jp)/6.0e0
           mat(ip,28)= dya(jp) * dya(jp) * dya(jp) *dza(jp)/6.0e0
           mat(ip,29)= dya(jp) * dza(jp) * dza(jp) *dza(jp)/6.0e0

           mat(ip,30)= dxa(jp) * dxa(jp) * dya(jp) *dya(jp)/4.0e0
           mat(ip,31)= dxa(jp) * dxa(jp) * dza(jp) *dza(jp)/4.0e0
           mat(ip,32)= dya(jp) * dya(jp) * dza(jp) *dza(jp)/4.0e0

           mat(ip,33)= dxa(jp) * dxa(jp) * dya(jp) *dza(jp)/2.0e0
           mat(ip,34)= dxa(jp) * dya(jp) * dya(jp) *dza(jp)/2.0e0
           mat(ip,35)= dxa(jp) * dya(jp) * dza(jp) *dza(jp)/2.0e0
222        continue
           iuterms(ip) = ia(jp)
           juterms(ip) = ja(jp)
           kuterms(ip) = ka(jp)
           return
           end

          subroutine printmat(iterms,mat,nx,iuterms,juterms,kuterms,l)
          implicit none
          include 'terms.inc'
          integer iterms,iuterms(i40),juterms(i40),kuterms(i40),nx,l
          real*8       mat(i40,i40)
          integer ii,jj,iw,jw,kw,ss
          write(80,*) '**************',l
          ss = nx*nx
           do ii=1,iterms
              do jj=1,iterms
                 write(80,33) mat(ii,jj)
              end do
C              write(80,*) '    ',uterms(ii)
               write(80,'(3i4)') iuterms(ii),juterms(ii),kuterms(ii)
           end do
33         format(2x,f9.4,$)
           write(80,*) '**************'
          return
          end

          subroutine copy_ba(iterms,mat,iuterms,
     .                       juterms,kuterms,ipvt,comat,pil,l)
          implicit none
          include 'terms.inc'
          integer l,pil,iterms,ipvt(i40)
          integer iuterms(i40),juterms(i40),kuterms(i40)
          real*8       mat(i40,i40),comat(iterms,iterms+4,pil)
          integer ii,jj

           do ii=1,iterms
              do jj=1,iterms
                 comat(ii,jj,l) = mat(ii,jj)
              end do
              comat(ii,iterms+1,l) = iuterms(ii)
              comat(ii,iterms+2,l) = juterms(ii)
              comat(ii,iterms+3,l) = kuterms(ii)
              comat(ii,iterms+4,l) = ipvt(ii)
           end do
          return
          end


c.......................
      integer function testuuv(iterms,ua,va,sa,jp,u1,u2,u3,maxc,
     .              nx,ny,nz,charm,dm,uwa,vwa,swa,urgent,wt,order)
        implicit none
        include 'terms.inc'
        integer iterms,ua(iterms),va,sa,jp,u1,u2,u3,maxc
        integer nx,ny,nz
         real*8     charm(nx,ny,nz)
         integer dm(9,9,9),uwa,vwa,swa
        integer urgent,order
        character*3 wt
        integer c1,c2,c3,jj,uuu,vvv,sss,us,a1,a2,a3,b1,b2,b3

        testuuv = 0
c now look left and look right for uuv point ....
        do jj=-3,3
           uuu = u1-(maxc-(uwa+jj))
           vvv = u2-(maxc-vwa)
           sss = u3-(maxc-swa)
           if (uuu.lt.1) uuu=1
           if (vvv.lt.1) vvv=1
           if (sss.lt.1) sss=1
           if (uuu.gt.nx) uuu=nx
           if (vvv.gt.ny) vvv=ny
           if (sss.gt.nz) sss=nz
           us = uwa+jj
           if (us.lt.1) us=1
           if (us.gt.iterms) us=iterms
c now we must see which guys go where
           if (wt.eq.'xxy') then
              a1 = us
              a2 = vwa
              a3 = swa
              b1 = uuu
              b2 = vvv
              b3 = sss
              dm(uwa,vwa,swa) = 1
              if (dm(a1,a2,a3).eq.0.and.charm(b1,b2,b3).ne.(0.0e0))
     .         call getcircm(c1,c2,c3,dm,maxc,a1,a2,a3,iterms,order)
              dm(uwa,vwa,swa) = 0
           else if (wt.eq.'yyx') then
              a1 = vwa
              a2 = us
              a3 = swa
              b1 = vvv
              b2 = uuu
              b3 = sss
              dm(vwa,uwa,swa) = 1
              if (dm(a1,a2,a3).eq.0.and.charm(b1,b2,b3).ne.(0.0e0))
     .         call getcircm(c2,c1,c3,dm,maxc,a1,a2,a3,iterms,order)
              dm(vwa,uwa,swa) = 0
           else if (wt.eq.'xxz') then
              a1 = us
              a2 = swa
              a3 = vwa
              b1 = uuu
              b2 = sss
              b3 = vvv
              dm(uwa,swa,vwa) = 1
              if (dm(a1,a2,a3).eq.0.and.charm(b1,b2,b3).ne.(0.0e0))
     .         call getcircm(c1,c3,c2,dm,maxc,a1,a2,a3,iterms,order)
              dm(uwa,swa,vwa) = 0
           else if (wt.eq.'zzx') then
              a1 = vwa
              a2 = swa
              a3 = us
              b1 = vvv
              b2 = sss
              b3 = uuu
              dm(vwa,swa,uwa) = 1
              if (dm(a1,a2,a3).eq.0.and.charm(b1,b2,b3).ne.(0.0e0))
     .         call getcircm(c2,c3,c1,dm,maxc,a1,a2,a3,iterms,order)
              dm(vwa,swa,uwa) = 0
           else if (wt.eq.'yyz') then
              a1 = swa
              a2 = us
              a3 = vwa
              b1 = sss
              b2 = uuu
              b3 = vvv
              dm(swa,uwa,vwa) = 1
              if (dm(a1,a2,a3).eq.0.and.charm(b1,b2,b3).ne.(0.0e0))
     .         call getcircm(c3,c1,c2,dm,maxc,a1,a2,a3,iterms,order)
              dm(swa,uwa,vwa) = 0
           else
              a1 = swa
              a2 = vwa
              a3 = us
              b1 = sss
              b2 = vvv
              b3 = uuu
              dm(swa,vwa,uwa) = 1
              if (dm(a1,a2,a3).eq.0.and.charm(b1,b2,b3).ne.(0.0e0))
     .          call getcircm(c3,c2,c1,dm,maxc,a1,a2,a3,iterms,order)
              dm(swa,vwa,uwa) = 0
           end if

             if (c1.ge.4.and.c2.ge.2) goto 999
        end do
        testuuv = 1
        return
999     continue
        return
        end
c.......................
      integer function testxyz(iterms,ia,ja,ka,jp,i,j,k,maxc,
     .              nx,ny,nz,charm,dm,iwa,jwa,kwa,order)
        implicit none
        include 'terms.inc'
        integer iterms,ia(iterms),ja(iterms),ka(iterms),jp,i,j,k,maxc
        integer nx,ny,nz
      real*8     charm(nx,ny,nz)
      integer dm(9,9,9),iwa,jwa,kwa
        integer urgent,order,iiterms
        integer cx,cy,cz,jj,iii,jjj,kkk,us

        iiterms= 2*order+1
        testxyz = 0
c now look left and look right for xxyz point ....
        jjj = j-(maxc-jwa)
        kkk = k-(maxc-kwa)
        if (jjj.lt.1) jjj=1
        if (kkk.lt.1) kkk=1
        if (jjj.gt.ny) jjj=ny
        if (kkk.gt.nz) kkk=nz
        do jj=-3,3
           us = iwa+jj
           iii = i-(maxc-(us))
           if (iii.lt.1) iii=1
           if (iii.gt.nx) iii=nx
           if (us.lt.1) us=1
           if (us.gt.iiterms) us=iiterms
           dm(iwa,jwa,kwa) = 1
           if (dm(us,jwa,kwa).eq.0.and.charm(iii,jjj,kkk).ne.(0.0e0))
     .         call getcircm(cx,cy,cz,dm,maxc,us,jwa,kwa,iterms,order)
           dm(iwa,jwa,kwa) = 0
c disregard next comment now ...
           if (cx.ge.3.and.cy.ge.2.and.cz.ge.2) goto 999
C don't set it to zero first since we will use the point .....
        end do
c got here, so we failed......
        testxyz = 1
        return
999     continue

c now look left and look right for xyyz point ....
        iii = i-(maxc-iwa)
        kkk = k-(maxc-kwa)
        if (iii.lt.1) iii=1
        if (kkk.lt.1) kkk=1
        if (iii.gt.ny) iii=ny
        if (kkk.gt.nz) kkk=nz
        do jj=-3,3
           us = jwa+jj
           jjj = j-(maxc-(us))
           if (jjj.lt.1) jjj=1
           if (jjj.gt.ny) jjj=ny
           if (us.lt.1) us=1
           if (us.gt.iiterms) us=iiterms
           dm(iwa,jwa,kwa) = 1
           if (dm(iwa,us,kwa).eq.0.and.charm(iii,jjj,kkk).ne.(0.0e0))
     .         call getcircm(cx,cy,cz,dm,maxc,iwa,us,kwa,iterms,order)
           dm(iwa,jwa,kwa) = 0
c disregard next comment now ...
           if (cx.ge.2.and.cy.ge.3.and.cz.ge.2) goto 888
C don't set it to zero first since we will use the point .....
        end do
c got here, so we failed......
        testxyz = 1
        return
888     continue

c now look left and look right for xyyz point ....
        iii = i-(maxc-iwa)
        jjj = j-(maxc-jwa)
        if (iii.lt.1) iii=1
        if (jjj.lt.1) jjj=1
        if (iii.gt.ny) iii=ny
        if (jjj.gt.nz) jjj=nz
        do jj=-3,3
           us = kwa+jj
           kkk = k-(maxc-(us))
           if (kkk.lt.1) kkk=1
           if (kkk.gt.ny) kkk=ny
           if (us.lt.1) us=1
           if (us.gt.iiterms) us=iiterms
           dm(iwa,jwa,kwa) = 1
           if (dm(iwa,jwa,us).eq.0.and.charm(iii,jjj,kkk).ne.(0.0e0))
     .         call getcircm(cx,cy,cz,dm,maxc,iwa,jwa,us,iterms,order)
           dm(iwa,jwa,kwa) = 0
c disregard next comment now ...
           if (cx.ge.2.and.cy.ge.2.and.cz.ge.3) goto 777
C don't set it to zero first since we will use the point .....
        end do
c got here, so we failed......
        testxyz = 1
        return
777     continue
c we made it ....
        dm(iwa,jwa,kwa) = 1
        return
        end
c----------------------------------------------
      integer function testuuuv(iterms,ua,va,sa,jp,u,v,s,maxc,
     .              nx,ny,nz,charm,dm,uwa,vwa,swa,order,wt)
        implicit none
        include 'terms.inc'
        integer iterms,ua(iterms),va(iterms),sa(iterms),jp,u,v,s,maxc
        integer nx,ny,nz
      real*8     charm(nx,ny,nz)
      integer dm(9,9,9),uwa,vwa,swa
        integer iiterms,urgent,order
        integer cu,cv,cs,jj,uuu,vvv,sss,us,vs
        character*4 wt

        testuuuv = 0
        iiterms = 2*order +1
        vvv = v-(maxc-vwa)
        sss = s-(maxc-swa)
        if (vvv.lt.1) vvv=1
        if (sss.lt.1) sss=1
        if (vvv.gt.ny) vvv=ny
        if (sss.gt.nz) sss=nz
        do jj=-4,4
           us = uwa+jj
           uuu = u-(maxc-(us))
           if (uuu.lt.1) uuu=1
           if (uuu.gt.ny) uuu=ny
           if (us.lt.1) us=1
           if (us.gt.iiterms) us=iiterms
           if (wt.eq.'xxxy') then
              dm(uwa,vwa,swa) = 1
              if (dm(us,vwa,swa).eq.0.and.charm(uuu,vvv,sss).ne.(0.0e0))
     .           call getcircm(cu,cv,cs,dm,maxc,us,vwa,swa,iterms,order)
              dm(uwa,vwa,swa) = 0
           else if (wt.eq.'yyyz') then
              dm(swa,uwa,vwa) = 1
              if (dm(swa,us,vwa).eq.0.and.charm(sss,uuu,vvv).ne.(0.0e0))
     .           call getcircm(cs,cu,cv,dm,maxc,swa,us,vwa,iterms,order)
              dm(swa,uwa,vwa) = 0
           else if (wt.eq.'zzzx') then
              dm(vwa,swa,uwa) = 1
              if (dm(vwa,swa,us).eq.0.and.charm(vvv,sss,uuu).ne.(0.0e0))
     .           call getcircm(cv,cs,cu,dm,maxc,vwa,swa,us,iterms,order)
              dm(vwa,swa,uwa) = 0

           end if
c disregard next comment now ...
           if (cu.ge.3.and.cv.ge.3) goto 999
C don't set it to zero first since we will use the point .....
        end do
        uuu = u-(maxc-uwa)
        sss = s-(maxc-swa)
        if (uuu.lt.1) uuu=1
        if (sss.lt.1) sss=1
        if (uuu.gt.ny) uuu=ny
        if (sss.gt.nz) sss=nz
        do jj=-4,4
           vs = vwa+jj
           vvv = v-(maxc-(vs))
           if (vvv.lt.1) vvv=1
           if (vvv.gt.ny) vvv=ny
           if (vs.lt.1) vs=1
           if (vs.gt.iiterms) vs=iiterms
           if (wt.eq.'xxxy') then
              dm(uwa,vwa,swa) = 1
              if (dm(uwa,vs,swa).eq.0.and.charm(uuu,vvv,sss).ne.(0.0e0))
     .           call getcircm(cu,cv,cs,dm,maxc,uwa,vs,swa,iterms,order)
              dm(uwa,vwa,swa) = 0
           else if (wt.eq.'yyyz') then
              dm(swa,uwa,vwa) = 1
              if (dm(swa,uwa,vs).eq.0.and.charm(sss,uuu,vvv).ne.(0.0e0))
     .           call getcircm(cs,cu,cv,dm,maxc,swa,uwa,vs,iterms,order)
              dm(swa,uwa,vwa) = 0
           else if (wt.eq.'zzzx') then
              dm(vwa,swa,uwa) = 1
              if (dm(vs,swa,uwa).eq.0.and.charm(vvv,sss,uuu).ne.(0.0e0))
     .           call getcircm(cv,cs,cu,dm,maxc,vs,swa,uwa,iterms,order)
              dm(vwa,swa,uwa) = 0

           end if
c disregard next comment now ...
           if (cu.ge.3.and.cv.ge.3) goto 999
C don't set it to zero first since we will use the point .....
        end do
c got here, so we failed......
        testuuuv = 1
999     continue
        return
        end
c----------------------------------------------
        subroutine changecxy(iterms,rulcx,rulcy,rulcz,ruldx,ruldy,ruldz
     1                       ,dx,dy,dz)
        implicit none
        integer iterms,rulcx(iterms),rulcy(iterms),rulcz(iterms)
        real*8       ruldx(iterms),ruldy(iterms),ruldz(iterms),dx,dy,dz
        integer i

c change the rules temporary ......

        rulcx(23) = 3
        rulcx(24) = 3
        rulcx(25) = 1
        rulcx(26) = 1
        rulcx(27) = 0
        rulcx(28) = 0
        rulcx(29) = 2
        rulcx(30) = 2
        rulcx(31) = 0
        rulcx(32) = 1
        rulcx(33) = 2
        rulcx(34) = 1
        rulcx(35) = 1

        rulcy(23) = 1
        rulcy(24) = 0
        rulcy(25) = 3
        rulcy(26) = 0
        rulcy(27) = 3
        rulcy(28) = 1
        rulcy(29) = 2
        rulcy(30) = 0
        rulcy(31) = 2
        rulcy(32) = 1
        rulcy(33) = 1
        rulcy(34) = 2
        rulcy(35) = 1

        rulcz(23) = 0
        rulcz(24) = 1
        rulcz(25) = 0
        rulcz(26) = 3
        rulcz(27) = 1
        rulcz(28) = 3
        rulcz(29) = 0
        rulcz(30) = 1
        rulcz(31) = 2
        rulcz(32) = 1
        rulcz(33) = 1
        rulcz(34) = 1
        rulcz(35) = 2

        do i=23,35
           if (rulcx(i).gt.0) then
              ruldx(i)=dx
           else
              ruldx(i)=0.0e0
           end if
           if (rulcy(i).gt.0) then
              ruldy(i)=dy
           else
              ruldy(i)=0.0e0
           end if
           if (rulcz(i).gt.0) then
              ruldz(i)=dz
           else
              ruldz(i)=0.0e0
           end if
        end do

        return
        end

        subroutine special_test(iterms,rulcx,rulcy,rulcz,ip,
     1                          iwa,jwa,kwa,ia,ja,ka,i,j,k,jp,
     2                          nx,ny,nz,charm,dm,urgent,order,
     3                          yzurg,xyurg,xzurg,upnts,maxc,it,ur2)
        implicit none
        integer iterms,ip,i,j,k,iwa,jwa,kwa,nx,ny,nz,it
        include 'terms.inc'
        integer rulcx(i40),rulcy(i40),rulcz(i40)
        real*8     charm(nx,ny,nz)
        integer upnts,ia(upnts),ja(upnts),ka(upnts)
        integer dm(9,9,9),urgent,order
        integer testuv,testuuv,testxyz,testuuuv,testyyzz
        integer maxc,jp,yzurg,xyurg,xzurg
        integer siyz,sjyz,skyz,sixy,sjxy,skxy,sixz,sjxz,skxz,ur2
     .             ,siy2,sjy2,sky2
        integer ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        common /sc/ sixy,sjxy,skxy,sixz,sjxz,skxz,siyz,sjyz,skyz
     .             ,siy2,sjy2,sky2
        common /k/ ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz


        it = 0
c now we have the special cases .......

        if (rulcx(ip).eq.1.and.rulcy(ip).eq.1.
     1      and.rulcz(ip).eq.0.and.iterms.gt.10) then
           if (iwa.eq.ksixy.and.jwa.eq.ksjxy.and.kwa.eq.kskxy) goto 50

           if (ksixy.ne.0.or.(iwa.eq.sixy.and.jwa.eq.sjxy.
     1         and.kwa.eq.skxy)) goto 300
50         it = testuv(iterms,ia,ja,ka(jp),jp,i,j,k,maxc,
     1     nx,ny,nz,charm,dm,iwa,jwa,kwa,urgent,'xy',order,ur2)
           if (it.eq.1) goto 300
              sixy = iwa
              sjxy = jwa
              skxy = kwa

        else if (rulcx(ip).eq.1.and.rulcz(ip).eq.1.
     1      and.rulcy(ip).eq.0.and.iterms.gt.10) then
           if (iwa.eq.ksixz.and.jwa.eq.ksjxz.and.kwa.eq.kskxz) goto 60
           if (ksixz.ne.0.or.(iwa.eq.sixz.and.jwa.eq.sjxz.
     1         and.kwa.eq.skxz)) goto 300
60         it = testuv(iterms,ia,ka,ja(jp),jp,i,k,j,maxc,
     1     nx,ny,nz,charm,dm,iwa,jwa,kwa,urgent,'xz',order,ur2)
           if (it.eq.1) goto 300
              sixz = iwa
              sjxz = jwa
              skxz = kwa

        else if (rulcy(ip).eq.1.and.rulcz(ip).eq.1.
     1      and.rulcx(ip).eq.0.and.iterms.gt.10) then
           if (iwa.eq.ksiyz.and.jwa.eq.ksjyz.and.kwa.eq.kskyz) goto 70

           if (ksiyz.ne.0.or.(iwa.eq.siyz.and.jwa.eq.sjyz.
     1         and.kwa.eq.skyz)) goto 300
70         it = testuv(iterms,ja,ka,ia(jp),jp,j,k,i,maxc,
     1     nx,ny,nz,charm,dm,iwa,jwa,kwa,urgent,'yz',order,ur2)
           if (it.eq.1) goto 300
           siyz = iwa
           sjyz = jwa
           skyz = kwa
c now test for fourth order stuff
        else if (rulcx(ip).eq.1.and.rulcy(ip).eq.1.
     1    and.rulcz(ip).eq.1.and.iterms.eq.35) then
          it = testxyz(iterms,ia,ja,ka,jp,i,j,k,maxc,
     .           nx,ny,nz,charm,dm,iwa,jwa,kwa,order)
          if (it.eq.1) goto 300

        else if (rulcx(ip).eq.0.and.rulcy(ip).eq.3.
     1    and.rulcz(ip).eq.1.and.yzurg.eq.1) then

          it = testuuuv(iterms,ja,ka,ia,jp,j,k,i,maxc,
     .         nx,ny,nz,charm,dm,jwa,kwa,iwa,order,'yyyz')
          if (it.eq.1) goto 300


        else if (rulcx(ip).eq.3.and.rulcy(ip).eq.1.
     1    and.rulcz(ip).eq.0.and.xyurg.eq.1) then

          it = testuuuv(iterms,ia,ja,ka,jp,i,j,k,maxc,
     .         nx,ny,nz,charm,dm,iwa,jwa,kwa,order,'xxxy')
          if (it.eq.1) goto 300

        else if (rulcx(ip).eq.1.and.rulcy(ip).eq.0.
     1    and.rulcz(ip).eq.3.and.xzurg.eq.1) then

          it = testuuuv(iterms,ka,ia,ja,jp,k,i,j,maxc,
     .         nx,ny,nz,charm,dm,kwa,iwa,jwa,order,'zzzx')
          if (it.eq.1) goto 300

        else if (rulcx(ip).eq.2.and.rulcy(ip).eq.1.
     1    and.rulcz(ip).eq.0.and.iterms.eq.35) then
          it = testuuv(iterms,ia,ja(jp),ka(jp),jp,i,j,k,maxc,
     1    nx,ny,nz,charm,dm,iwa,jwa,kwa,urgent,'xxy',order)
          if (it.eq.1) goto 300

        else if (rulcx(ip).eq.1.and.rulcy(ip).eq.2.
     1    and.rulcz(ip).eq.0.and.iterms.eq.35) then
          it = testuuv(iterms,ja,ia(jp),ka(jp),jp,j,i,k,maxc,
     1    nx,ny,nz,charm,dm,jwa,iwa,kwa,urgent,'yyx',order)
          if (it.eq.1) goto 300

        else if (rulcx(ip).eq.2.and.rulcy(ip).eq.0.
     1    and.rulcz(ip).eq.1.and.iterms.eq.35) then
          it = testuuv(iterms,ia,ka(jp),ja(jp),jp,i,k,j,maxc,
     1    nx,ny,nz,charm,dm,iwa,kwa,jwa,urgent,'xxz',order)
          if (it.eq.1) goto 300

        else if (rulcx(ip).eq.1.and.rulcy(ip).eq.0.
     1    and.rulcz(ip).eq.2.and.iterms.eq.35) then
          it = testuuv(iterms,ka,ia(jp),ja(jp),jp,k,i,j,maxc,
     1    nx,ny,nz,charm,dm,kwa,iwa,jwa,urgent,'zzx',order)
          if (it.eq.1) goto 300

        else if (rulcx(ip).eq.0.and.rulcy(ip).eq.2.
     1    and.rulcz(ip).eq.1.and.iterms.eq.35) then
          it = testuuv(iterms,ja,ka(jp),ia(jp),jp,j,k,i,maxc,
     1    nx,ny,nz,charm,dm,jwa,kwa,iwa,urgent,'yyz',order)
          if (it.eq.1) goto 300

        else if (rulcx(ip).eq.0.and.rulcy(ip).eq.1.
     1    and.rulcz(ip).eq.2.and.iterms.eq.35) then
          it = testuuv(iterms,ka,ja(jp),ia(jp),jp,k,j,i,maxc,
     1    nx,ny,nz,charm,dm,kwa,jwa,iwa,urgent,'zzy',order)
          if (it.eq.1) goto 300

        else if (rulcx(ip).eq.0.and.rulcy(ip).eq.2.
     1    and.rulcz(ip).eq.2.and.ip.eq.31) then
          if (iwa.eq.siy2.and.jwa.eq.sjy2.
     1         and.kwa.eq.sky2) goto 300
           siy2 = iwa
           sjy2 = jwa
           sky2 = kwa
        end if

        return
300     continue
        it =1
        return
        end


      subroutine evalc_3(nx,ny,nz,iterms,pil,coeff,u,wdc,soln)
      implicit none
      include 'terms.inc'
      integer nx,ny,nz,pil,iterms
      real*8       coeff(iterms,iterms+4,pil),u(nx,ny,nz),soln(pil)
      real*8       mat(i40,i40),rhs(i40)
      real*8       arr1d(i40*i40)
      integer ipvt(i40),ls,wd
      character*4 wdc
      integer i,j,l,ii,jj,kk,ll
      logical debug
      debug = .false.
      if (debug) then
          do l=1,pil
             write(91,*) l
             do j=1,iterms
                do i=1,iterms
                   write(91,'(e10.4,$)') coeff(j,i,l)
                end do
                write(91,'(f6.1,$)') coeff(j,iterms+1,l)
                write(91,'(f6.1$)') coeff(j,iterms+2,l)
                write(91,'(f6.1$)') coeff(j,iterms+3,l)
                write(91,'(f6.1)') coeff(j,iterms+4,l)
             end do
          end do
       end if

c find out which derivative to get ...
      call getd(wdc,wd)
c wd is which derivative ......
      do ll=1,pil
       do i=1,iterms
         do j=1,iterms
            mat(i,j) = coeff(i,j,ll)
         end do
         ii = int(coeff(i,iterms+1,ll))
         jj = int(coeff(i,iterms+2,ll))
         kk = int(coeff(i,iterms+3,ll))
         ipvt(i) = int(coeff(i,iterms+4,ll))
         if (ii.ge.1.and.ii.le.nx.and.jj.ge.1.and.jj.le.ny.and.
     .       kk.ge.1.and.kk.le.nx) then
               rhs(i) = u(ii,jj,kk)
         else
            rhs(i) = 0.0e0
         end if
       end do
       call sgesl(mat,i40,iterms,ipvt,rhs,0)
c now copy rhs into soln
         soln(ll) = rhs(wd)
      end do
      return
      end
c----------------------------------------------------------------------------
      subroutine getd(wdc,wd)
      implicit none
      include 'terms.inc'
      character*4 wdc
      character*4 derivs1(i40)
      integer wd

      data derivs1/'____','x___','y___','z___','xx__','yy__',
     .             'zz__','xy__','xz__','yz__',
     .             'xxx_','yyy_','zzz_','xxy_','xyy_','xxz_','xzz_',
     .             'yyz_','yzz_','xyz_',
     .             'xxxx','yyyy','zzzz','xxxy','xxxz','xyyy',
     .             'xzzz','yyyz','yzzz','xxyy','xxzz','yyzz',
     .             'xxyz','xyyz','xyzz' /



      integer iwd,i
      do i=1,15
        if (wdc.eq.derivs1(i)) then
           wd = i
           return
        endif
      end do
      write(6,*) 'Doesnt seem to be a valid derivative ....., run again'
      stop
      end
c-----------------------------------------------------------------------
      subroutine evalc3d(nx,ny,nz,order,pil,coeff,u,wdc,soln)
      integer nx,ny,nz,order,pil
      real*8       coeff(*)
      real*8       u(*)
      real*8       soln(*)
      character*(*) wdc

      include 'terms.inc'
      call evalc_3(nx,ny,nz,soc(order),pil,coeff,u,wdc,soln)
      return
      end
c-----------------------------------------------------------------------
      subroutine smoments(wp,iterms,pil,moments,smom,disi,dmom,
     .                   iuterms,juterms,kuterms,nx)
      implicit none
      include 'terms.inc'
      integer iterms,pil,disi,dmom(pil)
      real*8       moments(i40),smom(i40,pil)
      integer i,j,k,l,wp,tt,nx,iuterms(i40),juterms(i40),kuterms(i40)
      real*8       diff,small
      parameter(small=1.0e-06)
      real*8       t1(i40),t2(i40),t3(i40)
      real*8       tabx(4),taby(4),tabz(4),tmp1,tmp2,tmp3
      data tabx/+1.0e0,+1.0e0,+1.0e0,+1.0e0/
      data taby/+1.0e0,+1.0e0,-1.0e0,-1.0e0/
      data tabz/+1.0e0,-1.0e0,+1.0e0,-1.0e0/

c check everything to see if we have a distinct item
      do 200 i=1,disi
         if ((abs(moments(7)-smom(7,i)).lt.small).and.
     .       (abs(moments(8)-smom(8,i)).lt.small).and.
     .       (abs(moments(9)-smom(9,i)).lt.small)) then
            do j=1,4
               tmp1 = tabx(j)*taby(j)
               tmp2 = tabx(j)*tabz(j)
               tmp3 = taby(j)*tabz(j)
               if ((abs(tmp1*moments(10)-smom(10,i)).lt.small).and.
     .             (abs(tmp2*moments(11)-smom(11,i)).lt.small).and.
     .             (abs(tmp3*moments(12)-smom(12,i)).lt.small)) goto 100
            end do
            goto 200
          end if
          goto 200
100       continue
c we made it here, so we must of had this point before
         dmom(i) = dmom(i) + 1
         write(98,*) 'Point ',wp, ' is stencil',i
         do tt = 1,iterms
            t1(tt) = iuterms(tt)
            t2(tt) = juterms(tt)
            t3(tt) = kuterms(tt)
         end do

C         vsrc = vsxynt('stencil'//char(i),1.0e0*dmom(i),t1,t2,iterms)
         goto 300
200      continue
c NEW ITEM SO WE ARE IN THIS PART OF LOOP
         disi = disi + 1
         dmom(disi) = 1
         write(98,*) 'Point ',wp, ' is stencil',disi
         do l=1,40
            smom(l,disi) = moments(l)
         end do
         do tt = 1,iterms
            t1(tt) = iuterms(tt)
            t2(tt) = juterms(tt)
            t3(tt) = kuterms(tt)
         end do
C          vsrc = vsxynt('stencil'//char(disi),1.0e0,t1,t2,iterms)
300      continue
         return
         end

c-----------------------------------------------------------------------
       subroutine moments(iterms,iuterms,juterms,kuterms,nx,ii)
c evaluate the stencil by moments to see what type we have .......
      implicit none
      include 'terms.inc'

      integer iuterms(iterms),juterms(iterms),kuterms(iterms),nx
      integer iterms,ia(i40),ja(i40),ka(i40),box(6),axis(3)
      real*8       x(i40),y(i40),z(i40),cx,cy,cz
      real*8       rx(i40),ry(i40),rz(i40)
      real*8       ii(i40)
      integer i
      logical debug
      debug = .true.

      call read_point(nx,iuterms,juterms,kuterms,ia,ja,ka,iterms)
      call define_box(ia,ja,ka,iterms,box)
      call getxys(ia,ja,ka,box,iterms,x,y,z)

      call get_cent(x,y,z,iterms,box,cx,cy,cz,ii)
      call get_newl(x,y,z,cx,cy,cz,iterms,rx,ry,rz)

      call get_moments(rx,ry,rz,iterms,ii)
      if (debug) then
         write(77,*)
         do i=1,10
            write(77,'(3f8.2)') x(i),y(i),z(i)
         end do
      end if
32    format(i2,3x,f12.6)
      return
      end

c---------------------------------------------------------------------
      subroutine read_point(nx,iuterms,juterms,kuterms,ia,ja,ka,iterms)
      implicit none
      integer iterms,ia(iterms),ja(iterms),ka(iterms)
      integer iuterms(iterms),juterms(iterms),kuterms(iterms)

      integer i,nx
      do i=1,iterms
         ia(i) = iuterms(i)
         ja(i) = juterms(i)
         ka(i) = kuterms(i)
      end do
      return
      end
c---------------------------------------------------------------------
      subroutine define_box(ia,ja,ka,ssz,box)
      implicit none
      integer ssz,ia(ssz),ja(ssz),ka(ssz),box(6)

      integer i,j,k,mini,minj,mink,maxi,maxj,maxk

      mini = 99999
      minj = 99999
      mink = 99999
      maxi =-99999
      maxj =-99999
      maxk =-99999

      do i=1,ssz
         if (ia(i).le.mini) mini=ia(i)
         if (ia(i).ge.maxi) maxi=ia(i)
      end do

      do j=1,ssz
         if (ja(j).le.minj) minj=ja(j)
         if (ja(j).ge.maxj) maxj=ja(j)
      end do

      do k=1,ssz
         if (ka(k).le.mink) mink=ka(k)
         if (ka(k).ge.maxk) maxk=ka(k)
      end do

      box(1) = mini
      box(2) = maxi
      box(3) = minj
      box(4) = maxj
      box(5) = mink
      box(6) = maxk

      return
      end
c---------------------------------------------------------------------
      subroutine getxys(ia,ja,ka,box,ssz,x,y,z)
      implicit none
      include 'terms.inc'
      integer ssz,ia(ssz),ja(ssz),ka(ssz),box(6)
      real*8       x(ssz),y(ssz),z(ssz)
      real*8       x1(i40),y1(i40),z1(i40)
      real*8       x2(i40),y2(i40),z2(i40)
      integer i

      do i=1,ssz
            x(i) = 1.0e0*(ia(i) -box(1) )
            y(i) = 1.0e0*(ja(i) -box(3) )
            z(i) = 1.0e0*(ka(i) -box(5) )
      end do

      return
      end
c---------------------------------------------------------------------
      subroutine get_cent(x,y,z,ssz,box,cx,cy,cz,ii)
      implicit none
      include 'terms.inc'
      integer ssz,box(6)
      real*8       x(ssz),y(ssz),z(ssz),cx,cy,cz
      real*8       ii(i40)

      integer i,j
      real*8       sumx,sumy,sumz

      sumx = 0.0e0
      sumy = 0.0e0
      sumz = 0.0e0

      do i=1,ssz
         sumx = sumx + x(i)
         sumy = sumy + y(i)
         sumz = sumz + z(i)
      end do

      cx = sumx/ssz
      cy = sumy/ssz
      cz = sumz/ssz
      ii(1) = cx
      ii(2) = cy
      ii(3) = cz

      return
      end
c---------------------------------------------------------------------
      subroutine get_newl(x,y,z,cx,cy,cz,ssz,rx,ry,rz)
      integer ssz
      real*8       x(ssz),y(ssz),z(ssz),cx,cy,cz
      real*8       rx(ssz),ry(ssz),rz(ssz)

      integer i

      do i=1,ssz
         rx(i) = x(i) - cx
         ry(i) = y(i) - cy
         rz(i) = z(i) - cz
      end do

      return
      end
c---------------------------------------------------------------------
      subroutine get_moments(rx,ry,rz,ssz,ii)
      implicit none
      include 'terms.inc'
      integer ssz
      real*8       rx(ssz),ry(ssz),rz(ssz)
      real*8       ii(sz),magx,magy,magz,tmag,ttmag(sz)

      integer i,mn

      magx = ssz
      magy = ssz
      magz = ssz

c note first three moments should always be zero
      mn = 4

      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)
      end do
      ii(mn) = ii(mn)/magx

      mn = 5
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)
      end do
      ii(mn) = ii(mn)/magy

      mn = 6
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rz(i)
      end do
      ii(mn) = ii(mn)/magz

      mn = 7
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rx(i)
      end do
      ii(mn) = ii(mn)/magx/magx

      mn = 8
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magy/magy

      mn = 9
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rz(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magz/magz

      if(ii(8).ge.ii(7).and.ii(8).ge.ii(9)) then
             if (ii(7).ge.ii(9)) then
c (x,y,z) = y,x,z
                ii(10) = ii(7)
                ii(7) = ii(8)
                ii(8) = ii(10)
                ii(9) = ii(9)
                do i=1,ssz
                   ttmag(i) = rx(i)
                   rx(i) = ry(i)
                   ry(i) = ttmag(i)
                   rz(i) = rz(i)
                end do
             else
c (x,y,z) = y,z,x
                ii(10) = ii(7)
                ii(7) = ii(8)
                ii(8) = ii(9)
                ii(9) = ii(10)
                do i=1,ssz
                   ttmag(i) = rx(i)
                   rx(i) = ry(i)
                   ry(i) = rz(i)
                   rz(i) = ttmag(i)
                end do
             end if
      else if (ii(9).ge.ii(7).and.ii(9).ge.ii(8)) then
             if (ii(7).ge.ii(8)) then
c (x,y,z) = z,x,y
                ii(10) = ii(7)
                ii(7) = ii(9)
                ii(9) = ii(8)
                ii(8) = ii(10)
                do i=1,ssz
                   ttmag(i) = rx(i)
                   rx(i) = rz(i)
                   rz(i) = ry(i)
                   ry(i) = ttmag(i)
                end do
             else
c (x,y,z) = z,y,x
                ii(10) = ii(7)
                ii(7) = ii(9)
                ii(8) = ii(8)
                ii(9) = ii(10)
                do i=1,ssz
                   ttmag(i) = rx(i)
                   rx(i) = rz(i)
                   ry(i) = ry(i)
                   rz(i) = ttmag(i)
                end do
             end if
       end if


      mn = 10
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magx/magy

      mn = 11
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magx/magz


      mn = 12
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magy/magz
c now recenter accordingly   .....

      mn = 13
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rx(i)*rx(i)
      end do
      ii(mn) = ii(mn)/magx/magx/magx

      mn = 14
      ii(mn) = 0.0e00
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*ry(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magy/magy/magy

      mn = 15
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rz(i)*rz(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magz/magz/magz

      mn = 16
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rx(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magx/magx/magy

      mn = 17
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*ry(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magx/magy/magy

      mn = 18
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rx(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magx/magx/magz

      mn = 19
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rz(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magx/magz/magz

      mn = 20
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*ry(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magy/magy/magz

      mn = 21
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*rz(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magy/magz/magz

      mn = 22
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*ry(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magx/magy/magz
      end
c-----------------------------------------------------------------------------
      subroutine evalbh_(nx,ny,nz,iterms,pil,coeff,u,
     .                  solnx,solny,solnz,solnu)
      implicit none
      include 'terms.inc'
      integer nx,ny,nz,pil,iterms
      real*8       coeff(iterms,iterms+4,pil),u(nx,ny,nz)
      real*8       solnx(pil),solny(pil),solnz(pil),solnu(pil)
      real*8       mat(i40,i40),rhs(i40)
      real*8       arr1d(i40*i40)
      integer ipvt(i40),ls,wd
      character*4 wdc
      integer i,j,l,ii,jj,kk,ll
      logical debug
      debug = .false.

      if (debug) then
          do l=1,pil
             write(91,*) l
             do j=1,iterms
                do i=1,iterms
                   write(91,'(1P,e10.2,$)') coeff(j,i,l)
                end do
                write(91,'(f6.0,$)') coeff(j,iterms+1,l)
                write(91,'(f6.0$)') coeff(j,iterms+2,l)
                write(91,'(f6.0$)') coeff(j,iterms+3,l)
                write(91,'(f6.0)') coeff(j,iterms+4,l)
             end do
          end do
       end if

c wd is which derivative ......
      do ll=1,pil
       do i=1,iterms
         do j=1,iterms
            mat(i,j) = coeff(i,j,ll)
         end do
         ii = int(coeff(i,iterms+1,ll))
         jj = int(coeff(i,iterms+2,ll))
         kk = int(coeff(i,iterms+3,ll))
         ipvt(i) = int(coeff(i,iterms+4,ll))
         if (ii.ge.1.and.ii.le.nx.and.jj.ge.1.and.jj.le.ny.and.
     .       kk.ge.1.and.kk.le.nx) then
               rhs(i) = u(ii,jj,kk)
         else
            rhs(i) = 0.0e0
         end if
       end do
       call sgesl(mat,i40,iterms,ipvt,rhs,0)
c now copy rhs into soln
         solnu(ll) = rhs(1)
         solnx(ll) = rhs(2)
         solny(ll) = rhs(3)
         solnz(ll) = rhs(4)
      end do

		write(91,*) '*******************eof***********'
      return
      end
c-----------------------------------------------------------------------
      subroutine evalbh( nx,ny,nz,order,pil,coeff,u,
     .                    solnx,solny,solnz,solnu )
      integer nx,ny,nz,order,pil
      real*8       coeff(*)
      real*8       u(*)
      real*8       solnx(*),solny(*),solnz(*),solnu(*)

      include 'terms.inc'
      call evalbh_( nx,ny,nz,soc(order),pil,coeff,u,
     .              solnx,solny,solnz,solnu )
      return
      end
c-----------------------------------------------------------------------

