C Made by Scott Klasky ..... 
C modified the 2D version starting on January 5,1993.....

        subroutine coeff3d(nx,ny,nz,charm,x,y,z,pil,listx,listy,listz,
     .                     order,comat)
        include 'terms.inc'
        integer order,nx,ny,nz
        real*8 charm(nx,ny,nz)
        integer iterms,pil
        real*8 listx(pil),listy(pil),listz(pil)
        real*8 dx,dy,dz,x(nx),y(ny),z(nz)
        real*8 comat(*) 
        call coeff_3(nx,ny,nz,charm,x,y,z,pil,listx,listy,listz,
     .               soc(order),comat,order)
        return
        end
C---------------------------------------------------------------------
      subroutine coeff_3(nx,ny,nz,charm,x,y,z,pil,listx,listy,listz,
     .                     iterms,comat,order)
CFPP$ EXPAND (getcircm)
        implicit none
        include 'terms.inc'
        integer nx,ny,nz
        real*8 charm(nx,ny,nz)
        integer iterms,pil
        integer maxt
        parameter(maxt=10)
        real*8 listx(pil),listy(pil),listz(pil)
        real*8 dx,dy,dz,x(nx),y(ny),z(nz)
        real*8 comat(iterms,iterms+4,pil) 
        real*8 mat(i40,i40)
        integer order,iuterms(i40),juterms(i40),kuterms(i40),ipvt(i40)
C comat is 1-iterms is coeff matrix,next column is l number and last is ipvt
C last part of array is for each point in the list
C iterms is number of terms to use , i.e. 15 is 4th, 10 is 3rd order ...
        integer i,j,k,ip,jp,kp,upnts,iwa,jwa,kwa,l
        integer ii,jj,kk,get_val,first_time,maxtries
        integer it,cx,cy,cz,spc1,spc2,spc3
        integer dm(9,9,9),maxc,d18,d20,d21
        integer siyz,sjyz,skyz,sixy,sjxy,skxy,sixz,sjxz,skxz
        integer siy2,sjy2,sky2
        integer ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        common /k/ ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        common /sc/ sixy,sjxy,skxy,sixz,sjxz,skxz,siyz,sjyz,skyz
     .             ,siy2,sjy2,sky2
        common /d/ d18,d20,d21
        real*8 xx,yy,zz,xn,yn,zn,sgn
        real*8 dxa(sz),dya(sz),dza(sz),sa(sz),dxtc,dytc,dztc
        integer ia(sz),ja(sz),ka(sz),ias,jas,kas
        integer rulcx(i40),rulcy(i40),rulcz(i40)
        real*8 ruldx(i40),ruldy(i40),ruldz(i40)
        integer ifail,urgent,xyzurgent,yzurg,xyurg,xzurg,idum,ur2
        integer disi,maxpil
        parameter (maxpil=4000)
        integer dmom(maxpil)
        real*8 mmoments(i40),smom(i40,maxpil)
        logical pmdebug,debug
        
        debug=.false.
        pmdebug=.false.
        if (pmdebug) open(80,file='matrix.dat')
C        open(99,file='stencil.dat')
C        open(98,file='stencil2.dat')

        if ((iterms*(iterms+4)*pil).gt.coeffsize) then
           write(0,*) '***Too many points, try again***'
           stop
        end if
        call rulc(rulcx,rulcy,rulcz,iterms)
C assume uniform grid so ...
        dx = abs( x(2)-x(1) )
        dy = abs( y(2)-y(1) )
        dz = abs( z(2)-z(1) )
        call getrules(dx,dy,dz,rulcx,rulcy,rulcz,
     .                ruldx,ruldy,ruldz,iterms,maxc)


        do 100 l=1,pil
           write(6,*) l
        call zero()
      
        maxtries = 0
        if (xyzurgent.eq.1) 
     .      call getrules(dx,dy,dz,rulcx,rulcy,rulcz,
     .                    ruldx,ruldy,ruldz,iterms,maxc)
        yzurg = 0
        xyurg = 0
        xzurg = 0
        spc1 = 0
        spc2 = 0
        spc3 = 0
50      continue
        maxtries = maxtries + 1
        if (maxtries.gt.maxt) then
           write(6,*) '****MAJOR ERROR ****'
           stop 
        end if
         urgent=0
         ur2 = 0
         xyzurgent=0
         first_time=1
C get i and j values from list values
         xn = listx(l)
         yn = listy(l)
         zn = listz(l)
C now we need to get the coresponding i and j values ......
         ii = get_val(xn,x,nx)
         jj = get_val(yn,y,ny)
         kk = get_val(zn,z,nz)
C Now this point might be at a bad location we must check to make sure that
C it will be fine.......
C we will do this by seeing if we can get the maxc in each direction ....
         call find_ijk(ii,jj,kk,nx,ny,nz,maxc,charm,i,j,k)
         xx = x(i)
         yy = y(j)
         zz = z(k)
         call get_arrays(i,j,k,upnts,sa,ia,ja,ka,charm,dxa,dya,dza,
     .                   nx,ny,nz,x,y,z,xn,yn,zn)
C now sort this array according to sa ........
           call sort(upnts,sa,ia,ja,ka,dxa,dya,dza)
C array is now sorted, now set up circumference arrays
           call zero_dm(maxc,dm,iterms)

C now we have a set of rules for each of the terms ......

          do 200 ip=1,iterms
C now go through each point and then see if point obeys rules 
150         continue
            do 300 jp=1,upnts 
C now we center? point around boundary point... so 
              if (ia(jp).lt.0) goto 300
C kick out if we used this point
              if (ip.eq.1.and.(ia(jp).ne.i.or.ja(jp).ne.j.or.
     .                         ka(jp).ne.k)) goto 300
C we want the first point to be the point thats on the list..
              dxtc = abs(dxa(jp) + (xn-xx) ) + dx/100.0e0
              dytc = abs(dya(jp) + (yn-yy) ) + dy/100.0e0
              dztc = abs(dza(jp) + (zn-zz) ) + dz/100.0e0
C we are we on the (2maxc-1)*(2maxc-1)*(2maxc-1)
C (i,j,k) is at (maxc,maxc,maxc) so ....
              iwa = maxc - ( i - ia(jp) )
              jwa = maxc - ( j - ja(jp) )
              kwa = maxc - ( k - ka(jp) )
C check circumference test ....
C determine cx and cy and cz,... note they must be connected points to add
C so they are a measure of the connected points ....


              if (first_time.eq.0.and.(ip.le.4)) then
C we must be only 1 off in ias,jas,kas
                 idum = abs(ias-iwa)+abs(jas-jwa)+abs(kas-kwa)
                 if (idum.gt.1) goto 300 
              end if

C check dx and dy and dz test
              if (dxtc.ge.ruldx(ip).and.dytc.ge.ruldy(ip).and.
     .            dztc.ge.ruldz(ip) ) then
C one more test for straight derivatives....
C this was last test added due to center differencing off of a point that
C is not the closest to the point we are determining
                if ((rulcx(ip).eq.0.or.rulcy(ip).eq.0.or.
     1           rulcz(ip).eq.0).and.
     2           (dxtc.gt.dx.and.dytc.gt.dy.and.dztc.gt.dz)) goto 300 


                 if (iwa.gt.0.and.jwa.gt.0.and.kwa.gt.0.and.
     .               iwa.le.2*maxc-1.and.jwa.le.2*maxc-1.and.
     .               kwa.le.2*maxc-1) then
                   call getcircm(cx,cy,cz,dm,maxc,
     .                           iwa,jwa,kwa,iterms,order)
                 else
                     cx = 0
                     cy = 0
                     cz = 0
                 end if

                 if (cx.ge.1+rulcx(ip).and.cy.ge.1+rulcy(ip).and.
     .               cz.ge.1+rulcz(ip) ) then


                   if (iterms.gt.10.and.(maxt-maxtries).ge.3.
     .                and.ur2.eq.0) then
                      call special_test(iterms,rulcx,rulcy,rulcz,ip,
     1                     iwa,jwa,kwa,ia,ja,ka,i,j,k,jp,
     2                     nx,ny,nz,charm,dm,urgent,order,
     3                     yzurg,xyurg,xzurg,upnts,maxc,it,ur2) 
                       if (it.eq.1) goto 300
                   else
                      ur2=1
                      call special_test(iterms,rulcx,rulcy,rulcz,ip,
     1                     iwa,jwa,kwa,ia,ja,ka,i,j,k,jp,
     2                     nx,ny,nz,charm,dm,urgent,order,
     3                     yzurg,xyurg,xzurg,upnts,maxc,it,ur2) 
                       if (it.eq.1) goto 300
                   end if

C this point is a good point, so update cx,cy and comat ....
999             dm(iwa,jwa,kwa) = 1

                if (first_time.eq.1) then
                   ias = iwa
                   jas = jwa
                   kas = kwa
                   first_time=0
                endif
C update matrix values ....
                call upmat(nx,iterms,mat,ip,jp,dxa,dya,dza,
     .                    ia,ja,ka,iuterms,juterms,kuterms)
C keep values of sixy,sixz,siyz when appropriate...
                if (ip.eq.18.and.d18.eq.0) then
                   ksixy=sixy
                   ksjxy=sjxy
                   kskxy=skxy
                   d18=1
                else if (ip.eq.20.and.d20.eq.0) then
                   ksixz=sixz
                   ksjxz=sjxz
                   kskxz=skxz
                   d20 = 1
                else if (ip.eq.21.and.d21.eq.0) then
                   ksiyz=siyz
                   ksjyz=sjyz
                   kskyz=skyz
                   d21 = 1
                end if
 
C now zero out this point in the array of ia,ja
                ia(jp) = -99999
                goto 200
               end if 
            end if
300        continue
C if we made it here then we found no matches .....
             if (xyzurgent.eq.1) then
                 write(6,*) 'BIG ERROR' 
                 stop
             end if
             if (ip.eq.23) then
C let's try to do the xxyy,xxzz,and yyzz points before this one ...
               call changecxy(iterms,rulcx,rulcy,rulcz
     .                        ,ruldx,ruldy,ruldz,dx,dy,dz)
               call zero()
               xyzurgent=1
               goto 50
             else if (ip.eq.31.or.ip.eq.35) then
C try this to see if it works ......
                ksixz = 0
                ksjxz = 0
                kskxz = 0
                d20 = 0
C thus we must pick a new yz point ...
                yzurg=1
                goto 50
             else if (ip.eq.29.or.ip.eq.33) then
                xyurg=1
                goto 50
             else if (ip.eq.30.or.ip.eq.34) then
                xzurg=1
                goto 50
             end if 

             
             if (urgent.eq.0) then
               if (debug) then
                 write(6,*) '*****MAJOR ERROR.... WE CAN NOT MATCH ****'
                 write(6,*) 'TRYING URGENT TEST *****'
               end if
               urgent = 1
               goto 150
             else
               if (debug) 
     .         write(6,*) '*****MAJOR ERROR.... WE CAN NOT MATCH ****'
               if (ip.eq.17.or.ip.eq.18) then
                  spc1 = 1
                  if (spc2.eq.0) sixz=0 
                  if (spc3.eq.0) siyz=0
               else if (ip.eq.19.or.ip.eq.20) then
                  spc2 = 1
                  if (spc1.eq.0) sixy=0
                  if (spc3.eq.0) siyz=0
               else if (ip.eq.21.or.ip.eq.22) then
                  spc3 = 1
                  if (spc1.eq.0) sixy=0
                  if (spc2.eq.0) sixz=0
               end if
                   
               goto 50
             end if
200        continue
C   now we have the matrices ....
           if (pmdebug) call printmat(iterms,mat,nx,
     .                iuterms,juterms,kuterms,l)
C           call moments(iterms,iuterms,juterms,kuterms,nx,mmoments) 
C           call smoments(l,iterms,pil,mmoments,smom,disi,dmom,
C     .                   iuterms,juterms,kuterms,nx)


			call flowmark('sgefa')
           call sgefa(mat,i40,iterms,ipvt,ifail)
			call flowmark(0)
           if (ifail.ne.0) then
              write(*,*) '*****ERROR with routine'
              stop
           end if
C now copy information into the 1 big array
           call copy_ba(iterms,mat,iuterms,juterms,kuterms,
     .                  ipvt,comat,pil,l)
100    continue
       if (debug) then
          do l=1,pil
             write(90,*) l
             do j=1,iterms
                do i=1,iterms
                   write(90,'(e10.4,$)') comat(j,i,l)
                end do
                write(90,'(f6.1,$)') comat(j,iterms+1,l)
                write(90,'(f6.1,$)') comat(j,iterms+2,l)
                write(90,'(f6.1,$)') comat(j,iterms+3,l)
                write(90,'(f6.1)') comat(j,iterms+4,l)
             end do
          end do
       end if
C write out results for distinct stencils ....
C       write(99,*) 'Tabulations for different stencils'
C       write(99,*) 'There are ', disi, ' different stencils'
C       do l=1,disi
C          write(99,'(2i5,$)') l,dmom(l)
C          do i=7,12
C             write(99,'(f9.4,$)') smom(i,l)
C          end do
C          write(99,*)
C       end do

       return
       end 

        subroutine sort(upnts,sa,ia,ja,ka,dxa,dya,dza)
        implicit none
        include 'terms.inc'
        integer usp,unpnts,upnts,uspnts,ip,jp,kp,il
        real*8 slarge
        real*8 dxa(upnts),dya(upnts),dza(upnts),sa(upnts)
        integer ia(upnts),ja(upnts),ka(upnts)
        real*8 tdxa(sz),tdya(sz),tdza(sz),tsa(sz)
        integer i,index(sz),tia(sz),tja(sz),tka(sz)


       do i=1,upnts
          index(i)=i
       end do

        call batcher(sa,index,upnts)
        do i=1,upnts
           tdxa(i) = dxa(index(i))
           tdya(i) = dya(index(i))
           tdza(i) = dza(index(i))
           tia(i) = ia(index(i))
           tja(i) = ja(index(i))
           tka(i) = ka(index(i))
       end do
        do i=1,upnts
           dxa(i) = tdxa(i)
           dya(i) = tdya(i)
           dza(i) = tdza(i)
           ia(i) = tia(i)
           ja(i) = tja(i)
           ka(i) = tka(i)
       end do
       return
       end
           real*8 function sgn(a)
           real*8 a
           if (a.gt.0.0e0) then
              sgn=1.0e0
           else if (a.lt.0.0e0) then
              sgn=-1.0e0
           else
              sgn=0.0e0
           end if
           return
           end 

           integer function get_val(val,ar,n)
           integer i,j,k,n
           real*8 val,ar(n),diff,mindiff
           mindiff = 9999.99
           do i=1,n
              diff = abs(val-ar(i))
              if (diff.lt.mindiff) then
                 get_val=i
                 mindiff=diff
              end if
           end do
           return
           end


        subroutine getrules(dx,dy,dz,rulcx,rulcy,rulcz,
     .                      ruldx,ruldy,ruldz,iterms,maxc)
        implicit none
        include 'terms.inc'
        real*8 dx,dy,dz,ruldx(i40),ruldy(i40),ruldz(i40)
        integer rulcx(i40),rulcy(i40),rulcz(i40)
        integer i,iterms,maxc

        do i=1,iterms
           if (rulcx(i).gt.0) then
              ruldx(i)=dx
           else
              ruldx(i)=0.0e0
           end if
           if (rulcy(i).gt.0) then
              ruldy(i)=dy
           else
              ruldy(i)=0.0e00
           end if
           if (rulcz(i).gt.0) then
              ruldz(i)=dz
           else
              ruldz(i)=0.0e0
           end if
        end do

C define max circumferenc
        if (iterms.eq.4) then
           maxc=2
        else if (iterms.eq.10) then
           maxc=3
        else if (iterms.eq.20) then
           maxc=4
        else
           maxc=5
        end if

        return
        end

        subroutine rulc(rulcx,rulcy,rulcz,iterms)
        implicit none
        include 'terms.inc'
        integer iterms,rulcx(i40),rulcy(i40),rulcz(i40)
C        rules for getting derivatives
C        mixed derivatives are at end of list .....
        if (iterms.lt.11) then
           rulcx(1) = 0
           rulcx(2) = 1
           rulcx(3) = 0
           rulcx(4) = 0
           rulcx(5) = 2
           rulcx(6) = 0
           rulcx(7) = 0
           rulcx(8) = 1
           rulcx(9) = 1
           rulcx(10) =0

           rulcy(1) = 0
           rulcy(2) = 0
           rulcy(3) = 1
           rulcy(4) = 0
           rulcy(5) = 0
           rulcy(6) = 2
           rulcy(7) = 0
           rulcy(8) = 1
           rulcy(9) = 0
           rulcy(10) =1

           rulcz(1) = 0
           rulcz(2) = 0
           rulcz(3) = 0
           rulcz(4) = 1
           rulcz(5) = 0
           rulcz(6) = 0
           rulcz(7) = 2
           rulcz(8) = 0
           rulcz(9) = 1
           rulcz(10) =1
        else if (iterms.lt.21) then
           rulcx(1) = 0
           rulcx(2) = 1
           rulcx(3) = 0
           rulcx(4) = 0
           rulcx(5) = 2
           rulcx(6) = 0
           rulcx(7) = 0
           rulcx(8) = 3
           rulcx(9) = 0
           rulcx(10) =0
           rulcx(11) =1
           rulcx(12) =1
           rulcx(13) =0
           rulcx(14) =2
           rulcx(15) =1
           rulcx(16) =2
           rulcx(17) =1
           rulcx(18) =0
           rulcx(19) =0
           rulcx(20) =1

           rulcy(1) = 0
           rulcy(2) = 0
           rulcy(3) = 1
           rulcy(4) = 0
           rulcy(5) = 0
           rulcy(6) = 2
           rulcy(7) = 0
           rulcy(8) = 0
           rulcy(9) = 3
           rulcy(10) =0
           rulcy(11) =1
           rulcy(12) =0
           rulcy(13) =1
           rulcy(14) =1
           rulcy(15) =2
           rulcy(16) =0
           rulcy(17) =0
           rulcy(18) =2
           rulcy(19) =1
           rulcy(20) =1

           rulcz(1) = 0
           rulcz(2) = 0
           rulcz(3) = 0
           rulcz(4) = 1
           rulcz(5) = 0
           rulcz(6) = 0
           rulcz(7) = 2
           rulcz(8) = 0
           rulcz(9) = 0
           rulcz(10) =3
           rulcz(11) =0
           rulcz(12) =1
           rulcz(13) =1
           rulcz(14) =0
           rulcz(15) =0
           rulcz(16) =1
           rulcz(17) =2
           rulcz(18) =1
           rulcz(19) =2
           rulcz(20) =1
        else
           rulcx(1) = 0
           rulcx(2) = 1
           rulcx(3) = 0
           rulcx(4) = 0
           rulcx(5) = 2
           rulcx(6) = 0
           rulcx(7) = 0
           rulcx(8) = 3
           rulcx(9) = 0
           rulcx(10) =0
           rulcx(11) =4
           rulcx(12) =0
           rulcx(13) =0
           rulcx(14) =1
           rulcx(15) =1
           rulcx(16) =0
           rulcx(17) =2
           rulcx(18) =1
           rulcx(19) =2
           rulcx(20) =1
           rulcx(21) =0
           rulcx(22) =0
           rulcx(23) =1
           rulcx(24) =3
           rulcx(25) =3
           rulcx(26) =1
           rulcx(27) =1
           rulcx(28) =0
           rulcx(29) =0
           rulcx(30) =2
           rulcx(31) =1
           rulcx(32) =1
           rulcx(33) =2
           rulcx(34) =2
           rulcx(35) =0

           rulcy(1) = 0
           rulcy(2) = 0
           rulcy(3) = 1
           rulcy(4) = 0
           rulcy(5) = 0
           rulcy(6) = 2
           rulcy(7) = 0
           rulcy(8) = 0
           rulcy(9) = 3
           rulcy(10) =0
           rulcy(11) =0
           rulcy(12) =4
           rulcy(13) =0
           rulcy(14) =1
           rulcy(15) =0
           rulcy(16) =1
           rulcy(17) =1
           rulcy(18) =2
           rulcy(19) =0
           rulcy(20) =0
           rulcy(21) =2
           rulcy(22) =1
           rulcy(23) =1
           rulcy(24) =1
           rulcy(25) =0
           rulcy(26) =3
           rulcy(27) =0
           rulcy(28) =3
           rulcy(29) =1
           rulcy(30) =1
           rulcy(31) =2
           rulcy(32) =1
           rulcy(33) =2
           rulcy(34) =0
           rulcy(35) =2

           rulcz(1) = 0
           rulcz(2) = 0
           rulcz(3) = 0
           rulcz(4) = 1
           rulcz(5) = 0
           rulcz(6) = 0
           rulcz(7) = 2
           rulcz(8) = 0
           rulcz(9) = 0
           rulcz(10) =3
           rulcz(11) =0
           rulcz(12) =0
           rulcz(13) =4
           rulcz(14) =0
           rulcz(15) =1
           rulcz(16) =1
           rulcz(17) =0
           rulcz(18) =0
           rulcz(19) =1
           rulcz(20) =2
           rulcz(21) =1
           rulcz(22) =2
           rulcz(23) =1
           rulcz(24) =0
           rulcz(25) =1
           rulcz(26) =0
           rulcz(27) =3
           rulcz(28) =1
           rulcz(29) =3
           rulcz(30) =1
           rulcz(31) =1
           rulcz(32) =2
           rulcz(33) =0
           rulcz(34) =2
           rulcz(35) =2
        end if
        return
        end


         subroutine find_ijk(ii,jj,kk,nx,ny,nz,maxc,charm,i,j,k)
         implicit none
         include 'terms.inc'
         integer ii,jj,kk,i,j,k,nx,ny,nz
         real*8 charm(nx,ny,nz)
         integer maxc
         integer rulsi(sz),rulsj(sz),rulsk(sz)
         integer inp,mini,minj,mink,maxi,maxj,maxk,idummy,ic
         real*8 rulsd(sz),dum1(sz),dum2(sz),dum3(sz)

         ic = 0

         do k = -6,6
            do i = -6,6
               do j = -6,6
                  ic = ic + 1
                  rulsi(ic) = i
                  rulsj(ic) = j
                  rulsk(ic) = k
                  rulsd(ic) = i**2 + j**2 + k**2
                  dum1(ic) = 0.0e0
                  dum2(ic) = 0.0e0
                  dum3(ic) = 0.0e0
               end do
            end do
         end do
            call sort(ic,rulsd,rulsi,rulsj,rulsk,dum1,dum2,dum3)

C 320 loop gets the i and j and kto center difference from ....
         do 320 inp = 1,sz
            i = ii + rulsi(inp)
            j = jj + rulsj(inp)
            k = kk + rulsk(inp)
                    if (i.lt.1) i=1
                    if (j.lt.1) j=1
                    if (k.lt.1) k=1
                    if (i.gt.nx) i=nx
                    if (j.gt.ny) i=ny
                    if (k.gt.nz) k=nz
            if (charm(i,j,k).eq.(0.0e0)) goto 320
C we can't center difference off of a undefined point!!!
            mini=i-maxc
            minj=j-maxc
            mink=k-maxc
            maxi=i+maxc
            maxj=j+maxc
            maxk=k+maxc
            if (mini.lt.1) mini = 1
            if (minj.lt.1) minj=1
            if (mink.lt.1) mink=1
            if (maxi.gt.nx) maxi=nx
            if (maxj.gt.ny) maxj=ny
            if (maxk.gt.nz) maxk=nz
C these lines were to make sure we don't check outside of arrays....
C now begin check .....
            ic = 0
            do idummy=mini,maxi
               if (charm(idummy,j,k).ne.(0.0e0)) ic=ic+1
            end do
            if (ic.lt.maxc) goto 320
C we need a new point in the i-direction for our stencil .....
            ic = 0
            do idummy=minj,maxj
               if (charm(i,idummy,k).ne.(0.0e0)) ic=ic+1
            end do
            if (ic.lt.maxc) goto 320
            ic = 0
            do idummy=mink,maxk
               if (charm(i,j,idummy).ne.(0.0e0)) ic=ic+1
            end do
            if (ic.lt.maxc) goto 320
C Well if we are here then we can center difference the x and y derivatives
C NOTE: we have not checked the mixed derivatives.. if something real*8 funny
C is going on then this will not work!!!!!!!!
            goto 325
320         continue
            write(6,*) '**MAJOR ERRORR**, CAN NOT GET I,J VALUE'
            stop
325         continue
C well if we are here then we should be able to work!!!!!!
            return
            end

        subroutine zero_dm(maxc,dm,iterms)
        implicit none
        include 'terms.inc'
        integer iterms,maxc,dm(9,9,9)
        integer ip,jp,kp
        do kp=1,2*maxc-1
          do jp=1,2*maxc-1
            do ip=1,2*maxc-1
              dm(ip,jp,kp) = 0
            end do
          end do
        end do
        return
        end

         subroutine get_arrays(i,j,k,upnts,sa,ia,ja,ka,charm,
     .                         dxa,dya,dza,nx,ny,nz,x,y,z,xn,yn,zn)
         implicit none
         include 'terms.inc'
         integer i,j,k,upnts,ia(sz),ja(sz),ka(sz)
         integer nx,ny,nz
         real*8 charm(nx,ny,nz)
         real*8 dxa(sz),dya(sz),dza(sz),sa(sz),x(nx),y(ny)
         real*8 z(nz),xn,yn,zn
         integer ip,jp,kp,mini,minj,mink,maxi,maxj,maxk
C so we are evaluating everything at the point (xn,yn,zn) ....
C so first point is at (xn+sx,yn+sy,zn+sz)
C now we must set up our list
           upnts = 0
           if ((j-4).lt.1) then
                minj=1
           else
                minj=j-4
           end if
           if ((i-4).lt.1) then
                mini=1
           else
                mini=i-4
           end if
           if ((k-4).lt.1) then
                mink=1
           else
                mink=k-4
           end if

           if ((j+4).gt.ny) then
                maxj=ny
           else
                maxj=j+4
           end if
           if ((i+4).gt.nx) then
                maxi=nx
           else
                maxi=i+4
           end if
           if ((k+4).gt.nz) then
                maxk=nz
           else
                maxk=k+4
           end if

           do kp=mink,maxk
            do jp=minj,maxj
              do ip=mini,maxi
                 if (charm(ip,jp,kp).ne.(0.0e0)) then
C this is a usable point so set up arrays for sa,dxa,dya,dza,ia,ja,ka
                    upnts = upnts + 1
                    ia(upnts) = ip
                    ja(upnts) = jp
                    ka(upnts) = kp
                    dxa(upnts) = x(ip) - xn
                    dya(upnts) = y(jp) - yn
                    dza(upnts) = z(kp) - zn
                    sa(upnts)=dxa(upnts)**2+dya(upnts)**2+dza(upnts)**2
                 end if
              end do
            end do
           end do
          return
          end
         
        subroutine zero()
        implicit none
        integer sixy,sjxy,skxy,sixz,sjxz,skxz,siyz,sjyz,skyz
        integer siy2,sjy2,sky2
        common /sc/ sixy,sjxy,skxy,sixz,sjxz,skxz,siyz,sjyz,skyz
     .             ,siy2,sjy2,sky2
        integer ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        common /k/ ksixy,ksjxy,kskxy,ksixz,ksjxz,kskxz,ksiyz,ksjyz,kskyz
        integer d18,d20,d21
        common /d/ d18,d20,d21
        d18 = 0
        d20 = 0
        d21 = 0
        siy2 = 0
        sjy2 = 0
        sky2 = 0
        sixy = 0 
        sjxy = 0 
        skxy = 0
        sixz= 0 
        sjxz= 0 
        skxz= 0 
        siyz= 0 
        sjyz= 0 
        skyz= 0 
        ksixy = 0 
        ksjxy = 0 
        kskxy = 0
        ksixz= 0 
        ksjxz= 0 
        kskxz= 0 
        ksiyz= 0 
        ksjyz= 0 
        kskyz= 0 
        return
        end

       subroutine upmat(nx,iterms,mat,ip,jp,dxa,dya,dza,ia,ja,ka,
     .                  iuterms,juterms,kuterms)
       implicit none
       include 'terms.inc'
       integer nx,iterms,ip,jp,kp,ia(sz),ja(sz),ka(sz)
       integer iuterms(i40),juterms(i40),kuterms(i40)
       real*8 mat(i40,i40),dxa(sz),dya(sz),dza(sz)
           mat(ip,1) = 1.0e0
           mat(ip,2) = dxa(jp)
           mat(ip,3) = dya(jp)
           mat(ip,4) = dza(jp)
           if (iterms.lt.10) goto 222
           mat(ip,5) = dxa(jp) * dxa(jp) * 0.5
           mat(ip,6) = dya(jp) * dya(jp) * 0.5
           mat(ip,7) = dza(jp) * dza(jp) * 0.50e0
           mat(ip,8) = dxa(jp) * dya(jp)
           mat(ip,9) = dxa(jp) * dza(jp)
           mat(ip,10)= dya(jp) * dza(jp)
           if (iterms.lt.20) goto 222
           mat(ip,11)= dxa(jp) * dxa(jp) * dxa(jp) /6.0e0
           mat(ip,12)= dya(jp) * dya(jp) * dya(jp) /6.0e0
           mat(ip,13)= dza(jp) * dza(jp) * dza(jp) /6.0e0
           mat(ip,14)= dxa(jp) * dxa(jp) * dya(jp) *0.5
           mat(ip,15)= dxa(jp) * dya(jp) * dya(jp) *0.5
           mat(ip,16)= dxa(jp) * dxa(jp) * dza(jp) *0.5
           mat(ip,17)= dxa(jp) * dza(jp) * dza(jp) *0.5
           mat(ip,18)= dya(jp) * dya(jp) * dza(jp) *0.5
           mat(ip,19)= dya(jp) * dza(jp) * dza(jp) *0.5
           mat(ip,20)= dxa(jp) * dya(jp) * dza(jp)
           if (iterms.lt.15) goto 222
           mat(ip,21)= dxa(jp) * dxa(jp) * dxa(jp) *dxa(jp)/24.0e0
           mat(ip,22)= dya(jp) * dya(jp) * dya(jp) *dya(jp)/24.0e0
           mat(ip,23)= dza(jp) * dza(jp) * dza(jp) *dza(jp)/24.0e0

           mat(ip,24)= dxa(jp) * dxa(jp) * dxa(jp) *dya(jp)/6.0e0
           mat(ip,25)= dxa(jp) * dxa(jp) * dxa(jp) *dza(jp)/6.0e0
           mat(ip,26)= dxa(jp) * dya(jp) * dya(jp) *dya(jp)/6.0e0
           mat(ip,27)= dxa(jp) * dza(jp) * dza(jp) *dza(jp)/6.0e0
           mat(ip,28)= dya(jp) * dya(jp) * dya(jp) *dza(jp)/6.0e0
           mat(ip,29)= dya(jp) * dza(jp) * dza(jp) *dza(jp)/6.0e0

           mat(ip,30)= dxa(jp) * dxa(jp) * dya(jp) *dya(jp)/4.0e0
           mat(ip,31)= dxa(jp) * dxa(jp) * dza(jp) *dza(jp)/4.0e0
           mat(ip,32)= dya(jp) * dya(jp) * dza(jp) *dza(jp)/4.0e0

           mat(ip,33)= dxa(jp) * dxa(jp) * dya(jp) *dza(jp)/2.0e0
           mat(ip,34)= dxa(jp) * dya(jp) * dya(jp) *dza(jp)/2.0e0
           mat(ip,35)= dxa(jp) * dya(jp) * dza(jp) *dza(jp)/2.0e0
222        continue
           iuterms(ip) = ia(jp)
           juterms(ip) = ja(jp)
           kuterms(ip) = ka(jp)
           return
           end

          subroutine printmat(iterms,mat,nx,iuterms,juterms,kuterms,l)
          implicit none
          include 'terms.inc'
          integer iterms,iuterms(i40),juterms(i40),kuterms(i40),nx,l
          real*8   mat(i40,i40)
          integer ii,jj,iw,jw,kw,ss
          write(80,*) '**************',l
          ss = nx*nx
           do ii=1,iterms
              do jj=1,iterms
                 write(80,33) mat(ii,jj)
              end do
C              write(80,*) '    ',uterms(ii)
               write(80,'(3i4)') iuterms(ii),juterms(ii),kuterms(ii)
           end do
33         format(2x,f9.4,$)
           write(80,*) '**************'
          return
          end

          subroutine copy_ba(iterms,mat,iuterms,
     .                       juterms,kuterms,ipvt,comat,pil,l)
          implicit none
          include 'terms.inc'
          integer l,pil,iterms,ipvt(i40)
          integer iuterms(i40),juterms(i40),kuterms(i40)
          real*8   mat(i40,i40),comat(iterms,iterms+4,pil)
          integer ii,jj

           do ii=1,iterms
              do jj=1,iterms
                 comat(ii,jj,l) = mat(ii,jj)
              end do
              comat(ii,iterms+1,l) = iuterms(ii)
              comat(ii,iterms+2,l) = juterms(ii)
              comat(ii,iterms+3,l) = kuterms(ii)
              comat(ii,iterms+4,l) = ipvt(ii)
           end do
          return
          end


c----------------------------------------------
        subroutine changecxy(iterms,rulcx,rulcy,rulcz,ruldx,ruldy,ruldz
     1                       ,dx,dy,dz)
        implicit none
        integer iterms,rulcx(iterms),rulcy(iterms),rulcz(iterms)
        real*8   ruldx(iterms),ruldy(iterms),ruldz(iterms),dx,dy,dz
        integer i

c change the rules temporary ......

        rulcx(23) = 3
        rulcx(24) = 3
        rulcx(25) = 1
        rulcx(26) = 1
        rulcx(27) = 0
        rulcx(28) = 0
        rulcx(29) = 2
        rulcx(30) = 2
        rulcx(31) = 0
        rulcx(32) = 1
        rulcx(33) = 2
        rulcx(34) = 1
        rulcx(35) = 1

        rulcy(23) = 1
        rulcy(24) = 0
        rulcy(25) = 3
        rulcy(26) = 0
        rulcy(27) = 3
        rulcy(28) = 1
        rulcy(29) = 2
        rulcy(30) = 0
        rulcy(31) = 2
        rulcy(32) = 1
        rulcy(33) = 1
        rulcy(34) = 2
        rulcy(35) = 1

        rulcz(23) = 0
        rulcz(24) = 1
        rulcz(25) = 0
        rulcz(26) = 3
        rulcz(27) = 1
        rulcz(28) = 3
        rulcz(29) = 0
        rulcz(30) = 1
        rulcz(31) = 2
        rulcz(32) = 1
        rulcz(33) = 1
        rulcz(34) = 1
        rulcz(35) = 2

        do i=23,35
           if (rulcx(i).gt.0) then
              ruldx(i)=dx
           else
              ruldx(i)=0.0e0
           end if
           if (rulcy(i).gt.0) then
              ruldy(i)=dy
           else
              ruldy(i)=0.0e0
           end if
           if (rulcz(i).gt.0) then
              ruldz(i)=dz
           else
              ruldz(i)=0.0e0
           end if
        end do

        return
        end

      subroutine evalc_3(nx,ny,nz,iterms,pil,coeff,u,wdc,soln)
      implicit none
      include 'terms.inc'
      integer nx,ny,nz,pil,iterms
      real*8   coeff(iterms,iterms+4,pil),u(nx,ny,nz),soln(pil)
      real*8   mat(i40,i40),rhs(i40)
      real*8   arr1d(i40*i40)
      integer ipvt(i40),ls,wd
      character*4 wdc
      integer i,j,l,ii,jj,kk,ll
      logical debug
      debug = .false.
      if (debug) then
          do l=1,pil
             write(91,*) l
             do j=1,iterms
                do i=1,iterms
                   write(91,'(e10.4,$)') coeff(j,i,l)
                end do
                write(91,'(f6.1,$)') coeff(j,iterms+1,l)
                write(91,'(f6.1$)') coeff(j,iterms+2,l)
                write(91,'(f6.1$)') coeff(j,iterms+3,l)
                write(91,'(f6.1)') coeff(j,iterms+4,l)
             end do
          end do
       end if

c find out which derivative to get ...
      call getd(wdc,wd)
c wd is which derivative ......
      do ll=1,pil
       do i=1,iterms
         do j=1,iterms
            mat(i,j) = coeff(i,j,ll)
         end do
         ii = int(coeff(i,iterms+1,ll))
         jj = int(coeff(i,iterms+2,ll))
         kk = int(coeff(i,iterms+3,ll))
         ipvt(i) = int(coeff(i,iterms+4,ll))
         rhs(i) = u(ii,jj,kk)
       end do
       call sgesl(mat,i40,iterms,ipvt,rhs,0)
c now copy rhs into soln
         soln(ll) = rhs(wd)
      end do
      return
      end
      subroutine getd(wdc,wd)
      implicit none
      include 'terms.inc'
      character*4 wdc
      character*4 derivs1(i40)
      integer wd

      data derivs1/'____','x___','y___','z___','xx__','yy__',
     .             'zz__','xy__','xz__','yz__',
     .             'xxx_','yyy_','zzz_','xxy_','xyy_','xxz_','xzz_',
     .             'yyz_','yzz_','xyz_',
     .             'xxxx','yyyy','zzzz','xxxy','xxxz','xyyy',
     .             'xzzz','yyyz','yzzz','xxyy','xxzz','yyzz',
     .             'xxyz','xyyz','xyzz' /



      integer iwd,i
      do i=1,15
        if (wdc.eq.derivs1(i)) then
           wd = i
           return
        endif
      end do
      write(6,*) 'Doesnt seem to be a valid derivative ....., run again'
      stop
      end
c-----------------------------------------------------------------------
      subroutine evalc3d(nx,ny,nz,order,pil,coeff,u,wdc,soln)
      integer nx,ny,nz,order,pil
      real*8   coeff(*)
      real*8   u(*)
      real*8   soln(*)
      character*(*) wdc

      include 'terms.inc'
      call evalc_3(nx,ny,nz,soc(order),pil,coeff,u,wdc,soln)
      return
      end
c-----------------------------------------------------------------------
      subroutine smoments(wp,iterms,pil,moments,smom,disi,dmom,
     .                   iuterms,juterms,kuterms,nx)
      implicit none
      include 'terms.inc'
      integer iterms,pil,disi,dmom(pil)
      real*8   moments(i40),smom(i40,pil)
      integer i,j,k,l,wp,tt,nx,iuterms(i40),juterms(i40),kuterms(i40)
      real*8   diff,small
      parameter(small=1.0e-06)
      real*8   t1(i40),t2(i40),t3(i40)
      real*8   tabx(4),taby(4),tabz(4),tmp1,tmp2,tmp3
      data tabx/+1.0e0,+1.0e0,+1.0e0,+1.0e0/
      data taby/+1.0e0,+1.0e0,-1.0e0,-1.0e0/
      data tabz/+1.0e0,-1.0e0,+1.0e0,-1.0e0/

c check everything to see if we have a distinct item
      do 200 i=1,disi
         if ((abs(moments(7)-smom(7,i)).lt.small).and.
     .       (abs(moments(8)-smom(8,i)).lt.small).and.
     .       (abs(moments(9)-smom(9,i)).lt.small)) then
            do j=1,4
               tmp1 = tabx(j)*taby(j)
               tmp2 = tabx(j)*tabz(j)
               tmp3 = taby(j)*tabz(j)
               if ((abs(tmp1*moments(10)-smom(10,i)).lt.small).and.
     .             (abs(tmp2*moments(11)-smom(11,i)).lt.small).and.
     .             (abs(tmp3*moments(12)-smom(12,i)).lt.small)) goto 100
            end do
            goto 200
          end if
          goto 200
100       continue
c we made it here, so we must of had this point before
         dmom(i) = dmom(i) + 1
         write(98,*) 'Point ',wp, ' is stencil',i
         do tt = 1,iterms
            t1(tt) = iuterms(tt)
            t2(tt) = juterms(tt)
            t3(tt) = kuterms(tt)
         end do

C         vsrc = vsxynt('stencil'//char(i),1.0e0*dmom(i),t1,t2,iterms)
         goto 300
200      continue
c NEW ITEM SO WE ARE IN THIS PART OF LOOP
         disi = disi + 1
         dmom(disi) = 1
         write(98,*) 'Point ',wp, ' is stencil',disi
         do l=1,40
            smom(l,disi) = moments(l)
         end do
         do tt = 1,iterms
            t1(tt) = iuterms(tt)
            t2(tt) = juterms(tt)
            t3(tt) = kuterms(tt)
         end do
C          vsrc = vsxynt('stencil'//char(disi),1.0e0,t1,t2,iterms)
300      continue
         return
         end

c-----------------------------------------------------------------------
       subroutine moments(iterms,iuterms,juterms,kuterms,nx,ii)
c evaluate the stencil by moments to see what type we have .......
      implicit none
      include 'terms.inc'

      integer iuterms(iterms),juterms(iterms),kuterms(iterms),nx
      integer iterms,ia(i40),ja(i40),ka(i40),box(6),axis(3)
      real*8   x(i40),y(i40),z(i40),cx,cy,cz
      real*8   rx(i40),ry(i40),rz(i40)
      real*8   ii(i40)
      integer i
      logical debug
      debug = .true.

      call read_point(nx,iuterms,juterms,kuterms,ia,ja,ka,iterms)
      call define_box(ia,ja,ka,iterms,box)
      call getxys(ia,ja,ka,box,iterms,x,y,z)

      call get_cent(x,y,z,iterms,box,cx,cy,cz,ii)
      call get_newl(x,y,z,cx,cy,cz,iterms,rx,ry,rz)

      call get_moments(rx,ry,rz,iterms,ii)
      if (debug) then
         write(77,*)
         do i=1,10
            write(77,'(3f8.2)') x(i),y(i),z(i)
         end do
      end if
32    format(i2,3x,f12.6)
      return
      end

c---------------------------------------------------------------------
      subroutine read_point(nx,iuterms,juterms,kuterms,ia,ja,ka,iterms)
      implicit none
      integer iterms,ia(iterms),ja(iterms),ka(iterms)
      integer iuterms(iterms),juterms(iterms),kuterms(iterms)

      integer i,nx
      do i=1,iterms
         ia(i) = iuterms(i)
         ja(i) = juterms(i)
         ka(i) = kuterms(i)
      end do
      return
      end
c---------------------------------------------------------------------
      subroutine define_box(ia,ja,ka,ssz,box)
      implicit none
      integer ssz,ia(ssz),ja(ssz),ka(ssz),box(6)

      integer i,j,k,mini,minj,mink,maxi,maxj,maxk

      mini = 99999
      minj = 99999
      mink = 99999
      maxi =-99999
      maxj =-99999
      maxk =-99999

      do i=1,ssz
         if (ia(i).le.mini) mini=ia(i)
         if (ia(i).ge.maxi) maxi=ia(i)
      end do

      do j=1,ssz
         if (ja(j).le.minj) minj=ja(j)
         if (ja(j).ge.maxj) maxj=ja(j)
      end do

      do k=1,ssz
         if (ka(k).le.mink) mink=ka(k)
         if (ka(k).ge.maxk) maxk=ka(k)
      end do

      box(1) = mini
      box(2) = maxi
      box(3) = minj
      box(4) = maxj
      box(5) = mink
      box(6) = maxk

      return
      end
c---------------------------------------------------------------------
      subroutine getxys(ia,ja,ka,box,ssz,x,y,z)
      implicit none
      include 'terms.inc'
      integer ssz,ia(ssz),ja(ssz),ka(ssz),box(6)
      real*8   x(ssz),y(ssz),z(ssz)
      real*8   x1(i40),y1(i40),z1(i40)
      real*8   x2(i40),y2(i40),z2(i40)
      integer i

      do i=1,ssz
            x(i) = 1.0e0*(ia(i) -box(1) )
            y(i) = 1.0e0*(ja(i) -box(3) )
            z(i) = 1.0e0*(ka(i) -box(5) )
      end do

      return
      end
c---------------------------------------------------------------------
      subroutine get_cent(x,y,z,ssz,box,cx,cy,cz,ii)
      implicit none
      include 'terms.inc'
      integer ssz,box(6)
      real*8   x(ssz),y(ssz),z(ssz),cx,cy,cz
      real*8   ii(i40)

      integer i,j
      real*8   sumx,sumy,sumz

      sumx = 0.0e0
      sumy = 0.0e0
      sumz = 0.0e0

      do i=1,ssz
         sumx = sumx + x(i)
         sumy = sumy + y(i)
         sumz = sumz + z(i)
      end do

      cx = sumx/ssz
      cy = sumy/ssz
      cz = sumz/ssz
      ii(1) = cx
      ii(2) = cy
      ii(3) = cz

      return
      end
c---------------------------------------------------------------------
      subroutine get_newl(x,y,z,cx,cy,cz,ssz,rx,ry,rz)
      integer ssz
      real*8   x(ssz),y(ssz),z(ssz),cx,cy,cz
      real*8   rx(ssz),ry(ssz),rz(ssz)

      integer i

      do i=1,ssz
         rx(i) = x(i) - cx
         ry(i) = y(i) - cy
         rz(i) = z(i) - cz
      end do

      return
      end
c---------------------------------------------------------------------
      subroutine get_moments(rx,ry,rz,ssz,ii)
      implicit none
      include 'terms.inc'
      integer ssz
      real*8   rx(ssz),ry(ssz),rz(ssz)
      real*8   ii(sz),magx,magy,magz,tmag,ttmag(sz)

      integer i,mn

      magx = ssz
      magy = ssz
      magz = ssz

c note first three moments should always be zero
      mn = 4

      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)
      end do
      ii(mn) = ii(mn)/magx

      mn = 5
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)
      end do
      ii(mn) = ii(mn)/magy

      mn = 6
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rz(i)
      end do
      ii(mn) = ii(mn)/magz

      mn = 7
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rx(i)
      end do
      ii(mn) = ii(mn)/magx/magx

      mn = 8
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magy/magy

      mn = 9
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rz(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magz/magz

      if(ii(8).ge.ii(7).and.ii(8).ge.ii(9)) then
             if (ii(7).ge.ii(9)) then
c (x,y,z) = y,x,z
                ii(10) = ii(7)
                ii(7) = ii(8)
                ii(8) = ii(10)
                ii(9) = ii(9)
                do i=1,ssz
                   ttmag(i) = rx(i)
                   rx(i) = ry(i)
                   ry(i) = ttmag(i)
                   rz(i) = rz(i)
                end do
             else
c (x,y,z) = y,z,x
                ii(10) = ii(7)
                ii(7) = ii(8)
                ii(8) = ii(9)
                ii(9) = ii(10)
                do i=1,ssz
                   ttmag(i) = rx(i)
                   rx(i) = ry(i)
                   ry(i) = rz(i)
                   rz(i) = ttmag(i)
                end do
             end if
      else if (ii(9).ge.ii(7).and.ii(9).ge.ii(8)) then
             if (ii(7).ge.ii(8)) then
c (x,y,z) = z,x,y
                ii(10) = ii(7)
                ii(7) = ii(9)
                ii(9) = ii(8)
                ii(8) = ii(10)
                do i=1,ssz
                   ttmag(i) = rx(i)
                   rx(i) = rz(i)
                   rz(i) = ry(i)
                   ry(i) = ttmag(i)
                end do
             else
c (x,y,z) = z,y,x
                ii(10) = ii(7)
                ii(7) = ii(9)
                ii(8) = ii(8)
                ii(9) = ii(10)
                do i=1,ssz
                   ttmag(i) = rx(i)
                   rx(i) = rz(i)
                   ry(i) = ry(i)
                   rz(i) = ttmag(i)
                end do
             end if
       end if


      mn = 10
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magx/magy

      mn = 11
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magx/magz


      mn = 12
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magy/magz
c now recenter accordingly   .....

      mn = 13
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rx(i)*rx(i)
      end do
      ii(mn) = ii(mn)/magx/magx/magx

      mn = 14
      ii(mn) = 0.0e00
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*ry(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magy/magy/magy

      mn = 15
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rz(i)*rz(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magz/magz/magz

      mn = 16
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rx(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magx/magx/magy

      mn = 17
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*ry(i)*ry(i)
      end do
      ii(mn) = ii(mn)/magx/magy/magy

      mn = 18
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rx(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magx/magx/magz

      mn = 19
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*rz(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magx/magz/magz

      mn = 20
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*ry(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magy/magy/magz

      mn = 21
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + ry(i)*rz(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magy/magz/magz

      mn = 22
      ii(mn) = 0.0e0
      do i=1,ssz
        ii(mn) = ii(mn) + rx(i)*ry(i)*rz(i)
      end do
      ii(mn) = ii(mn)/magx/magy/magz
      end
