C----------------------------------------------------------
C Subroutine Boundary is the routine to map out the hole boundary
C onto the computational grid, this routine will have the following
C parameters:
C pil = number of points on the surface

      subroutine boundary( nx,ny,nz,a,c,x,y,z,sfi,sfj,sfk,
     .                     pil,xb,yb,zb,charm,
     .                     listx,listy,listz,
     .                     ht,hphi,iip )
      implicit none
      include 'param3.h'
      integer nx,ny,nz
      real*8 small,pi
      parameter(small=1.0d-10)
      real*8 a,c(3)
      integer index(MEMSTEN),stencil
      real*8 x(nx),y(ny),z(nz),xx,yy,zz
      integer xb(MEMSTEN),yb(MEMSTEN),zb(MEMSTEN)
      integer iip,sfi(MEMSTEN),sfj(MEMSTEN),sfk(MEMSTEN)
      real*8 charm(nx,ny,nz)
      real*8 listx(MEMSTEN),listy(MEMSTEN),listz(MEMSTEN)
      real*8 ht(MEMSTEN),hphi(MEMSTEN)
      real*8 r,r1,r2
      real*8 zero,one
      parameter ( zero = 0.0d0, one = 1.0d0)
      integer ibad

      integer pil,ip,jp,itt

      integer i,j,k,l,jq,icn
      integer ia,ib,ic,id,ie,ig,count
      real*8 theta,old_diff,diff,asq,point
      logical ltrace
      parameter (ltrace = .true.)

      pi  = 4.0d0*atan(1.0d0)

C scan in the x direction

      old_diff = 100.0d0
      asq = a*a
      do k = 2,nz-1
         do j=2,ny-1
            do i=2,nx-1
               charm(i,j,k) = 0.0d0
               point = (x(i)-c(1))**2+(y(j)-c(2))**2+(z(k)-c(3))**2
               diff = point - asq
               if (abs(diff).lt.small) diff=0.0d0
               if (diff.ge.zero.and.old_diff.lt.zero ) then
                  charm(i-1,j,k) = 2.0d0
               else if (diff.le.zero.and.old_diff.ge.zero) then
C was le , ge
                   charm(i,j,k) = 2.0d0
               else if (diff.lt.zero.and.old_diff.le.zero) then
                   charm(i,j,k) = -1.0d0
               end if
               old_diff = diff
            end do
         end do
      end do
C scan in the y direction
      old_diff = 100.0d0 
      do i=2,nx-1
         do k=2,nz-1
            do j=2,ny-1
               point = (x(i)-c(1))**2+(y(j)-c(2))**2+(z(k)-c(3))**2
               diff = point - asq
               if (abs(diff).lt.small) diff=0.0d0
               if (diff.ge.zero.and.old_diff.lt.zero) then
                  charm(i,j-1,k) = 2.0d0 
               else if (diff.le.zero.and.old_diff.ge.zero) then
C was le,ge
                  charm(i,j,k) = 2.0d0
               end if
               old_diff = diff
            end do
         end do
      end do
C scan in the z direction
      old_diff = 100.0d0                                   
      do j=2,ny-1
         do i=2,nx-1
            do k=2,nz-1
               point = (x(i)-c(1))**2+(y(j)-c(2))**2+(z(k)-c(3))**2
               diff = point - asq
               if (abs(diff).lt.small) diff=0.0d0
               if (diff.ge.zero.and.old_diff.lt.zero) then
                  charm(i,j,k-1) = 2.0d0
               else if (diff.le.zero.and.old_diff.ge.zero) then
C was ge 
                  charm(i,j,k) = 2.0d0
               end if
               old_diff = diff
            end do
         end do
      end do

C now get stencil  ..........................................................|
      pil = 0
      do k =2,nz-1
         do j=2,ny-1
            do i=2,nx-1
               if (int(charm(i,j,k)).le.0) then
                 goto 3300
               end if
               ia = -1*int(charm(i-1,j,k))
               ib = -1*int(charm(i+1,j,k))
               ic = -1*int(charm(i,j-1,k))
               id = -1*int(charm(i,j+1,k))
               ie = -1*int(charm(i,j,k-1))
               ig = -1*int(charm(i,j,k+1))

               pil = pil + 1
               ibad = 0

               if (ia.eq.1) then
                  sfi(pil) = 1
               else if (ib.eq.1) then
                  sfi(pil) = -1
               else
                  ibad = ibad + 1
                  r1 =  (x(i+1)-c(1))**2+(y(j)-c(2))**2+(z(k)-c(3))**2
                  r2 =  (x(i-1)-c(1))**2+(y(j)-c(2))**2+(z(k)-c(3))**2
                  if (r1.ge.r2) then
C switching these guys around
                     sfi(pil) = 1
                  else
                     sfi(pil) = -1
                  end if
               end if

               if (ic.eq.1) then
                  sfj(pil) = 1
               else if (id.eq.1) then
                  sfj(pil) = -1
               else
                  ibad = ibad + 1
                  r1 =  (x(i)-c(1))**2+(y(j+1)-c(2))**2+(z(k)-c(3))**2
                  r2 =  (x(i)-c(1))**2+(y(j-1)-c(2))**2+(z(k)-c(3))**2
                  if (r1.ge.r2) then
                     sfj(pil) = 1
                  else
                     sfj(pil) = -1
                  end if
               end if

               if (ie.eq.1) then
                  sfk(pil) = 1
               else if (ig.eq.1) then
                  sfk(pil) = -1
               else
                  ibad = ibad + 1
                  r1 =  (x(i)-c(1))**2+(y(j)-c(2))**2+(z(k+1)-c(3))**2
                  r2 =  (x(i)-c(1))**2+(y(j)-c(2))**2+(z(k-1)-c(3))**2
                  if (r1.ge.r2) then
                     sfk(pil) = 1
                  else
                     sfk(pil) = -1
                  end if
               end if

               if (ibad.eq.3) then
                  charm(i,j,k) = 0.0d0
                  pil = pil - 1
               else
                  xb(pil) = i
                  yb(pil) = j
                  zb(pil) = k
               end if

3300         continue
            end do
         end do
      end do
C----------------------------------------------------------------------------|
C now get the lists in the x and y directions .... along with theta.
       call list( nx,ny,nz, pil,x,y,z,xb,yb,zb,a,c,
     .            listx,listy,listz,ht, hphi ) 

C      if (ltrace) then
C write out charm array ......
C      if (iip.eq.1) then 
C      open(77,file='graph')

		if (ltrace) then
      do k=1,nz
         write(77,*) 'slice k=',k
         do j=1,ny
            do i=1,nx
               write(77,'(i1$)') int(charm(i,j,k))
				   if (int(charm(i,j,k)).ne.0) write(78,8) i,j,k,
     .                       int(charm(i,j,k))
            end do
            write(77,*)
         end do
      end do
66    continue
      write(77,*) '**************EOF**********'
      write(78,*) '**************EOF**********'
C      close(77)
C       end if
8		format(4i4)

		end if
C now convert the charm array to Matt's form
      do k=1,nz
         do j=1,ny
            do i=1,nx 
					if (charm(i,j,k).eq.(2.0d0)) write(81,*) i,j,k
               if (charm(i,j,k).eq.-one) then
                  charm(i,j,k) = zero
               else 
                  charm(i,j,k) = one 
               end if
            end do
         end do
      end do

		write(81,*) '******************EOF****************'
      return
      end
