subroutine horizon(nx,ny,nz,x,y,z,a,c,mask)
implicit none
integer                              :: nx,ny,nz
real*8,dimension(nx,ny,nz)           :: mask
real*8                               :: x(nx),y(ny),z(nz)
real*8                               :: a,c(3)
!***
real*8                               :: a2,r
integer                              :: i,j,k


a2 = a * a

do i = 1 , nx
do j = 1 , ny
do k = 1 , nz

   r = x(i)*x(i) + y(j)*y(j) + z(k)*z(k)
   if (r.lt.a2) then
      mask(i,j,k) = 0.0d0
   else
      mask(i,j,k) = 1.0d0
   end if

end do
end do
end do

do i = 1 , nx 
write(80,*) 'Slice_i:',i
do j = 1 , ny 
do k = 1 , nz 
   write(80,'(i1$)') int(mask(i,j,k))
end do
write(80,*)
end do
end do


return
end
!------------------------------------------------------------------

subroutine flags(nx,ny,nz,x,y,z,a,c,mask,m,d,nl) 
implicit none 
integer                       :: nx,ny,nz,nl
real*8,dimension(nx,ny,nz)    :: mask
real*8                        :: x(nx),y(ny),z(nz)
real*8,dimension(:)           :: d
integer,dimension(:)          :: m
real*8                        :: a,c(3)

!*** 
 
integer                      :: i,j,k,l
real*8 ,parameter            :: zero = 0.0d0
real*8 ,parameter            :: one  = 1.0d0

integer,parameter            :: maxnl = 513*513
real*8                       :: r1,r2

real*8,dimension(maxnl)      :: fx,fy,fz
integer,dimension(maxnl)     :: xi,yj,zk 

   fx = zero
   fy = zero
   fz = zero
   xi = 0
   yj = 0
   zk = 0

   l = 0 
 
do k = 2, nz-1 
do j = 2, ny-1 
do i = 2, nx-1 
 
   if (mask(i,j,k).eq.one .and.                                &
     ((mask(i+1,j,k).eq.zero).or.(mask(i-1,j,k).eq.zero).or.   & 
      (mask(i,j+1,k).eq.zero).or.(mask(i,j-1,k).eq.zero).or.   & 
      (mask(i,j,k+1).eq.zero).or.(mask(i,j,k-1).eq.zero)) ) then 

         l = l + 1 
      if (l.gt.maxnl) then
         write(0,*) '**** STOP RUNNING AND CHANGE MAXNL IN flags.f90 ***'
         stop
      end if
      xi(l) = i
      yj(l) = j
      zk(l) = k

      if ( mask(i+1,j,k).eq.zero ) fx(l) = -1.0d0 !use backwards in x
      if ( mask(i-1,j,k).eq.zero ) fx(l) =  1.0d0 !use forwards in x
      if ( mask(i,j+1,k).eq.zero ) fy(l) = -1.0d0 !use backwards in y
      if ( mask(i,j-1,k).eq.zero ) fy(l) =  1.0d0 !use forwards in y
      if ( mask(i,j,k+1).eq.zero ) fz(l) = -1.0d0 !use backwards in z
      if ( mask(i,j,k-1).eq.zero ) fz(l) =  1.0d0 !use forwards in z

      if (fx(l).eq.zero) then
         r1 =  (x(i+1)-c(1))**2
         r2 =  (x(i-1)-c(1))**2
         if (r1.ge.r2) then
            fx(l) =  1.0d0
         else 
            fx(l) = -1.0d0
         end if
      end if

      if (fy(l).eq.zero) then
         r1 =  (y(j+1)-c(2))**2
         r2 =  (y(j-1)-c(2))**2
         if (r1.ge.r2) then
            fy(l) =  1.0d0
         else 
            fy(l) = -1.0d0
         end if
      end if

      if (fz(l).eq.zero) then
         r1 =  (z(k+1)-c(3))**2
         r2 =  (z(k-1)-c(3))**2
         if (r1.ge.r2) then
            fz(l) =  1.0d0
         else 
            fz(l) = -1.0d0
         end if
      end if


      mask(i,j,k) = 333.0d0

   end if
end do                                                
end do
end do

where (mask.eq.(333.0d0)) mask=1.0d0

nl = l

do l = 1, nl
   m(l)      = xi(l)
   m(l+nl)   = yj(l)
   m(l+2*nl) = zk(l)
   d(l)      = fx(l)
   d(l+nl)   = fy(l)
   d(l+2*nl) = fz(l)
end do

return 
end 
