! this will be a simple test to see if this works for brill waves
program brill1
implicit none
real*8,dimension(:,:,:),allocatable          :: u,rhs,res,q,qx,qy,ans,mask
real*8                                       :: xmax,ymax,zmax
real*8                                       :: xmin,ymin,zmin
integer                                      :: nx,ny,nz
real*8                                       :: h
real*8,dimension(:),allocatable              :: x,y,z
real*8                                       :: epsilon,omega,l2norm,l2e
integer                                      :: nl,iter,prs
real*8,dimension(:),allocatable              :: d
integer,dimension(:),allocatable             :: m
real*8                                       :: a,c(3),l2normb

interface

   real*8 function relaxc(rres,u,rhs,mask,nx,ny,nz,h,q,qx,qy,x,y,z,omega)
   implicit none
   integer                    :: nx,ny,nz
   real*8,dimension(nx,ny,nz) :: rres,u,rhs,q,qx,qy,mask
   real*8                     :: x(nx),y(ny),z(nz),omega
	real*8                     :: h
   end function


   real*8 function relaxb( nx,ny,nz,a,c,x,y,z,u,rhs,res,h,m,d,nl,omega )
   implicit none
   integer nx,ny,nz,nl
   integer m(3*nl)
   real*8  d(3*nl)
   real*8  h,a,c(3)
   real*8  res(nx,ny,nz),rhs(nx,ny,nz),u(nx,ny,nz)
   real*8  x(nx),y(ny),z(nz)
   real*8  omega
   end function

   real*8 function n2i(nx,ny,nz,f,mask)
   implicit none
   integer nx,ny,nz
   real*8,dimension(nx,ny,nz) :: f,mask
   end function

   subroutine diff(f,a,b,wd,h,ord,opt,m,d,nl,df)
   implicit none
   real*8,dimension(:,:,:) :: f,df,a
   integer,dimension(:)    :: m
   real*8,dimension(:)     :: d
   real*8                                   :: h
   real*8                                   :: b
   integer                                  :: ord, opt, wd, nl
   end subroutine

   subroutine horizon(nx,ny,nz,x,y,z,a,c,mask)
   implicit none
   integer                              :: nx,ny,nz
   real*8,dimension(nx,ny,nz)           :: mask
   real*8                               :: x(nx),y(ny),z(nz)
   real*8                               :: a,c(3)
   end subroutine

   subroutine flags(nx,ny,nz,x,y,z,a,c,mask,m,d,nl)      
   implicit none
   integer                       :: nx,ny,nz,nl
   real*8,dimension(nx,ny,nz)    :: mask
   real*8                        :: x(nx),y(ny),z(nz)
   real*8,dimension(:)           :: d
   integer,dimension(:)          :: m
   real*8                        :: a,c(3)
   end subroutine

	subroutine initialize(nx,ny,nz,x,y,z,a,c,u,ans,q,rhs)
	implicit none
	integer                      :: nx,ny,nz
	real*8,dimension(nx,ny,nz)   :: u,ans,rhs,q
	real*8                       :: x(nx),y(ny),z(nz)
	real*8                       :: a,c(3)
	end subroutine


   subroutine initb(nx,ny,nz,a,c,x,y,z,rhs,m,nl)
   implicit none
   integer                    :: nx,ny,nz,nl
   real*8                     :: x(nx),y(ny),z(nz)
   real*8,dimension(nx,ny,nz) :: rhs(nx,ny,nz)
   integer,dimension(3*nl)    :: m(3*nl)
   real*8                     :: a,c(3)
   end subroutine


   subroutine initxyz(nx,ny,nz,xmin,ymin,zmin,xmax,ymax,zmax,h,x,y,z)
   implicit none
   integer              :: nx,ny,nz
   real*8               :: xmin,ymin,zmin
   real*8               :: xmax,ymax,zmax
   real*8               :: h
   real*8               :: x(nx),y(ny),z(nz)
	end subroutine


end interface

open(22,file='brill.in')
read(22,*) nx,ny,nz
read(22,*) xmin,ymin,zmin,xmax,ymax,zmax
read(22,*) a,c(1),c(2),c(3)
read(22,*) epsilon,omega
read(22,*) prs  !number of iterations before a print 
close(22)

write(6,*) 'allocatating memory',nx,ny,nz
allocate(u(nx,ny,nz),rhs(nx,ny,nz),res(nx,ny,nz) )
allocate(q(nx,ny,nz),qx(nx,ny,nz),qy(nx,ny,nz) )
allocate( ans(nx,ny,nz),mask(nx,ny,nz))
allocate(x(nx),y(ny),z(nz))
allocate(m(nx*nz*3),d(nx*nz*3))

! first initialize all variables

!write(6,*) 'calling initxyz'
call initxyz(nx,ny,nz,xmin,ymin,zmin,xmax,ymax,zmax,h,x,y,z)
!write(6,*) 'calling initialize'
call initialize(nx,ny,nz,x,y,z,a,c,u,ans,q,rhs)


!write(6,*) 'calling horizon' 
call horizon(nx,ny,nz,x,y,z,a,c,mask)
!write(6,*) 'calling flags' 
call flags(nx,ny,nz,x,y,z,a,c,mask,m,d,nl)

!write(6,*) 'calling initb' 
call initb(nx,ny,nz,a,c,x,y,z,rhs,m,nl)

! now get the derivatives of q....

!write(6,*) 'calling diff' 
call diff(q,q,0.0d0,1,h,2,3,m,d,nl,qx)
!write(6,*) 'calling diff' 
call diff(q,q,0.0d0,2,h,2,3,m,d,nl,qy)

! now iterate untill we converged to a small value

iter = 0
l2norm = 1.0d100

do while ( l2norm > epsilon )
   iter = iter + 1
!write(6,*) 'calling relaxc' 
   l2norm = relaxc(res,u,rhs,mask,nx,ny,nz,h,q,qx,qy,x,y,z,omega)
!write(6,*) 'calling relaxb' 
	l2normb= relaxb(nx,ny,nz,a,c,x,y,z,u,rhs,res,h,m,d,nl,1.0d0)

   if (mod(iter,prs).eq.0) then
      write(6,'(i6,1P,2e12.2)') iter,l2norm,l2normb
    end if 

end do 

! find the solution error now

ans = abs( u - ans )

l2e = n2i(nx,ny,nz,ans,mask)

write(6,'(i3,e14.4)') iter,l2e

stop
end


real*8 function n2i(nx,ny,nz,f,mask)
implicit none
integer nx,ny,nz
real*8,dimension(nx,ny,nz) :: f,mask
!***
real*8 points

n2i = sum(abs(f),mask=mask.ne.(0.0d0))
points = sum(mask)

n2i = n2i / points 

return
end
