subroutine initxyz(nx,ny,nz,xmin,ymin,zmin,xmax,ymax,zmax,h,x,y,z)
implicit none
integer              :: nx,ny,nz
real*8               :: xmin,ymin,zmin
real*8               :: xmax,ymax,zmax
real*8               :: h
real*8               :: x(nx),y(ny),z(nz)
!***
integer              :: i,j,k

h = (xmax-xmin)/(nx-1)

do i = 1 , nx
  x(i) = xmin + (i-1)*h
end do
do j = 1 , ny
  y(j) = ymin + (j-1)*h
end do
do k = 1 , nz
  z(k) = zmin + (k-1)*h
end do

return
end
!------------------------------------------------------------------
subroutine initialize(nx,ny,nz,x,y,z,a,c,u,ans,q,rhs)
implicit none
integer                      :: nx,ny,nz
real*8,dimension(nx,ny,nz)   :: u,ans,rhs,q
real*8                       :: x(nx),y(ny),z(nz)
real*8                       :: a,c(3)

!***
real*8,parameter             :: m=1.0d0
integer                      :: i,j,k
real*8                       :: r

! let q = exp( - (x+y) ) , u = 1+m/(2r)

do i = 1 , nx
do j = 1 , ny
do k = 1 , nz
 r = sqrt( (x(i)-c(1))**2+(y(j)-c(2))**2 + (z(k)-c(3))**2 )
 if (r.ne.(0.0d0)) then
    q(i,j,k) = exp(-(x(i)+y(j)+z(k)))
    ans(i,j,k) = 1.0d0 + m/ r 
    u(i,j,k) = ans(i,j,k) 
    rhs(i,j,k) = 0.0d0
 else
    q(i,j,k) = 0.0d0 
    ans(i,j,k) = 0.0d0 
    u(i,j,k) = 0.0d0 
    rhs(i,j,k) = 0.0d0
 end if

end do
end do
end do

return
end 

subroutine initb(nx,ny,nz,a,c,x,y,z,rhs,m,nl)
implicit none
integer                    :: nx,ny,nz,nl
real*8                     :: x(nx),y(ny),z(nz)
real*8,dimension(nx,ny,nz) :: rhs(nx,ny,nz)
integer,dimension(3*nl)    :: m(3*nl)
real*8                     :: a,c(3)
!***
integer i,j,k,l
real*8  r

do l = 1 , nl
	r = sqrt((x(m(l))-c(1))**2+(y(m(nl+l))-c(2))**2+(z(m(2*nl+l))-c(3))**2)
	rhs(m(l),m(nl+l),m(2*nl+l)) = 0.5/r/a*( r + a )
end do

return
end
