! Copyright Scott A. Klasky NPAC 1996
!============================================================================
      module def_grid
         type grd
            integer                             :: parent
            integer                             :: child
            integer                             :: neighbor
            integer                             :: sibling
            integer,dimension(2)                :: lb,ub
         end type grd
         integer, dimension(:),allocatable      :: lhead 
         integer, parameter                     :: UNDEF = -1
         integer, parameter                     :: max_stor = 10000 
         integer, dimension(max_stor)           :: lnext
      end module def_grid
!============================================================================
      subroutine cls_2d(msk,shp,blk_overlap, &
                        box_max,box_no,box_stk_lb, &
                        box_stk_ub,min_eff)
      USE def_grid
      implicit none
      integer, dimension(2)                      :: shp
      integer, dimension(shp(1),shp(2))          :: msk
      integer                                    :: blk_overlap
      integer                                    :: box_max, box_no
      integer, dimension(2,box_max)              :: box_stk_lb, box_stk_ub 
      integer                                    :: box_number 
      logical                                    :: not_done
      real*8                                     :: comput_eff,eff
      real*8                                     :: min_eff
      integer                                    :: level, grid,lmax
      type(grd), dimension(box_max)              :: grid_ptr
      integer                                    :: init_tree
      integer,dimension(shp(2))                  :: sigmax
      integer,dimension(shp(1))                  :: sigmay
      integer,dimension(shp(2))                  :: delx
      integer,dimension(shp(1))                  :: dely
      integer                                    :: maxsize
      logical                                    :: found_hole, find_hole

      allocate(lhead(box_max))

      not_done = .true.
      lnext    = UNDEF
      level    =  init_tree(grid_ptr,box_max,shp)

      do while (not_done) 
100   continue 

         grid = lhead(level)
         if (grid == UNDEF) exit 

200      continue

            if (grid == UNDEF) then
               level = level + 1
               goto 100 
            end if

            eff = comput_eff(grid,grid_ptr,msk,shp,box_max) 

            if (eff.ge.min_eff) then
               grid = grid_ptr(grid)%neighbor
               goto 200 
            end if

            call compute_sigma(grid,grid_ptr,msk,shp,box_max,  &
                               sigmax,sigmay) 

            found_hole = find_hole(box_max,level,grid,grid_ptr,&
                                   sigmax,sigmay,shp) 

            if (.not.found_hole) then

               call compute_delta(shp,grid,grid_ptr,box_max,  &
                                  sigmax,sigmay,delx,dely)
               call find_great_infl(level,grid,grid_ptr,box_max,  &
                                    shp,delx,dely) 

            end if

            grid = grid_ptr(grid)%neighbor
            goto 200
   end do

! now we put in the buffer zones, while extracting the usefull information
! into the output arrays

      lmax = level - 1
      box_no = 0

      do level = 1 , lmax
         grid = lhead(level)
300      continue
         if (grid.eq.UNDEF) cycle

         if (grid_ptr(grid)%child.eq.UNDEF) then
            box_no = box_no + 1

! don't forget to add the buffer zone
            box_stk_lb(1,box_no) = grid_ptr(grid)%lb(1)   
            box_stk_lb(2,box_no) = grid_ptr(grid)%lb(2)   
            box_stk_ub(1,box_no) = grid_ptr(grid)%ub(1)   
            box_stk_ub(2,box_no) = grid_ptr(grid)%ub(2)   

         end if

         grid = grid_ptr(grid)%neighbor
         goto 300
      end do


      return
      end
!============================================================================
      subroutine find_great_infl(level,grid,grid_ptr,box_max,  &
                                 shp,delx,dely) 
      USE def_grid
      implicit none
      integer                                    :: box_max
      integer                                    :: grid,level
      integer, dimension(2)                      :: shp
      type(grd), dimension(box_max)              :: grid_ptr
      integer, dimension(shp(1))                 :: delx
      integer, dimension(shp(2))                 :: dely
      integer                                    :: dir,location
      integer                                    :: change,maxchange
      integer, dimension(2)                      :: nlb,nub
      integer                                    :: i,j
      integer, external                          :: sign

      dir      = 1
      location = 1
		maxchange = 0

      if ( grid_ptr(grid)%lb(1)+1 < grid_ptr(grid)%ub(1) - 2 ) then
         do i = grid_ptr(grid)%lb(1)+1, grid_ptr(grid)%ub(1) - 2
            change = abs(delx(i) - delx(i+1))
            if (change.gt.maxchange.and.                                  &
                sign(delx(i)).ne.sign(delx(i+1))) then
               maxchange = change
               location  = i
               dir       = 1
            end if
         end do
      end if


      if ( grid_ptr(grid)%lb(2)+1 < grid_ptr(grid)%ub(2) - 2 ) then

         do j = grid_ptr(grid)%lb(2)+1, grid_ptr(grid)%ub(2) - 2
            change = abs(dely(j) - dely(j+1))
            if (change.gt.maxchange.and.                                  &
                sign(dely(j)).ne.sign(dely(j+1))) then
               maxchange = change
               location  = j
               dir       = 2
            end if
         end do
      end if
   
! now we can make a two new grids

      if (dir.eq.1) then
         nlb(1) = grid_ptr(grid)%lb(1)
         nlb(2) = grid_ptr(grid)%lb(2)
         nub(1) = location 
         nub(2) = grid_ptr(grid)%ub(2)
         call make_grid(level,grid,grid_ptr,nlb,nub,box_max) 

         nlb(1) = location + 1 
         nlb(2) = grid_ptr(grid)%lb(2)
         nub(1) = grid_ptr(grid)%ub(1)
         nub(2) = grid_ptr(grid)%ub(2)
         call make_grid(level,grid,grid_ptr,nlb,nub,box_max)

      else

         nlb(1) = grid_ptr(grid)%lb(1)
         nlb(2) = grid_ptr(grid)%lb(2)
         nub(1) = grid_ptr(grid)%ub(1)
         nub(2) = location
         call make_grid(level,grid,grid_ptr,nlb,nub,box_max)

         nlb(1) = grid_ptr(grid)%lb(1)
         nlb(2) = location + 1
         nub(1) = grid_ptr(grid)%ub(1)
         nub(2) = grid_ptr(grid)%ub(2)
         call make_grid(level,grid,grid_ptr,nlb,nub,box_max)

      end if

      return
      end
!============================================================================
      subroutine compute_delta(shp,grid,grid_ptr,box_max,  &
                                sigmax,sigmay,delx,dely)
      USE def_grid
      implicit none
      integer                                    :: box_max
      integer                                    :: grid
      type(grd), dimension(box_max)              :: grid_ptr
      integer, dimension(2)                      :: shp
      integer, dimension(shp(2))                 :: sigmax
      integer, dimension(shp(1))                 :: sigmay
      integer, dimension(shp(2))                 :: delx 
      integer, dimension(shp(1))                 :: dely

! compute sigma in all 3 directions
      delx = 0
      dely = 0

      delx= cshift(sigmax,1,1) + cshift(sigmax,-1,1) - 2*cshift(sigmax,0,1)
      dely= cshift(sigmay,1,1) + cshift(sigmay,-1,1) - 2*cshift(sigmay,0,1)

      return
      end
!============================================================================
      logical function find_hole(box_max,level,grid,grid_ptr,   &
                                 sigmax,sigmay,shp) 
      USE def_grid
      implicit none
      integer                                    :: box_max
      type(grd), dimension(box_max)              :: grid_ptr
      integer                                    :: grid,level
      integer, dimension(2)                      :: shp
      integer, dimension(shp(2))                 :: sigmax
      integer, dimension(shp(1))                 :: sigmay
      integer                                    :: i,j,l
      integer                                    :: ilb,jlb,iub,jub
      integer, dimension(2)                      :: nlb,nub
		logical                                    :: start

      find_hole = .false.

! first elminate the edges

      if ( sigmax(grid_ptr(grid)%lb(1)) == 0 ) then
         do i = grid_ptr(grid)%lb(1),grid_ptr(grid)%ub(1)
            if (sigmax(i).ne.0) then
               grid_ptr(grid)%lb(1) = i
               exit
            end if
         end do
      end if

      if ( sigmay(grid_ptr(grid)%lb(2)) == 0 ) then
         do j = grid_ptr(grid)%lb(2),grid_ptr(grid)%ub(2)
            if (sigmay(j).ne.0) then
               grid_ptr(grid)%lb(2) = j
               exit
            end if
         end do
      end if

      if ( sigmax(grid_ptr(grid)%ub(1)) == 0 ) then
         do i = grid_ptr(grid)%ub(1),grid_ptr(grid)%lb(1),-1
            if (sigmax(i).ne.0) then
               grid_ptr(grid)%ub(1) = i
               exit
            end if
         end do
      end if

      if ( sigmay(grid_ptr(grid)%ub(2)) == 0 ) then
         do j = grid_ptr(grid)%ub(2),grid_ptr(grid)%lb(2),-1
            if (sigmay(j).ne.0) then
               grid_ptr(grid)%ub(2) = j
               exit
            end if
         end do
      end if

! now find any more holes  ...
      nlb(2) = grid_ptr(grid)%lb(2)
      nub(2) = grid_ptr(grid)%ub(2)
      nlb(1) = grid_ptr(grid)%lb(1)
      start  = .true.

      do i= grid_ptr(grid)%lb(1),grid_ptr(grid)%ub(1)
         if (start.and.sigmax(i).eq.0) then
            find_hole = .true.
            nub(1) = i - 1
            call make_grid(level,grid,grid_ptr,nlb,nub,box_max)
            start = .false.
         else if (.not.start.and.sigmax(i).ne.0) then
            nlb(1) = i
            start = .true.
         end if
      end do

      if (start.and.nlb(1).ne.grid_ptr(grid)%lb(1)) then
         nub(1) = grid_ptr(grid)%ub(1)
         call make_grid(level,grid,grid_ptr,nlb,nub,box_max)   
      end if

! assume now that the first point is not a zero ...
      nlb(1) = grid_ptr(grid)%lb(1)
      nub(1) = grid_ptr(grid)%ub(1)
      nlb(2) = grid_ptr(grid)%lb(2)
		start  = .true.
      
      do j = grid_ptr(grid)%lb(2),grid_ptr(grid)%ub(2)
         if (start.and.sigmay(j).eq.0) then
            find_hole = .true.
            nub(2) = j - 1
            call make_grid(level,grid,grid_ptr,nlb,nub,box_max) 
				start = .false.
			else if (.not.start.and.sigmay(j).ne.0) then
				nlb(2) = j
		      start = .true.
         end if
      end do

      if (start.and.nlb(2).ne.grid_ptr(grid)%lb(2)) then
         nub(2) = grid_ptr(grid)%ub(2)
         call make_grid(level,grid,grid_ptr,nlb,nub,box_max) 
		end if

! one more check
! we could of made this box 3x3 or smaller so we must make this
! say that we found a box, thus,  this box would then be finished

		if ( (grid_ptr(grid)%ub(1)-grid_ptr(grid)%lb(1).le.3).and. &
           (grid_ptr(grid)%ub(2)-grid_ptr(grid)%lb(2).le.3)) then
			find_hole = .true.
		end if

      return
      end
!============================================================================
      subroutine make_grid(level,grid,grid_ptr,nlb,nub,box_max)
      USE def_grid
      implicit none
      integer                                    :: grid,level
      integer                                    :: box_max
      type(grd), dimension(box_max)              :: grid_ptr
      integer, dimension(2)                      :: nlb,nub
      integer                                    :: new_grid_num
      integer                                    :: get_grid

! first thing is to find the next grid number

      new_grid_num = get_grid()

      if ( lhead(level+1) == UNDEF )  then

         grid_ptr(grid)%child           = new_grid_num
         grid_ptr(new_grid_num)%parent  = grid 
         lhead(level+1)                 = new_grid_num

      else

         grid_ptr(grid)%child            = new_grid_num
         grid_ptr(new_grid_num)%parent   = grid 
         grid_ptr(new_grid_num)%neighbor = lhead(level+1)
         lhead(level+1)                  = new_grid_num

      end if

      grid_ptr(new_grid_num)%lb(1)  = nlb(1)
      grid_ptr(new_grid_num)%lb(2)  = nlb(2)
      grid_ptr(new_grid_num)%ub(1)  = nub(1)
      grid_ptr(new_grid_num)%ub(2)  = nub(2)

      return
      end
!============================================================================
      integer function  get_grid() 
      USE def_grid
      implicit none
      integer i

      do i = 1 , max_stor
         if (lnext(i).eq.UNDEF) then
            lnext(i) = 1 
            get_grid = i
            return
         end if
      end do

      write(0,*) 'MUST increase max_stor in the module that is in clustering' 
      stop
      end
!============================================================================
      subroutine compute_sigma(grid,grid_ptr,msk,shp,box_max,      &
                               sigmax,sigmay) 
      USE def_grid
      implicit none
      integer                                    :: box_max
      type(grd), dimension(box_max)              :: grid_ptr
      integer, dimension(2)                      :: shp 
      integer, dimension(shp(1),shp(2))          :: msk
      integer                                    :: grid
      integer, dimension(shp(1))                 :: sigmax 
      integer, dimension(shp(2))                 :: sigmay 
      integer                                    :: i,j


! compute sigma in all 3 directions
      sigmax = 0
      sigmay = 0

      do i = grid_ptr(grid)%lb(1),grid_ptr(grid)%ub(1)
         do j = grid_ptr(grid)%lb(2),grid_ptr(grid)%ub(2)
            sigmax(i) = sigmax(i) + msk(i,j)
         end do
      end do

      do j = grid_ptr(grid)%lb(2),grid_ptr(grid)%ub(2)
         do i = grid_ptr(grid)%lb(1),grid_ptr(grid)%ub(1)
            sigmay(j) = sigmay(j) + msk(i,j)
         end do
      end do

      return
      end
!============================================================================
      integer function init_tree(grid_ptr,box_max,shp)
      USE def_grid
      implicit none
      integer                                    :: box_max
      type(grd), dimension(box_max)              :: grid_ptr
      integer, dimension(2)                      :: shp 

      grid_ptr%parent   = UNDEF
      grid_ptr%child    = UNDEF
      grid_ptr%neighbor = UNDEF
      grid_ptr%sibling  = UNDEF
      lhead             = UNDEF
      grid_ptr%lb(1)       = UNDEF
      grid_ptr%lb(2)       = UNDEF
      grid_ptr%ub(1)       = UNDEF
      grid_ptr%ub(2)       = UNDEF
      
      lhead(1)           = 1
      grid_ptr(1)%lb(1)  = 1
      grid_ptr(1)%lb(2)  = 1
      grid_ptr(1)%ub(1)  = shp(1) 
      grid_ptr(1)%ub(2)  = shp(2) 
      lnext(1) = 1

      init_tree = 1

      return
      end
!============================================================================
      real*8 function comput_eff(grid,grid_ptr,msk,shp,box_max)
      USE def_grid
      implicit none
      integer                                    :: grid
      integer, dimension(2)                      :: shp
      integer, dimension(shp(1),shp(2))   :: msk
      integer                                    :: box_max
      type(grd), dimension(box_max)              :: grid_ptr
      integer                                    :: i,j


      comput_eff = 0.0d0

      do i = grid_ptr(grid)%lb(1), grid_ptr(grid)%ub(1)
         do j = grid_ptr(grid)%lb(2), grid_ptr(grid)%ub(2)
            comput_eff = comput_eff + 1.0d0* msk(i,j)
         end do
      end do

		if ( ((grid_ptr(grid)%ub(1)-grid_ptr(grid)%lb(1)).gt.2).or.   &
           ((grid_ptr(grid)%ub(2)-grid_ptr(grid)%lb(2)).gt.2) ) then

      comput_eff = comput_eff &
                       / ( (grid_ptr(grid)%ub(1)-grid_ptr(grid)%lb(1)+1) *  &
                           (grid_ptr(grid)%ub(2)-grid_ptr(grid)%lb(2)+1) ) 
		else
			comput_eff = 1.0d0
		end if

      return
      end

      integer function sign(num)
      implicit none
      integer num

      if (num.lt.0) then
         sign = -1
      else if (num.gt.0) then
         sign = +1
      else 
         sign = 0
      end if 

      return
      end 
