! This program creates a ring, so the inputs need to be r1 and r2
      program test_clst
      implicit none
      integer nx,ny,nz
		parameter ( nx=33,ny=33,nz=33) 
      real*8 f(nx,ny,nz),r(nx,ny,nz) 
      integer msk(nx,ny,nz)
		real*8 mskr(nx,ny,nz)
		real*8 x(nx),y(ny),z(nz)
		real*8 xmin,ymin,zmin
		parameter ( xmin = -1.0d0,ymin=-1.0d0,zmin=-1.0d0)
      real*8  h, maxv
		integer              lb(3),ub(3),shape(3)
		integer              blk_overlap
		integer box_max
		parameter ( box_max = 100) 
		integer           box_no
		integer   box_stk_lb(3,box_max),box_stk_ub(3,box_max)
		integer   box_stk(6,box_max)
		real*8            min_eff,r1,r2
		integer   i,j,k

		h = -2*xmin/(nx - 1)
		do i= 1 , 3
		   lb(i) = 0
		end do
	   ub(1) = nx - 1
	   ub(2) = ny - 1
	   ub(3) = nz - 1
		shape(1) = nx
		shape(2) = ny
		shape(3) = nz
		blk_overlap= 1
		write(6,*) 'input the min efficiency,r1,r2'
		read(5,*) min_eff,r1,r2


		do i = 1 , nx
			x(i) = xmin + h*(i-1)
		end do
		do i = 1 , ny
			y(i) = ymin + h*(i-1) 
		end do
		do i = 1 , nz
			z(i) = zmin + h*(i-1) 
		end do

		do k = 1 , nz
			do j = 1 ,ny
				do i = 1 , nx
					r(i,j,k) = sqrt(x(i)**2+y(j)**2+z(k)**2)
				end do
			end do
		end do

		do k = 1 ,nz
			do j = 1 , ny
				do i = 1 , nx
					if (r(i,j,k).ge.r1.and.r(i,j,k).le.r2) then
						msk(i,j,k) = 1
						mskr(i,j,k) = 1.0d0
					else
						msk(i,j,k) = 0
						mskr(i,j,k) = 0.0d0
					end if
				end do
			end do
		end do

		call cls_3d(msk,shape,blk_overlap,
     &            box_max,box_no,box_stk_lb,
     &            box_stk_ub,min_eff)

		call make_box(box_no,box_stk_lb,box_stk_ub,box_stk)

		call out_clstr(nx,ny,nz,box_no,mskr,box_stk,1,
     &               x,y,z,'flag.hdf','box.dat')

		write(6,*) 'Total # of boxes = ',box_no

		do i = 1 , box_no
			write(6,100) box_stk(1,i),box_stk(2,i), 
     &                box_stk(3,i), 
     &                box_stk(4,i),box_stk(5,i), 
     &                box_stk(6,i)

		end do

100   format(1P,6i6)

		stop
		end

		subroutine make_box(box_no,box_stk_lb,box_stk_ub,box_stk)
		implicit none
		integer box_no
		integer box_stk_lb(3,box_no),box_stk_ub(3,box_no)
		integer box_stk(6,box_no)

		integer i,j

		do i =1 , box_no
			do j= 1, 3
				box_stk(j,i) = box_stk_lb(j,i)
				box_stk(j+3,i)=box_stk_ub(j,i)
			end do
		end do

		return
		end
!------------------------------------------------------------------------
!
! Routine that outputs what the clustering algorithm has done to the
!  data given initially
!
!   box_stk(1-3,i) contains nx_lo, ny_lo, nz_lo - of the ith box
!   box_stk(4-6,i) contains nx_hi, ny_hi, nz_hi - of the ith box
!
!   fnamef - contains the flagged points.
!   fnameb - contains the box info.
!
!-----------------------------------------------------------------------
      subroutine out_clstr(nx,ny,nz,no_boxes,big_box,box_stk,
     &                     level, 
     &                     cx,cy,cz,fnamef,fnameb)

      implicit none

         integer ind, indlnb
         integer nx,ny,nz,no_boxes, i,j,k, level
         character*(*) fnamef, fnameb

         real*8 xmin,xmax,ymin,ymax,zmin,zmax
         integer bnx,bny,bnz

         integer box_stk(6,no_boxes)
         integer    gf3_rc, gf3_write_hdf_f77
         integer    dshape(3),       cshape(3)
         real*8     big_box(nx,ny,nz),cx(nx),cy(ny),cz(nz)

         if (nx.gt.100.or.ny.gt.100.or.nz.gt.100) then
            call error('Out_clstr: box size too large. > 100.')
         end if

         open(unit=7,file=fnameb(1:indlnb(fnameb)),form='formatted',   
     &           err=900)
         write(7,10)0.0d0,0.0d0,0.0d0, 0.0d0,0.0d0,0.0d0, 0, 0, 0, 0
         do i = 1,no_boxes
            xmin = (box_stk(1,i)) *1.0d0 +1.0d0
            xmax = (box_stk(4,i)) *1.0d0 +1.0d0
            ymin = (box_stk(2,i)) *1.0d0 +1.0d0
            ymax = (box_stk(5,i)) *1.0d0 +1.0d0
            zmin = (box_stk(3,i)) *1.0d0 +1.0d0
            zmax = (box_stk(6,i))*1.0d0
				bnx = 5
				bny = 5
				bnz = 5
            write(7,10)xmin,xmax,ymin,ymax,zmin,zmax,bnx,bny,bnz,i
         end do
         close(7)

         cshape(1) = nx
         cshape(2) = ny
         cshape(3) = nz

         dshape(1) = nx
         dshape(2) = ny
         dshape(3) = nz

			do i = 1 ,nx
				cx(i) = 1.0d0*i 
			end do
			do j = 1 ,ny
				cy(j) = 1.0d0*j
			end do
			do k = 1 ,nz
				cz(k) = 1.0d0*k
			end do
         gf3_rc = gf3_write_hdf_f77(fnamef(1:indlnb(fnamef)),        
     &            'flagged_pts',cshape, cx, cy, cz, dshape, big_box)
         if( gf3_rc .ne. 0 ) then
            call error('Out_clstr: Error writing flag file')
         end if

      return
  10  format(1p,6e13.5,4i4)
 900  continue
      write(8,*)'Out_clstr: error opening ',fnameb(1:indlnb(fnameb))
      stop
      end
