! This program creates a ring, so the inputs need to be r1 and r2
      program test_clst
      implicit none
      integer nx,ny
		parameter ( nx=33,ny=33) 
      real*8 f(nx,ny),r(nx,ny) 
      integer msk(nx,ny)
		real*8 mskr(nx,ny)
		real*8 x(nx),y(ny)
		real*8 xmin,ymin
		parameter ( xmin = -1.0d0,ymin=-1.0d0) 
      real*8  h, maxv
		integer              lb(2),ub(2),shape(2)
		integer              blk_overlap
		integer box_max
		parameter ( box_max = 1000) 
		integer           box_no
		integer   box_stk_lb(2,box_max),box_stk_ub(2,box_max)
		real*8    min_eff,r1,r2
		integer   i,j,l
		character*1 outg(2*nx-1,2*ny-1)

		h = -2*xmin/(nx - 1)
		do i= 1 , 2
		   lb(i) = 0
		end do

	   ub(1) = nx - 1
	   ub(2) = ny - 1

		shape(1) = nx
		shape(2) = ny

		blk_overlap= 0
		write(6,*) 'input the min efficiency,r1,r2'
		min_eff = 0.75d0
		r1 = 0.30d0
		r2 = 0.60d0
		read(5,*) min_eff,r1,r2


		do i = 1 , nx
			x(i) = xmin + h*(i-1)
		end do
		do i = 1 , ny
			y(i) = ymin + h*(i-1) 
		end do

		do j = 1 ,ny
			do i = 1 , nx
				r(i,j) = sqrt(x(i)**2+y(j)**2) 
			end do
		end do

		do j = 1 , ny
			do i = 1 , nx
				if (r(i,j).ge.r1.and.r(i,j).le.r2) then
					msk(i,j) = 1
					mskr(i,j) = 1.0d0
				else
					msk(i,j) = 0
					mskr(i,j) = 0.0d0
				end if
			end do
		end do

      open(88,file='mask.dat')
      do j= 1 , ny
         do i = 1 ,nx
            write(88,'(i1)',advance = "NO") msk(i,j)
         end do
         write(88,*)
      end do
		close(88)


		call cls_2d(msk,shape,blk_overlap,
     &            box_max,box_no,box_stk_lb,
     &            box_stk_ub,min_eff)

		write(6,*) 'Total # of boxes = ',box_no

		open(89,file='box.dat')
		do i = 1 , box_no
			write(89,100) box_stk_lb(1,i),box_stk_ub(1,i),
     .                 box_stk_lb(2,i),box_stk_ub(2,i)
		end do

		outg = ' '
		do j = 1 , ny
		   do i = 1 , nx
				if (msk(i,j).eq.0) then
				   outg(2*i-1,2*j-1) = '0'
				else
					outg(2*i-1,2*j-1) = '1'
				end if
			end do
		end do

		do l = 1 , box_no 
			   j = box_stk_lb(2,l)
			   do i = box_stk_lb(1,l),box_stk_ub(1,l)
					outg(2*i-2,2*j-2) = '-'
					outg(2*i-1,2*j-2) = '-'
					outg(2*i,2*j-2) = '-'
				end do
			   j = box_stk_ub(2,l)
            do i = box_stk_lb(1,l),box_stk_ub(1,l)
               outg(2*i-2,2*j) = '-'
               outg(2*i-1,2*j) = '-'
               outg(2*i,2*j) = '-'
            end do
		end do


      do l = 1 , box_no 
            i = box_stk_lb(1,l)
            do j = box_stk_lb(2,l),box_stk_ub(2,l)
               outg(2*i-2,2*j-2) = '|'
               outg(2*i-2,2*j-1) = '|'
               outg(2*i-2,2*j) = '|'
            end do
            i = box_stk_ub(1,l)
            do j = box_stk_lb(2,l),box_stk_ub(2,l)
               outg(2*i,2*j-2) = '|'
               outg(2*i,2*j-1) = '|'
               outg(2*i,2*j) = '|'

            end do
      end do


		open(90,file='graph.dat')
			do j = 1 ,2*ny-1
				do i = 1, 2*nx-1
					write(90,'(a1)',advance = "NO") outg(i,j)
				end do
				write(90,*)
			end do
		close(90)


100   format('(',i5,':',i5,',',i5,':',i5,')')

		stop
		end
