! This program creates a ring, so the inputs need to be r1 and r2
      program test_clst
      implicit none
      integer nx,ny,nz
      parameter ( nx=33,ny=33,nz=33) 
      real*8 f(nx,ny,nz),r(nx,ny,nz) 
      integer msk(nx,ny,nz)
      real*8 mskr(nx,ny,nz)
      real*8 x(nx),y(ny),z(nz)
      real*8 xmin,ymin,zmin
      parameter ( xmin = -1.0d0,ymin=-1.0d0,zmin=-1.0d0)
      real*8  h, maxv
      integer              lb(3),ub(3),shape(3)
      integer              blk_overlap
      integer box_max
      parameter ( box_max = 1000) 
      integer           box_no
      integer   box_stk_lb(3,box_max),box_stk_ub(3,box_max)
      integer   box_stk(6,box_max)
      real*8            min_eff,r1,r2
      integer   i,j,k,l,minlen2d
      character*1 outg(2*nx-1,2*ny-1,nz)
      character*9 names(2*nz-1),name
      integer   im,jm,km
      integer   im2,jm2,km2
      integer   im4,jm4,km4


      name = 'grk00.dat'

      do i = 1 , 1*nz
         write(name(4:5),'(i2)') i
         if (name(4:4).eq.' ') name(4:4) = '0'   
         names(i) = name
      end do
         
      h = -2*xmin/(nx - 1)
      do i= 1 , 3
         lb(i) = 0
      end do
      ub(1) = nx - 1
      ub(2) = ny - 1
      ub(3) = nz - 1
      shape(1) = nx
      shape(2) = ny
      shape(3) = nz
      blk_overlap= 0
      write(6,*) 'input the min efficiency,r1,r2,minlen2d'
      read(5,*) min_eff,r1,r2,minlen2d


      do i = 1 , nx
         x(i) = xmin + h*(i-1)
      end do
      do i = 1 , ny
         y(i) = ymin + h*(i-1) 
      end do
      do i = 1 , nz
         z(i) = zmin + h*(i-1) 
      end do

!        goto 800

      do k = 1 , nz
         do j = 1 ,ny
            do i = 1 , nx
               r(i,j,k) = sqrt(x(i)**2+y(j)**2+z(k)**2)
            end do
         end do
      end do

      do k = 1 ,nz
         do j = 1 , ny
            do i = 1 , nx
               if (r(i,j,k).ge.r1.and.r(i,j,k).le.r2) then
                  msk(i,j,k) = 1
                  mskr(i,j,k) = 1.0d0
               else
                  msk(i,j,k) = 0
                  mskr(i,j,k) = 0.0d0
               end if
            end do
         end do
      end do
800   continue
       goto 900

! let's try 2 squares

      im = int( (nx+1)/2)
      jm = int( (ny+1)/2)
      km = int( (nz+1)/2)

      im2 = int(im/2) 
      jm2 = int(jm/2)
      km2 = int( km/2)

      im4 = int(im/4)
      jm4 = int(jm/4)
      km4 = int(km/4)

      msk = 0
      mskr = 0.0d0
      im = im + im2 
      jm = jm + jm2 
      km = km + km2 
      msk(im-im4:im+im4,jm-jm4:jm+jm4,km-km4:km+km4) = 1
      mskr(im-im4:im+im4,jm-jm4:jm+jm4,km-km4:km+km4) = 1.0d0
      im = im - im2 - 1
      jm = jm - jm2 - 1
      km = km - km2 - 1
      msk(im-im4:im+im4,jm-jm4:jm+jm4,km-km4:km+km4) = 1
      mskr(im-im4:im+im4,jm-jm4:jm+jm4,km-km4:km+km4) = 1.0d0
900   continue   
      call cls_3d(msk,shape,blk_overlap,
     &            box_no,box_stk_lb,
     &            box_stk_ub,min_eff,minlen2d)

      write(6,*) 'Total # of boxes = ',box_no

      open(80,file='box3d.dat')

      write(80,*) box_no
      do i = 1 , box_no
         write(80,100) box_stk_lb(1,i),box_stk_lb(2,i), 
     &                box_stk_lb(3,i), 
     &                box_stk_ub(1,i),box_stk_ub(2,i), 
     &                box_stk_ub(3,i)

      end do

!      stop

      outg = ' '
      do k = 1 , nz
         do j = 1 , ny
            do i = 1 , nx
               if (msk(i,j,k).eq.0) then
                  outg(2*i-1,2*j-1,k) = '0'
               else
                  outg(2*i-1,2*j-1,k) = '1'
               end if
            end do
         end do
      end do




      do l = 1 , box_no
            i = box_stk_lb(1,l)
            do k = box_stk_lb(3,l),box_stk_ub(3,l)
               do j = box_stk_lb(2,l),box_stk_ub(2,l)
                  outg(2*i-2,2*j-2,k) = '|'
                  outg(2*i-2,2*j-1,k) = '|'
                  outg(2*i-2,2*j,k) = '|'
               end do
            end do
            i = box_stk_ub(1,l)
            do k = box_stk_lb(3,l),box_stk_ub(3,l)
               do j = box_stk_lb(2,l),box_stk_ub(2,l)
                  outg(2*i,2*j-2,k) = '|'
                  outg(2*i,2*j-1,k) = '|'
                  outg(2*i,2*j,k) = '|'
               end do
            end do

      end do


      do l = 1 , box_no
            j = box_stk_lb(2,l)
            do k = box_stk_lb(3,l),box_stk_ub(3,l)
               do i = box_stk_lb(1,l),box_stk_ub(1,l)
                  outg(2*i-2,2*j-2,k) = '-'
                  outg(2*i-1,2*j-2,k) = '-'
                  outg(2*i,2*j-2,k) = '-'
               end do
            end do
            j = box_stk_ub(2,l)
            do k = box_stk_lb(3,l),box_stk_ub(3,l)
               do i = box_stk_lb(1,l),box_stk_ub(1,l)
                  outg(2*i-2,2*j,k) = '-'
                  outg(2*i-1,2*j,k) = '-'
                  outg(2*i,2*j,k) = '-'
               end do
            end do

      end do

      close(67)
         do k = 1 ,nz
            open(90,file=names(k))
            do j = 1 ,2*ny-1
               do i = 1, 2*nx-1
                  write(90,'(a1)',advance = "NO") outg(i,j,k)
               end do
               write(90,'(a1)',advance="YES") " "

            end do
            close(90)
         end do


100   format(1P,6i6)

      stop
      end
