      program test_clst
      implicit none
      integer,parameter          :: nx=17,ny=17,nz=17
      real*8, dimension(nx,ny,nz):: f,r
      integer, dimension(nx,ny,nz):: msk 
      real*8, dimension(nx)      :: x
      real*8, dimension(ny)      :: y
      real*8, dimension(nz)      :: z
      real*8, parameter          :: xmin=-1.0d0,ymin=-1.0d0,zmin=-1.0d0
      real*8                     :: h, maxv
		integer, dimension(3)      :: lb,ub,shape
		integer                    :: blk_wid,buf_wid
		integer,parameter          :: box_max = 20
		integer                    :: box_no
		integer,dimension(3,box_max) :: box_stk_lb,box_stk_ub
		real*8                     :: min_eff
		integer                    :: i,j,k

		h = -2*xmin/(nx - 1)
		lb = 0
		ub = nx - 1
		shape = nx
		blk_wid = 1
		buf_wid = 1
		write(6,*) 'input the min efficiency,maxv'
		read(5,*) min_eff,maxv


		do i = 1 , nx
			x(i) = xmin + h*(i-1) + h/2
		end do
		do i = 1 , ny
			y(i) = ymin + h*(i-1) + h/2
		end do
		do i = 1 , nz
			z(i) = zmin + h*(i-1) + h/2
		end do

		do k = 1 , nz
			do j = 1 ,ny
				do i = 1 , nx
					r(i,j,k) = sqrt(x(i)**2+y(j)**2+z(k)**2)
				end do
			end do
		end do

		f = 1 / r

		where( f > maxv) 
			msk = 1
		else where
			msk = 0
		end where

		call dagh_cls_3d(msk,lb,ub,shape,blk_wid,buf_wid,
     &                 box_max,box_no,box_stk_lb,box_stk_ub,min_eff)

		write(6,*) 'Total # of boxes = ',box_no
		do i = 1 , box_no
			write(6,100) x(box_stk_lb(1,i)),y(box_stk_lb(2,i)), 
     &                z(box_stk_lb(3,i)), 
     &                x(box_stk_ub(1,i)),y(box_stk_ub(2,i)), 
     &                z(box_stk_ub(3,i))

		end do

100   format(1P,6e10.2)

		stop
		end
