! This program creates a ring, so the inputs need to be r1 and r2
      program test_clst
      implicit none
      integer nx,ny,nz
		parameter ( nx=33,ny=33,nz=33) 
      real*8 f(nx,ny,nz),r(nx,ny,nz) 
      integer msk(nx,ny,nz)
		real*8 mskr(nx,ny,nz)
		real*8 x(nx),y(ny),z(nz)
		real*8 xmin,ymin,zmin
		parameter ( xmin = -1.0d0,ymin=-1.0d0,zmin=-1.0d0)
      real*8  h, maxv
		integer              lb(3),ub(3),shape(3)
		integer              blk_wid,buf_wid
		integer box_max
		parameter ( box_max = 100) 
		integer           box_no
		integer   box_stk_lb(3,box_max),box_stk_ub(3,box_max)
		integer   box_stk(6,box_max)
		real*8            min_eff,r1,r2
		integer   i,j,k

		h = -2*xmin/(nx - 1)
		do i= 1 , 3
		   lb(i) = 0
		end do
	   ub(1) = nx - 1
	   ub(2) = ny - 1
	   ub(3) = nz - 1
		shape(1) = nx
		shape(2) = ny
		shape(3) = nz
		blk_wid = 1
		buf_wid = 0
		write(6,*) 'input the min efficiency,r1,r2'
		read(5,*) min_eff,r1,r2


		do i = 1 , nx
			x(i) = xmin + h*(i-1)
		end do
		do i = 1 , ny
			y(i) = ymin + h*(i-1) 
		end do
		do i = 1 , nz
			z(i) = zmin + h*(i-1) 
		end do

		do k = 1 , nz
			do j = 1 ,ny
				do i = 1 , nx
					r(i,j,k) = sqrt(x(i)**2+y(j)**2+z(k)**2)
				end do
			end do
		end do

!		f = 1 / r
		do k = 1 ,nz
			do j = 1 , ny
				do i = 1 , nx
					if (r(i,j,k).ge.r1.and.r(i,j,k).le.r2) then
						msk(i,j,k) = 1
						mskr(i,j,k) = 1.0d0
					else
						msk(i,j,k) = 0
						mskr(i,j,k) = 0.0d0
					end if
				end do
			end do
		end do

		call dagh_cls_3d(msk,lb,ub,shape,blk_wid,buf_wid,
     &                 box_max,box_no,box_stk_lb,box_stk_ub,min_eff)

		call make_box(box_no,box_stk_lb,box_stk_ub,box_stk)

		call out_clstr(nx,ny,nz,box_no,mskr,box_stk,1,
     &               x,y,z,'flag.hdf','box.dat')

		write(6,*) 'Total # of boxes = ',box_no

		do i = 1 , box_no
			write(6,100) box_stk(1,i),box_stk(2,i), 
     &                box_stk(3,i), 
     &                box_stk(4,i),box_stk(5,i), 
     &                box_stk(6,i)

		end do

100   format(1P,6i6)

		stop
		end

		subroutine make_box(box_no,box_stk_lb,box_stk_ub,box_stk)
		implicit none
		integer box_no
		integer box_stk_lb(3,box_no),box_stk_ub(3,box_no)
		integer box_stk(6,box_no)

		integer i,j

		do i =1 , box_no
			do j= 1, 3
				box_stk(j,i) = box_stk_lb(j,i)
				box_stk(j+3,i)=box_stk_ub(j,i)
			end do
		end do

		return
		end
