c
c     Argument processing routines 
c
      double precision function r8arg(argno,defval)

         implicit       none
         
         real*8         r8_never
         parameter    ( r8_never = -1.0d-60 )

         integer        i4_never 
         parameter    ( i4_never = -2 000 000 000 )

         logical        onedot 
         integer        iargc
         real*8         s2r8

         integer        argno
         real*8         defval

         character*32   argi

         if( argno .le. iargc() ) then
            call getarg(argno,argi)
            if( onedot(argi) ) then
               r8arg = defval
            else 
               r8arg = s2r8(argi)
               if( r8arg .eq. r8_never ) then
                  r8arg = defval
               end if
            end if
         else
            r8arg = defval
         end if

         return

      end

      integer function i4arg(argno,defval)

         implicit       none
         
         real*8         r8_never
         parameter    ( r8_never = -1.0d-60 )

         integer        i4_never 
         parameter    ( i4_never = -2 000 000 000 )

         logical        onedot
         integer        iargc
         integer        s2i4

         integer        argno
         integer        defval

         character*32   argi

         if( argno .le. iargc() ) then
            call getarg(argno,argi)
            if( onedot(argi) ) then
               i4arg = defval
            else
               i4arg = s2i4(argi)
               if( i4arg .eq. i4_never ) then
                  i4arg = defval
               end if
            end if
         else
            i4arg = defval
         end if

         return

      end

      character*128 function sarg(argno,defval)

         implicit        none

         integer         iargc

         logical         onedot
         integer         argno
         character*(*)   defval

         if( argno .le. iargc() ) then
            call getarg(argno,sarg)
            if( onedot(sarg) ) then
               sarg = defval
            end if
         else 
            sarg = defval
         end if

         return
      
      end
c
c-----------------------------------------------------------------------
c
c     Advances to end-of-file on unit LU for FTYPE:0 formatted,
c                                            FTYPE:1 unformatted.
c
c-----------------------------------------------------------------------
c
      subroutine toeof(lu,ftype)
c
         implicit      logical*1 (a-z)
c
         integer       ftype,   lu,    lcount
         character*1   char
c
         if( ftype .eq. 0 ) then
 100        continue
               lcount = lcount + 1
               read(lu,110,end=150) char
 110           format(a1)
            go to 100
 150        continue
            backspace lu
         else if( ftype .eq. 1 ) then
 200        continue
               read(lu,    end=250)
            go to 200
 250        continue
            backspace lu
         else
            WRITE(*,*) '<<< TOEOF: Invalid file type code: ',
     *                 FTYPE,'. >>>'
         end if
c
         return
c
      end
c
c     For parameter handling.
c
      logical function onedot(s)

         character*(*)     s

         integer           indlnb

         onedot = s(1:1) .eq. '.'  .and.  indlnb(s) .eq. 1

         return

      end

c
c     String to double precision ...
c
      double precision function s2r8(s)

         implicit      none

			real*8       r8_never
			parameter  ( r8_never = -1.0d-60 )

			integer      i4_never 
			parameter  ( i4_never = -2 000 000 000 )

         integer       indlnb

         character*(*) s     

         character*32  buffer
         integer       lens

         double precision default
         parameter      ( default = 0.0d0 )

         lens = indlnb(s)
         if( lens .gt. 99 ) then
            write(*,*) '>>> s2r8:: String too long for conversion.'
            s2r8 = default
         else 
            if( lens .le. 9 ) then
               write(buffer,100) lens
            else 
               write(buffer,101) lens
            end if
 100        format('(G',i1,'.0)')
 101        format('(G',i2,'.0)')
            read(s,fmt=buffer,end=900,err=900) s2r8
         end if

         return

 900        s2r8 = r8_never 
         return

      end
c
c     String to integer ...
c
      integer function s2i4(s)

         implicit      none

			real*8       r8_never
			parameter  ( r8_never = -1.0d-60 )

			integer      i4_never 
			parameter  ( i4_never = -2 000 000 000 )

         integer       indlnb

         character*(*) s     

         character*32  buffer
         integer       lens

         integer       default
         parameter   ( default = 0 )

         lens = indlnb(s)
         if( lens .gt. 99 ) then
            write(*,*) '>>> s2i4:: String too long for conversion.'
            s2i4 = default
         else 
            if( lens .le. 9 ) then
               write(buffer,100) lens
            else 
               write(buffer,101) lens
            end if
 100        format('(I',i1,')')
 101        format('(I',i2,')')
            read(s,fmt=buffer,end=900,err=900) s2i4
         end if

         return

 900        s2i4 = i4_never
         return

      end

c-----------------------------------------------------------------------
c
c     Returns index of last non-blank character in S.
c
c-----------------------------------------------------------------------
c
      integer function indlnb(s)
c
         character*(*)    s
         integer          i
c
         do 10 indlnb = len(s) , 1 , -1
            IF( S(INDLNB:INDLNB) .NE. ' ' ) RETURN
 10      continue
         indlnb = 0
c
         return
c
      end
