C wrapper routines for interps
C Case 1:
C option is 1 if you want just the boundary interpolated
C the first implementation will just interpolate the to dimension rank
C and copy the temporary storage into the uout array
C------------------------------------------------------------------------------
      integer function bbhintdgx0(rank,p,uin,uout,shpin,shpout,
     .                            bbin,bbout,wksp,nwksp,option)
      implicit none
      integer rank, p
      integer rho
      real*8   uin(*),uout(*)
      integer shpin(rank)
      integer interps
      integer shpout(3)
      integer shpin_p(3),shpout_p(3)
      real*8  bbin(2*rank),bbout(2*rank)
      integer ibb_in(6),ibb_out(6),nwksp
      real*8  wksp(nwksp)
      integer grid_ptr(2)
      integer option

      real*8 chin,chout,wkspc,wkspf
      real*8 xf,lx,ly,lz,lout,xc
      integer func,l,lsize
      integer get_bounds,define_grids,get_ptr,gsize,gsize2

C if the nwksp = 1 then we have the normal situation


      if (nwksp.gt.1) then
         do l = 1 , rank 
            if (p.gt.shpin(l)-1.or.p.gt.12.or.p.lt.2) then
               bbhintdgx0 = 1
               return
            end if
         end do
   
         bbhintdgx0=get_bounds(rank,shpin,shpout,bbin,bbout,
     .                         ibb_in,ibb_out)
			if (bbhintdgx0.eq.1) return

10       format(2i6)

         if (bbhintdgx0.eq.1) return

         grid_ptr(1) = 1

         gsize = 1

         do l = 1 , rank
         
            gsize = ( 1 + ibb_in(2*l) - ibb_in(2*l-1) ) * gsize 
            shpin_p(l) = ( 1 + ibb_in(2*l) - ibb_in(2*l-1) )
         end do
   
         grid_ptr(2) = 1 + gsize
   
         gsize2= 1
   
         do l = 1 , rank
            gsize2 = ( 1 + ibb_out(2*l) - ibb_out(2*l-1) ) * gsize2
            shpout_p(l) = ( 1 + ibb_out(2*l) - ibb_out(2*l-1) )
         end do
   
         if (gsize+gsize2.gt.nwksp) then
            write(0,*) 'increase temporary storage memory'
            bbhintdgx0 = 1
            return
         end if
   
         if (rank.eq.3) then
            call define_g1p3d(shpin,shpin_p,ibb_in,
     .                        uin,wksp(grid_ptr(1)))
         else if (rank.eq.2) then
            call define_g1p2d(shpin,shpin_p,ibb_in,
     .                        uin,wksp(grid_ptr(1)))
         else if (rank.eq.1) then
            call define_g1p1d(shpin,shpin_p,ibb_in,
     .                        uin,wksp(grid_ptr(1)))
         else
            bbhintdgx0 = 1
            return
         end if

         bbhintdgx0 = interps( rank,p,wksp(grid_ptr(1)),
     .                         wksp(grid_ptr(2)),chin,
     .                         chout,wkspc,wkspf,
     .                         xf,lx,ly,lz,lout,shpin_p,shpout_p,1,1,
     .                         1,1,1,1,0,1,xc,.false.,func)

         if (rank.eq.3) then
            call copy_g1p3d(shpout,shpout_p,ibb_out,
     .                      uout,wksp(grid_ptr(2)),option)
         else if (rank.eq.2) then
            call copy_g1p2d(shpout,shpout_p,ibb_out,
     .                        uout,wksp(grid_ptr(2)),option)
         else if (rank.eq.3) then
            call copy_g1p1d(shpout,shpout_p,ibb_out,
     .                        uout,wksp(grid_ptr(2)),option)
         else
            bbhintdgx0 = 1
            return
         end if

      else

         bbhintdgx0 = interps( rank,p,uin,uout,chin,chout,wkspc,wkspf,
     .                         xf,lx,ly,lz,lout,shpin,shpout,1,1,
     .                         1,1,1,1,0,1,xc,.false.,func)

      end if


      return
		end
C------------------------------------------------------------------------------
      integer function bbhintdgx1(rank,p,uin,uout,shpin,shpout,
     .                            bbin,bbout,wksp,nwksp,option,
     .                            chin,chout)
      implicit none
      integer rank, p
      integer rho
      real*8   uin(*),uout(*)
      real*8   chin(*),chout(*)
      integer shpin(rank)
      integer interps
      integer shpout(3)
      integer shpin_p(3),shpout_p(3)
      real*8  bbin(2*rank),bbout(2*rank)
      integer ibb_in(6),ibb_out(6),nwksp
      real*8  wksp(nwksp)
      integer grid_ptr(4)
      integer option

      real*8 wkspc,wkspf
      real*8 xf,lx,ly,lz,lout,xc
      integer func,l,lsize
      integer get_bounds,define_grids,get_ptr,gsize,gsize2

C if the nwksp = 1 then we have the normal situation


      if (nwksp.gt.1) then
         do l = 1 , rank 
            if (p.gt.shpin(l)-1.or.p.gt.12.or.p.lt.2) then
               bbhintdgx1 = 1
               return
            end if
         end do
   
         bbhintdgx1=get_bounds(rank,shpin,shpout,bbin,bbout,
     .                         ibb_in,ibb_out)
			if (bbhintdgx1.eq.1) return

10       format(2i6)

         if (bbhintdgx1.eq.1) return

         grid_ptr(1) = 1

         gsize = 1

         do l = 1 , rank
         
            gsize = ( 1 + ibb_in(2*l) - ibb_in(2*l-1) ) * gsize 
            shpin_p(l) = ( 1 + ibb_in(2*l) - ibb_in(2*l-1) )
         end do
   
         grid_ptr(2) = 1 + gsize
         grid_ptr(3) = grid_ptr(2) + gsize + 1
   
         gsize2= 1
   
         do l = 1 , rank
            gsize2 = ( 1 + ibb_out(2*l) - ibb_out(2*l-1) ) * gsize2
            shpout_p(l) = ( 1 + ibb_out(2*l) - ibb_out(2*l-1) )
         end do
         grid_ptr(4) = grid_ptr(3) + gsize2  + 1 

			write(6,*) grid_ptr(1),grid_ptr(2),grid_ptr(3),grid_ptr(4)
   
         if (2*(gsize+gsize2).gt.nwksp) then
            write(0,*) 'increase temporary storage memory'
            bbhintdgx1 = 1
            return
         end if
   
         if (rank.eq.3) then
            call define_g1p3d(shpin,shpin_p,ibb_in,
     .                        uin,wksp(grid_ptr(1)))
            call define_g1p3d(shpin,shpin_p,ibb_in,
     .                        chin,wksp(grid_ptr(2)))
         else if (rank.eq.2) then
            call define_g1p2d(shpin,shpin_p,ibb_in,
     .                        uin,wksp(grid_ptr(1)))
            call define_g1p2d(shpin,shpin_p,ibb_in,
     .                        chin,wksp(grid_ptr(2)))
         else if (rank.eq.1) then
            call define_g1p1d(shpin,shpin_p,ibb_in,
     .                        uin,wksp(grid_ptr(1)))
            call define_g1p1d(shpin,shpin_p,ibb_in,
     .                        chin,wksp(grid_ptr(2)))
         else
            bbhintdgx1 = 1
            return
         end if
C grid ptr is 1- uin, 2-chin, 3 -uout, 4 chout
         if (rank.eq.3) then
            call copy_g1p3d(shpout,shpout_p,ibb_out,
     .                      wksp(grid_ptr(4)),chout,option)
         else if (rank.eq.2) then
            call copy_g1p2d(shpout,shpout_p,ibb_out,
     .                        wksp(grid_ptr(4)),chout,option)
         else if (rank.eq.3) then
            call copy_g1p1d(shpout,shpout_p,ibb_out,
     .                        wksp(grid_ptr(4)),chout,option)
         else
            bbhintdgx1 = 1
            return
         end if


         bbhintdgx1 = interps( rank,p,wksp(grid_ptr(1)),
     .                         wksp(grid_ptr(3)),wksp(grid_ptr(2)),
     .                         wksp(grid_ptr(4)),wkspc,wkspf,
     .                         xf,lx,ly,lz,lout,
     .                         shpin_p,shpout_p,shpin_p,shpout_p,
     .                         1,1,1,1,0,1,xc,.false.,func)

         if (rank.eq.3) then
            call copy_g1p3d(shpout,shpout_p,ibb_out,
     .                      uout,wksp(grid_ptr(3)),option)
         else if (rank.eq.2) then
            call copy_g1p2d(shpout,shpout_p,ibb_out,
     .                        uout,wksp(grid_ptr(3)),option)
         else if (rank.eq.3) then
            call copy_g1p1d(shpout,shpout_p,ibb_out,
     .                        uout,wksp(grid_ptr(3)),option)
         else
            bbhintdgx1 = 1
            return
         end if

      else
         bbhintdgx1 = interps( rank,p,uin,uout,chin,chout,wkspc,wkspf,
     .                         xf,lx,ly,lz,lout,shpin,
     .                         shpout,shpin,shpout,
     .                         1,1,1,1,0,1,xc,.false.,func)

      end if

      return
      end
C------------------------------------------------------------------------------
C Case 3:
      integer function bbhintdgx2(rank,p,rho,uin,uout,shpin,chin,chout,
     .                            wksp,nwksp)
      implicit none
      integer  rank, p, nwksp
      integer  rho
      real*8   uin(*),uout(*)
      real*8   chin(*),chout(*)
      real*8   wksp(nwksp) 
      integer  shpin(rank)
      integer  interps
      integer  shpout(3)

      integer   maxp
      parameter ( maxp = 5000 )
      real*8    xf(maxp),lx,ly,lz,lout,xc
      integer   func
      integer   nwkspc, nwkspf, l, lc, lr,np 
      integer   ifail

      ifail = 1
      do l =1 , rank
         shpout(l) = shpin(l)*rho - (rho-1)
         ifail = ifail*shpout(l)
         if (p.gt.shpin(l)-1.or.p.gt.12.or.p.lt.2) then
            bbhintdgx2 = 1
            return
         end if
      end do

      ifail = nwksp - ifail
      if (ifail.lt.0) then
         bbhintdgx2 = 1
         write(0,*) '*** make the workspace larger ***'
         return
      end if

      nwkspc = 1
      nwkspf = 1

      do l = 1 , rank
         nwkspf = nwkspf*shpin(l) 
      end do

      nwkspf = nwkspf + 1

C need to generate xf ........

      lc = 0
      do lr = 1 , rank

         do l = 1, shpin(lr)*rho-(rho-1)
            lc = lc + 1
            if (lc.gt.maxp) then
               write(0,*) '*** too many points in bbhintdgx2 ***'
               bbhintdgx2 = 1
               return
            end if
            xf(lc) = 1.0d0*l
         end do
      end do

      bbhintdgx2 = interps( rank,p,uin,uout,chin,chout,
     .                      wksp(1),wksp(nwkspf),
     .                      xf,lx,ly,lz,lout,shpin,shpout,shpin,shpout,
     .                      shpin,shpout,shpout,1,0,1,xc,.false.,func)

      return
      end
C------------------------------------------------------------------------------
C Case 4
      integer function bbhintdgc0(rank,p,uin,uout,shpin,bbxin,bbcin,
     .                            shpout,c2xfu)
      implicit none
      integer rank,p
      real*8 uin(*),uout(*)
      integer shpin(rank)
      real*8 bbxin(rank*2),bbcin(rank*2)
      integer shpout(rank)
      integer c2xfu
      external c2xfu
      integer interps

      real*8 chin,chout,wksp
      real*8 lx,ly,lz,lout
      integer maxp
      parameter ( maxp = 5000)
      real*8 xin(maxp),xout(maxp)
      real*8 hx(3)
      real*8 hr(3) 
      integer l,l2,lc,np1,np2,ll

      if (p.gt.12.or.p.lt.2) then
         write(0,*) 'order is too large'
         bbhintdgc0 = 1
         return
      end if

C generate the xc's and the xf's from the bounding boxes

      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
         hr(1)= (bbcin(4)-bbcin(1))/(shpout(1)-1)
         hr(2)= (bbcin(5)-bbcin(2))/(shpout(2)-1)
         hr(3)= (bbcin(6)-bbcin(3))/(shpout(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
         hr(1)= (bbcin(3)-bbcin(1))/(shpout(1)-1)
         hr(2)= (bbcin(4)-bbcin(2))/(shpout(2)-1)
      end if

      l = 0 
      l2 = 0 
      np1 = 0
      np2 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         np2 =  np2 + shpout(lc)
         if (np1.gt.maxp.or.np2.gt.maxp) then
            bbhintdgc0 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpout(lc)
            l = l + 1
            xout(l) = bbcin(lc) + hr(lc)*(ll-1)
         end do
         do ll = 1 , shpin(lc)
            l2= l2+ 1
            xin(l2) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdgc0 = interps( rank,p,uin,uout,chin,chout,wksp,wksp,
     .                      xin,lx,ly,lz,lout,shpin,shpout,1,1,
     .                      1,1,shpin,1,0,shpout,xout,.true.,c2xfu)


      return
      end
C------------------------------------------------------------------------------
C Case 5
      integer function bbhintdgc1(rank,p,uin,uout,shpin,bbxin,bbcin,
     .                            shpout,c2xfu,chin)
      implicit none
      integer rank,p
      real*8 uin(*),uout(*)
      integer shpin(rank)
      real*8 bbxin(rank*2),bbcin(rank*2)
      real*8 chin(*)
      integer shpout(rank)
      integer c2xfu
      external c2xfu
      integer interps

      real*8 chout,wksp
      real*8 lx,ly,lz,lout
      integer maxp
      parameter ( maxp = 5000)
      real*8 xin(maxp),xout(maxp)
      real*8 hx(3)
      real*8 hr(3) 
      integer l,l2,lc,np1,np2,ll

      if (p.gt.12.or.p.lt.2) then
         write(0,*) 'order too large'
         bbhintdgc1 = 1
         return
      end if

C generate the xc's and the xf's from the bounding boxes

      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
         hr(1)= (bbcin(4)-bbcin(1))/(shpout(1)-1)
         hr(2)= (bbcin(5)-bbcin(2))/(shpout(2)-1)
         hr(3)= (bbcin(6)-bbcin(3))/(shpout(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
         hr(1)= (bbcin(3)-bbcin(1))/(shpout(1)-1)
         hr(2)= (bbcin(4)-bbcin(2))/(shpout(2)-1)
      end if

      l = 0
      l2 = 0
      np1 = 0
      np2 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         np2 =  np2 + shpout(lc)
         if (np1.gt.maxp.or.np2.gt.maxp) then
            bbhintdgc1 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpout(lc)
            l = l + 1
            xout(l) = bbcin(lc) + hr(lc)*(ll-1)
         end do
         do ll = 1 , shpin(lc)
            l2= l2+ 1
            xin(l2) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdgc1 = interps( rank,p,uin,uout,chin,chout,wksp,wksp,
     .                      xin,lx,ly,lz,lout,shpin,shpout,shpin,1,
     .                      1,1,shpin,1,0,shpout,xout,.true.,c2xfu)


      return
      end
C------------------------------------------------------------------------------
C Case 6
      integer function bbhintdlx0(rank,p,uin,bbxin,coordsin,
     .                            ulout,shpin,nlout)
      implicit none
      integer rank, p
      integer shpin(rank),nlout
      real*8 uin(*),ulout(nlout)
      real*8 bbxin(2*rank)
      real*8 coordsin(3*nlout)
      real*8 hx(3)

      integer interps
      real*8 uout,chin,chout,wksp
      integer np1,ll,l,lc
      integer maxp
      parameter ( maxp = 5000)
      real*8 xf(maxp),xc
      integer func


      if (p.gt.12.or.p.lt.2) then
         write(0,*) 'order to large'
         bbhintdlx0 = 1
         return
      end if
      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
      end if

      l = 0
      np1 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         if (np1.gt.maxp) then
            bbhintdlx0 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpin(lc)
            l = l + 1
            xf(l) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdlx0 = interps(rank,p,uin,uout,chin,chout,wksp,wksp,
     .                     xf,coordsin(1),coordsin(1+nlout),
     .                     coordsin(2*nlout+1),ulout,shpin,1,1,
     .                     1,1,1,shpin,nlout,0,1,xc,.false.,func)


      return
      end

C------------------------------------------------------------------------------
C Case 7
      integer function bbhintdlx1(rank,p,uin,bbxin,coordsin,ulout,shpin,
     .                            nlout,chin)
      implicit none
      integer rank, p
      integer shpin(rank),nlout
      real*8 uin(*),ulout(nlout)
      real*8 chin(*)
      real*8 bbxin(2*rank)
      real*8 coordsin(3*nlout)
      real*8 hx(3)

      integer interps
      real*8 uout,chout,wksp
      integer np1,ll,l,lc
      integer maxp
      parameter ( maxp = 5000)
      real*8 xf(maxp),xc
      integer func

      if (p.gt.12.or.p.lt.2) then
         write(0,*) 'order to large'
         bbhintdlx1 = 1
         return
      end if


      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
      end if

      l = 0
      np1 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         if (np1.gt.maxp) then
            bbhintdlx1 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpin(lc)
            l = l + 1
            xf(l) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdlx1 = interps(rank,p,uin,uout,chin,chout,wksp,wksp,
     .                     xf,coordsin(1),coordsin(1+nlout),
     .                     coordsin(2*nlout+1),ulout,shpin,1,shpin,
     .                     1,1,1,shpin,nlout,0,1,xc,.false.,func)


      return
      end
C------------------------------------------------------------------------------
C Case 8
      integer function bbhintdlc0(rank,p,uin,bbxin,coordsin,ulout,
     .                            shpin,nlout,c2xfun)
      implicit none
      integer rank, p
      integer shpin(rank),nlout
      real*8 uin(*),ulout(nlout)
      real*8 chin
      real*8 bbxin(2*rank)
      real*8 coordsin(3*nlout)
      real*8 hx(3)

      integer interps
      real*8 uout,chout,wksp
      integer np1,ll,l,lc
      integer maxp
      parameter ( maxp = 5000)
      real*8 xf(maxp),xc
      integer c2xfun
      external c2xfun


      if (p.gt.12.or.p.lt.2) then
         write(0,*) 'order to large'
         bbhintdlc0 = 1
         return
      end if



      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
      end if

      l = 0
      np1 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         if (np1.gt.maxp) then
            bbhintdlc0 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpin(lc)
            l = l + 1
            xf(l) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdlc0 = interps(rank,p,uin,uout,chin,chout,wksp,wksp,
     .                     xf,coordsin(1),coordsin(1+nlout),
     .                     coordsin(2*nlout+1),ulout,shpin,1,1,
     .                     1,1,1,shpin,nlout,0,1,xc,.true.,c2xfun)

      return
      end

C------------------------------------------------------------------------------
C Case 9
      integer function bbhintdlc1(rank,p,uin,bbxin,coordsin,ulout,
     .                            shpin,nlout,c2xfun,chin)
      implicit none
      integer rank, p
      integer shpin(rank),nlout
      real*8 uin(*),ulout(nlout)
      real*8 chin(*)
      real*8 bbxin(2*rank)
      real*8 coordsin(3*nlout)
      real*8 hx(3)

      integer interps
      real*8 uout,chout,wksp
      integer np1,ll,l,lc
      integer maxp
      parameter ( maxp = 5000)
      real*8 xf(maxp),xc
      integer c2xfun
      external c2xfun 

      if (p.gt.12.or.p.lt.2) then
         write(0,*) 'order to large'
         bbhintdlc1 = 1
         return
      end if



      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
      end if

      l = 0
      np1 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         if (np1.gt.maxp) then
            bbhintdlc1 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpin(lc)
            l = l + 1
            xf(l) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdlc1 = interps(rank,p,uin,uout,chin,chout,wksp,wksp,
     .                     xf,coordsin(1),coordsin(1+nlout),
     .                     coordsin(2*nlout+1),ulout,shpin,1,shpin,
     .                     1,1,1,shpin,nlout,0,1,xc,.true.,c2xfun)

      return
      end
C-----------------------------------------------------------------------------
      integer function get_bounds(rank,shpin,shpout,bbin,bbout,
     .                            ibb_in,ibb_out)
      implicit none
      integer rank,shpin(rank),shpout(rank)
      real*8  bbin(2*rank),bbout(2*rank)
      integer ibb_in(2*rank),ibb_out(2*rank)
      
      integer i,j,k,l
      real*8  hin(3),hout(3)
      real*8  small1,small2,off1,off2,xin,xout

C get the bounding boxes in terms of the i,j,k's
      get_bounds = 0

      do l = 1 , rank
         hin(l)  = ( bbin(2*l) -bbin(2*l-1) ) / ( shpin(l) - 1 )
         hout(l)  = ( bbout(2*l) -bbout(2*l-1) ) / ( shpout(l) - 1 )
      end do

      small1 = 1000.0d0
      small2 = 1000.0d0

      do l = 1 , rank 

         do i = 1 , shpin(l)

            xin = (i-1)*hin(l) + bbin(2*l-1)
            off1 = abs( xin - bbout(2*l-1) )
            off2 = abs( xin - bbout(2*l) )

            if (off1.le.small1) then
               ibb_in(2*l-1) = i
               small1 = off1
            end if

            if (off2.le.small2) then
               ibb_in(2*l)  = i
               small2 = off2
            end if
         end do

      end do
C now get the bounding box of the out(fine) grid

      small1 = 1000.0d0
      small2 = 1000.0d0

      do l = 1 , rank 

         do i = 1 , shpout(l) 

            xin = (i-1)*hout(l) + bbout(2*l-1)
            off1 = abs( xin - bbin(2*l-1) )
            off2 = abs( xin - bbin(2*l) )

            if (off1.le.small1) then
               ibb_out(2*l-1) = i
               small1 = off1
            end if

            if (off2.le.small2) then
               ibb_out(2*l)  = i
               small2 = off2
            end if
         end do

      end do

      return
      end
C---------------------------------------------------------------------------
      subroutine define_g1p3d(shpin,shpin_p,ibb_in,uin,uout) 
      implicit none
      integer shpin(3),shpin_p(3)
      integer ibb_in(2*3)
      real*8 uin(shpin(1),shpin(2),shpin(3))
      real*8 uout(shpin_p(1),shpin_p(2),shpin_p(3))
      integer i,j,k,ip,jp,kp

      kp = 0

      do k =  ibb_in(5), ibb_in(6)
         kp = kp + 1
         jp = 0
         do j =  ibb_in(3) , ibb_in(4)
            jp = jp + 1
            ip = 0
            do i =  ibb_in(1) , ibb_in(2)
               ip = ip + 1
               uout(ip,jp,kp) = uin(i,j,k)
            end do
         end do
      end do

      return
      end
C---------------------------------------------------------------------------
      subroutine define_g1p2d(shpin,shpin_p,ibb_in,uin,uout)
      implicit none
      integer shpin(2),shpin_p(2)
      integer ibb_in(2*2)
      real*8 uin(shpin(1),shpin(2)) 
      real*8 uout(shpin_p(1),shpin_p(2)) 
      integer i,j,ip,jp

      jp = 0
      do j =  ibb_in(3) , ibb_in(4)
         jp = jp + 1
         ip = 0
         do i =  ibb_in(1) , ibb_in(2)
            ip = ip + 1
            uout(ip,jp) = uin(i,j) 
         end do
      end do

      return
      end
C---------------------------------------------------------------------------
      subroutine define_g1p1d(shpin,shpin_p,ibb_in,uin,uout)
      implicit none
      integer shpin(1),shpin_p(1)
      integer ibb_in(2*1)
      real*8 uin(shpin(1)) 
      real*8 uout(shpin_p(1)) 
      integer i,ip

      ip = 0
      do i =  ibb_in(1) , ibb_in(2)
         ip = ip + 1
         uout(ip) = uin(i) 
      end do

      return
      end
C---------------------------------------------------------------------------
      subroutine copy_g1p3d(shpin,shpin_p,ibb_in,uin,uout,option)
      implicit none
      integer shpin(3),shpin_p(3)
      integer ibb_in(2*3)
      real*8 uin(shpin(1),shpin(2),shpin(3))
      real*8 uout(shpin_p(1),shpin_p(2),shpin_p(3))
      integer i,j,k,ip,jp,kp
      integer option


      if (option.eq.1) then

C 6 faces put into 2 parts
         jp = 0
         do j =  ibb_in(3) , ibb_in(4)
            jp = jp + 1
            ip = 0
            do i =  ibb_in(1) , ibb_in(2)
               ip = ip + 1
               uin(i,j,ibb_in(5)) =uout(ip,jp,1)
               uin(i,j,ibb_in(6)) =uout(ip,jp,shpin_p(3))
            end do
         end do

         kp = 0
         do k =  ibb_in(5) , ibb_in(6)
            kp = kp + 1
            ip = 0
            do i =  ibb_in(1) , ibb_in(2)
               ip = ip + 1
               uin(i,ibb_in(3),k) =uout(ip,1,kp)
               uin(i,ibb_in(4),k) =uout(ip,shpin_p(4),kp)
            end do
         end do
         kp = 0
         do k =  ibb_in(5) , ibb_in(6)
            kp = kp + 1
            jp = 0
            do j =  ibb_in(3) , ibb_in(4)
               jp = jp + 1
               uin(ibb_in(1),j,k) =uout(1,jp,kp)
               uin(ibb_in(2),j,k) =uout(shpin_p(2),jp,kp)
            end do
         end do

      else

         kp = 0

         do k =  ibb_in(5), ibb_in(6)
            kp = kp + 1
            jp = 0
            do j =  ibb_in(3) , ibb_in(4)
               jp = jp + 1
               ip = 0
               do i =  ibb_in(1) , ibb_in(2)
                  ip = ip + 1
                  uin(i,j,k) =uout(ip,jp,kp) 
               end do
            end do
         end do
      end if

      return
      end
C---------------------------------------------------------------------------
      subroutine copy_g1p2d(shpin,shpin_p,ibb_in,uin,uout,option)
      implicit none
      integer shpin(2),shpin_p(2)
      integer ibb_in(2*2)
      real*8 uin(shpin(1),shpin(2))
      real*8 uout(shpin_p(1),shpin_p(2))
      integer i,j,ip,jp
      integer option

		if (option.eq.1) then
C 4 lines
			ip = 0
			do i = ibb_in(1) , ibb_in(2)
				ip = ip + 1
				uin(i,ibb_in(3))  = uout(ip,1)
				uin(i,ibb_in(4))  = uout(ip,shpin_p(4))
			end do
			jp = 0
			do j = ibb_in(3) , ibb_in(4)
				jp = jp + 1
				uin(ibb_in(1),j)  = uout(1,jp)
				uin(ibb_in(2),j)  = uout(shpin_p(2),jp)
			end do

		else
      	jp = 0
      	do j =  ibb_in(3) , ibb_in(4)
         	jp = jp + 1
         	ip = 0
         	do i =  ibb_in(1) , ibb_in(2)
            	ip = ip + 1
            	uin(i,j) =uout(ip,jp) 
         	end do
      	end do
		end if

      return
      end
C---------------------------------------------------------------------------
      subroutine copy_g1p1d(shpin,shpin_p,ibb_in,uin,uout,option)
      implicit none
      integer shpin(1),shpin_p(1)
      integer ibb_in(2*1)
      real*8 uin(shpin(1))
      real*8 uout(shpin_p(1))
      integer i,ip
      integer option

		if (option.eq.1) then
			uin(ibb_in(1)) = uout(1)
			uin(ibb_in(2)) = uout(shpin_p(2))

		else
      	ip = 0
      	do i =  ibb_in(1) , ibb_in(2)
         	ip = ip + 1
         	uin(i) =uout(ip) 
      	end do
		end if

      return
      end
C these routines will return the required work space for the routines
C-----------------------------------------------------------------------------
		integer function workdgx0(rank,shpin,shpout,bbin,bbout)
		implicit none
		integer rank 
		integer shpin(rank),shpout(rank)
		integer ibb_in(6),ibb_out(6) 
		real*8 bbin(rank*2),bbout(rank*2)
		integer ierr,get_bounds,gsize,gsize2,l


		ierr = get_bounds(rank,shpin,shpout,bbin,bbout,ibb_in,ibb_out)
		if (ierr.eq.1) then
			write(0,*) '*** error in get_bounds ***'
			workdgx0 = -1
			return
		end if

      gsize = 1

		do l = 1 , rank
            gsize = ( 1 + ibb_in(2*l) - ibb_in(2*l-1) ) * gsize
		end do

      gsize2= 1
  
      do l = 1 , rank
         gsize2 = ( 1 + ibb_out(2*l) - ibb_out(2*l-1) ) * gsize2
		end do

		workdgx0 = gsize + gsize2

		return
		end
C-----------------------------------------------------------------------------
      integer function workdgx1(rank,shpin,shpout,bbin,bbout)
      implicit none
      integer rank
      integer shpin(rank),shpout(rank)
      integer ibb_in(6),ibb_out(6)
      real*8 bbin(rank*2),bbout(rank*2)
      integer ierr,get_bounds,gsize,gsize2,l


      ierr = get_bounds(rank,shpin,shpout,bbin,bbout,ibb_in,ibb_out)
      if (ierr.eq.1) then
         write(0,*) '*** error in get_bounds ***'
         workdgx1 = -1
         return
      end if

      gsize = 1

      do l = 1 , rank
            gsize = ( 1 + ibb_in(2*l) - ibb_in(2*l-1) ) * gsize
      end do

      gsize2= 1

      do l = 1 , rank
         gsize2 = ( 1 + ibb_out(2*l) - ibb_out(2*l-1) ) * gsize2
      end do

      workdgx1 = 2*(gsize + gsize2)

      return
      end
