c------------------------------------------------------------------------------
C routines in this section are
C  d2pro122c(uc,uf,d1c,d2c,charc,charf,xf,yf)       2x1  2 O 
C  d2pro124c(uc,uf,d1c,d2c,charc,charf,xf,yf)       2x1  4 O 
C  d2pro12nc(uc,uf,d1c,d2c,charc,charf,xf,yf,order) 2x1  p O 
c------------------------------------------------------------------------------
C 
      integer function d2pro122c( uc,uf,nxc,nyc,charmc,charmf)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(2*nxc-1,2*nyc-1) 
      real*8  charmc(nxc,nyc),charmf(2*nxc-1,2*nyc-1) 

      integer pil,l

      integer   ic , jc
      integer   iff , jf
      integer ierr,d2lintxyc
      integer d2pro122c_ 

      nxf = 2*nxc-1
      nyf = 2*nyc-1

      d2pro122c = 0

      d2pro122c =  d2pro122c_(uc,uf,nxc,nyc,charmc,charmf)

      return
      end
c-----------------------------------------------------------------------
C second order (linear interpolation on a 2x1 mesh) with char functions
c-----------------------------------------------------------------------
      integer function d2pro122c_( uc,uf,d1c, d2c, chc,chf) 
      implicit none
      integer d1c, d2c
      integer d1f, d2f
      real*8    uc(d1c,d2c),uf(2*d1c-1,2*d2c-1) 
      real*8    chc(d1c,d2c),chf(2*d1c-1,2*d2c-1) 

      integer maxsize
      parameter ( maxsize = 2049 )
      real*8 utempf(maxsize),utempc(maxsize),cthc(maxsize)


      integer   ic , jc
      integer   iff , jf
      integer d1122

      d1f = 2*d1c-1
      d2f = 2*d2c-1

      if (d1f.gt.maxsize.or.d2f.gt.maxsize) then
         write(0,*) 'd2pro122c_: shape too large'
         d2pro122c_ = 1
         return
      end if

      do jc = 1 , d2c
         jf = 2*jc - 1
         call d2vputv(uc,utempc,d1c,d2c,jc,1,1)
         call d2vputv(chc,cthc,d1c,d2c,jc,1,1)
         d2pro122c_ = d1122(d1c,utempc,utempf,cthc) 
         call dvput2v(utempf,uf,d1f,d2f,jf,1)
      end do


      do iff = 1 , d2f
         call d2vputv(uf,utempc,d1f,d2f,iff,2,2)
         call d2vputv(chf,cthc,d1f,d2f,iff,2,2)
         d2pro122c_ =  d1122(d1c,utempc,utempf,cthc)
         call dvput2v(utempf,uf,d1f,d2f,iff,2)
      end do

      return
      end
c-----------------------------------------------------------------------
      integer function d2pro124c( uc,uf,nxc,nyc,charmc,charmf)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(2*nxc-1,2*nyc-1) 
      real*8  charmc(nxc,nyc),charmf(2*nxc-1,2*nyc-1) 

      integer   ic , jc
      integer   iff , jf
      integer ierr,d4lintxyc
      integer d2pro124c_ 

      nxf = 2*nxc-1
      nyf = 2*nyc-1

      d2pro124c = 0

      d2pro124c =  d2pro124c_(uc,uf,nxc,nyc,charmc,charmf)

      return
      end
c-----------------------------------------------------------------------
c
c     2:1 cubic interpolation ...
c
C  from a 2x1 mesh
c-----------------------------------------------------------------------

      integer function  d2pro124c_(uc,uf,d1c,d2c,chc,chf)

         implicit       none

         logical        ccdim

         integer        d1c,     d2c
         real*8         uc(d1c,d2c),
     *                  uf(2*d1c-1,2*d2c-1) 
         real*8         chc(d1c,d2c), 
     *                  chf(2*d1c-1,2*d2c-1) 

         integer        i1,      i2,
     *                  d1f,     d2f
      integer jc,ic,jf,iff
      integer maxsize
      parameter ( maxsize = 2049 )
      real*8 utempf(maxsize),utempc(maxsize),cthc(maxsize)
      integer d1124


      d1f = 2 * d1c - 1
      d2f = 2 * d2c - 1

      if (d1f.gt.maxsize.or.d2f.gt.maxsize) then
         write(0,*) 'd2pro124c_: error shape too large'
         d2pro124c_ = 1
         return
      end if

      do jc = 1 , d2c
         jf = 2*jc - 1
         call d2vputv(uc,utempc,d1c,d2c,jc,1,1)
         call d2vputv(chc,cthc,d1c,d2c,jc,1,1)
         d2pro124c_ = d1124(d1c,utempc,utempf,cthc)
         if (d2pro124c_.eq.1) return
         call dvput2v(utempf,uf,d1f,d2f,jf,1)
      end do


      do iff = 1 , d1f
         call d2vputv(uf,utempc,d1f,d2f,iff,2,2)
         call d2vputv(chf,cthc,d1f,d2f,iff,2,2)
         d2pro124c_ =  d1124(d1c,utempc,utempf,cthc)
         call dvput2v(utempf,uf,d1f,d2f,iff,2)
      end do

      return
      end
C----------------------------------------------------------------------------
      integer function d2pro12nc( uc,uf,nxc,nyc,charmc,charmf,order)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(2*nxc-1,2*nyc-1) 
      real*8  charmc(nxc,nyc),charmf(2*nxc-1,2*nyc-1) 
      integer order

      integer pil,l

      integer   ic , jc
      integer   iff , jf
      integer ierr,dnlintxyc
      integer d2pro12nc_

      nxf = 2*nxc-1
      nyf = 2*nyc-1

      d2pro12nc = 0

      d2pro12nc =  d2pro12nc_(uc,uf,nxc,nyc,order,charmc,charmf)

      return
      end
c-----------------------------------------------------------------------
      integer function d2pro12nc_(uc,uf,nxc,nyc,order,chc,chf) 
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8    uc(nxc,nyc),uf(2*nxc-1,2*nyc-1) 
      real*8    chc(nxc,nyc),chf(2*nxc-1,2*nyc-1) 

      integer   ic , jc 
      integer   iff , jf

      integer order

      integer d1nint2c,ierr
      integer wksp_size
      parameter ( wksp_size = 8000 )
      real*8 wksp(wksp_size)
      integer maxsize,d1nint2ec
      parameter ( maxsize = 2049 )
      real*8 utempf(maxsize),utempc(maxsize),cthc(maxsize)


C the first thing that I must do is set up the coefficients ....
      nxf = 2*nxc-1
      nyf = 2*nyc-1

      if (nxf.gt.maxsize.or.nyf.gt.maxsize) then
         write(0,*) 'd2pro12nc_:error shape too large'
         d2pro12nc_ = 1
         return
      end if

      d2pro12nc_ = 0

      d2pro12nc_ = d1nint2c(order,wksp,wksp_size)


      if (d2pro12nc_.eq.1) return

C at first I do all the lines that I can ......

      do jc = 1 , nyc 
         jf = 2*jc - 1
         call d2vputv(uc,utempc,nxc,nyc,jc,1,1)
         call d2vputv(chc,cthc,nxc,nyc,jc,1,1)
         d2pro12nc_ =
     .      d1nint2ec(nxc,utempc,utempf,wksp,wksp_size,order,cthc)
         if (d2pro12nc_.eq.1) return
         call dvput2v(utempf,uf,nxf,nyf,jf,1)
      end do

C now fill all the  missing lines

      do iff = 1 , nxf
         call d2vputv(uf,utempc,nxf,nyf,iff,2,2)
         call d2vputv(chf,cthc,nxf,nyf,iff,2,2)
         d2pro12nc_ =
     .       d1nint2ec(nxc,utempc,utempf,wksp,wksp_size,order,cthc)
         if (d2pro12nc_.eq.1) return
         call dvput2v(utempf,uf,nxf,nyf,iff,2)
      end do

      return
      end
C======================================================================
c-----------------------------------------------------------------------
C routines in this section are
C       d2pro122(uc,uf,d1c,d2c)          2x1       second order
C       d2pro124(uc,uf,d1c,d2c)          2x1       fourth order
C       d2pro12n(uc,uf,d1c,d2c,order)    2x1       nth    order
c-----------------------------------------------------------------------

C second order (linear interpolation on a 2x1 mesh)
c-----------------------------------------------------------------------
      integer function d2pro122( uc,uf,nxc, nyc) 
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8    uc(nxc,nyc),uf(2*nxc-1,2*nyc-1) 

      integer   ic , jc 
      integer   if , jf

      nxf = 2*nxc-1
      nyf = 2*nyc-1

      d2pro122 = 0

c first injection

      do jc = 1, nyc
         jf = 2*jc -1
         do ic = 1, nxc 
            if = 2*ic -1
            uf(if,jf) = uc(ic,jc)
         end do
         do if = 2 , nxf - 1 , 2
            uf(if,jf) = 0.5d0*( uf(if-1,jf) + uf(if+1,jf) )
         end do

         if (jc.gt.1) then

c fill in missing lines

            do if = 1 , nxf

               uf(if,jf-1) = 0.5d0*( uf(if,jf-2) +
     .                               uf(if,jf) )
            end do

         end if


      end do


      return
      end
c-----------------------------------------------------------------------
c
c     2:1 cubic interpolation ...
c
C  from a 2x1 mesh
c-----------------------------------------------------------------------

      integer function d2pro124(uc,uf,d1c,d2c)

         implicit       none

         logical        ccdim

         integer        d1c,     d2c
         real*8         uc(d1c,d2c),
     *                  uf(2*d1c-1,2*d2c-1) 

         integer        i1,      i2,
     *                  d1f,     d2f

         real*8         lc(4),      cc(4),      rc(4)
         data
     *     lc / 0.31250d0,  0.93750d0, -0.31250d0,  0.06250d0 /,
     *     cc /-0.06250d0,  0.56250d0,  0.56250d0, -0.06250d0 /,
     *     rc / 0.06250d0, -0.31250d0,  0.93750d0,  0.31250d0 /


         d2pro124 = 0

         if( ccdim(d1c) .and. ccdim(d2c) ) then
            d1f = 2 * d1c - 1
            d2f = 2 * d2c - 1
            do 10 i2 = 1  , d2c
               call dv2i4_s(uc(1,i2),uf(1,2*i2-1),d1c)
 10            continue
               call dvsma4_s(uf(1,1),uf(1,3),
     *                     uf(1,5),uf(1,7),
     *                     uf(1,2),lc,d1f)
               do 30 i2 = 4 , d2f - 3 , 2
                  call dvsma4_s(uf(1,i2-3),uf(1,i2-1),
     *                        uf(1,i2+1),uf(1,i2+3),
     *                        uf(1,i2),cc,d1f)
 30            continue

               call dvsma4_s(uf(1,d2f-6),uf(1,d2f-4),
     *                     uf(1,d2f-2),uf(1,d2f),
     *                     uf(1,d2f-1),rc,d1f)

         else
            write(*,*) '>>> d2pro124: Invalid dimension(s): ',
     *                 d1c, d2c
            d2pro124 = 1
         end if

         return

      end

C this will do nth order interpolation on a 2x1 mesh .....
c-----------------------------------------------------------------------
      integer function d2pro12n(uc,uf,nxc,nyc,order) 
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8    uc(nxc,nyc),uf(2*nxc-1,2*nyc-1) 

      integer   ic , jc 
      integer   iff , jf

      integer order

      integer d1nint2,ierr
      integer wksp_size
      parameter ( wksp_size = 8000 )
      real*8 wksp(wksp_size)
      integer maxsize
      parameter ( maxsize = 2049 )
      real*8 utempf(maxsize),utempc(maxsize)


      d2pro12n = 0

C the first thing that I must do is set up the coefficients ....
      nxf = 2*nxc-1
      nyf = 2*nyc-1

      if (nxf.gt.maxsize.or.nyf.gt.maxsize) then
         write(0,*) 'd2pro12n: error shape too large'
         d2pro12n = 1
         return
      end if

      ierr = d1nint2(order,wksp,wksp_size)

      if (ierr.ne.0) then
         write(6,*) 'Error in d1nint2'
         d2pro12n = 1
      end if

C at first I do all the lines that I can ......

      do jc = 1 , nyc 
         jf = 2*jc - 1
         call d2vputv(uc,utempc,nxc,nyc,jc,1,1)
         call d1nint2e(nxc,utempc,utempf,wksp,wksp_size,order)
         call dvput2v(utempf,uf,nxf,nyf,jf,1)
      end do

C now fill all the  missing lines

      do iff = 1 , nxf
         call d2vputv(uf,utempc,nxf,nyf,iff,2,2)
         call d1nint2e(nxc,utempc,utempf,wksp,wksp_size,order)
         call dvput2v(utempf,uf,nxf,nyf,iff,2)
      end do

      return
      end
C======================================================================
C======================================================================
C these routines are 1xn refinements with a characteristic matrix
c------------------------------------------------------------------------------
C routines in this section are
C  d2pro1n2c(uc,uf,d1c,d2c,d1f,d2f,
C            charc,charf)                          nx1  2 O
C  d2pro1n4c(uc,uf,d1c,d2c,d1f,d2f,
C            charc,charf)                          nx1  4 O
C  d2pro1nnc(uc,uf,d1c,d2c,d1f,d2f,
C            charc,charf,order)                    nx1  p O
c------------------------------------------------------------------------------
      integer function d2pro1n2c( uc,uf,nxc,nyc,nxf,nyf,
     .                            charmc,charmf) 
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(nxf,nyf) 
      real*8  charmc(nxc,nyc),charmf(nxf,nyf) 

      integer   ic , jc 
      integer   iff , jf
      integer ierr,d2lintxyc
      integer d2pro1n2c_

      d2pro1n2c = 0

      d2pro1n2c =  d2pro1n2c_(nxf,nyf,nxc,nyc,uf,uc,charmc,charmf)

      return
      end
C-------------------------------------------------------------------------
C prolongs from a 1 to n grid using second order techinques
C i.e. cubic interpolation
C
      integer function  d2pro1n2c_(nxf,nyf,nxc,nyc,uf,uc,chc,chf)
      implicit none
      integer  nxf,nyf
      integer  nxc,nyc

      real*8 uf(nxf,nyf), uc(nxc,nyc)
      real*8 chf(nxf,nyf), chc(nxc,nyc)

      integer i,j
      integer iff,jf
      integer ic,jc
      integer nxfact,nyfact
      integer nxskip,nyskip
      integer iskip,jskip
      integer maxsize
      parameter ( maxsize = 2049)
      integer dvi1q1c

      real*8 vtc(maxsize),vtf(maxsize),cthc(maxsize)

C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)
      nyfact = (nyf-1)/(nyc-1)

      nxskip = nxfact - 1
      nyskip = nyfact - 1

      if (nxf.gt.maxsize.or.nyf.gt.maxsize) then
         write(0,*) 'd2pro1n2c_: error shape to large'
         d2pro1n2c_ = 1
         return
      end if
C

      do jc = 1 , nyc
         jf = nyfact*jc-nyskip
         call d2vputv(uc,vtc,nxc,nyc,jc,1,1)
         call d2vputv(chc,cthc,nxc,nyc,jc,1,1)
         d2pro1n2c_ =  dvi1q1c(vtc,vtf,nxfact,nxc,cthc)
         if (d2pro1n2c_.eq.1) return
         call dvput2v(vtf,uf,nxf,nyf,jf,1)
      end do

C now fill in the missing lines

      do iff = 1 , nxf
         call d2vputv(uf,vtc,nxf,nyf,iff,nyfact,2)
         call d2vputv(chf,cthc,nxf,nyf,iff,nyfact,2)
         d2pro1n2c_ =  dvi1q1c(vtc,vtf,nyfact,nyc,cthc) 
         call dvput2v(vtf,uf,nxf,nyf,iff,2)
      end do

      return
      end
C-----------------------------------------------------------------------------C
      integer function d2pro1n4c( uc,uf,nxc,nyc,nxf,nyf,
     .                      charmc,charmf)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(nxf,nyf) 
      real*8  charmc(nxc,nyc),charmf(nxf,nyf) 

      integer   ic , jc 
      integer   iff , jf
      integer ierr,d4lintxyc
      integer d2pro1n4c_

      d2pro1n4c = 0

      d2pro1n4c =  d2pro1n4c_(nxf,nyf,nxc,nyc,uf,uc,charmc,charmf)

      return
      end
C-------------------------------------------------------------------------
      integer function d2pro1n4c_(nxf,nyf,nxc,nyc,uf,uc,chc,chf)
      implicit none
      integer  nxf,nyf
      integer  nxc,nyc

      real*8 uf(nxf,nyf), uc(nxc,nyc)
      real*8 chf(nxf,nyf), chc(nxc,nyc)

      integer i,j
      integer iff,jf
      integer ic,jc
      integer nxfact,nyfact
      integer nxskip,nyskip
      integer iskip,jskip
      integer dvcuq1_sc

      integer max
      parameter ( max = 32 )
      real*8 ci(4,max),cbl(4,max),cbr(4,max)
      real*8 cel(4,max),cer(4,max)
      real*8 f1,f2

      integer maxsize
      parameter ( maxsize = 2049 )
      real*8 vtc(maxsize),vtf(maxsize),cthc(maxsize)

C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)
      nyfact = (nyf-1)/(nyc-1)

      nxskip = nxfact - 1
      nyskip = nyfact - 1

      if (nxfact.gt.max.or.nyfact.gt.max) then
         write(0,*) 'd2pro1n4c_: error refinement factor too large'
         d2pro1n4c_ = 1
         return
      end if

      call get3co4(nxfact,ci,cbl,cbr,cel,cer)

      do jc = 1 , nyc
         jf = nyfact*jc-nyskip
         call d2vputv(uc,vtc,nxc,nyc,jc,1,1)
         call d2vputv(chc,cthc,nxc,nyc,jc,1,1)
         d2pro1n4c_ =  dvcuq1_sc(vtc,vtf,nxfact,nxc,
     .                           cthc,ci,cbl,cbr,cel,cer)
         if (d2pro1n4c_.eq.1) return
         call dvput2v(vtf,uf,nxf,nyf,jf,1)
      end do

C now fill in the missing lines
      call get3co4(nyfact,ci,cbl,cbr,cel,cer)

      do iff = 1 , nxf
         call d2vputv(uf,vtc,nxf,nyf,iff,nyfact,2)
         call d2vputv(chf,cthc,nxf,nyf,iff,nyfact,2)
         d2pro1n4c_ =  dvcuq1_sc(vtc,vtf,nyfact,nyc,
     .                           cthc,ci,cbl,cbr,cel,cer)
         call dvput2v(vtf,uf,nxf,nyf,iff,2)
      end do

      return
      end
C---------------------------------------------------------------------
      integer function d2pro1nnc( uc,uf,nxc,nyc,nxf,nyf,
     .                      charmc,charmf,order)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(nxf,nyf) 
      real*8  charmc(nxc,nyc),charmf(nxf,nyf) 
      integer order


      integer   ic , jc 
      integer   iff , jf
      integer ierr,dnlintxyc
      integer d2pro1nnc_

      d2pro1nnc = 0

      d2pro1nnc =  d2pro1nnc_(nxf,nyf,nxc,nyc,uf,uc,order,
     .                ierr,charmc,charmf)

      if (d2pro1nnc.eq.1) return

      return
      end
C-------------------------------------------------------------------------
      integer function d2pro1nnc_(nxf,nyf,nxc,nyc,uf,uc,order,ierr,
     .                      chc,chf)
      implicit none
      integer  nxf,nyf
      integer  nxc,nyc
      integer order
      logical ccdimn

      real*8 uf(nxf,nyf), uc(nxc,nyc)
      real*8 chf(nxf,nyf), chc(nxc,nyc)

      integer wksp_size
      parameter ( wksp_size = 8000 )
C this size will suit must needs we can have a 20x1 refinement with
C 20th order 
      real*8 wksp(wksp_size)

      integer i,j
      integer iff,jf
      integer ic,jc
      integer nxfact,nyfact
      integer nxskip,nyskip
      integer iskip,jskip
      integer ierr
      integer d1nintnc,d1nintnec

      real*8 f1,f2

      integer maxsize
      parameter ( maxsize = 2049 )
      real*8 vtc(maxsize),vtf(maxsize),cthc(maxsize)

      ierr = 0

      if( (.not.ccdimn(nxc,order)).or.(.not.ccdimn(nyc,order))) then 
         write(6,*) 'not enough points for d2pro1nnc_'
         d2pro1nnc_ = 1
         return
      end if

      if (nxf.gt.maxsize.or.nyf.gt.maxsize) then
         write(0,*) 'd2pro1nnc_:error shape too large'
         d2pro1nnc_ = 1
         return
      end if


C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)
      nyfact = (nyf-1)/(nyc-1)

      nxskip = nxfact - 1
      nyskip = nyfact - 1

      d2pro1nnc_ = d1nintnc(order,wksp,wksp_size,nxfact)
      if (d2pro1nnc_.eq.1) return
C

      do jc = 1 , nyc
         jf = nyfact*jc-nyskip
         call d2vputv(uc,vtc,nxc,nyc,jc,1,1)
         call d2vputv(chc,cthc,nxc,nyc,jc,1,1)
         d2pro1nnc_ = d1nintnec( nxc,nxf,vtc,vtf,wksp,
     .                   wksp_size,order,nxfact,cthc )
         if (d2pro1nnc_.eq.1) return
         call dvput2v(vtf,uf,nxf,nyf,jf,1)
      end do

C now fill in the missing lines
      if (nyfact.ne.nxfact) then
         ierr = d1nintnc(order,wksp,wksp_size,nyfact)
      end if

      do iff = 1 , nxf
         call d2vputv(uf,vtc,nxf,nyf,iff,nyfact,2)
         call d2vputv(chf,cthc,nxf,nyf,iff,nyfact,2)
         d2pro1nnc_ = d1nintnec( nxc,nxf,vtc,vtf,wksp,
     .                   wksp_size,order,nyfact,cthc )
         call dvput2v(vtf,uf,nxf,nyf,iff,2)
      end do

      return
      end
C======================================================================
C------------------------------------------------------------------------------
C the routines to call are:
C  d2pro1n2(nxf,nyf,nxc,nyc,uf,uc)                  nx1    second order
C  d2pro1n4(nxf,nyf,nxc,nyc,uf,uc)                  nx1    fourth order
C  d2pro1nn(nxf,nyf,nxc,nyc,uf,uc,order)            nx1    nth    order
C------------------------------------------------------------------------------


C prolongs from a 1 to n grid using second order techinques
C i.e. linear interpolation
C
      integer function  d2pro1n2(nxf,nyf,nxc,nyc,uf,uc)
      implicit none
      integer  nxf,nyf
      integer  nxc,nyc

      real*8 uf(nxf,nyf), uc(nxc,nyc)

      integer i,j
      integer iff,jf
      integer ic,jc
      integer nxfact,nyfact
      integer nxskip,nyskip
      integer iskip,jskip

      real*8 vtc(1025),vtf(1025)

C figure out the refinement factors in each dimension 

      d2pro1n2 = 0
      if (nxf.gt.1025.or.nyf.gt.1025) then
         d2pro1n2 = 1
         return
      end if

      nxfact = (nxf-1)/(nxc-1)
      nyfact = (nyf-1)/(nyc-1)

      nxskip = nxfact - 1
      nyskip = nyfact - 1
C

      do jc = 1 , nyc
         jf = nyfact*jc-nyskip
         call d2vputv(uc,vtc,nxc,nyc,jc,1,1)
         call dvi1q1(vtc,vtf,nxfact,nxc)
         call dvput2v(vtf,uf,nxf,nyf,jf,1)
      end do

C now fill in the missing lines

      do iff = 1 , nxf
         call d2vputv(uf,vtc,nxf,nyf,iff,nyfact,2)
         call dvi1q1(vtc,vtf,nyfact,nyc) 
         call dvput2v(vtf,uf,nxf,nyf,iff,2)
      end do

      return
      end
C-----------------------------------------------------------------------------C
C prolongs from a 1 to n grid using fourth order techinques
C i.e. cubic interpolation
C

      integer function  d2pro1n4(nxf,nyf,nxc,nyc,uf,uc)
      implicit none
      integer  nxf,nyf
      integer  nxc,nyc

      real*8 uf(nxf,nyf), uc(nxc,nyc)

      integer i,j
      integer iff,jf
      integer ic,jc
      integer nxfact,nyfact
      integer nxskip,nyskip
      integer iskip,jskip

      real*8 f1,f2

      real*8 vtc(1025),vtf(1025)

      d2pro1n4 = 0

      if (nxf.gt.1025.or.nyf.gt.1025) then
         d2pro1n4 = 1
         return
      end if
C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)
      nyfact = (nyf-1)/(nyc-1)

      nxskip = nxfact - 1
      nyskip = nyfact - 1
C

      do jc = 1 , nyc
         jf = nyfact*jc-nyskip
         call d2vputv(uc,vtc,nxc,nyc,jc,1,1)
         call dvcuq1_s(vtc,vtf,nxfact,nxc)
         call dvput2v(vtf,uf,nxf,nyf,jf,1)
      end do

C now fill in the missing lines

      do iff = 1 , nxf
         call d2vputv(uf,vtc,nxf,nyf,iff,nyfact,2)
         call dvcuq1_s(vtc,vtf,nyfact,nyc) 
         call dvput2v(vtf,uf,nxf,nyf,iff,2)
      end do

      return
      end
C
C prolongs from a 1 to n grid using nth order techinques
C
C
C need a 1D nth order interpolation
C this routine will make sure that its a nx1 where n=nx=ny ....
C
C---------------------------------------------------------------------
      integer function  d2pro1nn(nxf,nyf,nxc,nyc,uf,uc,order) 
      implicit none
      integer  nxf,nyf
      integer  nxc,nyc
      integer order
      logical ccdimn

      real*8 uf(nxf,nyf), uc(nxc,nyc)

      integer wksp_size
      parameter ( wksp_size = 8000 )
C this size will suit must needs we can have a 20x1 refinement with
C 20th order 
      real*8 wksp(wksp_size)

      integer i,j
      integer iff,jf
      integer ic,jc
      integer nxfact,nyfact
      integer nxskip,nyskip
      integer iskip,jskip
      integer d1nintn

      real*8 f1,f2

      real*8 vtc(1025),vtf(1025)

      d2pro1nn = 0

      if( (.not.ccdimn(nxc,order)).or.(.not.ccdimn(nyc,order))) then
         write(6,*) 'not enough points for d2pro1nn'
         d2pro1nn = 1
         return
      end if
      if (nxf.gt.1025.or.nyf.gt.1025) then
         d2pro1nn = 1
         return
      end if


C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)
      nyfact = (nyf-1)/(nyc-1)

      nxskip = nxfact - 1
      nyskip = nyfact - 1

      d2pro1nn = d1nintn(order,wksp,wksp_size,nxfact)
C

      do jc = 1 , nyc
         jf = nyfact*jc-nyskip
         call d2vputv(uc,vtc,nxc,nyc,jc,1,1)
         call d1nintne( nxc,nxf,vtc,vtf,wksp,
     .                  wksp_size,order,nxfact )
         call dvput2v(vtf,uf,nxf,nyf,jf,1)
      end do

C now fill in the missing lines
      if (nyfact.ne.nxfact) then
         d2pro1nn = d1nintn(order,wksp,wksp_size,nyfact)
      end if

      do iff = 1 , nxf
         call d2vputv(uf,vtc,nxf,nyf,iff,nyfact,2)
         call d1nintne( nxc,nxf,vtc,vtf,wksp,
     .                  wksp_size,order,nyfact )
         call dvput2v(vtf,uf,nxf,nyf,iff,2)
      end do

      return
      end

C-----------------------------------------------------------------------------
C  given a list of points these routines interpolate to a solution vector
C
C  d2lintxy(nx,ny,x,y,pil,listx,listy,u,soln)       list    order 2
C  d4lintxy(nx,ny,x,y,pil,listx,listy,u,soln)       list    order 4
C  dnlintxy(nx,ny,x,y,pil,listx,listy,u,soln,order) list    order n
C-----------------------------------------------------------------------------
C This routine takes a list of points and interpolates to this to second
C order
      integer function d2lintxy(nx,ny,x,y,pil,listx,listy,
     .                           u,soln)
CFPP$ EXPAND(getijk)
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      integer pil
      real*8 listx(pil),listy(pil)
      real*8 u(nx,ny)
      real*8 soln(pil)

      integer order
      parameter ( order = 2 )

C local variables
      real*8 dx,dy
      real*8 dxi,dyi
      integer l
      integer i,j
      real*8 dx0,dy0
      integer ierr, getijk
      real*8 vx1,vx2

      d2lintxy = 0

      dx = abs( x(2)-x(1) )
      dy = abs( y(2)-y(1) )
      dxi= 1.0d0/dx
      dyi= 1.0d0/dy

C this will make a bounding box around each point and then interpolate
C in a series of 1d interpolations 


      do l = 1 , pil

         ierr =  getijk(nx,x,listx(l),i,dx0)
         if (ierr.eq.1) goto 1000
         ierr =  getijk(ny,y,listy(l),j,dy0)
         if (ierr.eq.1) goto 1000

         vx1 =  (dx-dx0)*dxi*u(i  ,j  )+dx0*dxi*u(i+1,j  )
         vx2 =  (dx-dx0)*dxi*u(i  ,j+1)+dx0*dxi*u(i+1,j+1)

         soln(l) = (dy-dy0)*dyi*vx1 + dy0*dyi*vx2

      end do

      return
1000   continue

      d2lintxy  = 1
      return
      end
C------------------------------------------------------------------------------
C This routine takes a list of points and interpolates to this to fourth
C order
      integer function d4lintxy(nx,ny,x,y,pil,listx,listy,
     .                           u,soln) 
CFPP$ EXPAND(getijk2)
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      integer pil
      real*8 listx(pil),listy(pil)
      real*8 u(nx,ny)
      real*8 soln(pil)

      integer order
      parameter ( order = 4 )

C local variables
      real*8 dx,dy
      real*8 dxi,dyi
      integer l,lj
      integer i,j
      real*8 dx0,dy0
      integer ierr, getijk2
      real*8 vx(4)
      real*8 den

      real*8 dx2,dx3,dx4,dx5
      real*8 dy2,dy3,dy4,dy5

      real*8 dx02,dx03,dx04,dx05
      real*8 dy02,dy03,dy04,dy05

      d4lintxy = 0

      dx = abs( x(2)-x(1) )
      dy = abs( y(2)-y(1) )
      dx2 = dx*dx
      dy2 = dy*dy

      dx3 = dx**3
      dy3 = dy**3

      dxi= 1.0d0/dx
      dyi= 1.0d0/dy

      do l = 1 , pil

C step 1 is to get the 2 points that surround this point in the x,y,z directions
C it returns the i-1,j-1,k-1 point and the dx0ff ...

         ierr =  getijk2(nx,x,listx(l),i,dx0)
         if (ierr.eq.1) goto 1000
         ierr =  getijk2(ny,y,listy(l),j,dy0)
         if (ierr.eq.1) goto 1000

         dx02 = dx0**2
         dx03 = dx0**3

         dy02 = dy0**2
         dy03 = dy0**3

         den = 1.0d0/(6.0d0*dx3) 

         do lj = 1 , 4
            vx(lj) =  den*(
     .            u(i+3,j+lj-1)*(dx03+2.0d0*dx2*dx0-
     .                           3.0d0*dx*dx02)+
     .            u(i+2,j+lj-1)*(-3.0d0*dx03-9.0d0*dx2*dx0
     .                           +12.0d0*dx*dx02) +
     .            u(i+1,j+lj-1)*(3.0d0*dx03+18.0d0*dx2*dx0-
     .                           15.0d0*dx*dx02)+
     .            u(i  ,j+lj-1)*(-dx03+6.0d0*dx3-11.0d0*dx2*dx0+
     .                           6.0d0*dx*dx02) )
         end do

         den = 1.0d0/(6.0d0*dy3) 

         soln(l) = den*(
     .            vx(4)*(dy03+2.0d0*dy2*dy0-3.0d0*dy*dy02) +
     .            vx(3)*(-3.0d0*dy03-9.0d0*dy2*dy0+12.0d0*dy*dy02) +
     .            vx(2)*(3.0d0*dy03+18.0d0*dy2*dy0-15.0d0*dy*dy02) +
     .            vx(1)*(-dy03+6.0d0*dy3-11.0d0*dy2*dy0 +
     .                    6.0d0*dy*dy02) )

      end do

      return
1000   continue

      d4lintxy    = 1
      return
      end
C------------------------------------------------------------------------------
C This routine takes a list of points and interpolates to this to fourth
C order
      integer function dnlintxy(nx,ny,x,y,pil,listx,listy,
     .                           u,soln,order) 
CFPP$ EXPAND(getijkn,getco)
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      integer pil
      real*8 listx(pil),listy(pil)
      real*8 u(nx,ny)
      real*8 soln(pil)

      integer order

C local variables
      real*8 dx,dy
      real*8 dxi,dyi
      integer l,lj,li
      integer i,j
      real*8 dx0,dy0
      integer ierr, getijkn
      integer maxorder
      parameter ( maxorder = 12 )
      real*8 mat2d(maxorder,maxorder)
      real*8 vx(maxorder)
      real*8 den,work(maxorder),sten(maxorder)
      integer getco

      real*8 dx2,dx3,dx4,dx5
      real*8 dy2,dy3,dy4,dy5

      real*8 dx02,dx03,dx04,dx05
      real*8 dy02,dy03,dy04,dy05

      dnlintxy = 0

      dx = abs( x(2)-x(1) )
      dy = abs( y(2)-y(1) )

      dxi= 1.0d0/dx
      dyi= 1.0d0/dy

      if (order.gt.maxorder) then
         write(0,*)  'dnlintxy: error order > maxorder'
         dnlintxy = 1
         return
      end if

C this will make a bounding box around each point and then interpolate
C in a series of 1d interpolations 


      do l = 1 , pil

C step 1 is to get the 2 points that surround this point in the x,y,z directions
C it returns the i-1,j-1,k-1 point and the dx0ff ...

         ierr =  getijkn(nx,x,listx(l),i,dx0,order)
         if (ierr.eq.1) goto 1000
         ierr =  getijkn(ny,y,listy(l),j,dy0,order)
         if (ierr.eq.1) goto 1000

C now we must get a 1d matrix of coefficients .......
c do first for the x direction

         ierr = getco(mat2d,order,dx,dx0,sten)
         if (ierr.eq.1) goto 1000

         do lj = 1 , order
            vx(lj) = 0.0d0
         end do

         do lj = 1 , order 
            do li = 1 , order
               vx(lj)=sten(li)*u(i+li-1,j+lj-1)+vx(lj)
            end do
         end do

         ierr = getco(mat2d,order,dy,dy0,sten)
         if (ierr.eq.1) goto 1000
         soln(l) = 0.0d0

         do li = 1 , order
            soln(l) = soln(l) + sten(li)*vx(li)
         end do

      end do

      return

1000   continue

      dnlintxy    = 1
      return
      end
C-------------------------------------------------------------------------------C
C  subroutine that inserts part of a 2D vector into a 1D vector.
C
C-----------------------------------------------------------------------------
      subroutine d2vputv(a2,a,nx,ny,l,stride,case)

      implicit none

      integer nx,ny,l,case,n
      integer stride

      real*8 a2(nx,ny), a(1025)
      integer i

      i = 0

      if (case.eq.1) then
         do n = 1,nx,stride
            i = i + 1
            a(i) = a2(n,l)
         end do
      else if (case.eq.2) then
         do n = 1,ny,stride
            i = i + 1
            a(i) = a2(l,n)
         end do
      else
         write(0,*)'ERROR: d2vputv - case=',case,' not correct'
         goto 900
      end if

      return
 900  continue
      end
C-------------------------------------------------------------------------------C
C  subroutine that inserts a 1D vector of a given stride into a 2D vector in
C   a specified place.
C
C-------------------------------------------------------------------------------
      subroutine dvput2v(a,a2,nx,ny,l,case)

      implicit none

      integer nx,ny,l,case,n

      real*8 a(1025), a2(nx,ny) 

      if (case.eq.1) then
         do n = 1,nx
            a2(n,l) = a(n)
         end do
      else if (case.eq.2) then
         do n = 1,ny
            a2(l,n) = a(n)
         end do
      else
         write(0,*)'ERROR: dvput3v - case=',case,' not correct'
         goto 900
      end if

      return
 900  continue
      end
C======================================================================
C routines in this section are
C       d2lintxyc(nx,ny,x,y,pil,lx,ly,u,v,char)
C                                                         list  char 2nd O 
C       d4lintxyc(nx,ny,x,y,pil,lx,ly,u,v,char)
C                                                         list  char 4th O 
C       dnlintxyc(nx,ny,x,y,pil,lx,ly,u,v,order,char)
C                                                         list  char pth O 
c-----------------------------------------------------------------------
      integer function d2lintxyc(nx,ny,x,y,pil,listx,listy,
     .                           u,soln,charm)
CFPP$ EXPAND(getijnew,reset_offsets42,movepoint2)
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      integer pil
      real*8 listx(pil),listy(pil)
      real*8 u(nx,ny),charm(nx,ny)
      real*8 soln(pil)
      integer moveit

      integer order,didit

C local variables
      real*8 dx,dy
      integer l,lj,li,ll
      integer i,j,iout
      real*8 dx0,dy0,dxout
      integer ierr
      real*8 mat2d(2,2)
      real*8 vx(2)
      real*8 den,work(2),sten(2)
      integer reset_offsets42
      integer movepoint2,getijnew
      parameter ( order = 2)
      integer iw

      real*8 dxi,dyi,dzi

      d2lintxyc= 0

      dx = abs( x(2)-x(1) )
      dy = abs( y(2)-y(1) )

      dxi = 1.0d0/dx
      dyi = 1.0d0/dy

C this will make a bounding box around each point and then interpolate
C in a series of 1d interpolations


      iw = nint(0.5*order)

      do l = 1 , pil

            moveit = 1
            ierr =  getijnew(nx,ny,listx(l),listy(l),x,y,
     .                     i,j,dx0,dy0,charm,order)

            if (charm(i+iw,j+iw).eq.1) then
               ierr = movepoint2(nx,ny,x,y,listx(l),listy(l),
     .                   i,j,dx0,dy0,charm,order)

               if (ierr.eq.1) goto 1000
               moveit = 0
            end if

         iout = i
         dxout = dx0

C
         if (moveit.eq.1) then
            do lj = 1 , order
               ierr = reset_offsets42(nx,ny,x,y,
     .          listx(l),charm,dxout,iout,j+lj-1,i,dx0,order)
                if (ierr.eq.1) goto 1000
                vx(lj) = (dx-dx0)*dxi*u(i,j+lj-1) + 
     .                      dx0*dxi*u(i+1,j+lj-1) 
            end do
         else

            do lj = 1 , order
               vx(lj) = (dx-dx0)*dxi*u(i,j+lj-1) + 
     .                   dx0*dxi*u(i+1,j+lj-1) 
            end do
         end if

         soln(l) = (dy-dy0)*dyi*vx(1) + dy0*dyi*vx(2)

      end do

      didit = didit + 1
      return

1000   continue

      didit = didit + 1
      d2lintxyc   = 1
      return
      end
C======================================================================
      integer function d2lintxycd(nx,ny,x,y,pil,listx,listy,
     .                           u,soln,charm,iwk,swk,didit,wd) 
CFPP$ EXPAND(getsten_num2)
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      integer pil
      real*8 listx(pil),listy(pil)
      real*8 soln(pil)
      real*8 u(nx,ny),charm(nx,ny)
      integer iwk(*),swk(*)
      integer order
      parameter ( order = 2)
      character*1 wd

      integer d2lintxyc
      integer didit
      integer l,m,lm
      integer maxs
      parameter ( maxs = 257 * 257 * 3)
      real*8 inlx(maxs),inly(maxs),ins(maxs)
      integer sten_num(maxs),getsten_num2
      real*8 dx,dy
      real*8 dxi,dyi
      real*8 coeff(5,3)
      integer ip

      d2lintxycd = 0

      if (pil.gt.257*257) then
         d2lintxycd = 1
         return
      end if

      if (wd.ne.' ') then
         call getcoeff2(coeff,2*order+1,order+1)
      end if


      if (wd.eq.' ') then

         d2lintxycd = d2lintxyc(nx,ny,x,y,pil,listx,listy,
     .                          u,soln,charm,iwk,didit) 
         if (d2lintxycd.eq.1) return
      else if (wd.eq.'x') then
         dx = x(2) - x(1) 
         dxi= 1.0d0/dx 
         ip = 0
         do m = 1 , pil

            if (didit.eq.0) then
               sten_num(m)=getsten_num2(nx,ny,x,y,listx(m),
     .                         listy(m),charm,order,1)
               swk(m) = sten_num(m)
            else
               sten_num(m) = swk(m)
            end if

            if (sten_num(m).eq.2) then
               l = -1
               do lm = 1,2
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  inly(ip) = listy(m)
                  l = l + 2
               end do
            else if (sten_num(m).eq.1) then
               do lm = 0,2
                  ip = ip + 1
                  inlx(ip) = listx(m) + lm*dx
                  inly(ip) = listy(m)
               end do
            else
               do lm = -2,0
                  ip = ip + 1
                  inlx(ip) = listx(m) + lm*dx
                  inly(ip) = listy(m)
               end do
            end if
         end do
         d2lintxycd = d2lintxyc(nx,ny,x,y,ip,
     .                    inlx,inly,u,ins,charm,iwk,didit) 
         if (d2lintxycd.eq.1) return
         ip = 0
         do m = 1 , pil
            ip = ip + 3
            if (sten_num(m).eq.2) then
               ip = ip - 1
               soln(m) = dxi*(coeff(4,2)*ins(ip)+coeff(2,2)*ins(ip-1)) 
            else if (sten_num(m).eq.1) then
               soln(m)=dxi*(coeff(3,1)*ins(ip-2)+coeff(4,1)*ins(ip-1)
     .                     +coeff(5,1)*ins(ip))
            else
               soln(m)=dxi*(coeff(1,3)*ins(ip-2)+coeff(2,3)*ins(ip-1)
     .                     +coeff(3,3)*ins(ip))
            end if
         end do

      else if (wd.eq.'y') then

         dy = y(2) - y(1)
         dyi= 1.0d0/dy
         ip = 0
         do m = 1 , pil

            if (didit.eq.0) then
               sten_num(m)=getsten_num2(nx,ny,x,y,listx(m),
     .                         listy(m),charm,order,1)
               swk(m) = sten_num(m)
            else
               sten_num(m) = swk(m)
            end if

            if (sten_num(m).eq.2) then
               l = -1
               do lm = 1,2
                  ip = ip + 1
                  inlx(ip) = listx(m) 
                  inly(ip) = listy(m) + l*dy
                  l = l + 2
               end do
            else if (sten_num(m).eq.1) then
               do lm = 0,2
                  ip = ip + 1
                  inlx(ip) = listx(m) 
                  inly(ip) = listy(m) + lm*dy
               end do
            else
               do lm = -2,0
                  ip = ip + 1
                  inlx(ip) = listx(m)
                  inly(ip) = listy(m) + lm*dy
               end do
            end if
         end do
         d2lintxycd = d2lintxyc(nx,ny,x,y,ip,
     .                    inlx,inly,u,ins,charm,iwk,didit)
         if (d2lintxycd.eq.1) return
         ip = 0
         do m = 1 , pil
            ip = ip + 3
            if (sten_num(m).eq.2) then
               ip = ip - 1
               soln(m) = dyi*(coeff(4,2)*ins(ip)+coeff(2,2)*ins(ip-1))
            else if (sten_num(m).eq.1) then
               soln(m)=dyi*(coeff(3,1)*ins(ip-2)+coeff(4,1)*ins(ip-1)
     .                     +coeff(5,1)*ins(ip))
            else
               soln(m)=dyi*(coeff(1,3)*ins(ip-2)+coeff(2,3)*ins(ip-1)
     .                     +coeff(3,3)*ins(ip))
            end if
         end do

      else
         write(6,*) '*** This derivative is not implemented ***'
         d2lintxycd = 1
      end if

      return
      end
C======================================================================
      integer function d4lintxyc(nx,ny,x,y,pil,listx,listy,
     .                           u,soln,charm) 
CFPP$ EXPAND(getijnew,reset_offsets42,movepoint2) 
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      integer pil
      real*8 listx(pil),listy(pil)
      real*8 u(nx,ny),charm(nx,ny)
      real*8 soln(pil)
      integer moveit
      integer didit

      integer order

C local variables
      real*8 dx,dy
      integer l,lj,lk,li,ll
      integer i,j,k
      real*8 dx0,dy0
      integer ierr, getijknc4
      real*8 vx(4),den
      integer reset_offsets42,getijnew
      integer movepoint2
      parameter ( order = 4)

C      real*8 sum
      real*8 dxi,dyi
      real*8 dx02,dy02
      real*8 dx03,dy03
      real*8 dx20,dxx02
      real*8 dy20,dyy02
      real*8 dx2,dy2
      real*8 dx3,dy3
      integer iout,iw
      real*8 dxout

      d4lintxyc= 0

      dx = abs( x(2)-x(1) )
      dy = abs( y(2)-y(1) )

      dxi = 1.0d0/dx
      dyi = 1.0d0/dy

      dx2 = dx*dx
      dy2 = dy*dy

      dx3 = dx**3
      dy3 = dy**3

      den = 1.0d0/(6.0d0*dx3)
      iw = nint(0.5*order)   

C this will make a bounding box around each point and then interpolate
C in a series of 1d interpolations 
      iw = nint(0.5*order)   
      
      do l = 1 , pil

            moveit = 1
            d4lintxyc =  getijnew(nx,ny,listx(l),listy(l),
     .                        x,y,i,j,dx0,dy0,charm,order)

            if (d4lintxyc.eq.1) goto 1000 


            if (charm(i+iw,j+iw).eq.1) then
               ierr = movepoint2(nx,ny,x,y,listx(l),listy(l),
     .                     i,j,dx0,dy0,charm,order)

               if (ierr.eq.1) goto 1000
               moveit = 0
            end if

         iout = i
         dxout = dx0
         den = 1.0d0/(6.0d0*dx3)

         dy02 = dy0**2
         dy03 = dy0**3
         dy20 = dy2*dy0
         dyy02= dy*dy02

C

         if (moveit.eq.1) then
               do lj = 1 , order
   
                  ierr = reset_offsets42(nx,ny,x,y,listx(l),
     .                   charm,dxout,iout,j+lj-1,i,dx0,order)
                  if (ierr.eq.1) goto 1000
   
                  dx02 = dx0**2
                  dx03 = dx0**3
                  dx20 = dx2*dx0
                  dxx02= dx*dx02

                  if (i+3.gt.nx) goto 1000
   
                  vx(lj) =  den*(
     .            u(i+3,j+lj-1)*(dx03+2.0d0*dx20-
     .                                  3.0d0*dxx02)+
     .            u(i+2,j+lj-1)*(-3.0d0*dx03-9.0d0*dx20
     .                                  +12.0d0*dxx02) +
     .            u(i+1,j+lj-1)*(3.0d0*dx03+18.0d0*dx20-
     .                                  15.0d0*dxx02)+
     .            u(i  ,j+lj-1)*(-dx03+6.0d0*dx3-11.0d0*dx20+
     .                                  6.0d0*dxx02) )

               end do
         else

            if (i+3.gt.nx) goto 1000
            do lj = 1 , order

                  dx02 = dx0**2
                  dx03 = dx0**3
                  dx20 = dx2*dx0
                  dxx02= dx*dx02

                  vx(lj) =  den*(
     .               u(i+3,j+lj-1)*(dx03+2.0d0*dx20-
     .                                     3.0d0*dxx02)+
     .               u(i+2,j+lj-1)*(-3.0d0*dx03-9.0d0*dx20
     .                                     +12.0d0*dxx02) +
     .               u(i+1,j+lj-1)*(3.0d0*dx03+18.0d0*dx20-
     .                                     15.0d0*dxx02)+
     .               u(i  ,j+lj-1)*(-dx03+6.0d0*dx3-11.0d0*dx20+
     .                                  6.0d0*dxx02) )

            end do

         end if

         den = 1.0d0/(6.0d0*dy3)

         soln(l) = den*(
     .            vx(4)*(dy03+2.0d0*dy20-3.0d0*dyy02) +
     .            vx(3)*(-3.0d0*dy03-9.0d0*dy20+12.0d0*dyy02) +
     .            vx(2)*(3.0d0*dy03+18.0d0*dy20-15.0d0*dyy02) +
     .            vx(1)*(-dy03+6.0d0*dy3-11.0d0*dy20 +
     .                    6.0d0*dyy02) )

      end do
      didit = didit + 1

      return

1000   continue

      d4lintxyc   = 1
      return
      end
C======================================================================
      integer function reset_offsets42(nx,ny,x,y,listx,
     .                               charm,dx,i,j,iout,dxout,order) 
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      real*8 listx
      real*8 charm(nx,ny) 
      real*8 dx
      integer i,j
      integer order
      integer im,ip,ims,ips
      integer istart,istop
      integer iout
      real*8    dxout


C local variables .......

      integer li,lj
      logical xhit
      integer mini
      real*8  minx

      reset_offsets42= 0

      iout = i
      dxout = dx


C now scan to see if we hit into charm=1
      xhit = .false.
      
      if (i+order-1.gt.nx) then
         reset_offsets42 = 1
         return
      end if

      do li = 1 , order 
         if(int(charm(i+li-1,j)).ne.1) xhit = .true.
      end do


      if (.not.xhit) return 
C move the i value back to the center of the stencil ........

      minx = abs(x(1)-listx) 
      do li = max(1,i-order),min(nx,i+order)
         if (abs(x(li)-listx).lt.minx) then
            iout = li
            minx = abs(x(li)-listx)   
         end if
      end do

C so the questions are : which way do I move the start point
C we try both directions 

      ip = 0
      im = 0
      ims = 0
      ips = 0
      
      istart= 1
      istop = nx 

C first move it in the negative direction
      do li = iout,istart, -1
         if (int(charm(li,j)).eq.1) then
            ims = li
            goto 100
         end if
         im = im + 1
      end do
100   continue

      do li = iout,istop
         if (int(charm(li,j)).eq.1) then
            ips = li
            goto 200
         end if
         ip = ip + 1
      end do
200   continue

      if (ips.eq.0.and.ims.eq.0)  then
         reset_offsets42= 1   
         return
      end if

      if (im.lt.ip) then
         iout = ims - nint(0.5*order) + 1
         if (iout.lt.1) then
            iout = 1
            reset_offsets42= 1   
         end if
      else
         iout = ips
         if (iout+order.gt.nx) then
            reset_offsets42= 1   
         end if
      end if

C one more check ....
5000  continue
      ip = 0
      do li = iout,iout+order-1
         ip = ip + int(charm(li,j))
      end do
      if (ip.lt.order) then
         iout = max(1,iout-(order-ip))
         goto 5000
      end if


      dxout = listx - x(iout)

      return
      end
C----------------------------------------------------------------------------
      integer function d4lintxycd(nx,ny,x,y,pil,listx,listy,
     .                           u,soln,charm,iwk,swk,didit,wd) 
CFPP$ EXPAND(getsten_num2)
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      integer pil
      real*8 listx(pil),listy(pil)
      real*8 soln(pil)
      real*8 u(nx,ny),charm(nx,ny)
      integer order
      parameter ( order = 4)
      character*1 wd

      integer d4lintxyc,d4lintyxc
      integer l,m,lm,ip
      integer maxs,ierr
      integer iwk(*),swk(*)
      integer didit
      parameter ( maxs = 257 * 257 * 5)
      real*8 inlx(maxs),inly(maxs),ins(maxs)
      real*8 dx,dy
      real*8 dxi,dyi
      integer sten_num(maxs),getsten_num2
      real*8 twel
      parameter ( twel = 1.0d0 / 12.0d0)
      real*8 coeff(9,5)

      d4lintxycd = 0
      if (pil.gt.257*257) then
         d4lintxycd = 1
         return
      end if
      if (wd.ne.' ') then

         call getcoeff4(coeff,2*order+1,order+1)

      end if

      if (wd.eq.' ') then

         d4lintxycd = d4lintxyc(nx,ny,x,y,pil,listx,listy,
     .                 u,soln,charm,iwk,didit) 
         if (d4lintxycd.eq.1) return
      else if (wd.eq.'x') then
         dx = x(2) - x(1) 
         dxi= 1.0d0/dx 
         ip = 0
         do m = 1 , pil

            if (didit.eq.0) then
            sten_num(m)=getsten_num2(nx,ny,x,y,listx(m),
     .                      listy(m),charm,order,1)

               swk(m) = sten_num(m)
            else
               sten_num(m) = swk(m)
            end if

            if (sten_num(m).eq.3) then
               l = -2
               do lm = 1,2
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  inly(ip) = listy(m)
                  l = l + 1
               end do
               l = 1
               do lm = 3,4
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  inly(ip) = listy(m)
                  l = l + 1
               end do

            else if (sten_num(m).eq.1) then
               l = 0
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  inly(ip) = listy(m)
                  l = l + 1
               end do
            else if (sten_num(m).eq.2) then
               l = -1 
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  inly(ip) = listy(m)
                  l = l + 1
               end do
            else if (sten_num(m).eq.4) then
               l = -3
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  inly(ip) = listy(m)
                  l = l + 1
               end do
            else if (sten_num(m).eq.5) then
               l = -4
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  inly(ip) = listy(m)
                  l = l + 1
               end do
            else 
               d4lintxycd = 1
               return
            end if
            
         end do

         d4lintxycd = d4lintxyc(nx,ny,x,y,ip,
     .               inlx,inly,u,ins,charm,iwk,didit)
         if (d4lintxycd.eq.1) return


         ip = 0

         do m = 1 , pil
            ip = ip + 5
            if (sten_num(m).eq.3) then
               ip = ip - 1
               soln(m) =dxi*( coeff(3,3)*ins(ip-3) +
     .                        coeff(4,3)*ins(ip-2) +
     .                        coeff(6,3)*ins(ip-1) +
     .                        coeff(7,3)*ins(ip  ) )

            else if (sten_num(m).eq.1) then
               soln(m) =dxi*( coeff(5,1)*ins(ip-4) +
     .                        coeff(6,1)*ins(ip-3) +
     .                        coeff(7,1)*ins(ip-2) +
     .                        coeff(8,1)*ins(ip-1) +
     .                        coeff(9,1)*ins(ip  ) )

            else if (sten_num(m).eq.2) then
               soln(m) =dxi*( coeff(4,2)*ins(ip-4) +
     .                        coeff(5,2)*ins(ip-3) +
     .                        coeff(6,2)*ins(ip-2) +
     .                        coeff(7,2)*ins(ip-1) +
     .                        coeff(8,2)*ins(ip  ) )

            else if (sten_num(m).eq.4) then
               soln(m) =dxi*( coeff(2,4)*ins(ip-4) +
     .                        coeff(3,4)*ins(ip-3) +
     .                        coeff(4,4)*ins(ip-2) +
     .                        coeff(5,4)*ins(ip-1) +
     .                        coeff(6,4)*ins(ip  ) )

            else if (sten_num(m).eq.5) then
               soln(m) =dxi*( coeff(1,5)*ins(ip-4) +
     .                        coeff(2,5)*ins(ip-3) +
     .                        coeff(3,5)*ins(ip-2) +
     .                        coeff(4,5)*ins(ip-1) +
     .                        coeff(5,5)*ins(ip  ) )

            end if

         end do

      else if (wd.eq.'y') then
         dy = y(2) - y(1)
         dyi= 1.0d0/dy

         ip = 0
         do m = 1 , pil
            if (didit.eq.0) then
            sten_num(m)=getsten_num2(nx,ny,x,y,listx(m),
     .                      listy(m),charm,order,2)

               swk(m) = sten_num(m)
            else
               sten_num(m) = swk(m) 
            end if

            if (sten_num(m).eq.3) then
               l = -2
               do lm = 1,2
                  ip = ip + 1
                  inlx(ip) = listx(m) 
                  inly(ip) = listy(m) + l*dy
                  l = l + 1
               end do
               l = 1
               do lm = 3,4
                  ip = ip + 1
                  inlx(ip) = listx(m) 
                  inly(ip) = listy(m) + l*dy
                  l = l + 1
               end do

            else if (sten_num(m).eq.1) then
               l = 0
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) 
                  inly(ip) = listy(m) + l*dy
                  l = l + 1
               end do
            else if (sten_num(m).eq.2) then
               l = -1 
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) 
                  inly(ip) = listy(m) + l*dy
                  l = l + 1
               end do
            else if (sten_num(m).eq.4) then
               l = -3
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) 
                  inly(ip) = listy(m) + l*dy
                  l = l + 1
               end do
            else if (sten_num(m).eq.5) then
               l = -4
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) 
                  inly(ip) = listy(m) + l*dy
                  l = l + 1
               end do
            else 
               d4lintxycd = 1
               return
            end if
            
         end do
   
         d4lintxycd = d4lintxyc(nx,ny,x,y,ip,
     .             inlx,inly,u,ins,charm,iwk,didit)
         if (d4lintxycd.eq.1) return


         ip = 0

         do m = 1 , pil
            ip = ip + 5
            if (sten_num(m).eq.3) then
               ip = ip - 1
               soln(m) =dyi*( coeff(3,sten_num(m))*ins(ip-3) +
     .                        coeff(4,sten_num(m))*ins(ip-2) +
     .                        coeff(6,sten_num(m))*ins(ip-1) +
     .                        coeff(7,sten_num(m))*ins(ip  ) )

            else if (sten_num(m).eq.1) then
               soln(m) =dyi*( coeff(5,sten_num(m))*ins(ip-4) +
     .                        coeff(6,sten_num(m))*ins(ip-3) +
     .                        coeff(7,sten_num(m))*ins(ip-2) +
     .                        coeff(8,sten_num(m))*ins(ip-1) +
     .                        coeff(9,sten_num(m))*ins(ip  ) )

            else if (sten_num(m).eq.2) then
               soln(m) =dyi*( coeff(4,sten_num(m))*ins(ip-4) +
     .                        coeff(5,sten_num(m))*ins(ip-3) +
     .                        coeff(6,sten_num(m))*ins(ip-2) +
     .                        coeff(7,sten_num(m))*ins(ip-1) +
     .                        coeff(8,sten_num(m))*ins(ip  ) )

            else if (sten_num(m).eq.4) then
               soln(m) =dyi*( coeff(2,sten_num(m))*ins(ip-4) +
     .                        coeff(3,sten_num(m))*ins(ip-3) +
     .                        coeff(4,sten_num(m))*ins(ip-2) +
     .                        coeff(5,sten_num(m))*ins(ip-1) +
     .                        coeff(6,sten_num(m))*ins(ip  ) )

            else if (sten_num(m).eq.5) then
               soln(m) =dyi*( coeff(1,sten_num(m))*ins(ip-4) +
     .                        coeff(2,sten_num(m))*ins(ip-3) +
     .                        coeff(3,sten_num(m))*ins(ip-2) +
     .                        coeff(4,sten_num(m))*ins(ip-1) +
     .                        coeff(5,sten_num(m))*ins(ip  ) )

            end if

         end do

      else

         write(6,*) '*** This derivative is not implemented ***'
         d4lintxycd = 1 
      end if

      return
      end
C=========================================================================
      integer function movepoint2(nx,ny,x,y,listx,listy,
     .                     i,j,dx0,dy0,charm,order)
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      real*8 charm(nx,ny)
      real*8 listx,listy
      integer i,j
      real*8 dx0,dy0
      real*8 count
      integer order
      integer li,lj,l
      integer is,js
      integer dirp1,dirp2
      integer dirm1,dirm2
      integer dir1,dir2
      integer sdir1,sdir2
      integer ip
      real*8 dist,xip

      movepoint2 =  0

      count = 0.0d0
      do li = i , i+order -1
         do lj = j , j+order-1
               count = count + charm(li,lj)
         end do
      end do

      if (int(count).eq.order**2) return

C put the point to the center of the stencil
      i = i + nint(order*0.5)
      j = j + nint(order*0.5)

      dir1 = -1
      dir2 = -1

      do l = 1 , order*4+1
         do lj = 0 , l
            do li = 0 , l
               count = 0.0d0
               xip = 0.0d0
               do js = max(1,j+lj*dir2),min(ny,j+lj*dir2+order-1)
                  do is = max(1,i+li*dir1),min(nx,i+li*dir1+order-1)
                     count = count + charm(is,js)
                     xip = xip + 1.0d0
                  end do
               end do
               if (int(count).eq.xip) goto 1000
            end do
         end do
      end do

      movepoint2 = 1
      i = i - nint(order*0.5)
      j = j - nint(order*0.5)

      return

1000   continue
      i = i +  li*dir1
      j = j + lj*dir2
      dx0 = listx - x(i)
      dy0 = listy - y(j)

      return
      end

C===============================================================================
      integer function getijnew(nx,ny,listx,listy,x,y,
     .                     i,j,dx0,dy0,charm,order)
CFPP$ EXPAND(getijknc4)
      implicit none
      integer nx,ny
      real*8 listx,listy
      real*8 x(nx),y(ny)
      integer i,j
      real*8 dx0,dy0
      real*8 charm(nx,ny) 
      integer order

      integer li,lj
      integer length
      integer ierr,getijknc4
      real*8 dist,mindist
      real*8 is,js
      integer offset

      ierr =  getijknc4(nx,x,listx,i,dx0,order)
		if  (ierr.eq.1) then
			getijnew = 1
			return
		end if
      ierr =  getijknc4(ny,y,listy,j,dy0,order)
		if  (ierr.eq.1) then
			getijnew = 1
			return
		end if

C make sure its the closest point

      length = nint(0.5*order)
      i = i + length
      j = j + length 

      getijnew = 0

      mindist = 9.90d09
      offset = 0
100   continue
      do li = i-offset , offset+i
         do lj = j-offset , offset+j
            dist = (x(li)-listx)**2+(y(lj)-listy)**2
            if (dist.le.charm(li,lj)*mindist) then
               mindist = dist
               is = li
               js = lj
            end if
         end do
      end do


      if (mindist.lt.(100.0d0)) then
         i = is - length 
         j = js - length

         if (i.lt.1.or.j.lt.1.or.i.gt.nx.or.
     .       j.gt.ny) then
            getijnew = 1
            return
         end if
  

   
         dx0  = listx - x(i)
         dy0  = listy - y(j)
      else if (offset.lt.nx) then
         offset = offset + 1
         goto 100
      else

         getijnew = 1

      end if


      return
      end
C==========================================================================
      integer function getsten_num2(nx,ny,x,y,listx,listy,
     .                             charm,order,dir)
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      real*8 listx,listy
      real*8 charm(nx,ny)
      integer dir
      integer order

      integer ierr,getijnew
      integer length
      integer ip,im,l,lp,lm
      integer i,j,k
      real*8 dx0,dy0

      length = nint(0.5*order)

      getsten_num2 =  getijnew(nx,ny,listx,listy,x,y,
     .               i,j,dx0,dy0,charm,order)
      i = i + length
      j = j + length

C now I have i,j

      if (dir.eq.1) then

         ip = 0
         im = 0

         do l = i+1 , i+order
            ip = ip + int(charm(l,j))
         end do

         do l = i-order,i-1
            im = im + int(charm(l,j))
         end do


         getsten_num2= 1 + length

         lm = 0
         lp = order
         do l = 1 , order+1
            if (ip.ge.lp.and.im.ge.lm) then
               getsten_num2= l
            end if
            lm = lm + 1
            lp = lp - 1
         end do

         if (ip.eq.im) getsten_num2= 1 + length


      else 

         ip = 0
         im = 0

         do l = j+1 , j+order
            ip = ip + int(charm(i,l))
         end do

         do l = j-order,j-1
            im = im + int(charm(i,l))
         end do


         getsten_num2= 1 + length

         lm = 0
         lp = order
         do l = 1 , order+1
            if (ip.ge.lp.and.im.ge.lm) then
               getsten_num2= l
            end if
            lm = lm + 1
            lp = lp - 1
         end do

         if (ip.eq.im) getsten_num2= 1 + length

      end if

1000   continue

      return
      end
C==============================================================================
C This routine takes a list of points and interpolates to this to nth
C order
      integer function dnlintxyc(nx,ny,x,y,pil,listx,listy,
     .                           u,soln,order,charm)
CFPP$ EXPAND(getijnew,reset_offsets42,movepoint2)
      implicit none
      integer nx,ny
      real*8 x(nx),y(ny)
      integer pil
      real*8 listx(pil),listy(pil)
      real*8 u(nx,ny),charm(nx,ny)
      real*8 soln(pil)

      integer order
      integer didit
      integer movepoint2,moveit
      integer istwk

C local variables
      real*8 dx,dy
      integer l,lj,lk,li,lli
      integer i,j,k
      real*8 dx0,dy0
      integer ierr, getijnew
      integer maxorder
      parameter ( maxorder = 12 )
      real*8 mat2d(maxorder,maxorder)
      real*8 vx(maxorder)
      real*8 den,work(maxorder),sten(maxorder)
      integer getcoc,reset_offsets42
      integer iw,iout,isoff
      real*8 dxout

      real*8 dy2,dy3,dy4,dy5

      dnlintxyc= 0

      dx = abs( x(2)-x(1) )
      dy = abs( y(2)-y(1) )
      iw = nint(0.5*order)

      isoff = order*order*pil
      istwk = 0

      do l = 1 , pil

            moveit = 1
            dnlintxyc =  getijnew(nx,ny,listx(l),listy(l),
     .                        x,y,i,j,dx0,dy0,charm,order)

				if (dnlintxyc.eq.1) goto 1000

            if (charm(i+iw,j+iw).eq.1) then
               ierr = movepoint2(nx,ny,x,y,listx(l),listy(l),
     .                     i,j,dx0,dy0,charm,order)

               if (ierr.eq.1) goto 1000
               moveit = 0
            end if
         iout = i
         dxout = dx0

C
            do lj = 1 , order
               vx(lj) = 0.0d0
            end do

         if (moveit.eq.1) then

               do lj = 1 , order
                  ierr = reset_offsets42(nx,ny,x,y,
     .             listx(l),charm,dxout,iout,j+lj-1,i,dx0,order)
                  if (ierr.eq.1) goto 1000

                     ierr = getcoc(mat2d,order,dx,dx0,sten)
                     if (ierr.eq.1) goto 1000

                  if (ierr.eq.1) goto 1000
						if (order+i-1.gt.nx) goto 1000
                  do li = 1 , order
                     vx(lj)=sten(li)*u(i+li-1,j+lj-1)+
     .                         vx(lj)
                  end do
               end do

         else

               do lj = 1 , order

                     ierr = getcoc(mat2d,order,dx,dx0,sten)
                     if (ierr.eq.1) goto 1000

						if (order+i-1.gt.nx) goto 1000
                  do li = 1 , order
                     vx(lj)=sten(li)*u(i+li-1,j+lj-1) + 
     .                         vx(lj)
                  end do
               end do
         end if

            ierr = getcoc(mat2d,order,dy,dy0,sten)
            if (ierr.eq.1) goto 1000

         if (ierr.eq.1) goto 1000
         soln(l) = 0.0d0

         do li = 1 , order
            soln(l) = soln(l) + sten(li)*vx(li)
         end do

      end do

      return

1000   continue

      dnlintxyc   = 1
      return
      end
      integer function d2pro122cs( uc,uf,nxc,nyc,charmc,charmf,
     .                             xf,yf,wkspf,wk2,nwk2,didit)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(2*nxc-1,2*nyc-1)
      real*8  wkspf(2*nxc-1,2*nyc-1)
      real*8  charmc(nxc,nyc),charmf(2*nxc-1,2*nyc-1)
      real*8  xf(2*nxc-1),yf(2*nyc-1)
      integer nwk2,didit
      real*8 wk2(nwk2)
      integer pil,maxpil
      parameter ( maxpil = 3000 )
      real*8 listx(maxpil),listy(maxpil)
      integer listi(maxpil),listj(maxpil)
      real*8 soln(maxpil)

      integer   ic , jc , l
      integer   iff , jf
      integer ierr,d2lintxyc
      integer d2pro122c_,getlists2

      nxf = 2*nxc-1
      nyf = 2*nyc-1

      d2pro122cs= 0

      call getwork2d(nxc,nyc,nxf,nyf,charmc,wkspf)

      d2pro122cs=  d2pro122c_(uc,uf,nxc,nyc,charmc,wkspf)
      if (d2pro122cs.eq.1) return

      call sub_(nxf*nyf,charmf,wkspf,wkspf)

      d2pro122cs= getlists2( nxf,nyf,wkspf,xf,yf,pil,
     .                       listx,listy,
     .                      listi,listj,maxpil )

      if (d2pro122cs.eq.1) return
C get the wkspf again 
      call getwork2d(nxc,nyc,nxf,nyf,charmc,wkspf)


      d2pro122cs = d2lintxyc( nxf,nyf,xf,yf,pil,
     .                         listx,listy,uf,soln,
     .                         wkspf) 

      call putsoln2(nxf,nyf,pil,listi,listj,soln,uf)

      return
      end
C-------------------------------------------------------------------------------
      integer function d2pro124cs( uc,uf,nxc,nyc,charmc,charmf,
     .                             xf,yf,wkspf,wk2,nwk2,didit)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(2*nxc-1,2*nyc-1)
      real*8  wkspf(2*nxc-1,2*nyc-1) 
      real*8  charmc(nxc,nyc),charmf(2*nxc-1,2*nyc-1) 
      real*8  xf(2*nxc-1),yf(2*nyc-1)
      integer nwk2,didit
      real*8 wk2(nwk2)
      integer pil,maxpil
      parameter ( maxpil = 30000 )
      real*8 listx(maxpil),listy(maxpil)
      integer listi(maxpil),listj(maxpil)
      real*8 soln(maxpil)

      integer   ic , jc , l
      integer   iff , jf
      integer ierr,d4lintxyc
      integer d2pro124c_,getlists2

      nxf = 2*nxc-1
      nyf = 2*nyc-1

      d2pro124cs= 0

      call getwork2d(nxc,nyc,nxf,nyf,charmc,wkspf)
      d2pro124cs=  d2pro124c_(uc,uf,nxc,nyc,charmc,wkspf)

      call sub_(nxf*nyf,charmf,wkspf,wkspf)

      d2pro124cs= getlists2( nxf,nyf,wkspf,xf,yf,pil,
     .                       listx,listy,listi,listj,maxpil )

      if (d2pro124cs.eq.1) return
C get the wkspf again 
      call getwork2d(nxc,nyc,nxf,nyf,charmc,wkspf)


      d2pro124cs = d4lintxyc( nxf,nyf,xf,yf,pil,
     .                         listx,listy,uf,soln,
     .                         wkspf)  

      call putsoln2(nxf,nyf,pil,listi,listj,soln,uf)

      return
      end
C-------------------------------------------------------------------------------
      integer function d2pro12ncs( uc,uf,nxc,nyc,charmc,charmf,
     .                             xf,yf,order,wkspf,wk2,nwk2,didit)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(2*nxc-1,2*nyc-1)
      real*8  wkspf(2*nxc-1,2*nyc-1) 
      real*8  charmc(nxc,nyc),charmf(2*nxc-1,2*nyc-1) 
      real*8  xf(2*nxc-1),yf(2*nyc-1)
      integer nwk2,didit
      real*8 wk2(nwk2)
      integer order
      integer pil,maxpil
      parameter ( maxpil = 300*300 )
      real*8 listx(maxpil),listy(maxpil)
      integer listi(maxpil),listj(maxpil)
      real*8 soln(maxpil),stwk(maxpil*10)


      integer   ic , jc , l
      integer   iff , jf
      integer ierr,dnlintxyc
      integer d2pro12nc_,getlists2

      nxf = 2*nxc-1
      nyf = 2*nyc-1

      d2pro12ncs= 0

      call getwork2d(nxc,nyc,nxf,nyf,charmc,wkspf)
      d2pro12ncs=  d2pro12nc_(uc,uf,nxc,nyc,order,charmc,wkspf)

      if (d2pro12ncs.eq.1) return

      call sub_(nxf*nyf,charmf,wkspf,wkspf)

      d2pro12ncs= getlists2( nxf,nyf,wkspf,xf,yf,pil,
     .                       listx,listy,listi,listj,maxpil )

      if ((order*order*order+2*order)*pil.gt.maxpil*10) d2pro12ncs=1

      if (d2pro12ncs.eq.1) return
C get the wkspf again 
      call getwork2d(nxc,nyc,nxf,nyf,charmc,wkspf)


      d2pro12ncs = dnlintxyc( nxf,nyf,xf,yf,pil,
     .                         listx,listy,uf,soln,order,
     .                         wkspf) 

      call putsoln2(nxf,nyf,pil,listi,listj,soln,uf)

      return
      end
C-------------------------------------------------------------------------------
      integer function d2pro1n2cs( uc,uf,nxc,nyc,nxf,nyf,charmc,charmf,
     .                             xf,yf,wkspf,wk2,nwk2,didit)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(nxf,nyf) 
      real*8  wkspf(nxf,nyf) 
      real*8  charmc(nxc,nyc),charmf(nxf,nyf) 
      real*8  xf(nxf),yf(nyf) 
      integer nwk2,didit
      real*8 wk2(nwk2)
      integer pil,maxpil
      parameter ( maxpil = 3000 )
      real*8 listx(maxpil),listy(maxpil)
      integer listi(maxpil),listj(maxpil)
      real*8 soln(maxpil)


      integer   ic , jc , l
      integer   iff , jf
      integer ierr,d2lintxyc
      integer d2pro1n2c_,getlists2

      d2pro1n2cs= 0

      call getwork2dn(nxc,nyc,nxf,nyf,charmc,wkspf)

      d2pro1n2cs=  d2pro1n2c_(nxf,nyf,nxc,nyc,uf,uc,charmc,wkspf)

      if (d2pro1n2cs.eq.1) return

      call sub_(nxf*nyf,charmf,wkspf,wkspf)

      d2pro1n2cs= getlists2( nxf,nyf,wkspf,xf,yf,pil,
     .                       listx,listy,
     .                      listi,listj,maxpil )

      if (d2pro1n2cs.eq.1) return
C get the wkspf again 
      call getwork2dn(nxc,nyc,nxf,nyf,charmc,wkspf)

      d2pro1n2cs = d2lintxyc( nxf,nyf,xf,yf,pil,
     .                         listx,listy,uf,soln,
     .                         wkspf) 

      call putsoln2(nxf,nyf,pil,listi,listj,soln,uf)

      return
      end
C-------------------------------------------------------------------------------
      integer function d2pro1n4cs( uc,uf,nxc,nyc,nxf,nyf,charmc,charmf,
     .                             xf,yf,wkspf,wk2,nwk2,didit)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(nxf,nyf) 
      real*8  wkspf(nxf,nyf) 
      real*8  charmc(nxc,nyc),charmf(nxf,nyf) 
      real*8  xf(nxf),yf(nyf)
      integer nwk2,didit
      real*8 wk2(nwk2)
      integer pil,maxpil
      parameter ( maxpil = 30000 )
      real*8 listx(maxpil),listy(maxpil)
      integer listi(maxpil),listj(maxpil)
      real*8 soln(maxpil)


      integer   ic , jc , l
      integer   iff , jf
      integer ierr,d4lintxyc
      integer d2pro1n4c_,getlists2

      d2pro1n4cs= 0

      call getwork2dn(nxc,nyc,nxf,nyf,charmc,wkspf)

      d2pro1n4cs=  d2pro1n4c_(nxf,nyf,nxc,nyc,uf,uc,charmc,wkspf)

      call sub_(nxf*nyf,charmf,wkspf,wkspf)

      d2pro1n4cs= getlists2( nxf,nyf,wkspf,xf,yf,pil,
     .                       listx,listy,listi,listj,maxpil )

      if (d2pro1n4cs.eq.1) return
C get the wkspf again 
      call getwork2dn(nxc,nyc,nxf,nyf,charmc,wkspf)

      d2pro1n4cs = d4lintxyc( nxf,nyf,xf,yf,pil,
     .                         listx,listy,uf,soln,
     .                         wkspf) 

      call putsoln2(nxf,nyf,pil,listi,listj,soln,uf)

      return
      end
C-------------------------------------------------------------------------------
      integer function d2pro1nncs( uc,uf,nxc,nyc,nxf,nyf,charmc,charmf,
     .                             xf,yf,order,wkspf,wk2,nwk2,didit)
      implicit none
      integer nxc, nyc
      integer nxf, nyf
      real*8  uc(nxc,nyc),uf(nxf,nyf) 
      real*8  wkspf(nxf,nyf) 
      real*8  charmc(nxc,nyc),charmf(nxf,nyf) 
      real*8  xf(nxf),yf(nyf)
      integer nwk2,didit
      real*8 wk2(nwk2)
      integer order
      integer pil,maxpil
      parameter ( maxpil = 300*300 )
      real*8 listx(maxpil),listy(maxpil)
      integer listi(maxpil),listj(maxpil)
      real*8 soln(maxpil),stwk(maxpil*10)


      integer   ic , jc , l
      integer   iff , jf
      integer ierr,dnlintxyc
      integer d2pro1nnc_,getlists2


      d2pro1nncs= 0

      call getwork2dn(nxc,nyc,nxf,nyf,charmc,wkspf)

      d2pro1nncs= d2pro1nnc_(nxf,nyf,nxc,nyc,uf,uc,order,
     .                       ierr,charmc,wkspf)

      if (d2pro1nncs.eq.1) return

      call sub_(nxf*nyf,charmf,wkspf,wkspf)

      d2pro1nncs= getlists2( nxf,nyf,wkspf,xf,yf,pil,
     .                       listx,listy,listi,listj,maxpil )

      if ((order*order*order+2*order)*pil.gt.maxpil*10) d2pro1nncs=1

      if (d2pro1nncs.eq.1) return
C get the wkspf again 
      call getwork2dn(nxc,nyc,nxf,nyf,charmc,wkspf)

      d2pro1nncs = dnlintxyc( nxf,nyf,xf,yf,pil,
     .                         listx,listy,uf,soln,order,
     .                         wkspf) 

      call putsoln2(nxf,nyf,pil,listi,listj,soln,uf)

      return
      end
C-------------------------------------------------------------------------------
      subroutine getwork2d(nxc,nyc,nxf,nyf,charmc,charmf)
      implicit none
      integer nxc,nyc
      integer nxf,nyf
      real*8 charmc(nxc,nyc) 
      real*8 charmf(nxf,nyf) 

      integer ic,jc,iff,jf,jff

      call inject212(nxc,nyc,charmc,charmf)

      do jc = 1 , nyc
         jf = 2 * jc - 1
         do ic = 1 , nxc-1
            iff = 2*ic - 1
            charmf(iff+1,jf)= nint(0.001d0+0.5d0*(
     .         charmc(ic,jc)+charmc(ic+1,jc)))
         end do
      end do

      do jf = 2 , nyf-1 , 2
         do iff = 1, nxf
            charmf(iff,jf)=charmf(iff,jf-1)*charmf(iff,jf+1)
         end do
      end do

      do jf = 1 , nyf
         do iff = 1 , nxf
            charmf(iff,jf)=charmf(iff,jf)*charmf(iff,jf)
         end do
      end do

      return
      end
C=============================================================================
      subroutine inject212(nxc,nyc,uc,uf)
      implicit none
      integer nxc,nyc
      integer nxf,nyf
      real*8 uc(nxc,nyc)
      real*8 uf(2*nxc-1,2*nyc-1) 

      integer ic,jc

      do jc = 1 , nyc
         do ic = 1 , nxc
            uf(2*ic-1,2*jc-1) = uc(ic,jc)
         end do
      end do

      return
      end
C=============================================================================
      integer function getlists2( nx,ny,wksp,x,y,pil,
     .                     listx,listy,listi,listj,maxp )
      implicit none
      integer nx,ny
      real*8 wksp(nx,ny)
      integer pil,maxp
      real*8 listx(maxp),listy(maxp)
      integer listi(maxp),listj(maxp)
      real*8 x(nx),y(ny)

      integer l,i,j

      pil = 0
      getlists2 = 0

      do j = 1 , ny
         do i= 1 , nx

            if (wksp(i,j).gt.0)  then
               pil = pil + 1
               listx(pil) = x(i)
               listy(pil) = y(j)
               listi(pil) = i
               listj(pil) = j
               if (pil.gt.maxp) then
                  getlists2 = 1
                  return
               end if
            end if
         end do
      end do

      return
      end
C=========================================================================
      subroutine putsoln2(nx,ny,pil,listi,listj,soln,uf)
      implicit none
      integer nx,ny,pil
      integer listi(pil),listj(pil)
      real*8 soln(pil)
      real*8 uf(nx,ny)

      integer l

      do l =1  , pil
         uf(listi(l),listj(l)) = soln(l)
      end do 


      return
      end
C=========================================================================
      subroutine getwork2dn(nxc,nyc,nxf,nyf,charmc,charmf)
      implicit none
      integer nxc,nyc
      integer nxf,nyf
      real*8 charmc(nxc,nyc)
      real*8 charmf(nxf,nyf)

      integer ic,jc,iff,jf,jff

      integer nxfact,nyfact
      integer nxskip,nyskip
      integer iskip
      real*8  f1,f2

      nxfact = (nxf-1)/(nxc-1)
      nyfact = (nyf-1)/(nyc-1)

      nxskip = nxfact - 1
      nyskip = nyfact - 1

      call injectn12(nxc,nyc,nxf,nyf,charmc,charmf)

      do jc = 1 , nyc
         jf = nyfact*jc-nyskip

         do iskip = 1 , nxskip
            do ic = 1 , nxc-1
               iff = nxfact*ic - nxskip
               charmf(iff+iskip,jf)= nint(0.001d0+0.5d0*(
     .               charmc(ic,jc)+charmc(ic+1,jc)))
            end do
         end do
      end do

      do iskip = 1 , nyskip
         do jf = 1+iskip , nyf , nyfact
            do iff = 1, nxf
               charmf(iff,jf)=charmf(iff,jf-iskip)*
     .                        charmf(iff,jf+nyfact-iskip)
            end do
         end do
      end do

      return
      end
C=============================================================================
      subroutine injectn12(nxc,nyc,nxf,nyf,uc,uf)
      implicit none
      integer nxc,nyc
      integer nxf,nyf
      real*8 uc(nxc,nyc)
      real*8 uf(nxf,nyf)

      integer ic,jc,kc
      integer nxfact,nyfact
      integer nxskip,nyskip

      nxfact = (nxf-1)/(nxc-1)
      nyfact = (nyf-1)/(nyc-1)

      nxskip = nxfact - 1
      nyskip = nyfact - 1

      do jc = 1 , nyc
         do ic = 1 , nxc
            uf(nxfact*ic-nxskip,nyfact*jc-nyskip) = uc(ic,jc)
         end do
      end do

      return
      end
C=============================================================================
