C This will be the wrapper for the interpolation routines
C By Scott Klasky
C
C    August 1995
C-----------------------------------------------------------------------------
      integer function interps( dim,order,uc,uf,charc,charf,wkspc,wkspf,
     .                          xf,lx,ly,lz,lout,
     .                          shapeuc,shapeuf,shapecch,shapefch,
     .                          shapecwk,shapefwk,shapefx,shapel,didit,
     .                          shapecx,xc,curv,func)
      implicit none
      integer order,dim,maxdim

      integer shapeuc(3),shapeuf(3)
      integer shapecch(3),shapefch(3)
      integer shapecwk(3),shapefwk(3)
      integer shapefx(3),shapel(1),shapecx(3)

      logical curv
      integer func
      external func
      
      real*8 uc(shapeuc(1),shapeuc(2),shapeuc(3))
      real*8 uf(shapeuf(1),shapeuf(2),shapeuf(3))
      real*8 charc(shapecch(1),shapecch(2),shapecch(3))
      real*8 charf(shapefch(1),shapefch(2),shapefch(3))
      real*8 wkspc(shapecwk(1),shapecwk(2),shapecwk(3))
      real*8 wkspf(shapefwk(1),shapefwk(2),shapefwk(3))

      real*8 xf(shapefx(1)+shapefx(2)+shapefx(3))
      real*8 xc(shapecx(1)+shapecx(2)+shapecx(3))
      real*8 lx(shapel(1))
      real*8 ly(shapel(1))
      real*8 lz(shapel(1))
      real*8 lout(shapel(1))

      integer d3pro122c,d3pro124c,d3pro12nc
      integer d3pro122cs,d3pro124cs,d3pro12ncs
      integer d3pro1n2cs,d3pro1n4cs,d3pro1nncs
      integer d3pro122,d3pro124,d3pro12n
      integer d3pro1n2,d3pro1n4,d3pro1nn
      integer d2lintxyz,d4lintxyz,dnlintxyz
      integer d2lintxyzc,d4lintxyzc,dnlintxyzc
      integer d3pro1n2c,d3pro1n4c,d3pro1nnc

      integer d2pro122c,d2pro124c,d2pro12nc
      integer d2pro122cs,d2pro124cs,d2pro12ncs
      integer d2pro1n2cs,d2pro1n4cs,d2pro1nncs
      integer d2pro122,d2pro124,d2pro12n
      integer d2pro1n2,d2pro1n4,d2pro1nn
      integer d2lintxy,d4lintxy,dnlintxy
      integer d2lintxyc,d4lintxyc,dnlintxyc
      integer d2pro1n2c,d2pro1n4c,d2pro1nnc

      integer d1pro122c,d1pro124c,d1pro12nc
      integer d1pro122,d1pro124,d1pro12n
      integer d1pro1n2,d1pro1n4,d1pro1nn
      integer d2lintx,d4lintx,dnlintx
      integer d2lintxc,d4lintxc,dnlintxc
      integer d1pro1n2c,d1pro1n4c,d1pro1nnc

      integer intcp3d,intcp2d,intcp3dc,intcp2dc
      integer intcpl3d,intcpl3dc,intcpl2d,intcpl2dc

      real*8 nxfact,nyfact,nzfact

      integer didit,nwkc

      interps = 0
      nwkc = shapecwk(1)*shapecwk(2)*shapecwk(3)

      if (.not.curv) then

C now do the checking ..........................................
C first of all,  what dimension ?

      if (dim.eq.3) then                                                  !(

C           is it a coarse grid to fine grid interpolation ?
         if (shapeuf(1).lt.3.or.shapeuf(2).lt.3.or.shapeuf(3).lt.3) then  !(
C it is a list
C           does it have a char. function ????

            if(shapecch(1).lt.3.or.shapecch(2).lt.3.or.
     .         shapecch(3).lt.3) then                                     !(

C we have no char function with a list ...

               if (order.eq.2) then                                       !(
                  interps = d2lintxyz(shapeuc(1),shapeuc(2),shapeuc(3),
     .                      xf(1),xf(1+shapefx(1)),
     .                      xf(1+shapefx(1)+shapefx(2)),
     .                      shapel(1),lx,ly,lz,uc,lout)
               else if (order.eq.4) then
                  interps = d4lintxyz(shapeuc(1),shapeuc(2),shapeuc(3),
     .                      xf(1),xf(1+shapefx(1)),
     .                      xf(1+shapefx(1)+shapefx(2)),
     .                      shapel(1),lx,ly,lz,uc,lout)
               else
                  interps = dnlintxyz(shapeuc(1),shapeuc(2),shapeuc(3),
     .                      xf(1),xf(1+shapefx(1)),
     .                      xf(1+shapefx(1)+shapefx(2)),
     .                      shapel(1),lx,ly,lz,uc,lout,order)
               end if                                                     !)

            else
C its a list with a char function

               if (order.eq.2) then                                       !(
                  interps = d2lintxyzc(shapeuc(1),shapeuc(2),shapeuc(3),
     .                      xf(1),xf(1+shapefx(1)),
     .                      xf(1+shapefx(1)+shapefx(2)),
     .                      shapel(1),lx,ly,lz,uc,lout,charc)
               else if (order.eq.4) then
                  interps = d4lintxyzc(shapeuc(1),shapeuc(2),shapeuc(3),
     .                      xf(1),xf(1+shapefx(1)),
     .                      xf(1+shapefx(1)+shapefx(2)),
     .                      shapel(1),lx,ly,lz,uc,lout,charc)
               else
                  interps = dnlintxyzc(shapeuc(1),shapeuc(2),shapeuc(3),
     .                      xf(1),xf(1+shapefx(1)),
     .                      xf(1+shapefx(1)+shapefx(2)),
     .                      shapel(1),lx,ly,lz,uc,lout,order,charc) 
               end if                                                    !)

            end if                                                       !)

         else
C its not a list

            nxfact = (shapeuf(1)-1)/(shapeuc(1)-1)
            nyfact = (shapeuf(2)-1)/(shapeuc(2)-1)
            nzfact = (shapeuf(3)-1)/(shapeuc(3)-1)

            if (nxfact.eq.2.and.nyfact.eq.2.and.nzfact.eq.2) then        !(
C 1x2 interpolations
               if(shapefch(1).lt.3.or.shapefch(2).lt.3.or.
     .            shapefch(3).lt.3) then                                 !(

C we have no char function with a 2x1 refinement

                  if (order.eq.2) then                                   !(
                     interps = d3pro122( uc,uf,shapeuc(1),
     .                                   shapeuc(2),shapeuc(3) )
                  else if (order.eq.4) then
                     interps = d3pro124( uc,uf,shapeuc(1),
     .                                   shapeuc(2),shapeuc(3) )
                  else
                     interps = d3pro12n( uc,uf,shapeuc(1),
     .                                   shapeuc(2),shapeuc(3),order )

                  end if                                                 !)
               else
C we have a char function with a 1x2 refinement

                  if (order.eq.2) then                                   !(

                     if (nwkc.gt.1) then
                        interps=d3pro122cs( uc,uf,shapeuc(1),shapeuc(2),
     .                         shapeuc(3),charc,charf,
     .                         xf(1),xf(1+shapefx(1)),
     .                         xf(1+shapefx(1)+shapefx(2)),
     .                         wkspf,wkspc,nwkc,didit )

                     else
                        interps= d3pro122c( uc,uf,shapeuc(1),shapeuc(2),
     .                         shapeuc(3),charc,charf) 

                     end if
                  else if (order.eq.4) then
                     if (nwkc.gt.1) then
                        interps=d3pro124cs( uc,uf,shapeuc(1),shapeuc(2),
     .                         shapeuc(3),charc,charf,
     .                         xf(1),xf(1+shapefx(1)),
     .                         xf(1+shapefx(1)+shapefx(2)),
     .                         wkspf,wkspc,nwkc,didit )

                     else
                        interps= d3pro124c( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuc(3),charc,charf)
                     end if

                  else
                     if (nwkc.gt.1) then
                        interps=d3pro12ncs(uc,uf,shapeuc(1),shapeuc(2),
     .                         shapeuc(3),charc,charf,
     .                         xf(1),xf(1+shapefx(1)),
     .                         xf(1+shapefx(1)+shapefx(2)),order,
     .                         wkspf,wkspc,nwkc,didit )


                     else
                        interps=d3pro12nc( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuc(3),charc,charf,
     .                            order )
                     end if
                  end if                                                 !)
               end if
 

         else

C 1xn interpolations
               if(shapefch(1).lt.3.or.shapefch(2).lt.3.or.
     .            shapefch(3).lt.3) then                                !(

C we have no char function with a 1xn refinement

                  if (order.eq.2) then                                  !(
                     interps = d3pro1n2( shapeuf(1),shapeuf(2),
     .                                   shapeuf(3),shapeuc(1),
     .                                   shapeuc(2),shapeuc(3),
     .                                   uf,uc )
                  else if (order.eq.4) then
                     interps = d3pro1n4( shapeuf(1),shapeuf(2),
     .                                   shapeuf(3),shapeuc(1),
     .                                   shapeuc(2),shapeuc(3),
     .                                   uf,uc )
                  else
                     interps = d3pro1nn( shapeuf(1),shapeuf(2),
     .                                   shapeuf(3),shapeuc(1),
     .                                   shapeuc(2),shapeuc(3),
     .                                   uf,uc,order )

                  end if                                                !)
               else
C we have a char function with a 2x1 refinement

                  if (order.eq.2) then                                  !(
                     if (nwkc.gt.1) then
                        interps=d3pro1n2cs( uc,uf,shapeuc(1),shapeuc(2),
     .                         shapeuc(3),shapeuf(1),shapeuf(2),
     .                         shapeuf(3),charc,charf,
     .                         xf(1),xf(1+shapefx(1)),
     .                         xf(1+shapefx(1)+shapefx(2)),
     .                         wkspf,wkspc,nwkc,didit )

                     else
                        interps=d3pro1n2c( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuc(3),shapeuf(1),shapeuf(2),
     .                            shapeuf(3),charc,charf) 
                  end if

                  else if (order.eq.4) then
                     if (nwkc.gt.1) then

                        interps=d3pro1n4cs( uc,uf,shapeuc(1),shapeuc(2),
     .                         shapeuc(3),shapeuf(1),shapeuf(2),
     .                         shapeuf(3),charc,charf,
     .                         xf(1),xf(1+shapefx(1)),
     .                         xf(1+shapefx(1)+shapefx(2)),
     .                         wkspf,wkspc,nwkc,didit )

                     else

                        interps= d3pro1n4c( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuc(3),shapeuf(1),shapeuf(2),
     .                            shapeuf(3),charc,charf) 
                     end if

                  else
                     if (nwkc.gt.1) then
                        interps=d3pro1nncs( uc,uf,shapeuc(1),shapeuc(2),
     .                         shapeuc(3),shapeuf(1),shapeuf(2),
     .                         shapeuf(3),charc,charf,
     .                         xf(1),xf(1+shapefx(1)),
     .                         xf(1+shapefx(1)+shapefx(2)),order,
     .                         wkspf,wkspc,nwkc,didit )

                     else
                        interps=d3pro1nnc( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuc(3),shapeuf(1),shapeuf(2),
     .                            shapeuf(3),charc,charf,order) 
                     end if

                  end if                                                !)

               end if                                                   !)

         end if                                                         !)

      end if                                                            !)


      else if (dim.eq.2) then

C           is it a coarse grid to fine grid interpolation ?
         if (shapeuf(1).lt.3.or.shapeuf(2).lt.3) then                   !(
C it is a list
C           does it have a char. function ????

            if(shapecch(1).lt.3.or.shapecch(2).lt.3) then               !(

C we have no char function with a list ...

               if (order.eq.2) then                                       !(
                  interps = d2lintxy(shapeuc(1),shapeuc(2),
     .                      xf(1),xf(1+shapefx(1)),
     .                      shapel(1),lx,ly,uc,lout)
               else if (order.eq.4) then
                  interps = d4lintxy(shapeuc(1),shapeuc(2),
     .                      xf(1),xf(1+shapefx(1)),
     .                      shapel(1),lx,ly,uc,lout)
               else
                  interps = dnlintxy(shapeuc(1),shapeuc(2),
     .                      xf(1),xf(1+shapefx(1)),
     .                      shapel(1),lx,ly,uc,lout,order)
               end if                                                     !)

            else
C its a list with a char function

               if (order.eq.2) then                                       !(
                  interps = d2lintxyc(shapeuc(1),shapeuc(2),
     .                      xf(1),xf(1+shapefx(1)),
     .                      shapel(1),lx,ly,uc,lout,charc)
               else if (order.eq.4) then
                  interps = d4lintxyc(shapeuc(1),shapeuc(2),
     .                      xf(1),xf(1+shapefx(1)),
     .                      shapel(1),lx,ly,uc,lout,charc)
               else
                  interps = dnlintxyc(shapeuc(1),shapeuc(2),
     .                      xf(1),xf(1+shapefx(1)),
     .                      shapel(1),lx,ly,uc,lout,order,charc)
               end if                                                    !)

            end if                                                       !)

         else
C its not a list

            nxfact = (shapeuf(1)-1)/(shapeuc(1)-1)
            nyfact = (shapeuf(2)-1)/(shapeuc(2)-1)

            if (nxfact.eq.2.and.nyfact.eq.2) then                        !(
C 1x2 interpolations
               if(shapefch(1).lt.3.or.shapefch(2).lt.3) then             !(

C we have no char function with a 2x1 refinement

                  if (order.eq.2) then                                   !(
                     interps = d2pro122( uc,uf,shapeuc(1),
     .                                   shapeuc(2) ) 
                  else if (order.eq.4) then
                     interps = d2pro124( uc,uf,shapeuc(1),
     .                                   shapeuc(2) ) 
                  else
                     interps = d2pro12n( uc,uf,shapeuc(1),
     .                                   shapeuc(2),order )

                  end if                                                 !)
               else
C we have a char function with a 1x2 refinement

                  if (order.eq.2) then                                   !(
                     if (nwkc.gt.1) then
                        interps=d2pro122cs( uc,uf,shapeuc(1),shapeuc(2),
     .                            charc,charf,
     .                            xf(1),xf(1+shapefx(1)),
     .                            wkspf,wkspc,nwkc,didit )

                     else

                        interps=d2pro122c( uc,uf,shapeuc(1),shapeuc(2),
     .                            charc,charf) 
                     end if
                  else if (order.eq.4) then
                     if (nwkc.gt.1) then
                        interps=d2pro124cs( uc,uf,shapeuc(1),shapeuc(2),
     .                            charc,charf,
     .                            xf(1),xf(1+shapefx(1)),
     .                            wkspf,wkspc,nwkc,didit )

                     else

                        interps=d2pro124c( uc,uf,shapeuc(1),shapeuc(2),
     .                            charc,charf)
                     end if

                  else

                     if (nwkc.gt.1) then
                        interps=d2pro12ncs( uc,uf,shapeuc(1),shapeuc(2),
     .                            charc,charf,
     .                            xf(1),xf(1+shapefx(1)),order,
     .                            wkspf,wkspc,nwkc,didit )

                     else

                        interps=d2pro12nc( uc,uf,shapeuc(1),shapeuc(2),
     .                         charc,charf,order)
                     end if

                  end if                                                 !)
 
            end if                                                       !)

         else

C 1xn interpolations
               if(shapefch(1).lt.3.or.shapefch(2).lt.3) then            !(

C we have no char function with a 1xn refinement

                  if (order.eq.2) then                                  !(

                        interps = d2pro1n2( shapeuf(1),shapeuf(2),
     .                                      shapeuc(1),shapeuc(2),
     .                                      uf,uc )
                  else if (order.eq.4) then
                     interps = d2pro1n4( shapeuf(1),shapeuf(2),
     .                                   shapeuc(1),shapeuc(2),
     .                                   uf,uc )
                  else
                     interps = d2pro1nn( shapeuf(1),shapeuf(2),
     .                                   shapeuc(1),shapeuc(2),
     .                                   uf,uc,order )
                  end if                                                !)
               else
C we have a char function with a 2x1 refinement

                  if (order.eq.2) then                                  !(
                     if (nwkc.gt.1) then
                        interps=d2pro1n2cs( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuf(1),shapeuf(2),
     .                            charc,charf,
     .                            xf(1),xf(1+shapefx(1)),
     .                            wkspf,wkspc,nwkc,didit )
                     else

                        interps=d2pro1n2c( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuf(1),shapeuf(2),
     .                            charc,charf)
                     end if

                  else if (order.eq.4) then
                     if (nwkc.gt.1) then
                        interps=d2pro1n4cs( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuf(1),shapeuf(2),
     .                            charc,charf,
     .                            xf(1),xf(1+shapefx(1)),
     .                            wkspf,wkspc,nwkc,didit )
                     else

                        interps=d2pro1n4c( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuf(1),shapeuf(2),
     .                            charc,charf)
                     end if

                  else
                     if (nwkc.gt.1) then
                        interps=d2pro1nncs( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuf(1),shapeuf(2),
     .                            charc,charf,
     .                            xf(1),xf(1+shapefx(1)),order,
     .                            wkspf,wkspc,nwkc,didit )
                     else
                        interps=d2pro1nnc( uc,uf,shapeuc(1),shapeuc(2),
     .                            shapeuf(1),shapeuf(2),
     .                            charc,charf,order)

                     end if

                  end if                                                !)

               end if                                                   !)
            end if                                                      !)
         end if                                                         !)

      else if (dim.eq.1) then

C           is it a coarse grid to fine grid interpolation ?
         if (shapeuf(1).lt.3) then                                      !(
C it is a list
C           does it have a char. function ????

            if(shapecch(1).lt.3) then                                   !(

C we have no char function with a list ...

               if (order.eq.2) then                                     !(
                  interps = d2lintx(shapeuc(1),
     .                      xf(1),
     .                      shapel(1),lx,uf,lout)
               else if (order.eq.4) then
                  interps = d4lintx(shapeuc(1),
     .                      xf(1),
     .                      shapel(1),lx,uf,lout)
               else
                  interps = dnlintx(shapeuc(1),
     .                      xf(1),
     .                      shapel(1),lx,uf,lout,order)
               end if                                                   !)

            else
C its a list with a char function

               if (order.eq.2) then                                       !(
                  interps = d2lintxc(shapeuc(1),
     .                      xf(1),
     .                      shapel(1),lx,uf,lout,charc)
               else if (order.eq.4) then
                  interps = d4lintxc(shapeuc(1),
     .                      xf(1),
     .                      shapel(1),lx,uf,lout,charc)
               else
                  interps = dnlintxc(shapeuc(1),
     .                      xf(1),
     .                      shapel(1),lx,uf,lout,order,charc)
               end if                                                    !)

            end if                                                       !)

         else
C its not a list

            nxfact = (shapeuf(1)-1)/(shapeuc(1)-1)

            if (nxfact.eq.2) then                        !(
C 1x2 interpolations
               if(shapefch(1).lt.3) then             !(

C we have no char function with a 2x1 refinement

                  if (order.eq.2) then                                   !(
                     interps = d1pro122( uc,uf,shapeuc(1)) 
                  else if (order.eq.4) then
                     interps = d1pro124( uc,uf,shapeuc(1)) 
                  else
                     interps = d1pro12n( uc,uf,shapeuc(1),
     .                                   order )

                  end if                                                 !)
               else
C we have a char function with a 1x2 refinement

                  if (order.eq.2) then                                   !(
                     interps = d1pro122c( uc,uf,shapeuc(1),
     .                         charc,charf,
     .                         xf(1)) 
                  else if (order.eq.4) then
                     interps = d1pro124c( uc,uf,shapeuc(1),
     .                         charc,charf,
     .                         xf(1))

                  else
                     interps = d1pro12nc( uc,uf,shapeuc(1),
     .                         charc,charf,
     .                         xf(1),order )

                  end if                                                 !)
 
            end if                                                       !)

         else

C 1xn interpolations
               if(shapefch(1).lt.3) then            !(

C we have no char function with a 1xn refinement

                  if (order.eq.2) then                                  !(
                     interps = d1pro1n2( shapeuf(1),
     .                                   shapeuc(1),
     .                                   uf,uc )
                  else if (order.eq.4) then
                     interps = d1pro1n4( shapeuf(1),
     .                                   shapeuc(1),
     .                                   uf,uc )
                  else
                     interps = d1pro1nn( shapeuf(1),
     .                                   shapeuc(1),
     .                                   uf,uc,order )
                  end if                                                !)
               else
C we have a char function with a 2x1 refinement

                  if (order.eq.2) then                                  !(
                     interps = d1pro1n2c( uc,uf,shapeuc(1),
     .                         shapeuf(1),
     .                         charc,charf,
     .                         xf(1))
                  else if (order.eq.4) then
                     interps = d1pro1n4c( uc,uf,shapeuc(1),
     .                         shapeuf(1),
     .                         charc,charf,
     .                         xf(1))

                  else
                     interps = d1pro1nnc( uc,uf,shapeuc(1),
     .                         shapeuf(1),
     .                         charc,charf,
     .                         xf(1),order)

                  end if                                                !)
               end if                                                   !)
            end if                                                      !)
         end if                                                         !)

      else

         interps = 1
         write(6,*) '*** dim <> 1,2,3 ***'

      end if                                                           !)


      else

C dim = 2 , 3 either line or grid either char or no char ......

         if (dim.eq.3) then !(

            if (shapeuc(1).ge.3.or.shapeuc(2).ge.3.or.
     .          shapeuc(3).ge.3) then !(

               if (shapecch(1).lt.3.or.shapecch(2).lt.3
     .             .or.shapecch(3).lt.3) then  !(

                  interps = intcp3d( uc,uf,
     .                      xf(1),xf(1+shapefx(1)),
     .                      xf(1+shapefx(1)+shapefx(2)),
     .                      xc(1),xc(1+shapecx(1)),
     .                      xc(1+shapecx(1)+shapecx(2)),
     .                      shapeuc(1),shapeuc(2),shapeuc(3),
     .                      shapeuf(1),shapeuf(2),shapeuf(3),
     .                      order, func )

               else

                  interps = intcp3dc( uc,uf,
     .                      xf(1),xf(1+shapefx(1)),
     .                      xf(1+shapefx(1)+shapefx(2)),
     .                      xc(1),xc(1+shapecx(1)),
     .                      xc(1+shapecx(1)+shapecx(2)),
     .                      shapeuc(1),shapeuc(2),shapeuc(3),
     .                      shapeuf(1),shapeuf(2),shapeuf(3),
     .                      order,func,charc )

               end if !)
            else
               if (shapecch(1).lt.3.or.shapecch(2).lt.3
     .             .or.shapecch(3).lt.3) then   !(

                  interps = intcpl3d(uc,
     .                      xc(1),xc(1+shapecx(1)),
     .                      xc(1+shapecx(1)+shapecx(2)),
     .                      shapeuc(1),shapeuc(2),shapeuc(3),
     .                      shapel,lx,ly,lz,lout,order,func)
               
               else

                  interps = 1
                  write(0,*) '*** feature is not implemented***'

               end if !)
            end if !)

         else if (dim.eq.2) then !(

            if (shapeuc(1).ge.3.or.shapeuc(2).ge.3) then  !(
               if (shapecch(1).lt.3.or.shapecch(2).lt.3) then !(
                  interps = intcp2d( uc,uf,
     .                      xf(1),xf(1+shapefx(1)),
     .                      xc(1),xc(1+shapecx(1)),
     .                      shapeuc(1),shapeuc(2),
     .                      shapeuf(1),shapeuf(2),
     .                      order,func )

               else

                  interps = intcp2dc( uc,uf,
     .                      xf(1),xf(1+shapefx(1)),
     .                      xc(1),xc(1+shapecx(1)),
     .                      shapeuc(1),shapeuc(2),
     .                      shapeuf(1),shapeuf(2),
     .                      order,func,charc )
               end if !)

            else !)
               if (shapecch(1).lt.3.or.shapecch(2).lt.3) then  !)

                  interps = intcpl2d(uc,xc(1),xc(1+shapecx(1)),
     .                               shapeuc(1),shapeuc(2),
     .                               shapel,lx,ly,lout,order,func)

               else !)

                  interps = 1
                  write(0,*) '*** feature is not implemented***'

               end if !)
            end if !)

         else

            interps = 1
            write(6,*) '*** dim <> 1,2,3 ***'
         end if !)

      end if !)


      return
      end
