! routines included here are:
! d2lintxyzc
! d4lintxyzc




! getijknew
! movepoint
! reset_offsets4
! getijknc4

      integer function d2lintxyzc(nx,ny,nz,x,y,z,pil,listx,listy,listz,
     .                           u,soln,charm)
cFPP$ EXPAND(getijknew,reset_offsets4,movepoint)
      implicit none
      integer nx,ny,nz
      real*8 x(nx),y(ny),z(nz)
      integer pil
      real*8 listx(pil),listy(pil),listz(pil)
      real*8 u(nx,ny,nz),charm(nx,ny,nz)
      real*8 soln(pil)
      integer moveit

      integer order,didit

c local variables
      real*8 dx,dy,dz
      integer l,lj,lk,li,ll
      integer i,j,k,iout
      real*8 dx0,dy0,dz0,dxout
      integer ierr
      real*8 mat2d(2,2)
      real*8 vx(4),vx2(2)
      real*8 den,work(2),sten(2)
      integer reset_offsets4
      integer movepoint,getijknew
      parameter ( order = 2)
      integer iw

      real*8 dxi,dyi,dzi

      d2lintxyzc= 0

      dx = abs( x(2)-x(1) )
      dy = abs( y(2)-y(1) )
      dz = abs( z(2)-z(1) )

      dxi = 1.0d0/dx
      dyi = 1.0d0/dy
      dzi = 1.0d0/dz

c this will make a bounding box around each point and then interpolate
c in a series of 1d interpolations


      iw = nint(0.5*order)

      do l = 1 , pil

            moveit = 1
            d2lintxyzc =
     .      getijknew(nx,ny,nz,listx(l),listy(l),listz(l),x,y,z,
     .                     i,j,k,dx0,dy0,dz0,charm,order)

            if (d2lintxyzc.eq.1) return

            if (charm(i+iw,j+iw,k+iw).eq.1) then
               ierr = movepoint(nx,ny,nz,x,y,z,listx(l),listy(l),
     .                   listz(l),i,j,k,dx0,dy0,dz0,charm,order)

               if (ierr.eq.1) goto 1000
               moveit = 0
            end if

         iout = i
         dxout = dx0

c
         if (moveit.eq.1) then
            ll = 0
            do lk = 1 , order
               do lj = 1 , order
                  ierr = reset_offsets4(nx,ny,nz,x,y,z,
     .             listx(l),charm,dxout,iout,j+lj-1,k+lk-1,i,dx0,order)
                   if (ierr.eq.1) goto 1000
                   ll = ll + 1
                   vx(ll) = (dx-dx0)*dxi*u(i,j+lj-1,k+lk-1) +
     .                      dx0*dxi*u(i+1,j+lj-1,k+lk-1)
               end do
            end do
         else

            ll = 0
            do lk = 1 , order
               do lj = 1 , order
                   ll = ll + 1
                   vx(ll) = (dx-dx0)*dxi*u(i,j+lj-1,k+lk-1) +
     .                      dx0*dxi*u(i+1,j+lj-1,k+lk-1)
               end do
            end do
         end if

         vx2(1) = (dy-dy0)*dyi*vx(1) + dy0*dyi*vx(2)
         vx2(2) = (dy-dy0)*dyi*vx(3) + dy0*dyi*vx(4)
         soln(l) = (dz-dz0)*dzi*vx2(1) + dz0*dzi*vx2(2)

      end do

      didit = didit + 1
      return

1000   continue

      didit = didit + 1
      d2lintxyzc   = 1
      return
      end
c======================================================================
      integer function d4lintxyzc(nx,ny,nz,x,y,z,pil,listx,listy,listz,
     .                           u,soln,charm)
cFPP$ EXPAND(getijknew,reset_offsets4,movepoint)
      implicit none
      integer nx,ny,nz
      real*8 x(nx),y(ny),z(nz)
      integer pil
      real*8 listx(pil),listy(pil),listz(pil)
      real*8 u(nx,ny,nz),charm(nx,ny,nz)
      real*8 soln(pil)
      integer moveit
      integer didit

      integer order

c local variables
      real*8 dx,dy,dz
      integer l,lj,lk,li,ll
      integer i,j,k
      real*8 dx0,dy0,dz0
      integer ierr, getijknc4
      real*8 vx(4,4),vx2(4),den
      integer reset_offsets4,getijknew
      integer movepoint
      parameter ( order = 4)

c      real*8 sum
      real*8 dxi,dyi,dzi
      real*8 dx02,dy02,dz02
      real*8 dx03,dy03,dz03
      real*8 dx20,dxx02
      real*8 dy20,dyy02
      real*8 dz20,dzz02
      real*8 dx2,dy2,dz2
      real*8 dx3,dy3,dz3
      integer iout,iw
      real*8 dxout

      d4lintxyzc= 0

      dx = abs( x(2)-x(1) )
      dy = abs( y(2)-y(1) )
      dz = abs( z(2)-z(1) )

      dxi = 1.0d0/dx
      dyi = 1.0d0/dy
      dzi = 1.0d0/dz

      dx2 = dx*dx
      dy2 = dy*dy
      dz2 = dz*dz

      dx3 = dx**3
      dy3 = dy**3
      dz3 = dz**3

      den = 1.0d0/(6.0d0*dx3)
      iw = nint(0.5*order)

c this will make a bounding box around each point and then interpolate
c in a series of 1d interpolations
      iw = nint(0.5*order)

      do l = 1 , pil

            moveit = 1
            d4lintxyzc =
     .      getijknew(nx,ny,nz,listx(l),listy(l),listz(l),
     .                x,y,z,i,j,k,dx0,dy0,dz0,charm,order)


            if (d4lintxyzc.eq.1) return

            if (charm(i+iw,j+iw,k+iw).eq.1) then
               ierr = movepoint(nx,ny,nz,x,y,z,listx(l),listy(l),
     .                     listz(l),i,j,k,dx0,dy0,dz0,charm,order)

               if (ierr.eq.1) goto 1000
               moveit = 0
            end if

         iout = i
         dxout = dx0

         dy02 = dy0**2
         dy03 = dy0**3
         dz02 = dz0**2
         dz03 = dz0**3
         dy20 = dy2*dy0
         dyy02= dy*dy02
         dz20 = dz2*dz0
         dzz02= dz*dz02
         den = 1.0d0/(6.0d0*dx3)

c

         if (moveit.eq.1) then
            do lk = 1 , order
               do lj = 1 , order
  
                  ierr = reset_offsets4(nx,ny,nz,x,y,z,listx(l),
     .                   charm,dxout,iout,j+lj-1,k+lk-1,i,dx0,order)
                  if (ierr.eq.1) goto 1000
  
                  dx02 = dx0**2
                  dx03 = dx0**3
                  dx20 = dx2*dx0
                  dxx02= dx*dx02
  
                  vx(lj,lk) =  den*(
     .            u(i+3,j+lj-1,k+lk-1)*(dx03+2.0d0*dx20-
     .                                  3.0d0*dxx02)+
     .            u(i+2,j+lj-1,k+lk-1)*(-3.0d0*dx03-9.0d0*dx20
     .                                  +12.0d0*dxx02) +
     .            u(i+1,j+lj-1,k+lk-1)*(3.0d0*dx03+18.0d0*dx20-
     .                                  15.0d0*dxx02)+
     .            u(i  ,j+lj-1,k+lk-1)*(-dx03+6.0d0*dx3-11.0d0*dx20+
     .                                  6.0d0*dxx02) )

               end do
            end do
         else

         do lk = 1 , order
            do lj = 1 , order
                  dx02 = dx0**2
                  dx03 = dx0**3
                  dx20 = dx2*dx0
                  dxx02= dx*dx02

                  vx(lj,lk) =  den*(
     .               u(i+3,j+lj-1,k+lk-1)*(dx03+2.0d0*dx20-
     .                                     3.0d0*dxx02)+
     .               u(i+2,j+lj-1,k+lk-1)*(-3.0d0*dx03-9.0d0*dx20
     .                                     +12.0d0*dxx02) +
     .               u(i+1,j+lj-1,k+lk-1)*(3.0d0*dx03+18.0d0*dx20-
     .                                     15.0d0*dxx02)+
     .               u(i  ,j+lj-1,k+lk-1)*(-dx03+6.0d0*dx3-11.0d0*dx20+
     .                                     6.0d0*dxx02) )

               end do
            end do

         end if

         den = 1.0d0/(6.0d0*dy3)

         do lk = 1 , 4

            vx2(lk) = den*(
     .            vx(4,lk)*(dy03+2.0d0*dy20-3.0d0*dyy02)+
     .            vx(3,lk)*(-3.0d0*dy03-9.0d0*dy20+12.0d0*dyy02)+
     .            vx(2,lk)*(3.0d0*dy03+18.0d0*dy20-15.0d0*dyy02)+
     .            vx(1,lk)*(-dy03+6.0d0*dy3-11.0d0*dy20 +
     .                      6.0d0*dyy02) )
         end do

         den = 1.0d0/(6.0d0*dz3)

         soln(l) = den*(
     .            vx2(4)*(dz03+2.0d0*dz20-3.0d0*dzz02) +
     .            vx2(3)*(-3.0d0*dz03-9.0d0*dz20+12.0d0*dzz02) +
     .            vx2(2)*(3.0d0*dz03+18.0d0*dz20-15.0d0*dzz02) +
     .            vx2(1)*(-dz03+6.0d0*dz3-11.0d0*dz20 +
     .                    6.0d0*dzz02) )

      end do
      didit = didit + 1

      return

1000   continue

      d4lintxyzc   = 1
      return
      end


c-----------------------------------------------------------------------
      integer function getijknew(nx,ny,nz,listx,listy,listz,x,y,z,
     .                     i,j,k,dx0,dy0,dz0,charm,order)
cFPP$ EXPAND(getijknc4)
      implicit none
      integer nx,ny,nz
      real*8 listx,listy,listz
      real*8 x(nx),y(ny),z(nz)
      integer i,j,k
      real*8 dx0,dy0,dz0
      real*8 charm(nx,ny,nz)
      integer order

      integer li,lj,lk
      integer length
      integer ierr,getijknc4
      real*8 dist,mindist
      real*8 is,js,ks
      integer offset

      getijknew =  getijknc4(nx,x,listx,i,dx0,order)
      if (getijknew.eq.1) return
      getijknew =  getijknc4(ny,y,listy,j,dy0,order)
      if (getijknew.eq.1) return
      getijknew =  getijknc4(nz,z,listz,k,dz0,order)
      if (getijknew.eq.1) return


c make sure its the closest point

      length = nint(0.5*order)
      i = i + length
      j = j + length
      k = k + length

      getijknew = 0

      mindist = 9.90d09
      offset = 0
100   continue
      do li = i-offset , offset+i
         do lj = j-offset , offset+j
            do lk = k-offset , offset+k
               dist = (x(li)-listx)**2+(y(lj)-listy)**2+(z(lk)-listz)**2
               if (dist.le.charm(li,lj,lk)*mindist) then
                  mindist = dist
                  is = li
                  js = lj
                  ks = lk
               end if
            end do
         end do
      end do


      if (mindist.lt.(100.0d0)) then
         i = is - length
         j = js - length
         k = ks - length
         if (i.lt.1.or.j.lt.1.or.k.lt.1.or.i.gt.nx.or.
     .       j.gt.ny.or.k.gt.nz) then
            getijknew = 1
            return
         end if
  
         dx0  = listx - x(i)
         dy0  = listy - y(j)
         dz0  = listz - z(k)
      else if (offset.lt.nx) then
         offset = offset + 1
         goto 100
      else
      getijknew = 1
      end if

      return
      end
      integer function movepoint(nx,ny,nz,x,y,z,listx,listy,
     .                     listz,i,j,k,dx0,dy0,dz0,charm,order)
      implicit none
      integer nx,ny,nz
      real*8 x(nx),y(ny),z(nz)
      real*8 charm(nx,ny,nz)
      real*8 listx,listy,listz
      integer i,j,k
      real*8 dx0,dy0,dz0
      real*8 count
      integer order
      integer li,lj,lk,l
      integer is,js,ks
      integer dirp1,dirp2,dirp3
      integer dirm1,dirm2,dirm3
      integer dir1,dir2,dir3
      integer sdir1,sdir2,sdir3
      integer ip
      real*8 dist,xip

      movepoint =  0

      count = 0.0d0

      if (i+order-1.gt.nx.or.j+order-1.gt.ny.
     .    or.k+order-1.gt.nz) then
         movepoint = 1
         return
      end if

      do li = i , i+order -1
         do lj = j , j+order-1
            do lk = k , k+order-1
               count = count + charm(li,lj,lk)
            end do
         end do
      end do

      if (int(count).eq.order**3) return

c put the point to the center of the stencil
      i = i + nint(order*0.5)
      j = j + nint(order*0.5)
      k = k + nint(order*0.5)

      dir1 = -1
      dir2 = -1
      dir3 = -1


      do l = 1 , order*4+1
         do lk = 0 , l
            do lj = 0 , l
               do li = 0 , l
                  count = 0.0d0
                  xip = 0.0d0
                  if (k+lk*dir3+order-1.gt.nz.or.
     .                j+lj*dir2+order-1.gt.ny.or.
     .                i+li*dir1+order-1.gt.nx) then
                     movepoint = 1
                     return
                  end if
                  do ks = max(1,k+lk*dir3),min(nz,k+lk*dir3+order-1)
                     do js = max(1,j+lj*dir2),min(ny,j+lj*dir2+order-1)
                        do is = max(1,i+li*dir1),
     .                          min(nx,i+li*dir1+order-1)
                           count = count + charm(is,js,ks)
                           xip = xip + 1.0d0
                        end do
                     end do
                  end do
                  if (int(count).eq.xip) goto 1000
                 end do
            end do
         end do
      end do



      movepoint = 1
      i = i - nint(order*0.5)
      j = j - nint(order*0.5)
      k = k - nint(order*0.5)

      return

1000   continue
      i = i +  li*dir1
      j = j + lj*dir2
      k = k + lk*dir3
      dx0 = listx - x(i)
      dy0 = listy - y(j)
      dz0 = listz - z(k)

      return
      end
c======================================================================
      integer function reset_offsets4(nx,ny,nz,x,y,z,listx,
     .                               charm,dx,i,j,k,iout,dxout,order)
      implicit none
      integer nx,ny,nz
      real*8 x(nx),y(ny),z(nz)
      real*8 listx
      real*8 charm(nx,ny,nz)
      real*8 dx
      integer i,j,k
      integer order
      integer im,ip,ims,ips
      integer istart,istop
      integer iout
      real*8    dxout


c local variables .......

      integer li,lj,lk
      logical xhit
      integer mini
      real*8  minx

      reset_offsets4= 0

      iout = i
      dxout = dx


c now scan to see if we hit into charm=1
      xhit = .false.

      do li = 1 , order
         if(int(charm(i+li-1,j,k)).ne.1) xhit = .true.
      end do


      if (.not.xhit) return
c move the i value back to the center of the stencil ........

      minx = abs(x(1)-listx)
      do li = max(1,i-order),min(nx,i+order)
         if (abs(x(li)-listx).lt.minx) then
            iout = li
            minx = abs(x(li)-listx)
         end if
      end do

c so the questions are : which way do I move the start point
c we try both directions

      ip = 0
      im = 0
      ims = 0
      ips = 0

      istart= 1
      istop = nx

c first move it in the negative direction
      do li = iout,istart, -1
         if (int(charm(li,j,k)).eq.1) then
            ims = li
            goto 100
         end if
         im = im + 1
      end do
100   continue

      do li = iout,istop
         if (int(charm(li,j,k)).eq.1) then
            ips = li
            goto 200
         end if
         ip = ip + 1
      end do
200   continue

      if (ips.eq.0.and.ims.eq.0)  then
         reset_offsets4= 1
         return
      end if

      if (im.lt.ip) then
         iout = ims - nint(0.5*order) + 1
         if (iout.lt.1) then
            iout = 1
            reset_offsets4= 1
         end if
      else
         iout = ips
         if (iout+order.gt.nx) then
            reset_offsets4= 1
         end if
      end if

c one more check ....
5000  continue
      ip = 0
      do li = iout,iout+order-1
         ip = ip + int(charm(li,j,k))
      end do
      if (ip.lt.order) then
         iout = max(1,iout-(order-ip))
         goto 5000
      end if


      dxout = listx - x(iout)

      return
      end

c------------------------------------------------------------------------------
      integer function getijknc4(n,v,lv,l,del,order)
      implicit none
      integer n,l
      real*8 v(n)
      real*8 del,lv
      integer order,length

      integer i,ip1,im1

      getijknc4= 0

      do i = 1 , n
         if (v(i).ge.lv) goto 100
      end do

      getijknc4= 1
      return

100   continue
      length = nint(0.5*order)

      ip1 = i + 1
      im1 = i - 1

C      if (ip1.gt.n.or.im1.lt.1) then
C         getijknc4 = 1
C         return
C      end if

      if (i.gt.1.and.abs(v(i-1)-lv).lt.abs(v(i)-lv)) then
            i = i - 1
      else if (i.lt.n.and.abs(v(i+1)-lv).lt.abs(v(i)-lv)) then
            i = i + 1
      end if

c now push this off 2 points ...

      l = i - length

      if (l.lt.1) l = 1
      if (l+length+1.gt.n) l = n - length - 1

      if (l.lt.1.or.l.gt.n) then
         getijknc4 = 1
         return
      end if
      del = lv - v(l)

      if (del.lt.(0.0d0)) getijknc4= 1

      return
      end

