		program test
		implicit none
		integer nx,ny,nz
		parameter ( nx = 33, ny = 65 , nz = 49 )
		integer pil,ntheta,nphi
		parameter ( ntheta = 33, nphi = 33 , pil = ntheta * nphi )

		real*8 u(nx,ny,nz),charm(nx,ny,nz)
		real*8 x(nx),y(ny),z(nz)
		real*8 r,hx,hy,hz,a,ans,err
		real*8 soln(pil),listx(pil),listy(pil),listz(pil)
		real*8 srad
		real*8 pi,theta,phi

		integer ord
		integer ierr,d2lintxyzc,d4lintxyzc

		integer i,j,k,l


		pi = 4.0d0 * atan(1.0d0)

		write(6,*) 'input order,radius of interpolation, radius of mask'
		read(5,*) ord,srad,a

		hx = 2.0d0/(nx - 1)
		hy = 2.0d0/(ny - 1)
		hz = 2.0d0/(nz - 1)

		do i = 1 ,nx
			x(i) = -1.0d0 + hx * (i - 1) 
		end do
		do j = 1 ,ny
			y(j) = -1.0d0 + hy* (j - 1) 
		end do
		do k = 1 ,nz
			z(k) = -1.0d0 + hz* (k - 1)
		end do

		do i = 1 , nx
			do j = 1 ,ny
				do k = 1 , nz

					u(i,j,k) = (x(i)+y(j)+z(k))**(ord-1)

				end do
			end do
		end do

		do i = 1 , nx
			do j = 1 ,ny
				do k = 1 , nz
					r = sqrt(x(i)**2+y(j)**2+z(k)**2)

					if (r.lt.a) then
						charm(i,j,k) = 0.0d0
					else
						charm(i,j,k) = 1.0d0
					end if
				end do
			end do
		end do


		k = 0
      do i = 1, NTHETA
         theta = (i-1)*(Pi / (NTHETA))
         do j = 1, NPHI
            phi = (j-1)*(Pi / (NPHI))
            k = k + 1
            listx(k) = srad*cos(phi)*cos(theta)
            listy(k) = srad*sin(phi)*cos(theta)
            listz(k) = srad*sin(theta)
         end do
      end do


! call the interpolator

		
		if (ord.eq.2) then
		   ierr = d2lintxyzc(nx,ny,nz,x,y,z,pil,listx,listy,listz,
     .                     u,soln,charm)


		else if (ord.eq.4) then

         ierr = d4lintxyzc(nx,ny,nz,x,y,z,pil,listx,listy,listz,
     .                     u,soln,charm)


		else
			write(6,*) 'cant interpolate to that order'

		end if


		err = 0.0d0
      do l = 1, pil 
			ans = (listx(l)+listy(l)+listz(l))**(ord-1)
			err = err + abs(ans - soln(l))
		end do

		write(6,*) 'error is',err

		stop
		end
