/*****************************************************************************/
/*           P.I.V.S  Platform Independent Visualization System              */
/*           ==================================================              */
/*       P.I.V.S is copyright (C) 1996, Scott Klasky, Jason McIlvain         */
/*                                                                           */
/*   This code was written at NPAC Northeast Parallel Architecture Center as */
/* an undergraduate research project funded by NSF, NPAC, Syracuse Univ., and*/
/* General Electric. The advising of this project was done by Scott Klasky,  */
/* research scientist at NPAC and the coding was done by Jason McIlvain,     */
/* an undergraduate in the NSF REU program, and Scott Klasky .               */
/*****************************************************************************/

import java.io.*;
import java.util.*;
import java.lang.*;
import java.util.StringTokenizer;

class cube {
    int cube;
    int y;
    int z;
}


class march {

     static char vertpats[]= {
                 (char)( 0 ),
                 (char)( (1<<0)  | (0) ),
                 (char)( (1<<0)  | (1<<1)  | (0) ),
                 (char)( (1<<0)  | (1<<3)  | (0) ),
                 (char)( (1<<0)  | (1<<7)  | (0) ),
                 (char)( (1<<1)  | (1<<5)  | (1<<4)  | (0) ),
                 (char)( (1<<0)  | (1<<1)  | (1<<7)  | (0) ),
                 (char)( (1<<2)  | (1<<1)  | (1<<7)  | (0) ),
                 (char)( (1<<0)  | (1<<1)  | (1<<5)  | (1<<4)  ),
                 (char)( (1<<0)  | (1<<4)  | (1<<5)  | (1<<6)  ),
                 (char)( (1<<0)  | (1<<2)  | (1<<5)  | (1<<7)  ),
                 (char)( (1<<0)  | (1<<4)  | (1<<5)  | (1<<7)  ),
                 (char)( (1<<2)  | (1<<4)  | (1<<5)  | (1<<1)  ),
                 (char)( (1<<0)  | (1<<3)  | (1<<5)  | (1<<6)  ),
                 (char)( (1<<1)  | (1<<5)  | (1<<4)  | (1<<6)  )  };


   static char edgepats[][]=
        {{ (char)0,                       (char)0,                        (char)0,                       (char)0 },
         { (char)((1<<0)|(1<<1)|(1<<2)),  (char)0,                        (char)0,                       (char)0 },
         { (char)((1<<1)|(1<<2)|(1<<5)),  (char)((1<<2)|(1<<10)|(1<<5)),  (char)0,                       (char)0 },
         { (char)((1<<0)|(1<<1)|(1<<2)),  (char)((1<<4)|(1<<5)|(1<<6)),   (char)0,                       (char)0 },
         { (char)((1<<0)|(1<<1)|(1<<2)),  (char)((1<<6)|(1<<9)|(1<<12)),  (char)0,                       (char)0 },
         { (char)((1<<0)|(1<<2)|(1<<13)), (char)((1<<0)|(1<<13)|(1<<9)),  (char)((1<<0)|(1<<9)|(1<<5)),  (char)0 },
         { (char)((1<<1)|(1<<2)|(1<<5)),  (char)((1<<2)|(1<<10)|(1<<5)),  (char)((1<<6)|(1<<9)|(1<<12)), (char)0 },
         { (char)((1<<1)|(1<<4)|(1<<14)), (char)((1<<0)|(1<<5)|(1<<10)),  (char)((1<<6)|(1<<9)|(1<<12)), (char)0 },
         { (char)((1<<1)|(1<<5)|(1<<9)),  (char)((1<<1)|(1<<13)|(1<<9)),  (char)0,                       (char)0 },
         { (char)((1<<1)|(1<<0)|(1<<14)), (char)((1<<0)|(1<<9)|(1<<10)),  (char)((1<<9)|(1<<12)|(1<<14)),(char)((1<<14)|(1<<0)|(1<<9))   },
         { (char)((1<<0)|(1<<2)|(1<<14)), (char)((1<<0)|(1<<14)|(1<<4)),  (char)((1<<8)|(1<<10)|(1<<6)), (char)((1<<8)|(1<<12)|(1<<6))   },
         { (char)((1<<0)|(1<<10)|(1<<6)), (char)((1<<0)|(1<<1)|(1<<13)),  (char)((1<<13)|(1<<12)|(1<<6)),(char)((1<<0)|(1<<13)|(1<<6))   },
         { (char)((1<<0)|(1<<2)|(1<<13)), (char)((1<<0)|(1<<13)|(1<<9)),  (char)((1<<0)|(1<<9)|(1<<5)),  (char)((1<<4)|(1<<1)|(1<<14))   },
         { (char)((1<<0)|(1<<1)|(1<<2)),  (char)((1<<4)|(1<<5)|(1<<6)),   (char)((1<<8)|(1<<9)|(1<<10)), (char)((1<<12)|(1<<13)|(1<<14)) },
         { (char)((1<<0)|(1<<2)|(1<<14)), (char)((1<<14)|(1<<12)|(1<<9)), (char)((1<<0)|(1<<14)|(1<<9)), (char)((1<<0)|(1<<9)|(1<<5))    }
        };

   static short cubedges[][] = new short[256][4];
   static char numtri[] = new char[256];
   static char edgecorns[] = new char[256];
   static char numedg[] = new char[256];
   static char edgecornsi[] = new char[256];
   static char edgecornsj[] = new char[256];
   static char edgecornsk[] = new char[256];
   static char edgecornst[] = new char[256];

   static char edgenums[][] ={{1,0,0},
                              {0,1,0},
                              {0,0,1},
                              {0,0,0},
                              {1,2,0},
                              {2,1,0},
                              {2,2,1},
                              {0,0,0},
                              {1,0,2},
                              {2,1,2},
                              {2,0,1},
                              {0,0,0},
                              {1,2,2},
                              {0,1,2},
                              {0,2,1}};


   static char revedges[][][] ={{{(char)255,(char)255,(char)255},{(char)255,(char)255,(char)255},{(char)255,(char)255,(char)255}},
                                {{(char)255,(char)255,(char)255},{(char)255,(char)255,(char)255},{(char)255,(char)255,(char)255}},
                                {{(char)255,(char)255,(char)255},{(char)255,(char)255,(char)255},{(char)255,(char)255,(char)255}}};

/*****************************************************************************************/
   public static void init_marchcubes() throws java.io.IOException {
        int i,j,crap;
        for(i=0;i<15;i++)
           revedges[(int)edgenums[i][0]][(int)edgenums[i][1]][(int)edgenums[i][2]]=(char)i;
        revedges[0][0][0]= (char)255;
        for(i=0;i<256;i++)
           for(j=0;j<4;j++)
              cubedges[i][j]=0;
        crap = rotate_cubes();

   }
/******************************************************************************************/

   static short pat[][] = {{0,1,2,1},
                         {0,0,2,2}};

/*****************************************************************************************/
   public static short rotate(short edge, short axis, short num) throws java.io.IOException {

        short index=0, newedge = 0, parity, inc;
        boolean y;

        if(num==0) return edge;
        y = (axis == 1);
          if((edge & (1<<(axis*2)))>0){
            parity=1;
            if(((axis==2)?(edge & (3<<2))>>2 :(edge &(3<<4))>>4)==2)
              if(((axis==0)?(edge&(3<<2))>>2 : (edge&3))==2)
                index = (short)((y) ? 3 : 2);
              else index = (short)((y) ? 2 : 3);
            else
                if(((axis==0)?(edge&(3<<2))>>2:(edge&3))==2)
                  index = (short)((y)?0:1);
                else index = (short)((y)?1:0);
          }
          else {
            parity = 0;
            switch((axis==2)?(edge&(3<<2))>>2:(edge&(3<<4))>>4) {
                case 0:
                       index=0; break;
                case 1:
                       if(((axis==0)?(edge&(3<<2))>>2:(edge&3))>0)
                          index=(short)((y)?3:1);
                       else index = (short)((y)?1:3); break;
                case 2:
                       index = 2; break;
            }
        }
        if(axis==01) inc = -1; else inc = 1;

        newedge|=((axis==2)?(pat[parity][(index+num)&3])<<2:(pat[parity][(index+num)&3])<<4);
        newedge|=((axis>0)?(pat[parity][(index+num+inc)&3]):(pat[parity][(index+num+inc)&3])<<2);
        newedge|=(edge & (3 << (axis*2)));
        return newedge;
   }


/******************************************************************************************/
static public int rotate_cubes() throws java.io.IOException {
    short h,i,j,k,tmp;
    short patt;

    rotcube((short)0,(short)0,(short)0,(short)0);
    for(h=1; h<15; h++)
       for(i=0; i<4; i++)
          for(j=0; j<4; j++)
             for(k=0; k<4; k++)
                rotcube(i,j,k,h);

    for(i=0; i<255; i++)
       if((cubedges[i ^ 255][0])>0) ; else
         for(j=0; j<4; j++)
            cubedges[i ^ 255][j] = cubedges[i][j];

    for(i=0; i<256; i++){
       tmp = 0;
       for(j=0; j<4; j++)
          if(cubedges[i][j]>0) tmp++; else break;
       numtri[i]=(char)(tmp & 255);
       tmp=0;
       patt = (short)(cubedges[i][0] | cubedges[i][1] | cubedges[i][2] | cubedges[i][3]);
       for(j=0; j<3; j++) {
          if((patt & (1<<(j)))>0)
            tmp++;
       }
       edgecorns[i] = (char)(tmp & 255);
       tmp=0;
       for(j=0; j<15; j++){
          if((patt & (1<<(j)))>0)
            tmp++;
       }
       numedg[i] = (char)(tmp & 255);
       edgecornsi[i] = (char)(((((patt & (1<<5))>0?1:0) + ((patt & (1<<10))>0?1:0))&(255)) & 255);
       edgecornsj[i] = (char)(((((patt & (1<<4))>0?1:0) + ((patt & (1<<14))>0?1:0))&(255)) & 255);
       edgecornsk[i] = (char)(((((patt & (1<<8))>0?1:0) + ((patt & (1<<13))>0?1:0))&(255)) & 255);
       edgecornst[i] = (char)((edgecorns[i] + edgecornsi[i]) & 255);
    }
    return 0;
}


/****************************************************************************************/
static public void rotcube(short xr, short yr, short zr, short onum) throws java.io.IOException {
    short i, aftx, afty, aftz, finl=0;

    for(i=0; i<8; i++)
       if(((((255)&(vertpats[onum])) & (1<<(i)))>0)&&(((((255)&(vertpats[onum]))& (1<<(i)))& (1<<7)) !=128)) {

         aftx = (short)(i ^ ((xr==2) ? 6: ((((i & (1<<1))>0?1:0) == ((i &(1<<2))>0?1:0)) ?
                    ((xr==3) ? 4: ((xr==1)?2:0)): ((xr==3)? 2: ((xr==1)? 4:0)))));

         afty = (short)(aftx ^ ((yr==2) ? 5: ((((aftx &(1<<0))>0?1:0)== ((aftx &(1<<2))>0?1:0)) ?
                       ((yr==3) ? 1: ((yr==1)? 4:0)): ((yr==3) ? 4: ((yr==1)? 1:0)))));

         aftz = (short)(afty ^ ((zr==2) ? 3: ((((afty &(1<<0))>0?1:0)== ((afty &(1<<01))>0?1:0)) ?
                       ((zr==3) ? 2: ((zr==1)? 1:0)): ((zr==3) ? 1: ((zr==1)? 2:0)))));

         finl |= (short)(1<<(aftz));
       }
    if(cubedges[finl][0]==0)
      rotedges(xr,yr,zr,onum,finl);
}

/*******************************************************************************************/
static public void rotedges(short xr, short yr, short zr, short onum, short npat) throws java.io.IOException {
    short i,j,e0,e1,e2,e3;

    for(i=0; i<4; i++){
       cubedges[npat][i] = 0;
       if((edgepats[onum][i])>0){
         for(j=0; j<15; j++){
            if(((short)(edgepats[onum][i] & (1<<j)))>0){
                e0 = (short)(edgenums[j][0] | (edgenums[j][1]<<2) | (edgenums[j][2]<<4));
                e1 = rotate(e0,(short)0,xr);
                e2 = rotate(e1,(short)1,yr);
                e3 = rotate(e2,(short)2,zr);
                cubedges[npat][i] |= (1<<(revedges[e3 & 3][(e3 &(3<<2))>>2][(e3 &(3<<4))>>4]));
            }
         }
       } else return;
    }
}




/***************************************************************************************/
public static int get_dimensions(char index) throws java.io.IOException {
 DataInputStream in = new DataInputStream(System.in);
 String s = new String();
 int size = 0;
double size2 = 0.0;
  switch(index){
   case 'x':
    System.out.println(" Input X dimension : ");
    s = in.readLine();
    size = Integer.valueOf(s).intValue();
    break;
   case 'y':
    System.out.println(" Input Y dimension : ");
    s = in.readLine();
    size = Integer.valueOf(s).intValue();
    break;
   case 'z':
    System.out.println(" Input Z dimension : ");
    s = in.readLine();
    size = Integer.valueOf(s).intValue();
    break;
   }
   return size;
}

/***************************************************************************************/
public static double get_ddimensions(char index) throws java.io.IOException {
 DataInputStream in = new DataInputStream(System.in);
 String s = new String();
 int size = 0;
double size2 = 0.0;
  switch(index){
   case 't':
    System.out.println(" Input threshold : ");
    s = in.readLine();
    size2 = Double.valueOf(s).doubleValue();
    break;
   }
   return size2;
}


/************************************************************************************/
public static String get_filename() throws java.io.IOException {
    DataInputStream in = new DataInputStream(System.in);
    String filename = new String();
    System.out.println(" Input dataset filename : ");
    filename = in.readLine();
    return filename;
}

/*************************************************************************************/
public static void VRML_out(long num_connections[], long num_corners, double corner_coords[][],
                             long connections[], double corner_norms[][],
                             int offset) throws java.io.IOException
{
    int n=0;
    double temp1,temp2,temp3,t1,t2,t3;
    long tmp1,tmp2,tmp3;
    double small;
    small= (0.0000);
    PrintStream out;


/*    RandomAccessFile f = new RandomAccessFile("out.wrl","rw"); */
    out = new PrintStream( new FileOutputStream("out.wrl") );


    out.println("#VRML V1.0 ascii\n\n");
    out.println("Separator {\n\n");
    out.println("   Coordinate3 {\n\n");
    out.println("      point   [ \n");

/*    f.writeChars("#VRML V1.0 ascii\n\n");   */
/*    f.writeChars("Separator {\n\n");   */
/*    f.writeChars("\t\tCoordinate3 {\n");   */
/*    f.writeChars("\t\t\tpoint\t[\n");   */

    for(n=1;n<=num_corners;n++)
       {
         temp3 = (double)(corner_coords[2][n] + offset + small);
         temp2 = (double)(corner_coords[1][n] + small);
         temp1 = (double)(corner_coords[0][n] + small);
/*         f.writeChars("\t\t\t");  */
/*         f.writeChars(""+temp1);  */
/*         f.writeChars(", ");  */
/*         f.writeChars(""+temp2);  */
/*         f.writeChars(", ");  */
/*         f.writeChars(""+temp3);  */
/*         f.writeChars(",\n");  */

         out.print(temp1);
         out.print("  ");
         out.print(temp2);
         out.print("  ");
         out.print(temp3);
         out.print(", \n");
       }

/*    f.writeChars("\t\t\t]\n");  */
/*    f.writeChars("\t\t}\n\n\n");  */
/*    f.writeChars("\tNormal {\n");  */
/*    f.writeChars("\t\tvector [\n");  */
      out.print("         ]\n");
      out.print("      }\n\n\n");
      out.print("   Normal{\n");
      out.print("      vector [\n");

    for(n=1;n<= num_corners; n++)
       {
         t1= (-corner_norms[0][n]+small);
         t2= (-corner_norms[1][n]+small);
         t3= (-corner_norms[2][n]+small);
/*         f.writeChars("\t\t\t");  */
/*         f.writeChars(""+t1);  */
/*         f.writeChars(", ");  */
/*         f.writeChars(""+t2);  */
/*         f.writeChars(", ");  */
/*         f.writeChars(""+t3);  */
/*         f.writeChars(",\n");  */
           out.print("         ");
           out.print(t1);
           out.print("  ");
           out.print(t2);
           out.print("  ");
           out.print(t3);
           out.print(", \n");
       }

/*    f.writeChars("\t\t\t]\n");  */
/*    f.writeChars("\t}\n\n\n");  */
/*    f.writeChars("\tNormalBinding { value PER_VERTEX_INDEXED }\n\n\n");  */
      out.print("         ]\n");
      out.print("   } \n\n\n");
      out.print("   NormalBinding { value PER_VERTEX_INDEXED }\n\n\n");

/*    f.writeChars("\tIndexedFaceSet {\n");  */
/*    f.writeChars("\t\tcoordIndex [\n");  */
      out.print("   IndexedFaceSet {\n");
      out.print("      coordIndex [\n");

    for(n=0;n< num_connections[0]; n+=3)
       { tmp1 = connections[n] -1;
         tmp2 = connections[n+1] -1;
         tmp3 = connections[n+2] -1;
/*         f.writeChars("\t\t\t");  */
/*         f.writeChars("" +tmp1);  */
/*         f.writeChars(", ");  */
/*         f.writeChars("" +tmp2);  */
/*         f.writeChars(", ");  */
/*         f.writeChars("" +tmp3);  */
/*         f.writeChars(", -1,\n");  */
           out.print("         ");
           out.print(tmp1);
           out.print(", ");
           out.print(tmp2);
           out.print(", ");
           out.print(tmp3);
           out.print(", -1,\n");
       }

/*    f.writeChars("\t\t\t]\n"); */
/*    f.writeChars("}\n"); */
/*    f.writeChars("}\n"); */
      out.print("         ]\n");
      out.print("   }\n");
      out.print("}\n");

}




/*******************************************************************************************/
public static long gouraud_tess(double array[][][], cube cubes[][],long depths[],double value, int dx, int dy,
                  int dz, long connections[],long p_edges[], long triangles_done,
                  long edges_done, long num_connections[], int offset)
                  throws java.io.IOException {

    int i,j,l,m,n,d=0,od,nd,q,ia,ib,ic;
    short tmp;
    int vec[] = new int[3];
    int lx,ly,lz,tri=0,ct;
    int sides_done=0, tri_done=0, num_edges=0;
    int t[] = new int[3];
    int fl[] = new int[3];
    int fg[] = new int[3];
    int cl[] = new int[3];
    int cg[] = new int[3];
    double s[] = new double[3];
    double b[] = new double[3];
    double u[] = new double[3];
    int f[] = new int[3];
    int c[] = new int[3];
    double mag;

    t[0]= dx-1;
    t[1]= dy-1;
    t[2]= dz-1;

    double corner_coords[][] = new double[3][(int)p_edges[0]];
    double corner_norms[][] = new double[3][(int)p_edges[0]];

    long nextslice[][][] = new long[dy][dz][3];
    long curslice[][][] = new long[dy][dz][3];
    long tmpslice[][][] = new long[dy][dz][3];

    for(i=0;i<t[0];i++) {
      System.out.print(" i="+i);
        if(depths[i]>0)
           for(j=0;j<depths[i];j++) {
               tri = (int)numtri[cubes[i][j].cube];
               lx = i;
               ly = cubes[i][j].y;
               lz = cubes[i][j].z;
               for(l=0;l<tri;l++) {
                   tmp = (short)cubedges[cubes[i][j].cube][l];
                   for(ct=0,m=0;m<15;m++)
                       if(((short)(tmp & (1<<(m))))>0) {
                          vec[0]= lx;
                          vec[1]= ly;
                          vec[2]= lz;
                          for(n=0;n<3;n++){
                              if(edgenums[m][n] == 1) d=n;
                              else if (edgenums[m][n] == 2) vec[n]++;}
                           if(((vec[0] == i)&&(curslice[vec[1]][vec[2]][d]==0)) || ((vec[0] != i)&&(nextslice[vec[1]][vec[2]][d]==0)))
                           {
                            if(vec[0] == i) curslice[vec[1]][vec[2]][d] = ++num_edges;
                            else nextslice[vec[1]][vec[2]][d] = ++num_edges;
                            if(d==0){od = 1; nd = 2;}
                            else if(d==1){od = 0; nd = 2;}
                            else { od = 0; nd = 1;}

                            if(vec[d] < t[d])
                               s[d] = corner_coords[d][num_edges]=
                               (double)((vec[d]) - ((((value - array[vec[0]][vec[1]][vec[2]])/(array[vec[0]][vec[1]][vec[2]] - array[((d==0)?vec[0]+1:vec[0])] [((d==1)?vec[1]+1:vec[1])]  [((d==2)?vec[2]+1:vec[2])] ))
                               < -1.0) ? -0.5  :    (((value - array[vec[0]][vec[1]][vec[2]])/(array[vec[0]][vec[1]][vec[2]] - array[((d==0)?vec[0]+1:vec[0])] [((d==1)?vec[1]+1:vec[1])]  [((d==2)?vec[2]+1:vec[2])] ))
                               >  1.0) ?  0.5  :     ((value - array[vec[0]][vec[1]][vec[2]])/(array[vec[0]][vec[1]][vec[2]] - array[((d==0)?vec[0]+1:vec[0])] [((d==1)?vec[1]+1:vec[1])]  [((d==2)?vec[2]+1:vec[2])] ))));

                           else s[d] = corner_coords[d][num_edges] = (double)(vec[d] + 0.5);

                           s[od] = corner_coords[od][num_edges] = (double)vec[od];
                           s[nd] = corner_coords[nd][num_edges] = (double)vec[nd];
                           //normfrag begins here
                           for(q=0;q<3;q++){
                              f[q]= (int)(Math.floor((double)s[q]));
                              c[q]= (int)(Math.ceil((double)s[q]));
                              if(f[q] != c[q]){
                                b[q]= (Math.floor((double)s[q]));
                                u[q]= (Math.ceil((double)s[q]));
                                if(f[q] <= 0) fl[q]= 0; else fl[q]= (f[q]-1);
                                if(c[q] <= 0) cl[q]= 0; else cl[q]= (c[q]-1);
                                if(f[q] >= t[q]) fg[q]= t[q]; else fg[q]= (f[q]+1);
                                if(c[q] >= t[q]) cg[q]= t[q]; else cg[q]= (c[q]+1);
                                if(f[q] < 0) f[q]= 0;
                                if(c[q] < 0) c[q]= 0;
                                if(c[q] >= t[q]) c[q]= f[q]= t[q];
                              }
                              else{
                                if(f[q] <= 0) fl[q]= 0; else fl[q]= (f[q]-1);
                                if(f[q] >= t[q]) fg[q]= t[q]; else fg[q]= (f[q]+1);
                              }
                           }
                           if(f[0] == c[0])
                             s[0]= corner_norms[0][num_edges]=
                                     array[fg[0]][f[1]][f[2]] - array[fl[0]][f[1]][f[2]];
                           else
                             s[0]= corner_norms[0][num_edges]=
                                     ((array[fg[0]][f[1]][f[2]] - array[fl[0]][f[1]][f[2]])*
                                      (s[0] - b[0]) + (u[0] - s[0])*
                                      (array[cg[0]][c[1]][c[2]] - array[cl[0]][c[1]][c[2]]));
                           if(f[1] == c[1])
                             s[1]= corner_norms[1][num_edges]=
                                     array[f[0]][fg[1]][f[2]] - array[f[0]][fl[1]][f[2]];
                           else
                             s[1]= corner_norms[1][num_edges]=
                                     ((array[f[0]][fg[1]][f[2]] - array[f[0]][fl[1]][f[2]])*
                                      (s[1] - b[1]) + (u[1] - s[1])*
                                      (array[c[0]][cg[1]][c[2]] - array[c[0]][cl[1]][c[2]]));
                           if(f[2] == c[2])
                             s[2]= corner_norms[2][num_edges]=
                                     array[f[0]][f[1]][fg[2]] - array[f[0]][f[1]][fl[2]];
                           else
                             s[2]= corner_norms[2][num_edges]=
                                     ((array[f[0]][f[1]][fg[2]] - array[f[0]][f[1]][fl[2]])*
                                      (s[2] - b[2]) + (u[2] - s[2])*
                                      (array[c[0]][c[1]][cg[2]] - array[c[0]][c[1]][cl[2]]));
                           mag= Math.sqrt(s[0]*s[0] + s[1]*s[1] + s[2]*s[2]);
                           corner_norms[0][num_edges] /= mag;
                           corner_norms[1][num_edges] /= mag;
                           corner_norms[2][num_edges] /= mag;
                           //end of normfrag

                         }
                         connections[sides_done++] = ((vec[0]==i)?curslice[vec[1]][vec[2]][d]:
                                                   nextslice[vec[1]][vec[2]][d]);
                         if(++ct>= 3) break;
                       }
                       tri_done++;
               }}
               for(ia=0;ia<dy;ia++){
                     for(ib=0;ib<dz;ib++){
                     for(ic=0;ic<3;ic++){
                        tmpslice[ia][ib][ic] = nextslice[ia][ib][ic];}}}

               for(ia=0;ia<dy;ia++){
                     for(ib=0;ib<dz;ib++){
                     for(ic=0;ic<3;ic++){
                        nextslice[ia][ib][ic]= curslice[ia][ib][ic];}}}

               for(ia=0;ia<dy;ia++){
                     for(ib=0;ib<dz;ib++){
                     for(ic=0;ic<3;ic++){
                        curslice[ia][ib][ic]= tmpslice[ia][ib][ic];}}}

               //memset set
                     for(ia=0;ia<dy;ia++){
                     for(ib=0;ib<dz;ib++){
                     for(ic=0;ic<3;ic++){
                        nextslice[ia][ib][ic]=0;}}}
           }
           triangles_done = tri_done;
           edges_done = num_edges;


            System.out.println(" end of gt: num edges =" +num_edges);//debug
            System.out.println("num triangles =" +tri_done);//debug

           VRML_out(num_connections,edges_done,corner_coords,connections,corner_norms,offset);


           return 0;

    }




/******************************************************************************************/
public static long process_array(int dx, int dy, int dz, double value, double data[][][],
                                  cube cubes[][], long depths[], long p_edges[], long num_connections[])
                                 throws java.io.IOException{
    int i,j,k=0,ic,bb,bs;
    int tmp;
    int tx,ty,pd;
    int tz;
    int tmptr[];
    long num_tri = 0, edges_predicted = 0;
    int num_cubes = 0;
    int dzd = 32;

    tx = dx-1;
    ty = dy-1;
    tz = dz-1;
    pd = (dz/dzd) + ((dz%dzd)>0 ? 1:0);

    int prevslice[] = new int[dy*pd];
    int curslice[] = new int[dy*pd];
    cube[][][] array = new cube[tx][ty][tz];
    for(i=0;i<tx;i++)
       for(j=0;j<(ty);j++)
          for(k=0;k<(tz);k++)
             array[i][j][k]= new cube();

    for(j=0;j<dy;j++)
       for(k=0;k<dz;k++)
          if(data[0][j][k] >= value) curslice[((j)*pd)+((k)/dzd)] |= (1<<(k&dzd-1));

    tmptr = curslice;
    curslice = prevslice;
    prevslice = tmptr;
    for(ic=0;ic<(dy*pd);ic++)
       curslice[ic]= 0;

    for(i=0; i<tx; i++){
        num_cubes = 0;
        if(i>1) { array[i]= array[i & 1];
                  for(bb=0;bb<ty;bb++)
                  for(bs=0;bs<tz;bs++){
                     array[i][bb][bs].cube=0;
                     array[i][bb][bs].y=0;
                     array[i][bb][bs].z=0;}
        }
        for(j=0;j<dy;j++)
           if(data[i+1][j][0] >= value) curslice[((j)*pd)+((0)/dzd)] |= (1<<(0&dzd-1));

        for(k=1;k<dz;k++)
           if(data[i+1][0][k] >= value) curslice[((0)*pd)+((k)/dzd)] |= (1<<((k)&dzd-1));

        for(j=0;j<ty;j++){
           for(k=0;k<tz;k++){
           if(data[i+1][j+1][k+1] >= value) curslice[((j+1)*pd)+((k+1)/dzd)] |= (1<<((k+1)&dzd-1));

           tmp  = 0;
           tmp |= ((prevslice[((j)  *pd)+((k)  /dzd)] & (1<<(k&dzd-1)))>0 ? 01: 0);
           tmp |= ((curslice [((j)  *pd)+((k)  /dzd)] & (1<<(k&dzd-1)))>0 ? 02: 0);
           tmp |= ((prevslice[((j+1)*pd)+((k)  /dzd)] & (1<<(k&dzd-1)))>0 ? 04: 0);
           tmp |= ((curslice [((j+1)*pd)+((k)  /dzd)] & (1<<(k&dzd-1)))>0 ? 010: 0);
           tmp |= ((prevslice[((j)  *pd)+((k+1)/dzd)] & (1<<((k+1)&dzd-1)))>0 ? 020: 0);
           tmp |= ((curslice [((j)  *pd)+((k+1)/dzd)] & (1<<((k+1)&dzd-1)))>0 ? 040: 0);
           tmp |= ((prevslice[((j+1)*pd)+((k+1)/dzd)] & (1<<((k+1)&dzd-1)))>0 ? 0100: 0);
           tmp |= ((curslice [((j+1)*pd)+((k+1)/dzd)] & (1<<((k+1)&dzd-1)))>0 ? 0200: 0);

           array[i][j][k].cube = tmp;
           if((tmp != 0) && (tmp != 255)){
              num_cubes++;
              if(i==(tx-2))
                 edges_predicted += edgecornst[tmp];
              else
                 edges_predicted += edgecorns[tmp];
           }
           }
        }
        depths[i] = num_cubes;

        if(num_cubes>0) {
            //cubes[i] = num_cubes
            num_cubes = 0;
            for(j=0;j<ty;j++)
               for(k=0;k<tz;k++) {
                  if(((tmp = array[i][j][k].cube) != 0)&&(tmp != 255)) {
                    num_tri += numtri[tmp];
                    cubes[i][num_cubes].cube = tmp;
                    cubes[i][num_cubes].y = j;
                    cubes[i][num_cubes].z = k;
                    num_cubes++;
                  }
               }
            for(j=0;j<ty-1;j++)
               if(i==(tx-2))
                 edges_predicted += numedg[array[i][j][tz-1].cube];
               else
                 edges_predicted += edgecornsk[array[i][j][tz-1].cube];

            for(k=0;k<tz-1;k++)
               if(i==(tx-2))
                 edges_predicted += numedg[array[i][ty-1][k].cube];
               else
                 edges_predicted += edgecornsj[array[i][ty-1][k].cube];

            edges_predicted += numedg[array[i][ty-1][tz-1].cube];

        }

        tmptr = curslice;
        curslice = prevslice;
        prevslice = tmptr;
        for(ic=0;ic<(dy*pd);ic++)
           curslice[ic]=0;
    }

System.out.println("cube vertices calculated, "+num_tri+" triangles, "+edges_predicted+" vertices");

    p_edges[0] = edges_predicted;
    num_connections[0] = 3*num_tri;


    return num_tri;
}

/*************************************************************************************/
public static void main(String argv[]) throws java.io.IOException{

    march mm = new march();
    String fname = new String();
    int xsize,ysize,zsize;
    double threshold;
    int i=0,j=0,k=0,m=4,ind,indd;
    int mn=3;
    char x = 'x';
    char y = 'y';
    char z = 'z';
    char t = 't';
    int ZC = 64;
    int fl,pt = 0;
    long temp_count;
    long p_edges[]= new long[1];
    double th;
    long triangles_done = 0;

    xsize = get_dimensions(x);
    ysize = get_dimensions(y);
    zsize = get_dimensions(z);
    threshold = get_ddimensions(t);

    double grid[][][] = new double[xsize][ysize][zsize];
    long num_corners= 0;
    long num_connections[] = new long[1];

    th = threshold;
    fname = get_filename();
    RandomAccessFile in = new RandomAccessFile(fname,"r");
    fl=xsize*ysize*zsize;
//    byte s[]= new byte[fl];
//    in.read(s,0,fl);

          for(k=0;k<zsize;k++)
           for(i=0;i<ysize;i++)
              for(j=0;j<xsize;j++){
//                  if(s[pt] == '1'){
//                    grid[j][i][k] = 1.0;
//                    pt++;
//                    }
//                  else {
//                    grid[j][i][k] = 0.0;
//                    pt++;
//                    }
                grid[i][j][k] = in.readDouble();
                //System.out.println(grid[i][j][k]);
              }

        long depths[] = new long[xsize-1];
        cube[][] cubes = new cube[xsize-1][500];//good enough for now
        for(i=0;i<(xsize-1);i++)
           for(j=0;j<(500);j++){//good enough for now
              cubes[i][j]= new cube();
              cubes[i][j].cube =0;
              cubes[i][j].y = 0;
              cubes[i][j].z = 0;}


        init_marchcubes();

        temp_count = mm.process_array(xsize,ysize,zsize,th,grid,cubes,depths,p_edges,num_connections);

        System.out.println("p_edges = " +p_edges[0]);//debug
        System.out.println("num_connections = " +num_connections[0]);//debug

        p_edges[0]++;
        long connections[]= new long[(int)num_connections[0]];

        mn=3;
        mm.gouraud_tess(grid,cubes,depths,th,xsize,ysize,zsize,connections,p_edges,
                     triangles_done,num_corners,num_connections,mn);

        System.out.println("(in main) marching cubes complete: "+temp_count+" triangles");

}
}
