#include <sys/types.h>
#include <stdio.h>
#include "dore.h"
#include <math.h>
#include <sys/signal.h>
#include <termio.h>
#include <fcntl.h>

#define DTOR(angle) ((angle) * (3.14159265358979 / 180.0))
#define Assign_Vec(vec, x, y, z) {*vec = (x); *(vec+1) = (y); *(vec+2) = (z);}
#define MAXTRIS  950000
#define MAXVERTS 500000
#define NODES 18
#define PI 3.141592654

DtReal	green[3] = {0.0, 0.7, 0.0};
DtReal	red[3] = {1.0, 0.0, 0.0};
DtReal	white[3] = {1.0, 1.0, 1.0};
DtReal	blue[3] = {0.0, 0.0, 1.0}; 
DtReal	mycolor[3]={0.7,0.7,0.7};
DtReal	flesh[3]={0.84,0.6,0.43};
DtReal	cyan[3] = {   0.0, 0.7, 1.0};
DtReal	purple[3] = {   0.7, 0.0, 0.7};
DtReal	yellow[3] = {   0.7, 0.7, 0.0};
DtReal	gold[3] = { 0.9, .85, 0.6}; 
DtReal	black[3]= {0.0,0.0,0.0};
DtReal	bgcolor[3] = {0.0, 0.0, 0.0};
DtReal	intensity[18],t_pos[3];
DtReal xrot,yrot,zrot,xtran,ytran,ztran,nx,ny,nz;
DtReal intxrt,intyrt,intzrt,intxt,intyt,intzt;
DtReal ixs,iys,izs,old_value=0.0;

DtRealTriple
	Light_Color, Light_Color2,
	Light_At, Light_From, Light_From2,Light_Up, 
	Camera_At, Camera_From, Camera_Up; 

DtInt sv[26],sc[26];
DtInt	do_me=0,see_mc,snap_frame;
DtInt iconst,izrot,icountot,count=0;

char	junkfile[64];

DtObject ingrpx,ingrpy;
DtObject device,view;

FILE 	*fp9,*fp1,*fp2,*fp3, *fp4,*fopen(),*fp8,*fp5;

DtPtr  red_ptr,blue_ptr,ptr_intensity,ptr_izrot;
/*****************************************************************************************/
DtPtr do_intens()
{
if (count==18) {count=0;do_me=0;}
if (do_me==1) {
fscanf(fp8,"%lf",&intensity[count]);
}
DsExecuteObj(DoDiffuseIntens( 1.0));
count++;
}
/*****************************************************************************************/

DtPtr do_scale2()
{
DtInt real_count;
	real_count = count -1;
DsExecuteObj(DoScale(0.5,0.5,0.5+1.4*intensity[real_count]));
}
/*****************************************************************************************/

DtPtr do_scale()
{
DtInt real_count;
	real_count = count -1;
DsExecuteObj(DoScale(5.0+5.0*intensity[real_count],5.0+5.0*intensity[real_count],5.0+5.0*intensity[real_count]));
}
/*****************************************************************************************/

DtPtr do_color()
{
DtInt real_count;
DtReal intensv;
	real_count= count-1;
      red[0] = intensity[real_count];

      red[1] = sin( PI*intensity[real_count]);

      red[2]=  1.0 - intensity[real_count];

	DsExecuteObj(DoDiffuseColor ( DcRGB,red));
}
/*****************************************************************************************/

DtPtr rot_fun(aangle)

 DtReal *aangle;
{
 DsExecuteObj(DoRotate(DcZAxis,DTOR(*aangle)));
}
/*****************************************************************************************/

DtPtr rot_fun2(aangle)

 DtReal *aangle;
{
 DsExecuteObj(DoRotate(DcZAxis,DTOR(*aangle)));
}
/*****************************************************************************************/

DtPtr rot_fun3()

{
DtInt real_count;
/*
        real_count = count -1;
	old_value = (intensity[real_count]/10.0+old_value);	
*/
	old_value+=0.25;
DsExecuteObj(DoRotate(DcZAxis,old_value));
}
/*****************************************************************************************/

main()
{
	FILE	*fp_view;

   DtReal xx,yy,zz;

   DtInt reloj,isphere,i;

	DtObject frame, studio_group, sphere_group,legend_group;
   DtObject makeobject(),make_studio(),makesphere(),makelegend();

	DtVolume volume;
/* start */

	DsInitializeSystem(0);
	fp5 = fopen("name_of_file","r");
	fscanf(fp5,"%s",junkfile);
	fscanf(fp5,"%d",&see_mc);
	fscanf(fp5,"%d",&snap_frame);
	fclose(fp5);

/* get the correct device */
/*
  	if (!(device = DoDevice("stdx11", "-geometry 640x480+0+0 -visualtype DcPseudoColor")))
	*/
  	if (!(device = DoDevice("stdx11", "-geometry 640x480+0+0")))
	

	{
		printf("can't create device\n");
		exit(1);
	}

	DdInqExtent(device,&volume);

	
	if (!(frame = DoFrame())) 
	{
		printf("can't create frame\n");
		exit(1);
	}

	DdSetFrame(device,frame);
	DfSetBoundary(frame,&volume);

	if (!(view = DoView())) 
	{
		printf("can't create view\n");
		exit(1);
	}

	DvSetRendStyle(view,DcRealTime);

	DgAddObjToGroup(DfInqViewGroup(frame), view);

	DvSetBoundary (view, &volume);
	DvSetBackgroundColor (view, DcRGB, bgcolor);
	DvSetClearFlag(view,DcTrue);
	fp8 = fopen (junkfile,"r");
	fp_view = fopen ("view.dat", "r");
	fscanf (fp_view, "%lf %lf %lf %lf %lf %lf %lf %lf %lf", 
	(long)	&Camera_From[0],(long) &Camera_From[1],(long) &Camera_From[2], 
	(long)	&Camera_At[0],(long) &Camera_At[1],(long) &Camera_At[2], 
	(long)	&Camera_Up[0],(long) &Camera_Up[1],(long) &Camera_Up[2]);

	fscanf (fp_view, "%lf %lf %lf %lf %lf %lf %lf %lf %lf", 
	(long)	&Light_From[0],(long) &Light_From[1],(long) &Light_From[2], 
	(long) &Light_At[0],(long) &Light_At[1], (long) &Light_At[2], 
	(long) &Light_Up[0],(long) &Light_Up[1],(long) &Light_Up[2]);

        fscanf (fp_view, "%lf %lf %lf %lf %lf %lf", (long) &intxrt, (long)&intyrt,(long)&intzrt,(long)&intxt,(long)&intyt,(long)&intzt);

	Light_From2[0] = -Light_From[0];
	Light_From2[1] = -Light_From[1];
	Light_From2[2] = -Light_From[2];
	fp3 = fopen("trisize","r");
        for (i=0;i<2;i++) {
                 fscanf(fp3,"%d %d",&sc[i],&sv[i]);
		 if (sv[i] == 0) fscanf (fp3,"%d %d",&sv[i],&sc[i]);
                           }
/* Now Lets start to render the object */
	studio_group = make_studio();
        DgAddObjToGroup(DvInqDefinitionGroup(view), studio_group);
	fp9 = fopen ("3dnodes.dore", "r");
			reloj = time(0);
			icountot=0;
			izrot=0;
			zrot = (DtReal)izrot;
			 ptr_izrot=&(zrot);
/*****************************************************************************************/
/*
			for (isphere=0;isphere<NODES;isphere++) {
			fscanf(fp9,"%lf %lf %lf",&xx,&yy,&zz);
			nx = intxt +xx;
			ny = intyt +yy;
			nz = intzt +zz;
			sphere_group= makesphere();
 			DgAddObjToGroup(DvInqDisplayGroup(view),sphere_group);
		}
		fclose(fp9);
*/
/*****************************************************************************************/
/*
			legend_group= makelegend();
	DgAddObjToGroup(DvInqDisplayGroup(view),DoTextHeight(10.0));
	t_pos[0] = 1.0;
	t_pos[1] = -5.0;
	t_pos[2] = 190.0;
        DgAddObjToGroup(DvInqDisplayGroup(view),DoDiffuseColor(DcRGB,blue));
	DgAddObjToGroup(DvInqDisplayGroup(view),DoAnnoText(t_pos,"Minimum"));
	t_pos[0] = 0.6;
	t_pos[1] = -6.0;
	t_pos[2] = 191.0;
        DgAddObjToGroup(DvInqDisplayGroup(view),DoDiffuseColor(DcRGB,white));
	DgAddObjToGroup(DvInqDisplayGroup(view),DoAnnoText(t_pos,"Minimum"));
	t_pos[0] = 1.0;
	t_pos[1] = -230.0;
   t_pos[2] = 190.0;
        DgAddObjToGroup(DvInqDisplayGroup(view),DoDiffuseColor(DcRGB,red));
	DgAddObjToGroup(DvInqDisplayGroup(view),DoAnnoText(t_pos,"Maximum"));
	t_pos[0] = 0.6;
	t_pos[1] = -231.0;
   t_pos[2] = 191.0;
        DgAddObjToGroup(DvInqDisplayGroup(view),DoDiffuseColor(DcRGB,white));
	DgAddObjToGroup(DvInqDisplayGroup(view),DoAnnoText(t_pos,"Maximum"));
   DgAddObjToGroup(DvInqDisplayGroup(view), DoPushMatrix());
	DgAddObjToGroup(DvInqDisplayGroup(view), DoRotate(DcXAxis, DTOR(90.0)));
	DgAddObjToGroup(DvInqDisplayGroup(view), DoRotate(DcYAxis, DTOR(0.0)));
	DgAddObjToGroup(DvInqDisplayGroup(view), DoRotate(DcZAxis, DTOR(263.0)));


			DgAddObjToGroup( DvInqDisplayGroup(view),DoTranslate(-148.0 ,-148.0 ,5.0));

			DgAddObjToGroup( DvInqDisplayGroup(view),DoScale(60.0,60.0,1.20));
                        DgAddObjToGroup(DvInqDisplayGroup(view),legend_group);
                        DgAddObjToGroup(DvInqDisplayGroup(view),DoPopMatrix());
*/

/*****************************************************************************************/

			DgOpen( DvInqDisplayGroup(view),DcTrue);
			DgAddObj( DoPushMatrix());
			DgAddObj( DoRotate(DcXAxis, DTOR(intxrt)));
			DgAddObj( DoRotate(DcYAxis, DTOR(intyrt)));
			DgAddObj( DoRotate(DcZAxis, DTOR(intzrt)));

			DgAddObj(DoCallback(rot_fun,DoDataPtr(ptr_izrot)));

			DgAddObj( DoTranslate(intxt  ,intyt ,intzt));
			DgAddObj( DoScale(1.0,1.0,1.0));
		if (see_mc==1) {
			printf("Starting to read in the info\n");

			DgAddObj( makeobject(0,sc[0],sv[0])); 

			DgAddObj( makeobject(1,sc[1],sv[1]));


			printf ("Done Reading in the info\n");
		}
			DgAddObj(DoPopMatrix());
			DgClose();
			printf ("****** DONE FOR ROTATION AT %d DEGREES ****** \n",izrot);
			fclose(fp1);
/*
			DsPrintObj(DfInqViewGroup(frame));
*/
			count = 0;
			do_me = 1;
			DvUpdate(view);
			reloj = time(0) -reloj;
			printf ("Picture is done in %d seconds\n",reloj);
	if (snap_frame==1) {
			system("rsh scivi snapframe");
			sleep(2);
	}

		for (izrot=1;izrot<360;izrot+=1)
			{

			reloj = time(0);

		   if (see_mc==1) {
			zrot = (DtReal)izrot;
         ptr_izrot=&(zrot);
			}
			count = 0;
			do_me = 1;

	DvUpdate(view);
			reloj = time(0) -reloj;
			printf ("Picture is done in %d seconds\n",reloj);
			printf ("****** DONE FOR ROTATION AT %d DEGREES ****** \n",izrot);
	if (snap_frame==1) {
			system("rsh scivi snapframe");
			sleep(2);
	}
         }

	DsReleaseObj(device);
	DsTerminateSystem();
}
/***************************************************************/
DtObject makelegend()
{
DtReal xa,ya,za,na,nb,nc,c0,c1,c2;
DtReal verts[90000];

DtInt points_on_circle=16,circles=360;
DtInt conts[90000];
DtInt junked[90000];
DtInt scum=0;
DtInt ia,ib,ic,laugh,a1,looper,old_looper;

	DoGroup(DcTrue);

		DgAddObj (DoHiddenSurfSwitch(DcOn));
		DgAddObj (DoAmbientSwitch (DcOff));
		DgAddObj (DoDiffuseSwitch(DcOn));
		DgAddObj (DoSpecularSwitch(DcOn));

		DgAddObj (DoSpecularIntens (1.0));
		DgAddObj (DoSpecularFactor (50.0));

		DgAddObj (DoInterpType (DcSurfaceShade));
		DgAddObj (DoDepthCueSwitch(DcOff));
		DgAddObj (DoRepType (DcSurface));

/* make our list of x,y,z points in array */
	for (ib=0;ib<circles;ib++)
	{
        c0 =  (DtReal)ib/(circles-1);
        c1 = sin( PI*ib/(circles-1));
        c2 = 1.0 - (DtReal)ib/(circles-1);

/* note that there are 8 points on our circle */
	for (ia=0;ia<points_on_circle;ia++)
	{
		xa = (ib/8.0+17)*cos(2.0*PI*ia/points_on_circle)/circles;
		ya = (ib/8.0+17)*sin(2.0*PI*ia/points_on_circle)/circles;
		za = (DtReal)ib/2.0;


		na = -sin(2.0*PI*ia/points_on_circle);
		nb =  cos(2.0*PI*ia/points_on_circle);
		nc = 0.0;
		verts[scum++] = xa;
		verts[scum++] = ya;  
		verts[scum++] = za;
		verts[scum++] = na;
		verts[scum++] = nb;
		verts[scum++] = nc;
		verts[scum++] = c0;
		verts[scum++] = c1;
		verts[scum++] = c2;
	}


	}
	for (laugh=0;laugh<(1+(points_on_circle)*(circles-1));laugh++) junked[laugh]= 4;
	looper = 0;
	ic=0;
	for (a1=0;a1<(points_on_circle*circles+1);a1+=points_on_circle) {
	ic++;
	conts[looper++] = a1;
	conts[looper++] =  a1+points_on_circle;
	conts[looper++] = a1+(points_on_circle+1);
	conts[looper++] = a1+1;
	old_looper = looper;
	for (looper=old_looper;looper<(old_looper-4+4*(points_on_circle-1));looper++) conts[looper] =  conts[looper-4] + 1;
	old_looper = looper;
	conts[looper++] = a1 +points_on_circle-1;
	conts[looper++] = a1 +2*points_on_circle-1;
	conts[looper++] = a1 + points_on_circle;
	conts[looper++] = a1 + 0;
 
	}
	DgAddObj (DoSimplePolygonMesh(DcRGB,DcLocNrmClr,circles*points_on_circle,verts,(points_on_circle)*(circles-1),junked,conts,DcConvex,DcFalse));
	return(DgClose());	
}
/***************************************************************/
DtObject makesphere()
{
       DoGroup(DcTrue);
                DgAddObj (DoShadowSwitch (DcOn));
                DgAddObj (DoHiddenSurfSwitch(DcOn));
                DgAddObj (DoAmbientSwitch (DcOff));
                DgAddObj (DoSpecularSwitch(DcOn));
                DgAddObj (DoTranspSwitch(DcOff));
                DgAddObj (DoDiffuseSwitch(DcOn));

                DgAddObj (DoSpecularIntens (0.8));
                DgAddObj (DoSpecularFactor (100.0));
                DgAddObj (DoCallback(do_intens,DcNullPtr));
                DgAddObj (DoCallback(do_color,DcNullPtr));
                DgAddObj (DoTranspIntens(0.1));
                DgAddObj (DoInterpType (DcSurfaceShade));
                DgAddObj (DoDepthCueSwitch(DcOff));
                DgAddObj (DoRepType (DcSurface));
                DgAddObj (DoRotate(DcXAxis, DTOR(intxrt)));
                DgAddObj (DoRotate(DcYAxis, DTOR(intyrt)));
                DgAddObj (DoRotate(DcZAxis, DTOR(intzrt)));
                DgAddObj (DoCallback(rot_fun,DoDataPtr(ptr_izrot)));

                DgAddObj (DoTranslate(nx,ny,nz));
                DgAddObj (DoCallback(do_scale,DcNullPtr));
                DgAddObj(DoPrimSurf(DcSphere));

                DgAddObj(DoRotate(DcXAxis,DTOR(10.0)));
                DgAddObj(DoRotate(DcYAxis,DTOR(10.0)));
                DgAddObj(DoCallback(rot_fun3,DcNullPtr));

                DgAddObj( DoPushMatrix());
                DgAddObj(DoCallback(do_scale2,DcNullPtr));
                DgAddObj( DoPrimSurf(DcCone));
                DgAddObj( DoPopMatrix());

                DgAddObj( DoPushMatrix());
                DgAddObj(DoRotate(DcXAxis, DTOR(90.0)));
                DgAddObj(DoCallback(do_scale2,DcNullPtr));
                DgAddObj( DoPrimSurf(DcCone));
                DgAddObj( DoPopMatrix());
 
                DgAddObj( DoPushMatrix());
                DgAddObj(DoRotate(DcXAxis, DTOR(180.0)));
                DgAddObj(DoCallback(do_scale2,DcNullPtr));
                DgAddObj( DoPrimSurf(DcCone));
                DgAddObj( DoPopMatrix());

                DgAddObj( DoPushMatrix());
                DgAddObj(DoRotate(DcXAxis, DTOR(270.0)));
                DgAddObj(DoCallback(do_scale2,DcNullPtr));
                DgAddObj( DoPrimSurf(DcCone));
                DgAddObj( DoPopMatrix());

                DgAddObj( DoPushMatrix());
                DgAddObj(DoRotate(DcYAxis, DTOR(90.0)));
                DgAddObj(DoCallback(do_scale2,DcNullPtr));
                DgAddObj( DoPrimSurf(DcCone));
                DgAddObj( DoPopMatrix());

                DgAddObj( DoPushMatrix());
                DgAddObj(DoRotate(DcYAxis, DTOR(270.0)));
                DgAddObj(DoCallback(do_scale2,DcNullPtr));
                DgAddObj( DoPrimSurf(DcCone));
                DgAddObj( DoPopMatrix());

        return(DgClose());
}
/***************************************************************/
DtObject makeobject (ii,sizeofconn,sizeofvert)
DtInt ii;
DtInt sizeofvert,sizeofconn;
{
	DtInt   i,j,icounter1,icounter2;
   DtInt *triangles;

	float  vertic[3];

	DtReal *vertic2,*norms2;

	if (ii==0 ) 

       {

	   if ((fp1=fopen("connections", "rb")) == NULL ) 
           {
		fprintf (stderr, "fopen: couldn't open input files\n");
		exit (0);
	          }	
		fp2=fopen("uniques","rb");
        }

		DoGroup (DcTrue);

		DgAddObj (DoHiddenSurfSwitch (DcOff));
		DgAddObj (DoAmbientSwitch (DcOn));
		DgAddObj (DoDiffuseSwitch (DcOn));
		DgAddObj (DoShadowSwitch (DcOff));
		DgAddObj (DoSpecularSwitch (DcOff));
		DgAddObj (DoDepthCueSwitch(DcOff));
		DgAddObj (DoBackfaceCullSwitch (DcOff));
		DgAddObj (DoTranspSwitch(DcOff ));

		DgAddObj (DoDepthCue(0.97,0.945,1.0,0.0,DcRGB,black));

		DgAddObj (DoSpecularFactor (50.0));

		DgAddObj (DoDiffuseIntens (1.0));
		DgAddObj (DoSpecularIntens (0.2));
		DgAddObj (DoTranspIntens(0.6));

		DgAddObj (DoDiffuseColor (DcRGB, flesh));
		DgAddObj (DoSpecularColor(DcRGB,mycolor));
		DgAddObj (DoTranspColor(DcRGB,white));

		DgAddObj (DoInterpType (DcConstantShade));
		DgAddObj (DoRepType (DcWireframe));
		DgAddObj (DoSurfaceShade(DcShaderLightSource));

 if((triangles = (DtInt *) calloc((unsigned) MAXTRIS, (unsigned) sizeof(DtInt ))) == NULL)
     perror("triangles[]");
 if((vertic2 = (DtReal *) calloc((unsigned)MAXVERTS, (unsigned) sizeof(DtReal ))) == NULL)
     perror("vertic2[]");
 if((norms2 = (DtReal *) calloc((unsigned)MAXVERTS, (unsigned) sizeof(DtReal ))) == NULL)
     perror("norms2[]");
         for (i=0;i<sizeofconn;i++)
            {
               fread(&triangles[i],sizeof(DtInt),1,fp1);
            }
         icounter1=0;
         icounter2=0;
         for (i=0;i<sizeofvert;i++)
            {
              for (j=0;j<3;j++)
                  {
                  fread(&vertic[j],sizeof(float),1,fp2);
                  vertic2[icounter1] =(DtReal) vertic[j];
                  if (j==2) vertic2[icounter1]*=2.0;
                  icounter1++;
                  }
              for (j=0;j<3;j++)
                  {
                  fread(&vertic[j],sizeof(float),1,fp2);
                  norms2[icounter2] =(DtReal) vertic[j];
                  icounter2++;
                  }
            }
	sizeofconn/=3;
		DgAddObj(DoVarTriangleMesh(DcRGB,sizeofvert,vertic2,norms2,DcNullPtr,sizeofconn,triangles,DcTrue));

	return(DgClose());
}
/*********************************************************************** */

DtObject make_studio ()
{
	Assign_Vec (Light_Color, 0.3, 0.3, 0.3);
	Assign_Vec (Light_Color2, 1.0, 1.0, 1.0);
	DoGroup (DcTrue);

		DgAddObj (DoPushMatrix());
			DgAddObj (DoLightType (DcLightAmbient));
			DgAddObj (DoLightIntens (0.5));
			DgAddObj (DoLightColor (DcRGB, Light_Color));
			DgAddObj (DoLookAtFrom(Light_At, Light_From, Light_Up));
			DgAddObj (DoLight ());
		DgAddObj (DoPopMatrix());

		DgAddObj (DoPushMatrix());
			DgAddObj (DoLightType (DcLightInfinite));
			DgAddObj (DoLightIntens (1.1));
			DgAddObj (DoLightColor (DcRGB, Light_Color2));
			DgAddObj (DoLookAtFrom(Light_At,Light_From2, Light_Up));
			DgAddObj (DoLight ());
		DgAddObj (DoPopMatrix());
                Light_From2[0] *= -1.0;
                Light_From2[1] *= -1.0;
                Light_From2[2] *= 1.0;
		DgAddObj (DoPushMatrix());
			DgAddObj (DoLightType (DcLightInfinite));
			DgAddObj (DoLightIntens (1.1));
			DgAddObj (DoLightColor (DcRGB, Light_Color2));
			DgAddObj (DoLookAtFrom(Light_At,Light_From2, Light_Up));
			DgAddObj (DoLight ());
		DgAddObj (DoPopMatrix());
		DgAddObj (DoPushMatrix());
			DgAddObj (DoParallel (300.0, -0.01, -1000.0));
			DgAddObj (DoLookAtFrom(Camera_At, Camera_From, Camera_Up));
			DgAddObj (DoCamera());
		DgAddObj (DoPopMatrix());

	return(DgClose()) ;
}
