      subroutine second_center_x(nx,ny,nz,i,j,k,dx,f,fx)
c
      implicit none
c
      integer nx, ny, nz, i, j, k
      real dx, f(nx,ny,nz), fx
c
      fx = 0.5*(f(i+1,j,k)-f(i-1,j,k))/dx
c
      return
      end
c
c******************************************************************************
c
      subroutine second_center_y(nx,ny,nz,i,j,k,dy,f,fy)
c
      implicit none
c
      integer nx, ny, nz, i, j, k
      real dy, f(nx,ny,nz), fy
c
      fy = 0.5*(f(i,j+1,k)-f(i,j-1,k))/dy
c
      return
      end
c
c******************************************************************************
c
      subroutine second_center_z(nx,ny,nz,i,j,k,dz,f,fz)
c
      implicit none
c
      integer nx, ny, nz, i, j, k
      real dz, f(nx,ny,nz), fz
c
      fz = 0.5*(f(i,j,k+1)-f(i,j,k-1))/dz
c
      return
      end
c
c******************************************************************************
c
      subroutine fourth_forward_x(nx,ny,nz,i,j,k,dx,f,fx)
c
      implicit none
c
      integer nx, ny, nz, i, j, k
c
      real dx, f(nx,ny,nz), fx
c
      fx = (-25.*f(i,j,k)+48.*f(i+1,j,k)-36.*f(i+2,j,k)+16.*f(i+3,j,k)-
     &     3.*f(i+4,j,k))/(12.*dx)
c
      return
      end
c
c******************************************************************************
c
      subroutine fourth_backward_x(nx,ny,nz,i,j,k,dx,f,fx)
c
      implicit none
c
      integer nx, ny, nz, i, j, k
c
      real dx, f(nx,ny,nz), fx
c
      fx = (25.*f(i,j,k)-48.*f(i-1,j,k)+36.*f(i-2,j,k)-16.*f(i-3,j,k)+
     &     3.*f(i-4,j,k))/(12.*dx)
c
      return
      end
c
c******************************************************************************
c
      subroutine fourth_forward_y(nx,ny,nz,i,j,k,dy,f,fy)
c
      implicit none
c
      integer nx, ny, nz, i, j, k
c
      real dy, f(nx,ny,nz), fy
c
      fy = (-25.*f(i,j,k)+48.*f(i,j+1,k)-36.*f(i,j+2,k)+16.*f(i,j+3,k)-
     &     3.*f(i,j+4,k))/(12.*dy)
c
      return
      end
c
c******************************************************************************
c
      subroutine fourth_backward_y(nx,ny,nz,i,j,k,dy,f,fy)
c
      implicit none
c
      integer nx, ny, nz, i, j, k
c
      real dy, f(nx,ny,nz), fy
c
      fy = (25.*f(i,j,k)-48.*f(i,j-1,k)+36.*f(i,j-2,k)-16.*f(i,j-3,k)+
     &     3.*f(i,j-4,k))/(12.*dy)
c
      return
      end
c
c******************************************************************************
c
      subroutine fourth_forward_z(nx,ny,nz,i,j,k,dz,f,fz)
c
      implicit none
c
      integer nx, ny, nz, i, j, k
c
      real dz, f(nx,ny,nz), fz
c
      fz = (-25.*f(i,j,k)+48.*f(i,j,k+1)-36.*f(i,j,k+2)+16.*f(i,j,k+3)-
     &     3.*f(i,j,k+4))/(12.*dz)
c
      return
      end
c
c******************************************************************************
c
      subroutine fourth_backward_z(nx,ny,nz,i,j,k,dz,f,fz)
c
      implicit none
c
      integer nx, ny, nz, i, j, k
c
      real dz, f(nx,ny,nz), fz
c
      fz = (25.*f(i,j,k)-48.*f(i,j,k-1)+36.*f(i,j,k-2)-16.*f(i,j,k-3)+
     &     3.*f(i,j,k-4))/(12.*dz)
c
      return
      end
