! This program will read in a 3dhdf file an then output a 2d slice to Scivis
! Scott A. Klasky


program hdf2ser
implicit none
character*32                             :: name,fname   !name of hdf file
integer                                  :: level,lev    !iteration number
integer,dimension(:),allocatable         :: shp          !shape
character*32,dimension(:),allocatable    :: cnames       !names of x,y,z axis 
integer                                  :: rank         !rank of grid function
real*8                                   :: time         !Time 
real*8,dimension(:), allocatable         :: otime        !Output Time Array

real*8,dimension(:),allocatable          :: coords       !coordinate values
real*8,dimension(:,:,:),allocatable      :: gf           !Grid function
integer                                  :: orank        !Output rank
real*8,dimension(:),allocatable          :: ogf          !1D gf output function
real*8,dimension(:),allocatable          :: ogx1d,ogy1d  !1D gf output x,y funcs
integer,dimension(:),allocatable         :: nx,nxy
integer                                  :: error        !Error condition
integer                                  :: iter         !Time iterations
integer                                  :: line_type, xvalue, yvalue
integer                                  :: i,j,mem_loc
integer                                  :: java_mser2d,java_mser,java_ser2d
integer                                  :: gft_read_rank, gft_read_shape
integer                                  :: gft_read_full,indlnb

! First read in the hdf file name

	write(6,*) 'Input the hdf file name'
!	read(5,*) fname
	fname = 'Ham.3d.hdf'
   write(6,*) 'Input the output rank'
   read(5,*) orank

   if (orank.eq.1) then
			write(6,*) 'x,y,z line ?:(1,2,3)'
!			read(5,*) line_type
		line_type = 3
			if (line_type.lt.1.or.line_type.gt.3) then
				write(6,*) 'Invalid line type:',line_type
				stop
			end if
         write(6,*) 'i,j value of line'
!			read(5,*) xvalue,yvalue
			xvalue = 9
			yvalue = 9
	else if (orank.eq.2) then
         write(6,*) 'xy xz yz ?:(1,2,3)'
!         read(5,*) line_type
			line_type = 1
         if (line_type.lt.1.or.line_type.gt.3) then
            write(6,*) 'Invalid box type:',line_type
            stop
         end if
		   write(6,*) 'value of other paramter (i value)'
!			read(5,*) xvalue
xvalue = 9
	else
		write(6,*) 'Invalid output rank:',orank
		stop
	end if
	

!Now obtain the rank

! I can't get gft_read_rank to work, so I will just ask the user
!	error = gft_read_rank(fname(1:indlnb(fname)),1,rank)
	write(6,*) 'input rank of gf in hdf file'
!	read(5,*) rank
	rank = 3
   error = 1
   if (error.eq.0) then
		write(6,*) 'hdf2ser: Can not read rank for file:',fname(1:indlnb(fname))
		stop
	end if
	if (rank.gt.3.or.orank.gt.rank) then
		write(6,*) 'Problem with the rank,orank:',rank,orank
		stop
	end if
	allocate(shp(rank),cnames(rank))

! Now read in the shape
	error = gft_read_shape(fname(1:indlnb(fname)),1,shp)
	write(6,*) 'shape=',shp(1),shp(2),shp(3)
   if (error.eq.0) then
      write(6,*) 'hdf2ser: Can not read shape for file:',fname(1:indlnb(fname))
      stop
   end if

! now check to make sure the user is not asking for something out of the shape
	if (orank.eq.1) then
		if (line_type.eq.1) then !xvalue = y, yvalue=z
	      if (xvalue.lt.1.or.xvalue.gt.shp(2).or.                              &
             yvalue.lt.1.or.yvalue.gt.shp(3)) then
            write(6,*) 'input values are not in the bounding box',xvalue,yvalue
            stop
         end if 
		else if (line_type.eq.2) then !xvalue=x,yvalue=z
	      if (xvalue.lt.1.or.xvalue.gt.shp(1).or.                              &
             yvalue.lt.1.or.yvalue.gt.shp(3)) then
            write(6,*) 'input values are not in the bounding box',xvalue,yvalue
            stop
         end if 
		else
	      if (xvalue.lt.1.or.xvalue.gt.shp(1).or.                              &
             yvalue.lt.1.or.yvalue.gt.shp(2)) then
            write(6,*) 'input values are not in the bounding box',xvalue,yvalue
            stop
         end if 
		end if
	else if (orank.eq.2) then
		if (line_type.eq.1) then !xvalue = zvalue
			if (xvalue.lt.1.or.xvalue.gt.shp(3)) then
            write(6,*) 'input values are not in the bounding box',xvalue
            stop
			end if
		else if (line_type.eq.2) then !xvalue=yvalue
			if (xvalue.lt.1.or.xvalue.gt.shp(2)) then
            write(6,*) 'input values are not in the bounding box',xvalue
            stop
			end if
		else if (line_type.eq.3) then !xvalue=yvalue
			if (xvalue.lt.1.or.xvalue.gt.shp(1)) then
            write(6,*) 'input values are not in the bounding box',xvalue
            stop
			end if
		end if
	end if


! Now allocate the memory
	allocate(gf(shp(1),shp(2),shp(3)))
   allocate(coords(shp(1)+shp(2)+shp(3)))

! This will be stupid, but I need to know how many timesteps are in the
! file before I can output this to Scivis, since the output will be done
! in 1 call

!	error = 1
!	iter = 0
!	do while(error.ne.0)
!		error = gft_read_full(fname,level,shp,cnames,rank,time,coords,gf)
!		iter = iter + 1
!	end do
!	iter = iter - 1
!	if (iter.ne.level) then
!	   iter = level
!		write(6,*) 'iter,level=',iter,level
!	end if
	write(6,*) 'Total number of time iterations:'
	read(5,*) iter
	level = iter

! now get the memory for the output function
	if (orank.eq.1) then
		allocate(ogf(iter*shp(line_type)))
		allocate(ogx1d(iter*shp(line_type)))
	else if (orank.eq.2) then
		if (line_type.eq.1) then
			allocate(ogf(iter*shp(1)*shp(2)))
			allocate(ogx1d(iter*shp(1)*shp(2)))
			allocate(ogy1d(iter*shp(1)*shp(2)))
		else if (line_type.eq.2) then
			allocate(ogf(iter*shp(1)*shp(3)))
			allocate(ogx1d(iter*shp(1)*shp(3)))
			allocate(ogy1d(iter*shp(1)*shp(3)))
		else
			allocate(ogf(iter*shp(2)*shp(3)))
			allocate(ogx1d(iter*shp(2)*shp(3)))
			allocate(ogy1d(iter*shp(2)*shp(3)))
		end if
	else 
		write(6,*) 'output rank is not supported:',orank
		stop
	end if
	allocate(otime(iter),nx(iter),nxy(iter))

! Now loop on all of the times
	mem_loc = 0
	do level = 1 , iter
		lev = level
      error = gft_read_full(fname,lev,shp,cnames,rank,time,coords,gf)
		otime(level) = time
		if (error.eq.0) then
			write(6,*) 'only could read in',level,'time steps'
			stop
		end if

! transfer 3d grid function to 1d grid function

		if (orank.eq.2) then
			if (line_type.eq.1) then
				nxy(level) = shp(1)*shp(2)
				do i = 1, shp(1)
					do j = 1 , shp(2)
						mem_loc = mem_loc + 1
						ogf(mem_loc) = gf(i,j,xvalue)
						ogx1d(mem_loc) = coords(i)
						ogy1d(mem_loc) = coords(j)
					end do
				end do
			else if (line_type.eq.2) then
				nxy(level) = shp(1)*shp(3)
				do i = 1, shp(1)
					do j = 1 , shp(3)
						mem_loc = mem_loc + 1
						ogf(mem_loc) = gf(i,xvalue,j)
						ogx1d(mem_loc) = coords(i)
						ogy1d(mem_loc) = coords(j)
					end do
				end do
			else  !line_type=3
				nxy(level) = shp(2)*shp(3)
            do i = 1, shp(2)
               do j = 1 , shp(3)
                  mem_loc = mem_loc + 1                     
                  ogf(mem_loc) = gf(xvalue,i,j)
						ogx1d(mem_loc) = coords(i)
						ogy1d(mem_loc) = coords(j)
               end do
            end do
			end if
		else !orank.eq.1
			if(line_type.eq.1) then
				nx(level) = shp(1)
				do i = 1, shp(1)
					mem_loc = mem_loc + 1
					ogf(mem_loc) = gf(i,xvalue,yvalue)
					ogx1d(mem_loc) = coords(i)
				end do
			else if (line_type.eq.2) then
				nx(level) = shp(2)
				do i = 1, shp(2)
					mem_loc = mem_loc + 1
					ogf(mem_loc) = gf(xvalue,i,yvalue)
					ogx1d(mem_loc) = coords(i)
				end do
			else !line_type=3
				nx(level) = shp(3)
				do i = 1, shp(3)
					mem_loc = mem_loc + 1
					ogf(mem_loc) = gf(xvalue,yvalue,i)
					ogx1d(mem_loc) = coords(i)
				end do
			end if
		end if
	end do

! now we just output this into java_mser2d

	if (orank.eq.2) then

!	   if (line_type.eq.1) then
!	      error = java_mser2d(fname(1:indlnb(fname)),iter,otime,          &
!                             ogx1d,ogy1d,ogf,nxy)
!	   else if (line_type.eq.2) then
!	      error = java_mser2d(fname(1:indlnb(fname)),iter,otime,          &
!                             ogx1d,ogy1d,ogf,nxy) 
!	   else 
!	      error = java_mser2d(fname(1:indlnb(fname)),iter,otime,          &
!                             ogx1d,ogy1d,ogf,nxy) 
!	   end if

	else 
	   if (line_type.eq.1) then
	      error = java_mser(fname(1:indlnb(fname)),iter,otime,          &
                             ogx1d,ogf,nx) 
	   else if (line_type.eq.2) then
	      error = java_mser(fname(1:indlnb(fname)),iter,otime,          &
                             ogx1d,ogf,nx) 
	   else 
	      error = java_mser(fname(1:indlnb(fname)),iter,otime,          &
                             ogx1d,ogf,nx) 
		end if

	end if

	stop
	end
