#include      <string.h>

int java_ser(char *name, double time, double *x, double *y, double *fxy, int n);

#define        MAX_NPAIR      1000000
#define        MAX_LABEL      256

main(int argc,char **argv) {
   double    x[MAX_NPAIR],    y[MAX_NPAIR],    fxy[MAX_NPAIR];
   char     *label;
   int       i,               wt, rc;

   int       verbose = 0;

   double    ltime;

   if( argc > 2 ) {
      printf("usage: %s <list of xyz triplets>.\n",argv[0]);
      exit(-1);
   }
   if( argc > 1 ) {
      label = argv[1];
   } else {
      label = (char *) malloc(MAX_LABEL * sizeof(char));
      label = strcpy(label,"Standard input");
   }
   for( i = 0; scanf("%lf %lf %lf",x+i,y+i,fxy+i) == 3;i++ ) {
		/*printf(" ");*/
      if( i == MAX_NPAIR ) {
         printf("%s:: Internal buffer full, possible loss of data.\n",argv[0]);
         goto full;
      }
   }
full:
   if( i == 0 ) {
      printf("%s:: Null input.\n",argv[0]);
   } else {
      if( verbose ) {
         printf("%s:: %d pairs read.\n",argv[0],i);
      }
      if( (rc = java_ser2d(label,0.0,x,y,fxy,i)) ) {
         printf("%s:: Could not transmit to server ...\n",argv[0]);
      }
   }
   exit(0);
}
