c
c     string load with character.
c
      subroutine sload(s,c)

         implicit       logical (a-z)

         character*(*)  s
         character*1    c

         integer        i

         do 10 i = 1 , len(s)
            s(i:i) = c
 10      continue

         return

      end

C-----------------------------------------------------------------------
C
C     Returns index of last non-blank character in S.
C
C-----------------------------------------------------------------------
C
      INTEGER FUNCTION INDLNB(S)
C
         CHARACTER*(*)    S
         INTEGER          I
C
         DO 10 INDLNB = LEN(S) , 1 , -1
            IF( S(INDLNB:INDLNB) .NE. ' ' ) RETURN
 10      CONTINUE
         INDLNB = 0
C
         RETURN
C
      END


c---------------------------------------------------------------------
c
c     Vector minimum.
c
c---------------------------------------------------------------------
c
      integer function ivmin(v1,n)
c
         integer     min0
         integer     v1(1)
         integer     i, n
c
         ivmin = v1(1)
         do 10 i = 2 , n
            ivmin = min0(ivmin,v1(i))
 10      continue
c
         return
c
			end
c
c---------------------------------------------------------------------
c
c     Vector maximum.
c
c---------------------------------------------------------------------
c
		integer function ivmax(v1,n)
c
         integer     max0
         integer     v1(1)
         integer     i, n
c
         ivmax = v1(1)
         do 10 i = 2 , n
            ivmax = max0(ivmax,v1(i))
 10      continue
c
         return
c
      end
c


---------------------------------------------------------------------
c
c     Returns maximum deviation between two vectors relativized
c     by maximum l-inf norm.
c
c---------------------------------------------------------------------

      double precision function dvmaxrd(v1,v2,n)

         implicit        none

         real*8          dvlinf

         integer         n
         real*8          v1(n),         v2(n)

         real*8          nrmv12,        nrmdev

         integer         i

         logical         ltrace
         parameter     ( ltrace = .false. )
         if( n .gt. 1 ) then
            nrmv12 = max(dvlinf(v1,n),dvlinf(v2,n))
            nrmdev = abs(v1(1) - v2(1))
            do i = 2 , n
               nrmdev = max(nrmdev,abs(v1(i) - v2(i)))
            end do
            if( nrmv12 .eq. 0.0d0 ) then
               dvmaxrd = nrmdev
            else
               dvmaxrd = nrmdev / nrmv12
            end if
         else
            dvmaxrd = 0.0d0
         end if
  
         if( ltrace ) then
            write(0,*) 'dvmaxrd: Returning ', dvmaxrd
         end if

         return

      end

c-----------------------------------------------------------------------
c
c     "l-inifinity" norm of V.
c
c-----------------------------------------------------------------------
c
      double precision function dvlinf(v,n)
c
         real*8     v(1), dabsvi
         integer    n
c
         dvlinf = abs(v(1))
         do 10 i = 2 , n
            dabsvi = abs(v(i))
            if( dabsvi .gt. dvlinf ) dvlinf = dabsvi
 10      continue
c
         return
c
      end

