c-----------------------------------------------------------------------
c     Creates RNPL-style .hdf file from data in server window
c
c     Note: RNPL .hdf file can only store single set of x-coordinates.
c-----------------------------------------------------------------------

      program       vs2hdf
 	
		implicit      none

		real*8        dvmaxrd
      integer       indlnb,      vsgxynall,      iargc,
     *              ivmin,       ivmax,
     *              gft_write_full
      integer       gft_rc,      nindex_out
      integer       shape(1),    p

      character*64  name

      integer       max_xy
      parameter   ( max_xy = 1 500 000 )

      integer       max_ngroup
      parameter   ( max_ngroup = 100 000 )
      real*8        x(max_xy),   y(max_xy),      time(max_ngroup) 
      integer       n(max_ngroup)

      integer       nf
      parameter   ( nf = 1 )
      character*1   cnames(1)
      character*24  segname

      integer       it
 
      real*8        fuzz
		parameter   ( fuzz = 1.0d-6 )

      logical       ltrace
      parameter   ( ltrace = .false. )

      if( iargc() .lt. 1 ) go to 900
      call sload(name,' ')
      call getarg(1,name)

c-----------------------------------------------------------------------
c     vsgxynall retrieves all data from window 'name' and returns 
c     the number of time groups stored.
c-----------------------------------------------------------------------
      nindex_out = vsgxynall(name,x,y,n,time)

      if( nindex_out .gt. 0 ) then
c-----------------------------------------------------------------------
c        Check that spatial coordinates define a single lattice
c-----------------------------------------------------------------------
			if( ivmin(n,nindex_out) .ne. ivmax(n,nindex_out) ) go to 950
			p = n(1) + 1
         do it = 2 , nindex_out
				if( dvmaxrd(x(1),x(p),n(it)) .gt. fuzz ) go to 950
				p = p + n(it)
			end do

c-----------------------------------------------------------------------
c        Write the .hdf file using the RNPL/BBHTUIL interface
c-----------------------------------------------------------------------
         p = 1
         cnames(1) = 'x'
         do it = 1 , nindex_out
            shape(1) = n(it)
             gft_rc = gft_write_full(name,time(it),
     *                  shape,cnames,1,x(p),y(p))
            p = p + n(it)
         end do
      else 
         write(0,*) 'vs2hdf: Can not extract data from window <'//
     *              name(1:indlnb(name))//'>'
      end if

      stop

900   continue
         write(0,*) 'usage: vs2hdf <window name>'
      stop

950   continue
         write(0,*) 'vstohdf: Can only store fixed-grid function'
		stop

      end
