C-----------------------------------------------------------------------
C
C     History: s2s, ss
C
C     Sends data to server using vsmxy1 ... intention is to have 
C     same functionality as s2s but speedier ... 
C
C     Only plots one function per invocation, uses open by name 
C     mechanism and name from segdat file.
C
C     Modified to take stride argument; send only every stride'th
C     spatial value ...
C
C-----------------------------------------------------------------------
C
      IMPLICIT         NONE              
C
      INTEGER          vsmxynt,                 i4arg

C
      INTEGER          INDLNB,                  IRDIVN,
     *                 IARGC
      LOGICAL          ONEDOT,                  QUERY
C
      CHARACTER*128    FS,                      CS1
      LOGICAL          P4FS,                    P4CS1
C
      CHARACTER*80     FMT
      CHARACTER*128    LFNAME
      INTEGER          LNB
C
      INTEGER          MAX_NVEC
      PARAMETER      ( MAX_NVEC = 100 000 )
      INTEGER          IVEC 
      INTEGER          START(MAX_NVEC + 1)

      REAL*8           TIME(MAX_NVEC)
      INTEGER          TAG(MAX_NVEC)
C
      INTEGER          MAXNF
      PARAMETER      ( MAXNF = 100 )
C
      INTEGER          MAX_NEVENT
      PARAMETER      ( MAX_NEVENT = 1 800 000 )
      INTEGER          MAX_NR
		PARAMETER      ( MAX_NR = 100 000 )
      REAL*8           X(MAX_NEVENT),           Y(MAX_NEVENT)
	   REAL*8           READX(MAX_NR),           READY(MAX_NR)
C
      CHARACTER*16     FNAME(MAXNF)
C
      INTEGER          IOTA(MAXNF),   FIV(MAXNF),
     *                 TIV(MAX_NVEC), nx(max_nvec)
C
      INTEGER          UDATA,         ULIST,       USER,
     *                 COMPAR,        UOUT
      PARAMETER      ( UDATA = 11,    ULIST = 4,   USER = 6,
     *                 COMPAR = 2)    
C
      REAL*8           TTIME
C
      INTEGER          GROUP, IF, IFCN, ISKIP, IT, J, LFIV, LTIV,
     *                 NFCN, NT, PRSKIP(MAXNF), PSSKIP, SKIP, 
     *                 READNR, TNR, NROUT, IX, total_points
      INTEGER          NVEC
C
C     PAR_NAME overrides FNAME (kludge to avoid window collision 
C     with query by name.
C
      INTEGER        NARG,     LARG
      CHARACTER*1024 ARGI,     PGNAME,     INCDNM,
     *               PAR_NAME
C
      INTEGER        PAR_IF,   PAR_IT
      LOGICAL        P4F,      P4T,        NAME_FROM_SEGDAT
C
      INTEGER        STRIDE
C
      INTEGER        RC

      INTEGER        MAX_WT
      PARAMETER    ( MAX_WT = 10 )
      INTEGER        WT(MAX_WT)
      integer        lastiv

      logical        auto_thin

      integer        warn_freq
      parameter    ( warn_freq = 10 )
      integer        loop


      integer        trace
      parameter    ( trace = 0 )

		logical        ltrace 
		parameter    ( ltrace = .false. )


		integer java_ser, java_fser, java_mser
		integer ipause
      parameter (ipause = 100)
! we must pause every 100 time iterations since we can send too much data
      
      do 5 if = 1 , maxnf
         call sload(fname(if),' ') 
 5    continue
C
C     Command line parsing ...
C
      NARG = IARGC()
      CALL GETARG(0,PGNAME)
      IF( NARG .LT. 1 ) THEN
         GO TO 999
      ELSE
         CALL GETARG(1,INCDNM)
         IF( onedot(incdnm) ) then
            CALL GETENV('CODE',INCDNM)
            IF( INCDNM .EQ. ' ' ) THEN
               WRITE(*,*) PGNAME(1:INDLNB(PGNAME)),
     *              ': CODE environment variable unset.'
               STOP
            END IF
         END IF
      END IF

      p4fs = narg .lt. 2
      if( .not. p4fs ) then
         call getarg(2,fs)
         if( onedot(fs) ) then
            fs = '1-*'
         else if( query(fs) ) then
            p4fs = .true.
         end if
      end if

      p4cs1 = narg .lt. 3 
      if( .not. p4cs1 ) then
         call getarg(3,cs1)
         if( onedot(cs1) ) then
            cs1 = '1-*'
         else if( query(fs) ) then
            p4cs1 = .true. 
         end if
      end if

      if( narg .ge. 4 ) then
         name_from_segdat = .false.
         call getarg(4,par_name)
			if( onedot(par_name) ) then
				name_from_segdat = .true. 
			else 
            write(*,*) PGNAME(1:INDLNB(PGNAME))//' will label '//
     *                 'as '//PAR_NAME(1:INDLNB(PAR_NAME))//'.'
			end if
      else 
         name_from_segdat = .true.
      end if

		stride = 1
		if( narg .ge. 5 ) then
			stride = i4arg(5,1)
			if( stride .le. 0 ) then
				stride = 1
			end if
		end if
		if( ltrace ) then
			write(0,*) 'nss: stride = ', stride
		end if
C
C     Open data file ...
C
      CALL MYOPEN(UDATA,INCDNM(1:INDLNB(INCDNM))//'.segdat',
     *            'OLD',1,0,0,RC)
      IF( RC .NE. 0 ) THEN
C
C        Try something else ...
C
         CALL MYOPEN(UDATA,'/d'//INCDNM(1:INDLNB(INCDNM))//'.segdat',
     *               'OLD',1,0,0,RC)
         IF( RC .NE. 0 ) THEN
C
C           One more thing ...
C
            IF( INDEX(INCDNM,'.') .NE. 0 ) THEN
               CALL MYOPEN(UDATA,INCDNM(1:INDLNB(INCDNM)),'OLD',
     *                     1,0,0,RC)
               IF( RC .NE. 0 ) THEN
                  CALL nerr1(PGNAME,'Error opening .segdat file.')
               END IF
            ELSE 
               CALL nerr1(PGNAME,'Error opening .segdat file.')
            END IF
         ELSE
            WRITE(*,*) PGNAME(1:INDLNB(PGNAME))//
     *                 ': '//'/d'//INCDNM(1:INDLNB(INCDNM))//
     *                 '.segdat opened.'
         END IF
      END IF
C
      READ(UDATA) NFCN
      READ(UDATA) ( FNAME(IFCN) , IFCN = 1 , NFCN )
C
C     Prompt user for functions to be plotted if necessary.
C
      if( p4fs ) then
         CALL IVRAMP(IOTA,1,1,NFCN)
         WRITE(USER,1000) ( IOTA(IFCN) , FNAME(IFCN) , IFCN = 1 , NFCN )
1000     FORMAT(' The following functions are stored:'//
     *          (3(I3,' : ',A)))
         WRITE(USER,*)
         CALL INPTIV(FIV,LFIV,MAXNF,NFCN,' ',USER)
C
C        ... but ignore everything but the first element of selection
C        vector ...
C
         lfiv = 1
      else
         if( irdivn(fiv,lfiv,maxnf,1,nfcn,fs) .lt. -1 ) then
            write(*,*) PGNAME(1:INDLNB(PGNAME))//': '//
     *                  'Error parsing <f iv>: '//
     *                  fs(1:indlnb(fs))//'.'
            go to 999
         end if
      end if
C
C     Get window tags.  
C
      call sload(lfname,' ')
      do 80 if = 1 , lfiv 
         if( name_from_segdat ) then
            write(lfname,8000) fname(fiv(if))
8000        format(a)
         else 
            write(lfname,8000) par_name(1:indlnb(par_name))
         end if

 80   continue
C
      nt = 0
 100  continue
      read(udata,end=400,err=350) ttime,   tnr
         nt = nt + 1
         time(nt) = ttime
         read(udata,end=300,err=300)
         do 200 ifcn = 1 , nfcn
            read(udata,end=300,err=300)
 200     continue
      go to 100
 300  continue
         WRITE(USER,*) 'nss: Unexpected error/end-of-file.'
         nt = nt - 1
      go to 400
 350  continue
         write(user,*) 'nss: Unexpected error/end-of-file.'
      go to 400
 400  continue
      if( nt .le. 0 ) then
         call nerr1('nss','No data in .segdat file.')
      end if
C
C     Prompt user for plotting times if necessary.
C
      if( p4cs1 ) then
         CALL INPTIV(TIV,LTIV,MAX_NVEC,NT,' temporal indices ',USER)
      else
         if( irdivn(tiv,ltiv,MAX_NVEC,1,nt,cs1) .lt. -1 ) then
            write(*,*) PGNAME(1:INDLNB(PGNAME))//': '//
     *                  'Error parsing <t iv>: '//
     *                  cs1(1:indlnb(cs1))//'.'
            go to 999
         end if
      end if
c
c     ... and the PRSKIP, PSSKIP arrays ...
c
      lastiv = 0
      do 555 if = 1 , lfiv 
         prskip(if) = fiv(if) - lastiv - 1
         lastiv = fiv(if)
 555  continue
      psskip = nfcn - fiv(lfiv)

C
C     Do the transmission.
C
C
C
      REWIND UDATA
      READ(UDATA)
      READ(UDATA)
C
      total_points = 0
      GROUP = 1
      START(1) = 1
      DO 575 IT = 1 , LTIV
         CALL USKIP(UDATA,(2 + NFCN) * (TIV(IT) - GROUP))
         READ(UDATA) TIME(IT), READNR
         TNR = 1 + (READNR - 1) / STRIDE
         total_points = total_points + tnr
c 
c        Check for internal array overflow ...
c
			if( (start(it) + tnr) .gt. MAX_NEVENT ) then
				call err2('nss','Internal array overflow: '//
     &                'transmitting partial data')
				nvec = it - 1
            go to 600
			end if

			IF( LTRACE ) THEN
				write(0,*) it, readnr, '->', tnr
			END IF

         READ(UDATA) ( READX(J) , J = 1 , READNR )
         do 560 if = 1 , lfiv 
            CALL USKIP(UDATA,PRSKIP(if))
            READ(UDATA) ( READY(J) , J = 1 , READNR )
 560     continue

! now print out the data here.....
!         rc =  java_fser(
!     .         lfname(1:indlnb(lfname)),time(it),readx,ready,readnr)


!			if (rc.ne.0) then
! 			if (mod(it,10).eq.0) then
!				call ssleep()
!
!			end if
				
			call dvinj(READX,X(START(IT)),STRIDE,READNR)
			call dvinj(READY,Y(START(IT)),STRIDE,READNR)
         call uskip(udata,psskip)
         group = tiv(it) + 1
         start(it + 1) = start(it) + tnr
			nx(it) = readnr
 575  continue

		nvec = ltiv
 600  continue

		write(6,*) 'calling java_mser'
		write(6,*) 'number of time steps=',LTIV
		write(6,*) 'total number of points=',total_points
		write(6,*) lfname(1:indlnb(lfname))
!		do  it = 1 , ltiv
!			do ix = 1 , readnr
!				write(6,*) x(ix+(it-1)*readnr),y(ix+(it-1)*readnr)
!			end do
!		end do

       rc = java_mser(lfname(1:indlnb(lfname)),LTIV,time,x,y,nx)
!      This line transmit the data to the server ......
!      rc = vsmxynt(lfname(1:indlnb(lfname)),start,time,nvec,x,y)
!      if( rc .lt. 0 ) then
!         call err2('nss','Could not transmit data to server.')
!      end if

      STOP

 999  CONTINUE
         WRITE(*,*) 'usage: '//PGNAME(1:INDLNB(PGNAME))//
     *              ' <segdat file> [<fcn index>] [<tiv>] '//
     *              '[<name>] [<stride>]'
      STOP
C
      END
