/*
 * sv2 api header file                       
 */


/* Include files which define SEEK_SET, O_RD_ONLY, etc. */
/* and prototype open(), close(), lseek(), etc. */
#include <unistd.h>
#include <fcntl.h>


/**********************************************************************
 * Functions to do binary I/O of floats, ints, etc. with byte swapping
 * as needed.
 **********************************************************************/

extern void flip4(unsigned int *src, unsigned int *dest, int n);

extern int read_int4(int f, int *i);
extern int read_float4(int f, float *x);
extern int write_int4(int f, int i);
extern int write_float4(int f, float x);

/* initialize the socket to the server
extern int initialize();

/**********************************************************************
 * Real sv2 apis. Users only need the following functions
 **********************************************************************/

extern int sv2_ser_(char *name, double *time, \
                  double x[], double fx[], int *nx);

extern int sv2_mser_(char *name, int *nt, double time[], \
                  double x[], double fx[], int nx[]);

extern int sv2_bbser_(char *name, double *time, \
                  double bb[], int *nx, double fx[]);

extern int sv2_bbmser_(char *name, int *nt, double time[], \
                  double bb[][2], int nx[], double fx[]);

extern int sv2_ser2d_(char *name, double *time, \
                  double x[], double y[], double fxy[], int *nx);

extern int sv2_mser2d_(char *name, int *nt, double time[], \
                  double x[], double y[], double fxy[], int nx[]);

extern int sv2_bbser2d_(char *name, double *time, \
                  double bb[], int *nx, int *ny, double fxy[]);

extern int sv2_bbmser2d_(char *name, int *nt, double time[], \
                  double bb[][4], int nx[], int ny[], double fxy[]);

extern int sv2_ser3d_(char *name, double *time, \
                  int *nx, int *ny, int *nz, double grid[]);

extern int sv2_mser3d_(char *name, int *nt, double time[], \
                  int nx[], int ny[], int nz[], double grid[]);
