#include <stdio.h>
#include "java_ser.h"

test_java_ser() {
   char *name = "test";
   double time = 10.0;
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0 };
   java_ser(name, time, x, fx, 5);
}

test_java_mser() {      
   char *name = "test";
   int nt = 2;
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                         0.0, 1.0, 2.0, 3.0, 4.00009 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                          5.0, 4.0, 3.0, 2.0, 2.0, };
   static int nx[] = { 5, 5 };
   java_mser(name, nt, time, x, fx, nx);
}

test_java_ser2d() {
   char *name = "test";
   double time = 10.0;
   static double x[] = { 0.0, 0.0, 0.0, 1.0, 1.0, 1.0 };
   static double y[] = { 0.0, 1.0, 2.0, 0.0, 1.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   java_ser2d(name, time, x, y, fx, 6);
}

test_java_mser2d() {      
   char *name = "test";
   int nt = 2;
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 0.0, 0.0, 1.0, 1.0, 1.0,
                         0.0, 0.0, 0.0, 1.0, 1.0, 1.0 };
   static double y[] = { 0.0, 1.0, 2.0, 0.0, 1.0, 2.0,
                         0.0, 1.0, 2.0, 0.0, 1.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 
                          6.0, 5.0, 4.0, 3.0, 2.0, 2.0, };
   static int nx[] = { 6, 6 };
   java_mser2d(name, nt, time, x, y, fx, nx);
}

test_java_bser2d() {
   char *name = "test";
   double time = 10.0;
   static double x[] = { 0.0, 1.0 };
   static double y[] = { 0.0, 1.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   java_bser2d(name, time, x, 2, y, 3, fx);
   
}

test_java_bmser2d() {
   char *name = "test";
   static double time[] = { 1.0,  2.0 };
   static double x[] = { 0.0, 1.0, 0.0, 1.0, 2.0 };
   static int nx[] = { 2, 3 };
   static double y[] = { 0.0, 1.0, 2.0, 0.0, 1.0, 2.0 };
   static int ny[] = { 3, 3 };
   static double fxy[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0,
        1.0, 2.0, 3.0, 4.0, 5.0, 1.0, 1.0, 2.0, 3.0  };
   java_bmser2d(name, 2, time, x, nx, y, ny, fxy);
}

test_java_bbser2d() {
   char *name = "test";
   double time = 10.0;
   static double bb[] = { 0.0, 1.0, 0.0, 2.0 };
   static double fxy[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   java_bbser2d(name, time, bb, 2, 3, fxy);
   
}

test_java_bbmser2d() {
   char *name = "test";
   static double time[] = { 1.0,  2.0 };
   static double bb[][4] = { 0.0, 1.0, 0.0, 2.0, 0.0, 1.0, 0.0, 2.0 };
   static int nx[] = { 2, 3 };
   static int ny[] = { 3, 3 };
   static double fxy[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0,
        1.0, 2.0, 3.0, 4.0, 5.0, 1.0, 1.0, 2.0, 3.0  };
   java_bbmser2d(name, 2, time, bb, nx, ny, fxy);
}

test_java_vser() {
   char *name = "test";
   double time = 10.0;
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0 };
   static double y[] = { 0.0, 1.0, 2.0, 1.0, 2.0, 3.0 };
   static double r[] = { 1.0, 2.0, 1.0, 1.0, 2.0, 1.0 };
   static double t[] = { 2.0, 2.0, 3.0, 2.0, 2.0, 3.0 };
   java_vser(name, time, x, y, r, t, 6);
   
}

test_java_vmser() {
   char *name = "test";
   static double time[] = { 1.0, 2.0 };
   static double x[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                         1.0, 2.0, 3.0, 4.0, 5.0 };
   static double y[] = { 0.0, 1.0, 2.0, 1.0, 2.0, 3.0,
                         1.0, 2.0, 1.0, 2.0, 3.0, 4.0 };
   static double r[] = { 1.0, 2.0, 1.0, 1.0, 2.0, 1.0,
                         1.0, 2.0, 1.0, 1.0, 2.0, 1.0 };
   static double t[] = { 2.0, 2.0, 3.0, 2.0, 2.0, 3.0,
                         1.0, 1.0, 1.0, 1.0, 1.0, 1.0 };
   static int nx[] = { 6, 6 };
   java_vmser(name, 2, time, x, y, r, t, nx);
   
}

test_java_bbser() {
   char *name = "test";
   double time = 10.0;
   static double bb[] = { 0.0, 2.0 };
   static double fx[] = { 1.0, 2.0, 3.0};
   java_bbser(name, time, bb, 3, fx);
   
}

test_java_bbmser() {
   char *name = "test";
   static double time[] = { 1.0,  2.0 };
   static double bb[][4] = { 0.0, 2.0, 0.0, 2.0 };
   static int nx[] = { 3, 3 };
   static double fx[] = { 1.0, 2.0, 3.0, 4.0, 5.0, 1.0 };
   java_bbmser(name, 2, time, bb, nx, fx);
}

test_java_pser() {
   char *name = "test";
   double time = 10.0;

   static double x1[] = { 0.0, 1.0, 2.0, 3.0, 4.0 };
   static double fx1[] = { 1.0, 2.0, 3.0, 4.0, 5.0 };
   static double x2[] = { 4.0, 5.0, 6.0, 7.0, 8.0 };
   static double fx2[] = { 1.0, 2.0, 3.0, 4.0, 5.0 };

   java_pser(name, time, x1, fx1, 5, 2);

   /* Uncomment next line means that each processor calculates each time data.
    * Otherwise, each processor calculates some parts of the time data
    */
   /* time = 20.0; */
   java_pser(name, time, x2, fx2, 5, 2);
}

test_java_pser2d() {
   char *name = "test";
   double time = 10.0;

   /* each processor produce 3 x 5 data set */
   static double x1[] = { 0.0, 0.0, 0.0, 0.0, 0.0,
                          1.0, 1.0, 1.0, 1.0, 1.0,
                          2.0, 2.0, 2.0, 2.0, 2.0, };
   static double y1[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                          0.0, 1.0, 2.0, 3.0, 4.0,
                          0.0, 1.0, 2.0, 3.0, 4.0  };
   static double fxy1[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                            1.0, 2.0, 3.0, 3.0, 3.0,
                            1.0, 2.0, 3.0, 4.0, 5.0 };

   static double x2[] = { 2.0, 2.0, 2.0, 2.0, 2.0,
                          3.0, 3.0, 3.0, 3.0, 3.0,
                          4.0, 4.0, 4.0, 4.0, 4.0 };
   static double y2[] = { 0.0, 1.0, 2.0, 3.0, 4.0,
                          0.0, 1.0, 2.0, 3.0, 4.0,
                          0.0, 1.0, 2.0, 3.0, 4.0  };
   static double fxy2[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                            2.0, 2.0, 2.0, 1.0, 1.0,
                            1.0, 2.0, 2.0, 2.0, 3.0 };

   java_pser2d(name, time, x1, y1, fxy1, 15, 2);

   /* Uncomment next line means that each processor calculates each time data.
    * Otherwise, each processor calculates some parts of the time data
    */
   /* time = 20.0; */
   java_pser2d(name, time, x2, y2, fxy2, 15, 2);
}


test_java_pbbser2d() {
   char *name = "test";
   double time = 10.0;
   static double bb1[] = { 0.0, 2.0, 0.0, 4.0 };
   static double bb2[] = { 2.0, 4.0, 0.0, 4.0 };
   
   static double fxy1[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                           1.0, 2.0, 3.0, 3.0, 3.0,
                           1.0, 2.0, 3.0, 4.0, 5.0 };
   static double fxy2[] = { 1.0, 2.0, 3.0, 4.0, 5.0,
                            2.0, 2.0, 2.0, 1.0, 1.0,
                            1.0, 2.0, 2.0, 2.0, 3.0 };
   java_pbbser2d(name, time, bb1, 3, 5, fxy1, 2);
   java_pbbser2d(name, time, bb2, 3, 5, fxy2, 2);
}


main() {
  /*
   test_java_ser();
   test_java_mser();
   test_java_ser2d();
   test_java_mser2d();
   test_java_bser2d();
   test_java_bmser2d();
   test_java_bbser2d();
   test_java_bbmser2d();
   test_java_vser();
   test_java_vmser();
   test_java_bbser();
   test_java_bbmser();
   test_java_pser();
   test_java_pser2d();
   */

   test_java_pbbser2d();
}




