		program wavedrive

		implicit none
	
		integer	nx, ny, nit

		parameter(nx = 33, ny = 33)

		integer	chr(nx,ny)

		real*8	anp(nx, ny), anm(nx, ny), an(nx, ny),
     .         bnp(nx, ny), bnm(nx, ny), bn(nx, ny),
     .         cnp(nx, ny), cnm(nx, ny), cn(nx, ny),
     .         phim(nx, ny), phip(nx,ny), phi(nx,ny),
     .			temp1(nx,ny), temp2(nx,ny), temp3(nx,ny)

		real*8	dt, h, width, ampl, time,stp, thres,
     .			xmin, xmax, ymin, ymax, vx, vy,cfl

		open(unit=1,file='wave2d.in')
			read(1,*)xmin,xmax
			read(1,*)ymin,ymax
			read(1,*)width
			read(1,*)ampl
			read(1,*)vx, vy
			read(1,*)cfl
			read(1,*)thres
		close(unit=1)

		h  = (xmax - xmin)/float(nx-1)
		dt = h * cfl

		stp = 1.0e-5
c		Set up initial data

		call initial(nx, ny, dt, h, width, ampl,
     .            vx, vy,xmin, xmax, ymin, ymax,
     .            an, bn, cn, phi)


c		call dumpdata(nx, ny, an, 'inita.dat')
c		call dumpdata(nx, ny, bn, 'initb.dat')
c		call dumpdata(nx, ny, cn, 'initc.dat')
c		call dumpdata(nx, ny, phi, 'initphi.dat')

c		Set up n=1 before initializing leapfrog

c		call initn1(nx, ny,  dt, h,xmin,ymin,vx, vy,width,ampl,
c     .            anp, anm, an, bnp, bnm, bn, cnp, cnm, cn,
c     .            phip, phim, phi)	
		call initstep(nx, ny, dt, h,stp, xmin,ymin,vx,vy,width,ampl,
     .            anp, anm, an, bnp, bnm, bn, cnp, cnm, cn,
     .            phip, phim, phi, temp1, temp2, temp3)

		time = 0.0
		do nit = 1, 50

			call bdyupdt2d(nx, ny, dt, h,
     .            anp, anm, an, bnp, bnm, bn, cnp, cnm, cn,
     .				phip, phim, phi)

			call leapfrog2d(nx, ny, dt, h,
     .            anp, anm, an, bnp, bnm, bn, cnp, cnm, cn)

			call updatephi(nx, ny, dt, h, an,bn,cn, phip, phim)
			call spaceavg(nx, ny, phip)
			call spaceavg(nx, ny, anp)
			call spaceavg(nx, ny, bnp)
			call spaceavg(nx, ny, cnp)
c			call secexpl(nx, ny, dt, h, phip,phim,phi)



			if(nit .ne. 50)then
			  call copy(nx, ny, an, anm)
			  call copy(nx, ny, bn, bnm)
			  call copy(nx, ny, cn, cnm)

			  call copy(nx, ny, phi, phim)

			  call swap(nx, ny, anp, an, temp1)
			  call swap(nx, ny, bnp, bn, temp1)
			  call swap(nx, ny, cnp, cn, temp1)

			  call swap(nx, ny, phip, phi, temp1)

c			  call charfunc(nx, ny, phi, chr, thres)

c		dump slices
			  call dumpnamedslice(nx, ny, nit, h, h,xmin,ymin,an, 'a')
			  call dumpnamedslice(nx, ny, nit, h, h,xmin,ymin,bn, 'b')
			  call dumpnamedslice(nx, ny, nit, h, h,xmin,ymin,cn, 'c')
			  call dumpnamedslice(nx, ny, nit, h,h, xmin,ymin,phip, 'p')
c			  call dumpnamedslicei(nx, ny, nit, h,h,xmin,ymin,chr, 'c')

			end if

		end do

c		call dumpdata(nx, ny, an, 'finala.dat')
c		call dumpdata(nx, ny, bn, 'finalb.dat')
c		call dumpdata(nx, ny, cn, 'finalc.dat')

c		call dumpdata(nx, ny, phip, 'finalphi.dat')


		stop
		end
