      program test
C test routines A-C
      implicit none
      integer nxmax,nymax,nzmax
      integer rank
      parameter ( nxmax = 129,nymax=129,nzmax=129)
      integer nxc,nyc,nzc
      integer nxf,nyf,nzf,nwksp
      parameter ( nwksp = 2 000 000 ) 

      real*8  uc(nxmax,nymax,nzmax),charmc(nxmax,nymax,nzmax)
      real*8  wksp(nwksp)
      real*8  xc(nxmax),yc(nymax),zc(nzmax)
      real*8  tempc(nxmax,nymax,nzmax)
      real*8  bbin(6),bbout(6)

      real*8  uf(nxmax,nymax,nzmax),charmf(nxmax,nymax,nzmax)
      real*8  xf(nxmax),yf(nymax),zf(nzmax)
      real*8  tempf(nxmax,nymax,nzmax)

      real*8  radius
      integer ierr,bbhinterp,ip,ip2,bbhintdgx1,bbhintdgx0,bbhintdgx2
      integer order,pil
      integer iargc, i4arg, fact, didit
      real*8  r8arg
      real*8 lx,ly,lz,lout,h,hf
      real*8 xfin(nxmax+nymax+nzmax)
      integer schxc,schyc,schzc
      integer schxf,schyf,schzf
      integer shape1c(3),shape2c(3),shape3c(3)
      integer shape1f(3),shape2f(3),shape3f(3)
      integer l,option
      integer workdgx0,workdgx1
      real*8  f5

      if (iargc().lt.1) then
         write(6,*) 'usage: test'//
     *       ' rank  n  rho  order   option radiusc  radiusf%' 
         stop
      end if

      rank = i4arg(1,3)
      nxc= i4arg(2,9)
      nyc= nxc
      nzc= nxc
      fact = i4arg(3,2)


      if (rank.eq.1) then
         nzc = 1
         nyc = 1
      else if (rank.eq.2) then
         nzc = 1
      end if

      nxf= fact*nxc - (fact-1) 
      nyf= fact*nyc - (fact-1) 
      nzf= fact*nzc - (fact-1) 

      if (nxf.gt.nxmax) then
         write(6,*) 'nx>nxmax'
         stop
      end if

      order = i4arg(4,2)
      option = i4arg(5,0)
      radius = r8arg(6,0.0d0)
      f5 = r8arg(7,1.0d0)

      write(6,*) 'input the bounding box on the coarse grid'//
     .           '(xmin,xmax,ymin,...'
		do l = 1 , 6
			bbin(l) = 0.0d0
			bbout(l) = 0.0d0
		end do

      do l = 1 , rank 
C         read(5,*)  bbin(2*l-1),bbin(2*l)
			 bbin(2*l-1) = -1.0d0
			 bbin(2*l)   =  1.0d0
			 bbout(2*l-1) =  -0.5d0
			 bbout(2*l)  =   0.5d0
      end do

      write(6,*) 'input the bounding box on the fine grid'//
     .           '(xmin,xmax,ymin,...'
      do l = 1 , rank 
C          read(5,*)  bbout(2*l-1),bbout(2*l)
      end do


C need nxf,nyf,nzf redefined

      h = ( bbin(2) - bbin(1) ) / ( nxc - 1 ) 
      hf= h  / fact

      nxf = (bbout(2) - bbout(1)) / hf + 1 
      nyf = nxf 
      nzf = nxf 
      nxf = (bbout(2) - bbout(1)) / hf +  1 


      call init(nxc,nyc,nzc,xc,yc,zc,nxf,nyf,nzf,xf,yf,zf,uc,uf,order,
     .          rank,bbin(1),bbin(2),bbout(1),bbout(2))

      call init_fine(nxf,nyf,nzf,xf,yf,zf,bbin,bbout,uf,order)

      call initcharm(nxc,nyc,nzc,xc,yc,zc,charmc,uc,radius,rank) 

      call initcharm(nxf,nyf,nzf,xf,yf,zf,charmf,uf,radius*f5,rank) 

      do l = 2 , 3
         bbin(2*l-1) = bbin(1)
         bbin(2*l) = bbin(2)
         bbout(2*l-1) = bbout(1)
         bbout(2*l) = bbout(2)
      end do

      shape1c(1) = nxc
      shape1c(2) = nyc
      shape1c(3) = nzc
      shape1f(1) = nxf
      shape1f(2) = nyf
      shape1f(3) = nzf

      shape2c(1) = nxc
      shape2c(2) = nyc
      shape2c(3) = nzc
      shape2f(1) = nxf
      shape2f(2) = nyf
      shape2f(3) = nzf

      shape3c(1) = 1
      shape3c(2) = 1
      shape3c(3) = 1
      shape3f(1) = 1
      shape3f(2) = 1
      shape3f(3) = 1

      if (radius.eq.(0.0d0)) then
         do ierr = 1 , 3
            shape2c(1) = 1
            shape2f(1) = 1
         end do
      end if

      ip2 = 0
      do ip = 1 , nxf
         ip2 = ip2 + 1
         xfin(ip2) = xf(ip)
      end do
      do ip = 1 , nxf
         ip2 = ip2 + 1
         xfin(ip2) = yf(ip)
      end do
      do ip = 1 , nxf
         ip2 = ip2 + 1
         xfin(ip2) = zf(ip)
      end do

      didit = 0

      write(6,*) 'wksp size=',nwksp

      if (radius.gt.(0.0d0)) then
         if (f5.eq.(1.0d0)) then
            write(6,*) 'The amount of workspace needed for routine=',
     .                 workdgx1(rank,shape1c,shape1f,bbin,bbout) 
            ierr = bbhintdgx1(rank,order,uc,uf,shape1c,shape1f,
     .                     bbin,bbout,wksp,nwksp,option,charmc,charmf)
         else 
            ierr = bbhintdgx2(rank,order,fact,uc,uf,shape1c,
     .                        charmc,charmf,wksp,nwksp)
         end if
      else
         write(6,*) 'The amount of workspace needed for routine=',
     .              workdgx0(rank,shape1c,shape1f,bbin,bbout) 
         ierr = bbhintdgx0(rank,order,uc,uf,shape1c,shape1f,
     .                     bbin,bbout,wksp,nwksp,option)
      end if

      if (ierr.eq.1) then
         write(6,*) 'problem in interpolation'
         stop
      end if

      call error(nxf,nyf,nzf,xf,yf,zf,charmf,uf,order,rank,bbout,option)


      stop
      end
C---------------------------------------------------------------
      subroutine init(nx,ny,nz,x,y,z,nxf,nyf,nzf,xf,yf,zf,u,uf,order,
     .                rank,xmin,xmax,xminf,xmaxf)
      implicit none
      integer nx,ny,nz,rank
      integer nxf,nyf,nzf
      real*8 x(nx),y(ny),z(nz)
      real*8 xf(nxf),yf(nyf),zf(nzf)
      integer order
      real*8 u(nx,ny,nz)
      real*8 uf(nxf,nyf,nzf)
      real*8 r,hx,hy,hz
      real*8 xmin,xmax,xminf,xmaxf

      integer i,j,k


      hx = (xmax-xmin)/(nx-1)
      if (ny.gt.1) then
         hy =(xmax-xmin)/(ny-1)
      else
         hy = 1.0d0
      end if
      if (nz.gt.1) then
         hz = (xmax-xmin)/(nz-1)
      else
         hz = 1.0d0
      end if

      do k = 1 , nz
         z(k) = xmin + hz*(k-1) 
      end do

      do i = 1 , nx
         x(i) = xmin + hx*(i-1) 
      end do

      do j = 1 , ny
         y(j) = xmin + hy*(j-1) 
      end do

      hx = (xmaxf-xminf)/(nxf-1)

      if (ny.gt.1) then
         hy = (xmaxf-xminf)/(nyf-1)
      else
         hy = 1.0d0
         y(1) = 0.0d0
      end if
      if (nz.gt.1) then
         hz = (xmaxf-xminf)/(nzf-1)
      else
         hz = 1.0d0
         z(1) = 0.0d0
      end if


      do k = 1 , nzf
         zf(k) = xminf + hz*(k-1)
      end do

      do i = 1 , nxf
         xf(i) = xminf + hx*(i-1)
      end do

      do j = 1 , nyf
         yf(j) = xminf + hy*(j-1)
      end do

      if (rank.eq.1) then
         nzf= 1
         nyf= 1
         zf(1) = 0.0d0
         yf(1) = 0.0d0
      else if (rank.eq.2) then
         nzf= 1
         zf(1) = 0.0d0
      end if

      do  k = 1 ,  nz
         do  j = 1 ,  ny
            do  i = 1 ,  nx
                  u(i,j,k)=(x(i)+y(j)+z(k))**(order-1)
            end do
        end do
      end do

      do k = 1 , nzf
         do j = 1 , nyf
            do i = 1 , nxf
               uf(i,j,k) = 0.0d0
            end do
         end do
      end do
      return
      end
C---------------------------------------------------------------------------
      subroutine  error(nx,ny,nz,x,y,z,charm,u,order,rank,bbout,option)
      implicit none
      integer nx,ny,nz,rank
      real*8 charm(nx,ny,nz),u(nx,ny,nz)
      real*8 x(nx),y(ny),z(nz)
      real*8 enorm,ans,err,ecount
      integer order
      real*8 bbout(6)
      real*8 small
      integer option
   
      parameter ( small = 1.0d-06 )

      integer i,j,k
      enorm = 0.0d0
      ecount = 0.0d0

      do k  = 1 , nz
         do j= 1 , ny
            do i = 1 , nx

               if (option.eq.1) then

                  if ((x(i).eq.bbout(1).or.x(i).eq.
     .                bbout(2)).or.(y(j).eq.bbout(3).
     .                               and.y(j).eq.bbout(4))
     .                .or.(z(k).eq.bbout(5).and.
     .                     z(k).eq.bbout(6)))   then
                     ans = charm(i,j,k)*(x(i)+y(j)+z(k))**(order-1)
                     err = charm(i,j,k)*abs(u(i,j,k) - ans)
                     if (err.ge.small) then 
                        write(80,88) x(i),y(j),z(k),u(i,j,k),ans,err
                     end if

                     enorm = enorm + err
                     ecount = ecount + 1
                  end if
               else
                     ans = charm(i,j,k)*(x(i)+y(j)+z(k))**(order-1)
                     err = charm(i,j,k)*abs(u(i,j,k) - ans)
                     if (err.ge.small) then
                        write(80,88) x(i),y(j),z(k),u(i,j,k),ans,err
                     end if

                     enorm = enorm + err
                     ecount = ecount + 1

               end if

            end do
         end do
      end do

88      format(1P,6e12.2)
      enorm = enorm/ecount

      write(6,*) 'error in function=',enorm,ecount

      return
      end
C---------------------------------------------------------------------------
      subroutine initcharm(nx,ny,nz,x,y,z,charm,u,radius,rank) 
      implicit none
      integer nx,ny,nz
      real*8 charm(nx,ny,nz),u(nx,ny,nz)
      real*8 radius,r
      real*8 x(nx),y(ny),z(nz)
      integer rank
   

      integer i,j,k

      do k = 1 , nz
         do j = 1 , ny
            do i = 1 , nx
               r= sqrt(x(i)**2+y(j)**2+z(k)**2)   
               if (r.ge.radius) then
                  charm(i,j,k) = 1.0d0
               else
                  charm(i,j,k) = 0.0d0
                  u(i,j,k) = -9.0d99
               end if
            end do
         end do
      end do

      return
		end
C---------------------------------------------------------------------------
      subroutine init_fine(nx,ny,nz,x,y,z,bbin,bbout,u,order)
      implicit none
		integer nx,ny,nz
		real*8  x(nx),y(ny),z(nz)
		real*8  bbin(6),bbout(6)
		real*8  u(nx,ny,nz)
		integer order
C this will set up u will the boundary boxes do not intersect

		integer i,j,k

		do k = 1 , nz
			do j = 1 , ny
				do i = 1 , nx

					if (
     .             x(i).ge.bbin (1).and.
     .             x(i).ge.bbout(1).and.
     .             x(i).le.bbin (2).and.
     .             x(i).le.bbout(2).and.
C
     .             y(j).ge.bbin (3).and.
     .             y(j).ge.bbout(3).and.
     .             y(j).le.bbin (4).and.
     .             y(j).le.bbout(4).and.
C
     .             z(k).ge.bbin (5).and.
     .             z(k).ge.bbout(5).and.
     .             z(k).le.bbin (6).and.
     .             z(k).le.bbout(6) ) then

						u(i,j,k) = -100.0d0
					else
						u(i,j,k) = (x(i)+y(j)+z(k))**(order-1)
					end if

				end do
			end do
		end do
		
      return
      end
