      program test9
      implicit none
      integer nxmax,nymax,nzmax,nxmaxp,nymaxp
      integer maxorder
		integer rank
      parameter ( maxorder = 9)
      parameter ( nxmax = 129,nymax=129,nzmax=129)
      parameter ( nxmaxp = 33,nymaxp=33) 
      integer nx,ny,nz
      real*8 u(nxmax,nymax,nzmax),charm(nxmax,nymax,nzmax)
      real*8 x(nxmax),y(nymax),z(nzmax)
      real*8 listx(nxmaxp*nymaxp)
      real*8 listy(nxmaxp*nymaxp)
      real*8 listz(nxmaxp*nymaxp)
		integer l,bbhintdlx0,bbhintdlx1,order,pil
      real*8 soln(nxmax*nymax),radius,srad
      integer ierr,dnlintxyzc,d2lintxyzc,d4lintxyzc,d5lintxyzc
      integer d4lintxyz,dnlintxyz
      integer dnlintxyzcd,d2lintxyzcd,d4lintxyzcd,d5lintxyzcd
		real*8 bigl(3*nxmaxp*nymaxp)
      integer iargc,i4arg,lc,lcount,shpin(3)
      real*8  r8arg,enorm,bbxin(6)

      if (iargc().lt.1) then
         write(6,*) 'usage: test9'//
     *       ' rank, n, order, radius, srad'
         stop
      end if

		rank= i4arg(1,3)
      nx = i4arg(2,33)
      ny = nx 
		if (rank.eq.3) then 
   	nz = nx 
		else
			nz = 1
		end if
      order = i4arg(3,4)
      radius = r8arg(4,0.5d0)
      srad = r8arg(5,0.52d0)
      call initl(rank,nx,ny,pil,listx,listy,listz,srad)
      call init(rank,nx,ny,nz,x,y,z,u,order)
      call initcharm(nx,ny,nz,x,y,z,charm,u,radius,srad)
		lcount = 0
		do l = 1 , pil
			lcount = lcount +1
			bigl(lcount) = listx(l)
		end do
		do l = 1 , pil
			lcount = lcount +1
			bigl(lcount) = listy(l)
		end do
		do l = 1 , pil
			lcount = lcount +1
			bigl(lcount) = listz(l)
		end do
		shpin(1) = nx
		shpin(2) = ny
		shpin(3) = nz

		if (rank.eq.3) then
		   bbxin(1) = x(1)
		   bbxin(2) = y(1)
		   bbxin(3) = z(1)
		   bbxin(4) = x(nx)
		   bbxin(5) = x(nx)
		   bbxin(6) = x(nx)
		else
			bbxin(1) = x(1)
		   bbxin(2) = y(1)
		   bbxin(3) = x(nx)
		   bbxin(4) = y(ny)
		end if
			
		if (radius.eq.(0.0d0)) then
		   ierr = bbhintdlx0(rank,order,u,bbxin,bigl,soln,shpin,pil)
		else
		   ierr = bbhintdlx1(rank,order,u,bbxin,bigl,soln,shpin,pil,charm)
		end if

		if (ierr.eq.1) then
			write(0,*) '*** error in bbhlintdlx0,1 routines'
			stop
		end if

      call error(pil,listx,listy,listz,soln,order,enorm)
		write(6,*) enorm

      stop
      end
C---------------------------------------------------------------
      subroutine init(rank,nx,ny,nz,x,y,z,u,order)
      implicit none
      integer nx,ny,nz,order
      real*8 x(nx),y(ny),z(nz),u(nx,ny,nz)
      real*8 r,hx,hy,hz,xmin,ymin,zmin
      integer i,j,k,rank

      xmin = -1.0d0
      ymin = -1.0d0
      zmin = -1.0d0
      hx = 2.0d0/(nx-1)
      hy = 2.0d0/(nx-1)
      hz = 2.0d0/(nx-1)
      do k = 1 , nz
         z(k) = zmin + hz*(k-1) 
      end do
		if (rank.eq.2) z(1) = 0.0d0
      do i = 1 , nx
         x(i) = xmin + hx*(i-1) 
      end do
      do j = 1 , ny
         y(j) = ymin + hy*(j-1) 
      end do
      do  k = 1 ,  nz
         do  j = 1 ,  ny
            do  i = 1 ,  nx
                  u(i,j,k)=(x(i)+y(j)+z(k))**(order-1)

            end do
        end do
      end do
      return
      end
C---------------------------------------------------------------------------
      subroutine initl(rank,nx,ny,pil,listx,listy,listz,srad)
      implicit none
      integer pil
      real*8 listx(65*65),listy(65*65),listz(65*65)
      real*8 srad,Pi
      integer nx,ny,rank
      real*8 theta,phi
      integer ntheta,nphi

      integer l,i,j,k

      pi = 4.0d0*atan(1.0d0)

      ntheta =17

		if (rank.eq.2) ntheta = 1
      nphi =  17 

      k =0
      do i = 1, NTHETA
         theta = (i-1)*(Pi / (NTHETA))
         do j = 1, NPHI
            phi = (j-1)*(Pi / (NPHI))
            k = k + 1
            listx(k) = srad*cos(phi)*cos(theta)
            listy(k) = srad*sin(phi)*cos(theta)
            listz(k) = srad*sin(theta)
C            write(20,'(1P,3e20.10)')listx(k),listy(k),listz(k)
         end do
      end do

      pil = k


      return
      end
C---------------------------------------------------------------------------
      subroutine error(pil,listx,listy,listz,soln,order,enorm)
      implicit none
      integer pil
      real*8 listx(pil),listy(pil),listz(pil),soln(pil)
      integer order
      real*8 ans,err,r
      real*8 enorm
      integer l

      enorm = 0.0d0
      do l  = 1 , pil
         ans=  (listx(l)+listy(l)+listz(l))**(order-1)
         err = abs(soln(l) - ans)
         enorm = enorm + err
      end do
12      format(i5,1P,6e12.3)
      enorm = enorm/pil

      return
      end
C---------------------------------------------------------------------------
      subroutine initcharm(nx,ny,nz,x,y,z,charm,u,radius,srad)
      implicit none
      integer nx,ny,nz
      real*8 charm(nx,ny,nz),u(nx,ny,nz)
      real*8 radius,r,srad
      real*8 x(nx),y(ny),z(nz)
      integer i,j,k

      do k = 1 , nz
         do j = 1 , ny
            do i = 1 , nx
               r= sqrt(x(i)**2+y(j)**2+z(k)**2)   
               if (r.ge.radius) then
                  charm(i,j,k) = 1.0d0
               else
                  charm(i,j,k) = 0.0d0
                  u(i,j,k) = -9.0d99
               end if
            end do
         end do
      end do

      return
      end
