      program testc
C test the curvilinear coordinate grid routines
      implicit none
      integer nx,ny,nz,nr,ntheta,nphi,order
      integer nxm,nym,nzm,nrm,nthetam,nphim
      parameter ( nxm = 129, nym = 129, nzm = 129,
     .            nrm = 129, nthetam = 129, nphim = 129 )

      real*8  x(nxm),y(nym),z(nzm),r(nrm),theta(nthetam),phi(nphim)
      real*8  u(nxm,nym,nzm),uc(nthetam,nrm,nphim)
      real*8  ch(nxm,nym,nzm)
      integer iargc, i4arg
      integer intcp2dc,ierr,didit,intcp2d,option
      real*8  r8arg,enorm,cerr,radius
      integer bbhintdgc0,bbhintdgc1

      integer polar,spherical,cylindrical
      external polar,spherical,cylindrical

      integer shpin(3),shpout(3),rank
      real*8 bbxin(6),bbcout(6)

      if (iargc().lt.1) then
         write(6,*) 'usage: testc'//
     *       ' nx, ny, nz, nr, ntheta, nphi, order, radius, option' 
         stop
      end if


      nx     = i4arg(1,17) 
      ny     = i4arg(2,nx) 
      nz     = i4arg(3,ny) 
      nr     = i4arg(4,nx)
      ntheta = i4arg(5,nr)
      nphi   = i4arg(6,nphi)
      order  = i4arg(7,2)
      radius = r8arg(8,0.5e0)
      option = i4arg(9,0)
      didit  = 0

      rank = 3
      
      if (nz.eq.1) rank = 2

      call init(nx,ny,nz,x,y,z,u,ch,radius,order)
      call initcc(nx,ny,nz,ntheta,nr,nphi,x,y,z,theta,r,phi,uc)

      shpin(1) = nx
      shpin(2) = ny
      shpin(3) = nz
      shpout(1) = ntheta 
      shpout(2) = nr 
      shpout(3) = nphi 


		if (rank.eq.3) then
         bbxin(1) = x(1)
         bbxin(2) = y(1)
         bbxin(3) = z(1)
         bbxin(4) = x(nx)
         bbxin(5) = y(ny)
         bbxin(6) = z(nz)
   
         bbcout(1) = theta(1)
         bbcout(2) = r(1)
         bbcout(3) = phi(1)
         bbcout(4) = theta(ntheta)
         bbcout(5) = r(nr)
         bbcout(6) = phi(nphi)
		else
         bbxin(1) = x(1)
         bbxin(2) = y(1)
         bbxin(3) = x(nx)
         bbxin(4) = y(ny)
   
         bbcout(1) = theta(1)
         bbcout(2) = r(1)
         bbcout(3) = theta(ntheta)
         bbcout(4) = r(nr)

		end if

      if (option.eq.0) then

         if (rank.eq.2) then
            ierr = bbhintdgc0(rank,order,u,uc,shpin,bbxin,bbcout,
     .                        shpout,polar)
         else
            ierr = bbhintdgc0(rank,order,u,uc,shpin,bbxin,bbcout,
     .                        shpout,spherical)
         end if

      else

         if (rank.eq.2) then
            ierr = bbhintdgc1(rank,order,u,uc,shpin,bbxin,bbcout,
     .                        shpout,polar,ch)
         else
            ierr = bbhintdgc1(rank,order,u,uc,shpin,bbxin,bbcout,
     .                        shpout,spherical,ch)
         end if

      end if

      if (ierr.eq.1) then
         write(6,*) '*** Error in routine ***'
         stop
      end if

      enorm = cerr(ntheta,nr,nphi,theta,r,phi,uc,order)

      write(6,*) nr,enorm

      stop
      end
C---------------------------------------------------------------
      subroutine init(nx,ny,nz,x,y,z,u,ch,rad,order)
      implicit none
      integer nx,ny,nz
      real*8 x(nx),y(ny),z(nz)
      real*8 ch(nx,ny,nz)
      real*8 rad
      integer order
      real*8 u(nx,ny,nz)
      real*8 r,hx,hy,hz,xmin,ymin,zmin

      integer i,j,k

      xmin = -1.0d0
      ymin = -1.0d0
      zmin = -1.0d0

      hx = 2.0d0/(nx-1)
      hy = 2.0d0/(ny-1)
      if (nz.gt.1) then
         hz = 2.0d0/(nz-1)
      else
         hz = 0.0d0
      end if

      open(87,file='out3.dat')

      do i = 1 , nx
         x(i) = xmin + hx*(i-1)
      end do

      do j = 1 , ny
         y(j) = ymin + hy*(j-1)
      end do

      do k = 1 , nz
         z(k) = zmin + hz*(k-1)
      end do

      if (nz.eq.1) z(1) = 0.0d0

      do  k = 1 ,  nz
         do  j = 1 ,  ny
            do  i = 1 ,  nx
               u(i,j,k)=( x(i) + y(j) + z(k) )**(order-1)
               r = sqrt ( x(i)**2 + y(j)**2 + z(k)**2 )
               if (r.ge.rad) then
                  ch(i,j,k) = 1.0d0
               else
                  ch(i,j,k) = 0.0d0
               end if
            end do 
         end do
      end do

      close(87)
      return
      end
C------------------------------------------------------------------------------
      subroutine initcc(nx,ny,nz,ntheta,nr,nphi,x,y,z,theta,r,phi,uc)
      implicit none
      integer nx,ny,nz,nr,ntheta,nphi
      real*8 x(nx),y(ny),z(nz),r(nr),theta(ntheta),phi(nphi)
      real*8 uc(ntheta,nr,nphi)

      integer i,j,k
      real*8 rmax,rmin,thetamax,thetamin,phimin,phimax,rc
      real*8 pi,tpi,hr,htheta,hphi

C find out the largest/smallest r
      rmax = sqrt(x(1)**2 + y(1)**2) 
      rmin = sqrt(x(1)**2 + y(1)**2) 

      do k = 1 , nz
         do j = 1 , ny
            do i = 1 , nx
               rc= sqrt(x(i)**2 + y(j)**2 + z(k)**2)
               if (rc.gt.rmax) rmax = rc
               if (rc.lt.rmin) rmin = rc
            end do
         end do
      end do

      rmax = min(x(nx),y(ny))

      pi = 4.0d0*atan(1.0d0)
      tpi = 2.0d0 * pi 
      thetamax = tpi
      thetamin = 0.0d0
      phimax = pi 
      phimin = 0.0d0

      hr        = (rmax-rmin)/(nr - 1)
      htheta    = (thetamax-thetamin)/(ntheta - 1)
		if (nz.gt.1) then
         hphi    = (phimax-phimin)/(nphi - 1)
		else
			hphi = 0.0d0
		end if

      do i = 1 , nr
         r(i) = rmin + hr*(i-1)
      end do

      do j = 1 , ntheta
         theta(j) = thetamin + htheta*(j-1)
      end do

      do k = 1 , nphi
         phi(k) = phimin + hphi*(k-1)
      end do

		if (nphi.eq.1) phi(1) = 0.0d0

      return
      end
C------------------------------------------------------------------------------
      real*8 function cerr(ntheta,nr,nphi,theta,r,phi,uc,order)
      integer nr,ntheta,nphi
      real*8 r(nr),theta(ntheta),phi(nphi)
      real*8 uc(ntheta,nr,nphi)
      integer order

      real*8 x,y,z,ans,error
      integer i,j,k

      err = 0.0d0
      do k = 1 , nphi
         do j = 1 , nr
            do i = 1 , ntheta
               x    = r(j)*cos(theta(i))*cos(phi(k))
               y    = r(j)*sin(theta(i))*cos(phi(k))
               z    = r(j)*sin(phi(k))

               ans  = (x+y+z)**(order-1) 

               error = abs( ans - uc(i,j,k) )
               err = err + error
            end do
         end do
      end do

66		format(6e12.2)
      cerr = err / nr / ntheta / nphi

      return
      end
