C wrapper routines for interps
C Case 1:
      integer function bbhintdgx0(rank,p,rho,uin,uout,shpin)
      implicit none
      integer rank, p
      integer rho
      real*8   uin(*),uout(*)
      integer shpin(rank)
      integer interps
      integer shpout(3)

      real*8 chin,chout,wkspc,wkspf
      real*8 xf,lx,ly,lz,lout,xc
      integer func,l

      do l = 1 , rank 
         shpout(l) = shpin(l)*rho -(rho-1)
			if (p.gt.shpin(l)-1.or.p.gt.12.or.p.lt.2) then
				bbhintdgx0 = 1
				return
			end if
      end do


      bbhintdgx0 = interps( rank,p,uin,uout,chin,chout,wkspc,wkspf,
     .                      xf,lx,ly,lz,lout,shpin,shpout,1,1,
     .                      1,1,1,1,0,1,xc,.false.,func)


      return
      end
C------------------------------------------------------------------------------
C Case 2:
      integer function bbhintdgx1(rank,p,rho,uin,uout,shpin,chin,chout)
      implicit none
      integer  rank, p
      integer  rho
      real*8   uin(*),uout(*)
      real*8   chin(*),chout(*)
      integer  shpin(rank)
      integer  interps
      integer  shpout(3)

      real*8    wkspc,wkspf
      real*8    xf,lx,ly,lz,lout,xc
      integer   func,l

      do l = 1 , rank
         shpout(l) = shpin(l)*rho-(rho-1)
         if (p.gt.shpin(l)-1.or.p.gt.12.or.p.lt.2) then
            bbhintdgx1 = 1
            return
         end if

      end do

      bbhintdgx1 = interps( rank,p,uin,uout,chin,chout,wkspc,wkspf,
     .                      xf,lx,ly,lz,lout,shpin,shpout,shpin,shpout,
     .                      1,1,1,1,0,1,xc,.false.,func)


      return
      end
C------------------------------------------------------------------------------
C Case 3:
      integer function bbhintdgx2(rank,p,rho,uin,uout,shpin,chin,chout,
     .                            wksp,nwksp)
      implicit none
      integer  rank, p, nwksp
      integer  rho
      real*8   uin(*),uout(*)
      real*8   chin(*),chout(*)
      real*8   wksp(nwksp) 
      integer  shpin(rank)
      integer  interps
      integer  shpout(3)

      integer   maxp
      parameter ( maxp = 5000 )
      real*8    xf(maxp),lx,ly,lz,lout,xc
      integer   func
      integer   nwkspc, nwkspf, l, lc, lr,np 
		integer   ifail

		ifail = 1
      do l =1 , rank
         shpout(l) = shpin(l)*rho - (rho-1)
			ifail = ifail*shpout(l)
         if (p.gt.shpin(l)-1.or.p.gt.12.or.p.lt.2) then
            bbhintdgx2 = 1
            return
         end if
      end do

		ifail = nwksp - ifail
		if (ifail.lt.0) then
			bbhintdgx2 = 1
			write(0,*) '*** make the workspace larger ***'
			return
		end if

      nwkspc = 1
      nwkspf = 1

      do l = 1 , rank
         nwkspf = nwkspf*shpin(l) 
      end do

      nwkspf = nwkspf + 1

C need to generate xf ........

      lc = 0
      do lr = 1 , rank

         do l = 1, shpin(lr)*rho-(rho-1)
            lc = lc + 1
            if (lc.gt.maxp) then
               write(0,*) '*** too many points in bbhintdgx2 ***'
               bbhintdgx2 = 1
               return
            end if
            xf(lc) = 1.0d0*l
         end do
      end do

      bbhintdgx2 = interps( rank,p,uin,uout,chin,chout,
     .                      wksp(1),wksp(nwkspf),
     .                      xf,lx,ly,lz,lout,shpin,shpout,shpin,shpout,
     .                      shpin,shpout,shpout,1,0,1,xc,.false.,func)

      return
      end
C------------------------------------------------------------------------------
C Case 4
      integer function bbhintdgc0(rank,p,uin,uout,shpin,bbxin,bbcin,
     .                            shpout,c2xfu)
      implicit none
      integer rank,p
      real*8 uin(*),uout(*)
      integer shpin(rank)
      real*8 bbxin(rank*2),bbcin(rank*2)
      integer shpout(rank)
      integer c2xfu
      external c2xfu
      integer interps

      real*8 chin,chout,wksp
      real*8 lx,ly,lz,lout
      integer maxp
      parameter ( maxp = 5000)
      real*8 xin(maxp),xout(maxp)
      real*8 hx(3)
      real*8 hr(3) 
      integer l,l2,lc,np1,np2,ll

		if (p.gt.12.or.p.lt.2) then
			write(0,*) 'order is too large'
			bbhintdgc0 = 1
			return
		end if

C generate the xc's and the xf's from the bounding boxes

      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
         hr(1)= (bbcin(4)-bbcin(1))/(shpout(1)-1)
         hr(2)= (bbcin(5)-bbcin(2))/(shpout(2)-1)
         hr(3)= (bbcin(6)-bbcin(3))/(shpout(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
         hr(1)= (bbcin(3)-bbcin(1))/(shpout(1)-1)
         hr(2)= (bbcin(4)-bbcin(2))/(shpout(2)-1)
      end if

      l = 0 
      l2 = 0 
      np1 = 0
      np2 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         np2 =  np2 + shpout(lc)
         if (np1.gt.maxp.or.np2.gt.maxp) then
            bbhintdgc0 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpout(lc)
            l = l + 1
            xout(l) = bbcin(lc) + hr(lc)*(ll-1)
         end do
         do ll = 1 , shpin(lc)
            l2= l2+ 1
            xin(l2) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdgc0 = interps( rank,p,uin,uout,chin,chout,wksp,wksp,
     .                      xin,lx,ly,lz,lout,shpin,shpout,1,1,
     .                      1,1,shpin,1,0,shpout,xout,.true.,c2xfu)


      return
      end
C------------------------------------------------------------------------------
C Case 5
      integer function bbhintdgc1(rank,p,uin,uout,shpin,bbxin,bbcin,
     .                            shpout,c2xfu,chin)
      implicit none
      integer rank,p
      real*8 uin(*),uout(*)
      integer shpin(rank)
      real*8 bbxin(rank*2),bbcin(rank*2)
      real*8 chin(*)
      integer shpout(rank)
      integer c2xfu
      external c2xfu
      integer interps

      real*8 chout,wksp
      real*8 lx,ly,lz,lout
      integer maxp
      parameter ( maxp = 5000)
      real*8 xin(maxp),xout(maxp)
      real*8 hx(3)
      real*8 hr(3) 
      integer l,l2,lc,np1,np2,ll

		if (p.gt.12.or.p.lt.2) then
			write(0,*) 'order too large'
			bbhintdgc1 = 1
			return
		end if

C generate the xc's and the xf's from the bounding boxes

      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
         hr(1)= (bbcin(4)-bbcin(1))/(shpout(1)-1)
         hr(2)= (bbcin(5)-bbcin(2))/(shpout(2)-1)
         hr(3)= (bbcin(6)-bbcin(3))/(shpout(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
         hr(1)= (bbcin(3)-bbcin(1))/(shpout(1)-1)
         hr(2)= (bbcin(4)-bbcin(2))/(shpout(2)-1)
      end if

      l = 0
      l2 = 0
      np1 = 0
      np2 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         np2 =  np2 + shpout(lc)
         if (np1.gt.maxp.or.np2.gt.maxp) then
            bbhintdgc1 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpout(lc)
            l = l + 1
            xout(l) = bbcin(lc) + hr(lc)*(ll-1)
         end do
         do ll = 1 , shpin(lc)
            l2= l2+ 1
            xin(l2) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdgc1 = interps( rank,p,uin,uout,chin,chout,wksp,wksp,
     .                      xin,lx,ly,lz,lout,shpin,shpout,shpin,1,
     .                      1,1,shpin,1,0,shpout,xout,.true.,c2xfu)


      return
      end
C------------------------------------------------------------------------------
C Case 6
      integer function bbhintdlx0(rank,p,uin,bbxin,coordsin,
     .                            ulout,shpin,nlout)
      implicit none
      integer rank, p
      integer shpin(rank),nlout
      real*8 uin(*),ulout(nlout)
      real*8 bbxin(2*rank)
      real*8 coordsin(3*nlout)
      real*8 hx(3)

      integer interps
      real*8 uout,chin,chout,wksp
      integer np1,ll,l,lc
      integer maxp
      parameter ( maxp = 5000)
      real*8 xf(maxp),xc
      integer func


		if (p.gt.12.or.p.lt.2) then
			write(0,*) 'order to large'
			bbhintdlx0 = 1
			return
		end if
      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
      end if

      l = 0
      np1 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         if (np1.gt.maxp) then
            bbhintdlx0 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpin(lc)
            l = l + 1
            xf(l) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdlx0 = interps(rank,p,uin,uout,chin,chout,wksp,wksp,
     .                     xf,coordsin(1),coordsin(1+nlout),
     .                     coordsin(2*nlout+1),ulout,shpin,1,1,
     .                     1,1,1,shpin,nlout,0,1,xc,.false.,func)


      return
      end

C------------------------------------------------------------------------------
C Case 7
      integer function bbhintdlx1(rank,p,uin,bbxin,coordsin,ulout,shpin,
     .                            nlout,chin)
      implicit none
      integer rank, p
      integer shpin(rank),nlout
      real*8 uin(*),ulout(nlout)
      real*8 chin(*)
      real*8 bbxin(2*rank)
      real*8 coordsin(3*nlout)
      real*8 hx(3)

      integer interps
      real*8 uout,chout,wksp
      integer np1,ll,l,lc
      integer maxp
      parameter ( maxp = 5000)
      real*8 xf(maxp),xc
      integer func

      if (p.gt.12.or.p.lt.2) then
         write(0,*) 'order to large'
         bbhintdlx1 = 1
         return
      end if


      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
      end if

      l = 0
      np1 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         if (np1.gt.maxp) then
            bbhintdlx1 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpin(lc)
            l = l + 1
            xf(l) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdlx1 = interps(rank,p,uin,uout,chin,chout,wksp,wksp,
     .                     xf,coordsin(1),coordsin(1+nlout),
     .                     coordsin(2*nlout+1),ulout,shpin,1,shpin,
     .                     1,1,1,shpin,nlout,0,1,xc,.false.,func)


      return
      end
C------------------------------------------------------------------------------
C Case 8
      integer function bbhintdlc0(rank,p,uin,bbxin,coordsin,ulout,
     .                            shpin,nlout,c2xfun)
      implicit none
      integer rank, p
      integer shpin(rank),nlout
      real*8 uin(*),ulout(nlout)
      real*8 chin
      real*8 bbxin(2*rank)
      real*8 coordsin(3*nlout)
      real*8 hx(3)

      integer interps
      real*8 uout,chout,wksp
      integer np1,ll,l,lc
      integer maxp
      parameter ( maxp = 5000)
      real*8 xf(maxp),xc
      integer c2xfun
      external c2xfun


      if (p.gt.12.or.p.lt.2) then
         write(0,*) 'order to large'
         bbhintdlc0 = 1
         return
      end if



      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
      end if

      l = 0
      np1 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         if (np1.gt.maxp) then
            bbhintdlc0 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpin(lc)
            l = l + 1
            xf(l) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdlc0 = interps(rank,p,uin,uout,chin,chout,wksp,wksp,
     .                     xf,coordsin(1),coordsin(1+nlout),
     .                     coordsin(2*nlout+1),ulout,shpin,1,1,
     .                     1,1,1,shpin,nlout,0,1,xc,.true.,c2xfun)

      return
      end

C------------------------------------------------------------------------------
C Case 9
      integer function bbhintdlc1(rank,p,uin,bbxin,coordsin,ulout,
     .                            shpin,nlout,c2xfun,chin)
      implicit none
      integer rank, p
      integer shpin(rank),nlout
      real*8 uin(*),ulout(nlout)
      real*8 chin(*)
      real*8 bbxin(2*rank)
      real*8 coordsin(3*nlout)
      real*8 hx(3)

      integer interps
      real*8 uout,chout,wksp
      integer np1,ll,l,lc
      integer maxp
      parameter ( maxp = 5000)
      real*8 xf(maxp),xc
      integer c2xfun
      external c2xfun 

      if (p.gt.12.or.p.lt.2) then
         write(0,*) 'order to large'
         bbhintdlc1 = 1
         return
      end if



      if (rank.eq.3) then
         hx(1)= (bbxin(4)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(5)-bbxin(2))/(shpin(2)-1)
         hx(3)= (bbxin(6)-bbxin(3))/(shpin(3)-1)
      else
         hx(1)= (bbxin(3)-bbxin(1))/(shpin(1)-1)
         hx(2)= (bbxin(4)-bbxin(2))/(shpin(2)-1)
      end if

      l = 0
      np1 = 0
      do lc = 1 , rank
         np1 =  np1 + shpin(lc)
         if (np1.gt.maxp) then
            bbhintdlc1 = 1
            write(0,*) '*** too many points***'
            return
         end if
         do ll = 1 , shpin(lc)
            l = l + 1
            xf(l) = bbxin(lc) + hx(lc)*(ll-1)
         end do
      end do

      bbhintdlc1 = interps(rank,p,uin,uout,chin,chout,wksp,wksp,
     .                     xf,coordsin(1),coordsin(1+nlout),
     .                     coordsin(2*nlout+1),ulout,shpin,1,shpin,
     .                     1,1,1,shpin,nlout,0,1,xc,.true.,c2xfun)

      return
      end
