      integer function intcp2d(ucs1,ucs2,xcs1,ycs1,xcs2,ycs2,
     .                         nxcs1,nycs1,nxcs2,nycs2,
     .                         order,func)
CFPP$ EXPAND (func)
      implicit none

      integer nxcs1,nycs1,nxcs2,nycs2
      real*8 ucs1(nxcs1,nycs1),ucs2(nxcs2,nycs2)
      real*8 xcs1(nxcs1),ycs1(nycs1)
      real*8 xcs2(nxcs2),ycs2(nycs2)
      integer maxv
      parameter ( maxv = 729 )
      real*8 lx(maxv),ly(maxv),s(maxv)
      integer order

      integer func
      external func 
      integer d2lintxy,d4lintxy,dnlintxy

      real*8 x,y
      integer i,j,l,pil,ierr,ii,jj
      integer istart,istop,iss,ist
      integer jstart,jstop

      intcp2d = 0

C step 1: define the lx , ly , and s parameters
      l = 0
      istart = 1
      jstart = 1
      do j = 1 , nycs2
         do  i = 1 , nxcs2
            l = l + 1
            intcp2d = func(xcs2(i),ycs2(j),lx(l),ly(l))
            if (l.ge.maxv.or.(i.eq.nxcs2.and.j.eq.nycs2)) then
               pil = l
               l = 0

               istop = i
               jstop = j

               if (order.eq.2) then
                  intcp2d = d2lintxy(nxcs1,nycs1,xcs1,ycs1,
     .                               pil,lx,ly,ucs1,s)
               else if (order.eq.4) then
                  intcp2d = d4lintxy(nxcs1,nycs1,xcs1,ycs1,
     .                               pil,lx,ly,ucs1,s)
               else
                  intcp2d = dnlintxy(nxcs1,nycs1,xcs1,ycs1,
     .                               pil,lx,ly,
     .                               ucs1,s,order)

               end if

					if (intcp2d.eq.1) return

               do jj = jstart , jstop 

                  if (jj.eq.jstart) then
                     iss = istart
                  else
                     iss = 1
                  end if

                  if (jj.eq.jstop) then
                     ist = istop
                  else
                     ist = nxcs2
                  end if

                  do  ii = iss, ist 

                        l = l + 1
                        ucs2(ii,jj) = s(l)
                  end do
               end do
               l = 0

               istart = i + 1
               jstart = j 
               if (istart.gt.nxcs2) then
                  jstart = j + 1
                  istart = 1
               end if
            end if
         end do
      end do
      return
      end
C------------------------------------------------------------------------------
      integer function intcpl2d(ucs1,xcs1,ycs1,
     .                         nxcs1,nycs1,pil,lx,ly,s,
     .                         order,func)
CFPP$ EXPAND (func)
      implicit none
		integer pil
      integer nxcs1,nycs1
      real*8 ucs1(nxcs1,nycs1)
      real*8 xcs1(nxcs1),ycs1(nycs1)
      real*8 lx(pil),ly(pil),s(pil) 
      integer order
C the lx and ly are not x and y there are in the other coordinate system ...
C they must be converted to this coordinate system

      integer func
      external func 
      integer d2lintxy,d4lintxy,dnlintxy

      real*8 x,y
      integer i,j,l,ierr

      intcpl2d = 0

		do l = 1 , pil
         intcpl2d = func(lx(l),ly(l),lx(l),ly(l))
		end do

      if (order.eq.2) then
         intcpl2d = d2lintxy(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,ucs1,s)
      else if (order.eq.4) then
         intcpl2d = d4lintxy(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,ucs1,s)
      else 
         intcpl2d = dnlintxy(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,
     .                      ucs1,s,order)
      end if


      return
      end
C------------------------------------------------------------------------
      integer function intcp3d(ucs1,ucs2,xcs1,ycs1,zcs1,xcs2,ycs2,zcs2,
     .                         nxcs1,nycs1,nzcs1,nxcs2,nycs2,nzcs2,
     .                         order,func)
CFPP$ EXPAND (func)
      implicit none
      integer nxcs1,nycs1,nzcs1,nxcs2,nycs2,nzcs2
      real*8 ucs1(nxcs1,nycs1,nzcs1),ucs2(nxcs2,nycs2,nzcs2)
      real*8 xcs1(nxcs1),ycs1(nycs1),zcs1(nzcs1)
      real*8 xcs2(nxcs2),ycs2(nycs2),zcs2(nzcs2)
      integer maxv
      parameter ( maxv = 729 )

      real*8 lx(maxv) , ly(maxv), lz(maxv), s(maxv) 
      integer order
      integer ii,jj,kk

      integer func
      external func 
      integer d2lintxyz,d4lintxyz,dnlintxyz

      real*8 x,y,z
      integer i,j,k,l,pil,ierr
      integer istart,istop,iss,ist
      integer jstart,jstop,jss,jst
      integer kstart,kstop

      intcp3d = 0

C step 1: define the lx , ly , lz, and s parameters
      l = 0
		istart = 1
		jstart = 1
		kstart = 1
      do k = 1 , nzcs2 !(
         do j = 1 , nycs2 !(
            do  i = 1 , nxcs2 !(
               l = l + 1
               intcp3d = func(xcs2(i),ycs2(j),zcs2(k),
     .                        lx(l),ly(l),lz(l))

               if (l.ge.maxv.or.(i.eq.nxcs2.and.j.eq.nycs2.
     .             and.k.eq.nzcs2)) then !(

                  pil = l
                  l = 0
                  istop = i
                  jstop = j
                  kstop = k
      
                  if (order.eq.2) then !(
                     intcp3d = d2lintxyz(nxcs1,nycs1,nzcs1,
     .                                   xcs1,ycs1,zcs1,
     .                                   pil,lx,ly,lz,ucs1,s)
                  else if (order.eq.4) then
                     intcp3d = d4lintxyz(nxcs1,nycs1,nzcs1,
     .                                   xcs1,ycs1,zcs1,
     .                                   pil,lx,ly,lz,ucs1,s)
                  else 
                     intcp3d = dnlintxyz(nxcs1,nycs1,nzcs1,
     .                                   xcs1,ycs1,zcs1,
     .                                   pil,lx,ly,lz,ucs1,s,order)
                  end if !)

						if (intcp3d.eq.1) return

               
                  do kk = kstart,kstop !(
                     if (kk.eq.kstart) then
                        jss = jstart
                     else
                        jss = 1
                     end if
                     if (kk.eq.kstop) then
                        jst = jstop
                     else
                        jst = nycs2
                     end if

                     do jj = jss, jst !(

                        if (jj.eq.jstart.and.kk.eq.kstart) then
                           iss = istart
                        else
                           iss = 1
                        end if
      
                        if (jj.eq.jstop.and.kk.eq.kstop) then
                           ist = istop
                        else
                           ist = nxcs2
                        end if
      
                        do  ii = iss, ist !(
      
                              l = l + 1
                              ucs2(ii,jj,kk) = s(l)
                        end do !)
                     end do !)
                  end do !)

                  l = 0
   
                  istart = i + 1
                  jstart = j
                  kstart = k
                  if (istart.gt.nxcs2) then
                     jstart = j + 1
                     istart = 1
                  end if
                  if (jstart.gt.nycs2) then
                     kstart = kstart + 1
                     jstart = 1
                  end if
               end if !)
               
            end do !)
         end do !)
      end do !)
      
      return
      end
C------------------------------------------------------------------------------
      integer function intcpl3d(ucs1,xcs1,ycs1,zcs1,
     .                         nxcs1,nycs1,nzcs1,pil,lx,ly,lz,s,
     .                         order,func)
CFPP$ EXPAND (func)
      implicit none
		integer pil
      integer nxcs1,nycs1,nzcs1
      real*8 ucs1(nxcs1,nycs1,nzcs1)
      real*8 xcs1(nxcs1),ycs1(nycs1),zcs1(nzcs1)
      real*8 lx(pil),ly(pil),lz(pil),s(pil)
      integer order

      integer func
      external func
      integer d2lintxyz,d4lintxyz,dnlintxyz

      integer i,j,l,ierr

      intcpl3d = 0

		do l = 1 , pil
         intcpl3d = func(lx(l),ly(l),lz(l),lx(l),ly(l),lz(l))
		end do

      if (order.eq.2) then
         intcpl3d = d2lintxyz(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,ucs1,s)
      else if (order.eq.4) then
         intcpl3d = d4lintxyz(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,ucs1,s)
      else
         intcpl3d = dnlintxyz(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,
     .                      ucs1,s,order)
      end if


      return
      end
C------------------------------------------------------------------------------
      integer function intcp2dc(ucs1,ucs2,xcs1,ycs1,xcs2,ycs2,
     .                         nxcs1,nycs1,nxcs2,nycs2,
     .                         order,func,char)
CFPP$ EXPAND (func)
      implicit none

      integer nxcs1,nycs1,nxcs2,nycs2
      real*8 ucs1(nxcs1,nycs1),ucs2(nxcs2,nycs2)
		real*8 char(nxcs1,nycs1)
      real*8 xcs1(nxcs1),ycs1(nycs1)
      real*8 xcs2(nxcs2),ycs2(nycs2)
      integer maxv
      parameter ( maxv = 729 )
      real*8 lx(maxv),ly(maxv),s(maxv)
		integer maxo
		parameter (maxo = 15 )
      integer order

      integer func
      external func 
      integer d2lintxyc,d4lintxyc,dnlintxyc

      real*8 x,y
      integer i,j,l,pil,ierr,ii,jj
      integer istart,istop,iss,ist
      integer jstart,jstop

		if (order.gt.maxo) then
			intcp2dc = 1
			write(0,*) 'intcp2dc: error order is to large'
		end if

      intcp2dc = 0

C step 1: define the lx , ly , and s parameters
      l = 0
      istart = 1
      jstart = 1
      do j = 1 , nycs2
         do  i = 1 , nxcs2
            l = l + 1
            intcp2dc = func(xcs2(i),ycs2(j),lx(l),ly(l))
            if (l.ge.maxv.or.(i.eq.nxcs2.and.j.eq.nycs2)) then
               pil = l
               l = 0

               istop = i
               jstop = j

               if (order.eq.2) then
                  intcp2dc = d2lintxyc(nxcs1,nycs1,xcs1,ycs1,
     .                               pil,lx,ly,ucs1,s,char) 
               else if (order.eq.4) then
                  intcp2dc = d4lintxyc(nxcs1,nycs1,xcs1,ycs1,
     .                               pil,lx,ly,ucs1,s,char) 
               else
                  intcp2dc = dnlintxyc(nxcs1,nycs1,xcs1,ycs1,
     .                               pil,lx,ly,
     .                               ucs1,s,order,char) 

               end if

					if (intcp2dc.eq.1.) return

               do jj = jstart , jstop 

                  if (jj.eq.jstart) then
                     iss = istart
                  else
                     iss = 1
                  end if

                  if (jj.eq.jstop) then
                     ist = istop
                  else
                     ist = nxcs2
                  end if

                  do  ii = iss, ist 

                        l = l + 1
                        ucs2(ii,jj) = s(l)
                  end do
               end do
               l = 0

               istart = i + 1
               jstart = j 
               if (istart.gt.nxcs2) then
                  jstart = j + 1
                  istart = 1
               end if
            end if
         end do
      end do
      return
      end
C------------------------------------------------------------------------------
      integer function intcpl2dc(ucs1,xcs1,ycs1,
     .                         nxcs1,nycs1,pil,lx,ly,s,
     .                         order,func,char)
CFPP$ EXPAND (func)
      implicit none
		integer pil
      integer nxcs1,nycs1
      real*8 ucs1(nxcs1,nycs1),char(nxcs1,nycs1)
      real*8 xcs1(nxcs1),ycs1(nycs1)
      real*8 lx(pil),ly(pil),s(pil) 
      integer order

      integer func
      external func 
      integer d2lintxy,d4lintxy,dnlintxy

      real*8 x,y
      integer i,j,l,ierr

      intcpl2dc = 0

      do l = 1 , pil
         intcpl2dc= func(lx(l),ly(l),lx(l),ly(l))
      end do

      if (order.eq.2) then
         intcpl2dc = d2lintxy(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,ucs1,s)
      else if (order.eq.4) then
         intcpl2dc = d4lintxy(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,ucs1,s)
      else 
         intcpl2dc = dnlintxy(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,
     .                      ucs1,s,order)
      end if


      return
      end
C------------------------------------------------------------------------
      integer function intcp3dc(ucs1,ucs2,xcs1,ycs1,zcs1,xcs2,ycs2,zcs2,
     .                         nxcs1,nycs1,nzcs1,nxcs2,nycs2,nzcs2,
     .                         order,func,char)
CFPP$ EXPAND (func)
      implicit none
      integer nxcs1,nycs1,nzcs1,nxcs2,nycs2,nzcs2
      real*8 ucs1(nxcs1,nycs1,nzcs1),ucs2(nxcs2,nycs2,nzcs2)
		real*8 char(nxcs1,nycs1,nzcs1)
      real*8 xcs1(nxcs1),ycs1(nycs1),zcs1(nzcs1)
      real*8 xcs2(nxcs2),ycs2(nycs2),zcs2(nzcs2)
      integer maxv
      parameter ( maxv = 729 )
      integer maxo
      parameter (maxo = 15 )

      real*8 lx(maxv) , ly(maxv), lz(maxv), s(maxv) 
      integer order
      integer ii,jj,kk

      integer func
      external func 
      integer d2lintxyzc,d4lintxyzc,dnlintxyzc

      real*8 x,y,z
      integer i,j,k,l,pil,ierr
      integer istart,istop,iss,ist
      integer jstart,jstop,jss,jst
      integer kstart,kstop

      intcp3dc = 0

C step 1: define the lx , ly , lz, and s parameters
      l = 0
		istart = 1
		jstart = 1
		kstart = 1
      do k = 1 , nzcs2 !(
         do j = 1 , nycs2 !(
            do  i = 1 , nxcs2 !(
               l = l + 1
               intcp3dc = func(xcs2(i),ycs2(j),zcs2(k),
     .                        lx(l),ly(l),lz(l))

               if (l.ge.maxv.or.(i.eq.nxcs2.and.j.eq.nycs2.
     .             and.k.eq.nzcs2)) then !(

                  pil = l
                  l = 0
                  istop = i
                  jstop = j
                  kstop = k
      
                  if (order.eq.2) then !(
                     intcp3dc = d2lintxyzc(nxcs1,nycs1,nzcs1,
     .                          xcs1,ycs1,zcs1,
     .                          pil,lx,ly,lz,ucs1,s,char) 
                  else if (order.eq.4) then
                     intcp3dc = d4lintxyzc(nxcs1,nycs1,nzcs1,
     .                          xcs1,ycs1,zcs1,
     .                          pil,lx,ly,lz,ucs1,s,char) 
                  else 
                     intcp3dc = dnlintxyzc(nxcs1,nycs1,nzcs1,
     .                                   xcs1,ycs1,zcs1,
     .                                   pil,lx,ly,lz,ucs1,s,order,
     .                                   char) 
                  end if !)

               
                  do kk = kstart,kstop !(
                     if (kk.eq.kstart) then
                        jss = jstart
                     else
                        jss = 1
                     end if
                     if (kk.eq.kstop) then
                        jst = jstop
                     else
                        jst = nycs2
                     end if

                     do jj = jss, jst !(

                        if (jj.eq.jstart.and.kk.eq.kstart) then
                           iss = istart
                        else
                           iss = 1
                        end if
      
                        if (jj.eq.jstop.and.kk.eq.kstop) then
                           ist = istop
                        else
                           ist = nxcs2
                        end if
      
                        do  ii = iss, ist !(
      
                              l = l + 1
                              ucs2(ii,jj,kk) = s(l)
                        end do !)
                     end do !)
                  end do !)

                  l = 0
   
                  istart = i + 1
                  jstart = j
                  kstart = k
                  if (istart.gt.nxcs2) then
                     jstart = j + 1
                     istart = 1
                  end if
                  if (jstart.gt.nycs2) then
                     kstart = kstart + 1
                     jstart = 1
                  end if
               end if !)
               
            end do !)
         end do !)
      end do !)
      
      return
      end
C------------------------------------------------------------------------------
      integer function intcpl3dc(ucs1,xcs1,ycs1,zcs1,
     .                         nxcs1,nycs1,nzcs1,pil,lx,ly,lz,s,
     .                         order,func)
CFPP$ EXPAND (func)
      implicit none
		integer pil
      integer nxcs1,nycs1,nzcs1
      real*8 ucs1(nxcs1,nycs1,nzcs1)
      real*8 xcs1(nxcs1),ycs1(nycs1),zcs1(nzcs1)
      real*8 lx(pil),ly(pil),lz(pil),s(pil)
      integer order

      integer func
      external func
      integer d2lintxyz,d4lintxyz,dnlintxyz

      integer i,j,l,ierr

      intcpl3dc = 0

      do l = 1 , pil
         intcpl3dc= func(lx(l),ly(l),lz(l),lx(l),ly(l),lz(l))
      end do


      if (order.eq.2) then
         intcpl3dc = d2lintxyz(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,ucs1,s)
      else if (order.eq.4) then
         intcpl3dc = d4lintxyz(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,ucs1,s)
      else
         intcpl3dc = dnlintxyz(nxcs1,nycs1,xcs1,ycs1,pil,lx,ly,
     .                      ucs1,s,order)
      end if


      return
      end
C---------------------------------------------------------------
      integer function polar(theta,r,x,y)
      implicit none
      real*8 r,theta,x,y

      polar = 0
      x = r * cos(theta)
      y = r * sin(theta)

      return
      end
C---------------------------------------------------------------
      integer function spherical(theta,r,phi,x,y,z)
      implicit none
      real*8 r,theta,phi,x,y,z

      spherical = 0
      x = r * cos(theta)*cos(phi)
      y = r * sin(theta)*cos(phi)
      z = r * sin(phi)

      return
      end
C---------------------------------------------------------------
      integer function cylindrical(r,theta,zin,x,y,z)
      implicit none
      real*8 r,theta,z,x,y,zin

      cylindrical = 0
      x = r * cos(theta)
      y = r * sin(theta)
      z = zin

      return
      end
C---------------------------------------------------------------
