c------------------------------------------------------------------------------
C routines in this section are
C  d1pro122c(uc,uf,d1c,charc,charf,xf,)       2x1  2 O 
C  d1pro124c(uc,uf,d1c,charc,charf,xf,)       2x1  4 O 
C  d1pro12nc(uc,uf,d1c,charc,charf,xf,order) 2x1  p O 
c------------------------------------------------------------------------------
C 
      integer function d1pro122c( uc,uf,nxc,charmc,charmf,xf)
      implicit none
      integer nxc
      integer nxf
      real*8  uc(nxc),uf(2*nxc-1) 
      real*8  charmc(nxc),charmf(2*nxc-1) 
      real*8  badval,bigval
      real*8  xf(2*nxc-1)

      parameter ( badval = 9.9d020, bigval = 1.0d010  )

      integer pil,l

      integer   ic
      integer   iff
      integer ierr
      integer d1pro122c_ 

      nxf = 2*nxc-1

      d1pro122c = 0

      d1pro122c =  d1pro122c_(uc,uf,nxc,charmc,charmf)

      return
      end
c-----------------------------------------------------------------------
C second order (linear interpolation on a 2x1 mesh) with char functions
c-----------------------------------------------------------------------
      integer function d1pro122c_( uc,uf,d1c, chc,chf) 
      implicit none
      integer d1c
      integer d1f
      real*8    uc(d1c),uf(2*d1c-1) 
      real*8    chc(d1c),chf(2*d1c-1) 

      integer   ic
      integer   iff
      integer d1122

      d1pro122c_ = d1122(d1c,uc,uf,chc) 

      return
      end
c-----------------------------------------------------------------------
      integer function d1pro124c( uc,uf,nxc,charmc,charmf,xf)
      implicit none
      integer nxc
      integer nxf
      real*8  uc(nxc),uf(2*nxc-1) 
      real*8  charmc(nxc),charmf(2*nxc-1) 
      real*8  xf(2*nxc-1)


      integer   ic 
      integer   iff 
      integer ierr
      integer d1pro124c_ 

      nxf = 2*nxc-1

      d1pro124c = 0

      d1pro124c =  d1pro124c_(uc,uf,nxc,charmc,charmf)

      return
      end
c-----------------------------------------------------------------------
c
c     2:1 cubic interpolation ...
c
C  from a 2x1 mesh
c-----------------------------------------------------------------------

      integer function  d1pro124c_(uc,uf,d1c,chc,chf)

         implicit       none

         logical        ccdim

         integer        d1c
         real*8         uc(d1c),
     *                  uf(2*d1c-1) 
         real*8         chc(d1c), 
     *                  chf(2*d1c-1) 

         integer        i1,      i2,
     *                  d1f
      integer jc,ic
      integer d1124

      d1f = 2 * d1c - 1

      d1pro124c_ = d1124(d1c,uc,uf,chc)

      return
      end
C----------------------------------------------------------------------------
      integer function d1pro12nc( uc,uf,nxc,charmc,charmf,
     .                            xf,order)
      implicit none
      integer nxc
      integer nxf
      real*8  uc(nxc),uf(2*nxc-1) 
      real*8  charmc(nxc),charmf(2*nxc-1) 
      real*8  xf(2*nxc-1)
      integer order

      integer pil,l

      integer   ic
      integer   iff 
      integer ierr
      integer d1pro12nc_

      nxf = 2*nxc-1

      d1pro12nc = 0

      d1pro12nc =  d1pro12nc_(uc,uf,nxc,order,charmc,charmf)

      return
      end
c-----------------------------------------------------------------------
      integer function d1pro12nc_(uc,uf,nxc,order,chc,chf) 
      implicit none
      integer nxc
      integer nxf
      real*8    uc(nxc),uf(2*nxc-1) 
      real*8    chc(nxc),chf(2*nxc-1) 

      integer   ic
      integer   iff 

      integer order

      integer d1nint2c,ierr
      integer wksp_size
      parameter ( wksp_size = 8000 )
      real*8 wksp(wksp_size)

C the first thing that I must do is set up the coefficients ....
      nxf = 2*nxc-1

      d1pro12nc_ = d1nint2c(order,wksp,wksp_size)

      if (d1pro12nc_.ne.0) then
         write(0,*) 'Error in d1nint2c'
      end if

C at first I do all the lines that I can ......
      call d1nint2ec(nxc,uc,uf,wksp,wksp_size,order,chc)

      return
      end
C======================================================================
c-----------------------------------------------------------------------
C routines in this section are
C       d1pro122(uc,uf,d1c)          2x1       second order
C       d1pro124(uc,uf,d1c)          2x1       fourth order
C       d1pro12n(uc,uf,d1c,order)    2x1       nth    order
c-----------------------------------------------------------------------

C second order (linear interpolation on a 2x1 mesh)
c-----------------------------------------------------------------------
      integer function d1pro122( uc,uf,nxc) 
      implicit none
      integer nxc
      integer nxf
      real*8    uc(nxc),uf(2*nxc-1) 

      integer   ic 
      integer   if 

      nxf = 2*nxc-1

      d1pro122 = 0

c first injection

      do ic = 1, nxc 
         if = 2*ic -1
         uf(if) = uc(ic)
      end do
      do if = 2 , nxf - 1 , 2
         uf(if) = 0.5d0*( uf(if-1) + uf(if+1) )
      end do

      return
      end
c-----------------------------------------------------------------------
c
c     2:1 cubic interpolation ...
c
C  from a 2x1 mesh
c-----------------------------------------------------------------------

      integer function d1pro124(uc,uf,d1c) 

         implicit       none

         logical        ccdim

         integer        d1c
         real*8         uc(d1c),
     *                  uf(2*d1c-1) 

         integer        i1,      i2, d1f

         real*8         lc(4),      cc(4),      rc(4)
         data
     *     lc / 0.31250d0,  0.93750d0, -0.31250d0,  0.06250d0 /,
     *     cc /-0.06250d0,  0.56250d0,  0.56250d0, -0.06250d0 /,
     *     rc / 0.06250d0, -0.31250d0,  0.93750d0,  0.31250d0 /


         d1pro124 = 0

         if( ccdim(d1c) ) then 
            call dv2i4_s(uc,uf,d1c)

         else
            write(*,*) '>>> d1pro124: Invalid dimension(s): ',
     *                 d1c
            d1pro124 = 1
         end if

         return

      end

C this will do nth order interpolation on a 2x1 mesh .....
c-----------------------------------------------------------------------
      integer function d1pro12n(uc,uf,nxc,order) 
      implicit none
      integer nxc
      integer nxf
      real*8    uc(nxc),uf(2*nxc-1) 

      integer   ic 
      integer   iff 

      integer order

      integer d1nint2,ierr
      integer wksp_size
      parameter ( wksp_size = 8000 )
      real*8 wksp(wksp_size)


      d1pro12n = 0

C the first thing that I must do is set up the coefficients ....
      nxf = 2*nxc-1

      ierr = d1nint2(order,wksp,wksp_size)

      if (ierr.ne.0) then
         write(6,*) 'Error in d1nint2'
         d1pro12n = 1
      end if

      call d1nint2e(nxc,uc,uf,wksp,wksp_size,order)

      return
      end
C======================================================================
C======================================================================
C these routines are 1xn refinements with a characteristic matrix
c------------------------------------------------------------------------------
C routines in this section are
C  d1pro1n2c(uc,uf,d1c,d1f,
C            charc,charf,xf)                          nx1  2 O
C  d1pro1n4c(uc,uf,d1c,d1f,
C            charc,charf,xf)                          nx1  4 O
C  d1pro1nnc(uc,uf,d1c,d1f,
C            charc,charf,xf,order)                    nx1  p O
c------------------------------------------------------------------------------
      integer function d1pro1n2c( uc,uf,nxc,nxf,
     .                            charmc,charmf,xf) 
      implicit none
      integer nxc
      integer nxf
      real*8  uc(nxc),uf(nxf) 
      real*8  charmc(nxc),charmf(nxf) 
      real*8  badval,bigval
      real*8  xf(nxf)

      integer   ic 
      integer   iff 
      integer ierr
      integer d1pro1n2c_

      d1pro1n2c = 0

      d1pro1n2c =  d1pro1n2c_(nxf,nxc,uf,uc,charmc,charmf)

      return
      end
C-------------------------------------------------------------------------
C prolongs from a 1 to n grid using second order techinques
C i.e. cubic interpolation
C
      integer function d1pro1n2c_(nxf,nxc,uf,uc,chc,chf)
      implicit none
      integer  nxf
      integer  nxc

      real*8 uf(nxf), uc(nxc)
      real*8 chf(nxf), chc(nxc)

      integer i
      integer iff
      integer ic
      integer nxfact
      integer nxskip
      integer iskip
      integer maxsize
      integer dvi1q1c

C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)

      nxskip = nxfact - 1
C

      d1pro1n2c_ =  dvi1q1c(uc,uf,nxfact,nxc,chc)

      return
      end
C-----------------------------------------------------------------------------C
      integer function d1pro1n4c( uc,uf,nxc,nxf,
     .                      charmc,charmf,xf)
      implicit none
      integer nxc
      integer nxf
      real*8  uc(nxc),uf(nxf) 
      real*8  charmc(nxc),charmf(nxf) 
      real*8  badval,bigval
      real*8  xf(nxf)

      integer   ic 
      integer   iff 
      integer ierr
      integer d1pro1n4c_

      d1pro1n4c = 0

      d1pro1n4c =  d1pro1n4c_(nxf,nxc,uf,uc,charmc,charmf)

      return
      end
C-------------------------------------------------------------------------
      integer function d1pro1n4c_(nxf,nxc,uf,uc,chc,chf)
      implicit none
      integer  nxf
      integer  nxc

      real*8 uf(nxf), uc(nxc)
      real*8 chf(nxf), chc(nxc)

      integer i
      integer iff
      integer ic
      integer nxfact
      integer nxskip
      integer iskip
      integer dvcuq1_sc

      integer max
      parameter ( max = 32 )
      real*8 ci(4,max),cbl(4,max),cbr(4,max)
      real*8 cel(4,max),cer(4,max)
      real*8 f1,f2

C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)

      nxskip = nxfact - 1

      call get3co4(nxfact,ci,cbl,cbr,cel,cer)

      d1pro1n4c_ =  dvcuq1_sc(uc,uf,nxfact,nxc,
     .                        chc,ci,cbl,cbr,cel,cer)
      return
      end
C---------------------------------------------------------------------
      integer function d1pro1nnc( uc,uf,nxc,nxf,
     .                      charmc,charmf,
     .                      xf,order)
      implicit none
      integer nxc
      integer nxf
      real*8  uc(nxc),uf(nxf) 
      real*8  charmc(nxc),charmf(nxf) 
      real*8  xf(nxf)
      integer order

      integer   ic 
      integer   iff
      integer ierr
      integer d1pro1nnc_

      d1pro1nnc = 0

      d1pro1nnc =  d1pro1nnc_(nxf,nxc,uf,uc,order,
     .                ierr,charmc,charmf)

      if (d1pro1nnc.eq.1) return

      return
      end
C-------------------------------------------------------------------------
      integer function d1pro1nnc_(nxf,nxc,uf,uc,order,ierr,
     .                      chc,chf)
      implicit none
      integer  nxf
      integer  nxc
      integer order
      logical ccdimn

      real*8 uf(nxf), uc(nxc) 
      real*8 chf(nxf), chc(nxc) 

      integer wksp_size
      parameter ( wksp_size = 8000 )
C this size will suit must needs we can have a 20x1 refinement with
C 20th order 
      real*8 wksp(wksp_size)

      integer i
      integer iff
      integer ic
      integer nxfact
      integer nxskip
      integer iskip
      integer ierr
      integer d1nintnc,d1nintnec

      real*8 f1,f2

      ierr = 0

      if( .not.ccdimn(nxc,order) ) then 
         write(6,*) 'not enough points for d1pro1nnc_'
         d1pro1nnc_ = 1
         return
      end if


C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)

      nxskip = nxfact - 1

      d1pro1nnc_ = d1nintnc(order,wksp,wksp_size,nxfact)
      if (d1pro1nnc_.eq.1) return
C

      d1pro1nnc_ = d1nintnec( nxc,nxf,uc,uf,wksp,
     .                        wksp_size,order,nxfact,chc )

      return
      end
C======================================================================
C------------------------------------------------------------------------------
C the routines to call are:
C  d1pro1n2(nxf,nxc,uf,uc)                  nx1    second order
C  d1pro1n4(nxf,nxc,uf,uc)                  nx1    fourth order
C  d1pro1nn(nxf,nxc,uf,uc,order)            nx1    nth    order
C------------------------------------------------------------------------------
C prolongs from a 1 to n grid using second order techinques
C i.e. linear interpolation
C
      integer function  d1pro1n2(nxf,nxc,uf,uc)
      implicit none
      integer  nxf
      integer  nxc

      real*8 uf(nxf), uc(nxc) 

      integer i
      integer iff
      integer ic
      integer nxfact
      integer nxskip
      integer iskip


C figure out the refinement factors in each dimension 

      d1pro1n2 = 0

      nxfact = (nxf-1)/(nxc-1)

      nxskip = nxfact - 1

      call dvi1q1(uc,uf,nxfact,nxc)

      return
      end
C-----------------------------------------------------------------------------C
C prolongs from a 1 to n grid using fourth order techinques
C i.e. cubic interpolation
C
      integer function  d1pro1n4(nxf,nxc,uf,uc)
      implicit none
      integer  nxf
      integer  nxc

      real*8 uf(nxf), uc(nxc)

      integer i
      integer iff
      integer ic
      integer nxfact
      integer nxskip
      integer iskip

      real*8 f1,f2

      d1pro1n4 = 0

C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)

      call dvcuq1_s(uc,uf,nxfact,nxc)

      return
      end
C
C prolongs from a 1 to n grid using nth order techinques
C
C
C need a 1D nth order interpolation
C this routine will make sure that its a nx1 where n=nx ....
C
C---------------------------------------------------------------------
      integer function  d1pro1nn(nxf,nxc,uf,uc,order) 
      implicit none
      integer  nxf
      integer  nxc
      integer order
      logical ccdimn

      real*8 uf(nxf), uc(nxc)

      integer wksp_size
      parameter ( wksp_size = 8000 )
C this size will suit must needs we can have a 20x1 refinement with
C 20th order 
      real*8 wksp(wksp_size)

      integer i
      integer iff
      integer ic
      integer nxfact
      integer nxskip
      integer iskip
      integer d1nintn

      d1pro1nn = 0

      if( (.not.ccdimn(nxc,order))) then
         write(6,*) 'not enough points for d1pro1nn'
         d1pro1nn = 1
         return
      end if
C figure out the refinement factors in each dimension 

      nxfact = (nxf-1)/(nxc-1)

      d1pro1nn = d1nintn(order,wksp,wksp_size,nxfact)
C

      call d1nintne( nxc,nxf,uc,uf,wksp,
     .               wksp_size,order,nxfact )

      return
      end

C-----------------------------------------------------------------------------
C  given a list of points these routines interpolate to a solution vector
C
C  d2lintx(nx,x,pil,listx,u,soln)       list    order 2
C  d4lintx(nx,x,pil,listx,u,soln)       list    order 4
C  dnlintx(nx,x,pil,listx,u,soln,order) list    order n
C-----------------------------------------------------------------------------
C This routine takes a list of points and interpolates to this to second
C order
      integer function d2lintx(nx,x,pil,listx,u,soln)
CFPP$ EXPAND(getijk)
      implicit none
      integer nx
      real*8 x(nx)
      integer pil
      real*8 listx(pil)
      real*8 u(nx)
      real*8 soln(pil)

      integer order
      parameter ( order = 2 )

C local variables
      real*8 dx
      real*8 dxi
      integer l
      integer i
      real*8 dx0
      integer ierr, getijk
      real*8 vx1

      d2lintx = 0

      dx = abs( x(2)-x(1) )
      dxi= 1.0d0/dx

      do l = 1 , pil
         ierr =  getijk(nx,x,listx(l),i,dx0)
         soln(l) =  (dx-dx0)*dxi*u(i)+dx0*dxi*u(i+1)
      end do
      if (ierr.eq.1) goto 1000

      return
1000   continue

      d2lintx = 1
      return
      end
C------------------------------------------------------------------------------
C This routine takes a list of points and interpolates to this to fourth
C order
      integer function d4lintx(nx,x,pil,listx,u,soln) 
CFPP$ EXPAND(getijk2)
      implicit none
      integer nx
      real*8 x(nx)
      integer pil
      real*8 listx(pil)
      real*8 u(nx)
      real*8 soln(pil)

      integer order
      parameter ( order = 4 )

C local variables
      real*8 dx
      real*8 dxi
      integer l,lj
      integer i,j
      real*8 dx0
      integer ierr, getijk2
      real*8 vx(4)
      real*8 den

      real*8 dx2,dx3,dx4,dx5

      real*8 dx02,dx03,dx04,dx05

      d4lintx = 0

      dx = abs( x(2)-x(1) )
      dx2 = dx*dx

      dx3 = dx**3

      dxi= 1.0d0/dx

      do l = 1 , pil

C step 1 is to get the 2 points that surround this point in the x directions
C it returns the i-1,j-1,k-1 point and the dx0ff ...

         ierr =  getijk2(nx,x,listx(l),i,dx0)
         if (ierr.eq.1) goto 1000

         dx02 = dx0**2
         dx03 = dx0**3

         den = 1.0d0/(6.0d0*dx3) 

         soln(l) = den*(
     .            u(i+3)*(dx03+2.0d0*dx2*dx0-3.0d0*dx*dx02) +
     .            u(i+2)*(-3.0d0*dx03-9.0d0*dx2*dx0+12.0d0*dx*dx02) +
     .            u(i+1)*(3.0d0*dx03+18.0d0*dx2*dx0-15.0d0*dx*dx02) +
     .            u(i  )*(-dx03+6.0d0*dx3-11.0d0*dx2*dx0 +
     .                    6.0d0*dx*dx02) )

      end do

      return
1000   continue

      d4lintx = 1
      return
      end
C------------------------------------------------------------------------------
C This routine takes a list of points and interpolates to this to fourth
C order
      integer function dnlintx(nx,x,pil,listx,
     .                           u,soln,order) 
CFPP$ EXPAND(getijkn,getco)
      implicit none
      integer nx
      real*8 x(nx)
      integer pil
      real*8 listx(pil)
      real*8 u(nx)
      real*8 soln(pil)

      integer order

C local variables
      real*8 dx
      real*8 dxi
      integer l,lj,li
      integer i
      real*8 dx0
      integer ierr, getijkn
      integer maxorder
      parameter ( maxorder = 64 )
      real*8 mat2d(maxorder,maxorder)
      real*8 den,work(maxorder),sten(maxorder)
      integer getco

      real*8 dx2,dx3,dx4,dx5

      real*8 dx02,dx03,dx04,dx05

      dnlintx = 0

      dx = abs( x(2)-x(1) )

      dxi= 1.0d0/dx

C this will make a bounding box around each point and then interpolate
C in a series of 1d interpolations 


      do l = 1 , pil

C step 1 is to get the 2 points that surround this point in the x directions
C it returns the i-1,j-1,k-1 point and the dx0ff ...

         ierr =  getijkn(nx,x,listx(l),i,dx0,order)
         if (ierr.eq.1) goto 1000

C now we must get a 1d matrix of coefficients .......
c do first for the x direction

         ierr = getco(mat2d,order,dx,dx0,sten)
         if (ierr.eq.1) goto 1000

         soln(l) = 0.0d0

         do li = 1 , order
            soln(l) = soln(l) + sten(li)*u(i+li-1) 
         end do

      end do

      return

1000   continue

      dnlintx    = 1
      return
      end
C======================================================================
C routines in this section are
C       d2lintxc(nx,x,pil,lx,u,v,char,iwk,didit) 
C                                                         list  char 2nd O 
C       d4lintxc(nx,x,pil,lx,u,v,char,iwk,didit)
C                                                         list  char 4th O 
C       dnlintxc(nx,x,pil,lx,u,v,order,char,iwk,stwk,didit)
C                                                         list  char pth O 
c-----------------------------------------------------------------------
      integer function d2lintxc(nx,x,pil,listx,
     .                           u,soln,charm,iwk,didit)
CFPP$ EXPAND(getinew,reset_offsets41,movepoint1)
      implicit none
      integer nx
      real*8 x(nx)
      integer pil
      real*8 listx(pil)
      real*8 u(nx),charm(nx) 
      real*8 soln(pil)
      integer iwk(2*pil),moveit

      integer order,didit

C local variables
      real*8 dx
      integer l,lj,li,ll
      integer i,j,iout
      real*8 dx0,dxout
      integer ierr
      real*8 den,work(2),sten(2)
      integer reset_offsets41
      integer movepoint1,getinew
      parameter ( order = 2)
      integer iw

      real*8 dxi

      d2lintxc= 0

      dx = abs( x(2)-x(1) )

      dxi = 1.0d0/dx

      iw = nint(0.5*order)

      do l = 1 , pil

         if(didit.eq.0) then
            iwk(1*pil+1) = 1
            moveit = 1
            d2lintxc =  getinew(nx,listx(l),x,
     .                     i,dx0,charm,order)
            if (d2lintxc.eq.1) return

            if (charm(i+iw).eq.1) then
               ierr = movepoint1(nx,x,listx(l),
     .                   i,dx0,charm,order)

               if (ierr.eq.1) goto 1000
               moveit = 0
               iwk(1*pil+l) = 0
            end if

            iwk(l) = i
         else
            i = iwk(l)
            moveit = iwk(1*pil+l)
            dx0 = listx(l) - x(i)
         end if

         iout = i
         dxout = dx0

C
         if (moveit.eq.1) then
            ierr = reset_offsets41(nx,x,
     .       listx(l),charm,dxout,iout,i,dx0,order)
             if (ierr.eq.1) goto 1000
             soln(l)= (dx-dx0)*dxi*u(i) + 
     .                 dx0*dxi*u(i+1) 
         else

             soln(l) = (dx-dx0)*dxi*u(i) + 
     .                  dx0*dxi*u(i+1) 
         end if

      end do

      didit = didit + 1
      return

1000   continue

      didit = didit + 1
      d2lintxc   = 1
      return
      end
C======================================================================
      integer function d2lintxcd(nx,x,pil,listx,
     .                           u,soln,charm,iwk,swk,didit,wd) 
CFPP$ EXPAND(getsten_num1)
      implicit none
      integer nx
      real*8 x(nx)
      integer pil
      real*8 listx(pil)
      real*8 soln(pil)
      real*8 u(nx),charm(nx)
      integer iwk(*),swk(*)
      integer order
      parameter ( order = 2)
      character*1 wd

      integer d2lintxc
      integer didit
      integer l,m,lm
      integer maxs
      parameter ( maxs = 257 * 257 * 3)
      real*8 inlx(maxs),ins(maxs)
      integer sten_num(maxs),getsten_num1
      real*8 dx
      real*8 dxi
      real*8 coeff(5,3)
      integer ip

      d2lintxcd = 0

      if (pil.gt.257*257) then
         d2lintxcd = 1
         return
      end if

      if (wd.ne.' ') then
         call getcoeff2(coeff,2*order+1,order+1)
      end if


      if (wd.eq.' ') then

         d2lintxcd = d2lintxc(nx,x,pil,listx,
     .                          u,soln,charm,iwk,didit) 
         if (d2lintxcd.eq.1) return
      else if (wd.eq.'x') then
         dx = x(2) - x(1) 
         dxi= 1.0d0/dx 
         ip = 0
         do m = 1 , pil

            if (didit.eq.0) then
               sten_num(m)=getsten_num1(nx,x,listx(m),
     .                         charm,order,1)
               swk(m) = sten_num(m)
            else
               sten_num(m) = swk(m)
            end if

            if (sten_num(m).eq.2) then
               l = -1
               do lm = 1,2
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  l = l + 2
               end do
            else if (sten_num(m).eq.1) then
               do lm = 0,2
                  ip = ip + 1
                  inlx(ip) = listx(m) + lm*dx
               end do
            else
               do lm = -2,0
                  ip = ip + 1
                  inlx(ip) = listx(m) + lm*dx
               end do
            end if
         end do
         d2lintxcd = d2lintxc(nx,x,ip,
     .                    inlx,u,ins,charm,iwk,didit) 
         if (d2lintxcd.eq.1) return
         ip = 0
         do m = 1 , pil
            ip = ip + 3
            if (sten_num(m).eq.2) then
               ip = ip - 1
               soln(m) = dxi*(coeff(4,2)*ins(ip)+coeff(2,2)*ins(ip-1)) 
            else if (sten_num(m).eq.1) then
               soln(m)=dxi*(coeff(3,1)*ins(ip-2)+coeff(4,1)*ins(ip-1)
     .                     +coeff(5,1)*ins(ip))
            else
               soln(m)=dxi*(coeff(1,3)*ins(ip-2)+coeff(2,3)*ins(ip-1)
     .                     +coeff(3,3)*ins(ip))
            end if
         end do

      else
         write(6,*) '*** This derivative is not implemented ***'
         d2lintxcd = 1
      end if

      return
      end
C======================================================================
      integer function d4lintxc(nx,x,pil,listx,
     .                           u,soln,charm,iwk,didit) 
CFPP$ EXPAND(getijnew,reset_offsets41,movepoint1) 
      implicit none
      integer nx
      real*8 x(nx)
      integer pil
      real*8 listx(pil)
      real*8 u(nx),charm(nx) 
      real*8 soln(pil)
      integer iwk(2*pil),moveit
      integer didit

      integer order

C local variables
      real*8 dx
      integer l,lj,lk,li,ll
      integer i,j,k
      real*8 dx0
      integer ierr, getijknc4
      real*8 den
      integer reset_offsets41,getinew
      integer movepoint1
      parameter ( order = 4)

C      real*8 sum
      real*8 dxi
      real*8 dx02
      real*8 dx03
      real*8 dx20,dxx02
      real*8 dx2
      real*8 dx3
      integer iout,iw
      real*8 dxout

      d4lintxc= 0

      dx = abs( x(2)-x(1) )

      dxi = 1.0d0/dx

      dx2 = dx*dx

      dx3 = dx**3

      den = 1.0d0/(6.0d0*dx3)
      iw = nint(0.5*order)   

C this will make a bounding box around each point and then interpolate
C in a series of 1d interpolations 
      iw = nint(0.5*order)   
      
      do l = 1 , pil

         if (didit.eq.0) then
            iwk(1*pil+l) = 1
            moveit = 1
            d4lintxc =  getinew(nx,listx(l),
     .                        x,i,dx0,charm,order)

            if (d4lintxc.eq.1) return
            if (charm(i+iw).eq.1) then
               ierr = movepoint1(nx,x,listx(l),
     .                     i,dx0,charm,order)

               if (ierr.eq.1) goto 1000
               moveit = 0
               iwk(1*pil+l) = 0 
            end if

            iwk(l) = i
         else
            i = iwk(l)
            moveit = iwk(1*pil+l)
            dx0 = listx(l) - x(i)
         end if

         iout = i
         dxout = dx0

C

         if (moveit.eq.1) then
            ierr = reset_offsets41(nx,x,listx(l),
     .                   charm,dxout,iout,i,dx0,order)
            if (ierr.eq.1) goto 1000
   
            dx02 = dx0**2
            dx03 = dx0**3
            dx20 = dx2*dx0
            dxx02= dx*dx02

            soln(l) =  den*(
     .            u(i+3)*(dx03+2.0d0*dx20-
     .                                  3.0d0*dxx02)+
     .            u(i+2)*(-3.0d0*dx03-9.0d0*dx20
     .                                  +12.0d0*dxx02) +
     .            u(i+1)*(3.0d0*dx03+18.0d0*dx20-
     .                                  15.0d0*dxx02)+
     .            u(i  )*(-dx03+6.0d0*dx3-11.0d0*dx20+
     .                                  6.0d0*dxx02) )

         else


                  dx02 = dx0**2
                  dx03 = dx0**3
                  dx20 = dx2*dx0
                  dxx02= dx*dx02

                  soln(l) =  den*(
     .               u(i+3)*(dx03+2.0d0*dx20-
     .                                     3.0d0*dxx02)+
     .               u(i+2)*(-3.0d0*dx03-9.0d0*dx20
     .                       +12.0d0*dxx02) +
     .               u(i+1)*(3.0d0*dx03+18.0d0*dx20-
     .                                     15.0d0*dxx02)+
     .               u(i  )*(-dx03+6.0d0*dx3-11.0d0*dx20+
     .                                  6.0d0*dxx02) )

         end if

      end do

      didit = didit + 1

      return

1000   continue

      d4lintxc   = 1
      return
      end
C======================================================================
      integer function reset_offsets41(nx,x,listx,
     .                               charm,dx,i,iout,dxout,order) 
      implicit none
      integer nx
      real*8 x(nx)
      real*8 listx
      real*8 charm(nx) 
      real*8 dx
      integer i
      integer order
      integer im,ip,ims,ips
      integer istart,istop
      integer iout
      real*8    dxout


C local variables .......

      integer li
      logical xhit
      integer mini
      real*8  minx

      reset_offsets41= 0

      iout = i
      dxout = dx


C now scan to see if we hit into charm=1
      xhit = .false.
      
      do li = 1 , order 
         if(int(charm(i+li-1)).ne.1) xhit = .true.
      end do


      if (.not.xhit) return 
C move the i value back to the center of the stencil ........

      minx = abs(x(1)-listx) 
      do li = max(1,i-order),min(nx,i+order)
         if (abs(x(li)-listx).lt.minx) then
            iout = li
            minx = abs(x(li)-listx)   
         end if
      end do

C so the questions are : which way do I move the start point
C we try both directions 

      ip = 0
      im = 0
      ims = 0
      ips = 0
      
      istart= 1
      istop = nx 

C first move it in the negative direction
      do li = iout,istart, -1
         if (int(charm(li)).eq.1) then
            ims = li
            goto 100
         end if
         im = im + 1
      end do
100   continue

      do li = iout,istop
         if (int(charm(li)).eq.1) then
            ips = li
            goto 200
         end if
         ip = ip + 1
      end do
200   continue

      if (ips.eq.0.and.ims.eq.0)  then
         reset_offsets41= 1   
         return
      end if

      if (im.lt.ip) then
         iout = ims - nint(0.5*order) + 1
         if (iout.lt.1) then
            iout = 1
            reset_offsets41= 1   
         end if
      else
         iout = ips
         if (iout+order.gt.nx) then
            reset_offsets41= 1   
         end if
      end if

C one more check ....
5000  continue
      ip = 0
      if (iout+order-1.gt.nx) then
         reset_offsets41 = 1 
         return
      end if

      do li = iout,iout+order-1
         ip = ip + int(charm(li))
      end do

      if (ip.lt.order) then
         iout = max(1,iout-(order-ip))
         goto 5000
      end if


      dxout = listx - x(iout)

      return
      end
C----------------------------------------------------------------------------
      integer function d4lintxcd(nx,x,pil,listx,
     .                           u,soln,charm,iwk,swk,didit,wd) 
CFPP$ EXPAND(getsten_num1)
      implicit none
      integer nx
      real*8 x(nx)
      integer pil
      real*8 listx(pil)
      real*8 soln(pil)
      real*8 u(nx),charm(nx)
      integer order
      parameter ( order = 4)
      character*1 wd

      integer d4lintxc
      integer l,m,lm,ip
      integer maxs,ierr
      integer iwk(*),swk(*)
      integer didit
      parameter ( maxs = 257 * 257 * 5)
      real*8 inlx(maxs),ins(maxs)
      real*8 dx
      real*8 dxi
      integer sten_num(maxs),getsten_num1
      real*8 twel
      parameter ( twel = 1.0d0 / 12.0d0)
      real*8 coeff(9,5)

      d4lintxcd = 0
      if (pil.gt.257*257) then
         d4lintxcd = 1
         return
      end if
      if (wd.ne.' ') then
         call getcoeff4(coeff,2*order+1,order+1)
      end if

      if (wd.eq.' ') then

         d4lintxcd = d4lintxc(nx,x,pil,listx,
     .                 u,soln,charm,iwk,didit) 
         if (d4lintxcd.eq.1) return
      else if (wd.eq.'x') then
         dx = x(2) - x(1) 
         dxi= 1.0d0/dx 
         ip = 0
         do m = 1 , pil

            if (didit.eq.0) then
            sten_num(m)=getsten_num1(nx,x,listx(m),
     .                               charm,order,1)

               swk(m) = sten_num(m)
            else
               sten_num(m) = swk(m)
            end if

            if (sten_num(m).eq.3) then
               l = -2
               do lm = 1,2
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  l = l + 1
               end do
               l = 1
               do lm = 3,4
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  l = l + 1
               end do

            else if (sten_num(m).eq.1) then
               l = 0
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  l = l + 1
               end do
            else if (sten_num(m).eq.2) then
               l = -1 
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  l = l + 1
               end do
            else if (sten_num(m).eq.4) then
               l = -3
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  l = l + 1
               end do
            else if (sten_num(m).eq.5) then
               l = -4
               do lm = 1,order+1
                  ip = ip + 1
                  inlx(ip) = listx(m) + l*dx
                  l = l + 1
               end do
            else 
               d4lintxcd = 1
               return
            end if
            
         end do

         d4lintxcd = d4lintxc(nx,x,ip,
     .               inlx,u,ins,charm,iwk,didit)
         if (d4lintxcd.eq.1) return


         ip = 0

         do m = 1 , pil
            ip = ip + 5
            if (sten_num(m).eq.3) then
               ip = ip - 1
               soln(m) =dxi*( coeff(3,3)*ins(ip-3) +
     .                        coeff(4,3)*ins(ip-2) +
     .                        coeff(6,3)*ins(ip-1) +
     .                        coeff(7,3)*ins(ip  ) )

            else if (sten_num(m).eq.1) then
               soln(m) =dxi*( coeff(5,1)*ins(ip-4) +
     .                        coeff(6,1)*ins(ip-3) +
     .                        coeff(7,1)*ins(ip-2) +
     .                        coeff(8,1)*ins(ip-1) +
     .                        coeff(9,1)*ins(ip  ) )

            else if (sten_num(m).eq.2) then
               soln(m) =dxi*( coeff(4,2)*ins(ip-4) +
     .                        coeff(5,2)*ins(ip-3) +
     .                        coeff(6,2)*ins(ip-2) +
     .                        coeff(7,2)*ins(ip-1) +
     .                        coeff(8,2)*ins(ip  ) )

            else if (sten_num(m).eq.4) then
               soln(m) =dxi*( coeff(2,4)*ins(ip-4) +
     .                        coeff(3,4)*ins(ip-3) +
     .                        coeff(4,4)*ins(ip-2) +
     .                        coeff(5,4)*ins(ip-1) +
     .                        coeff(6,4)*ins(ip  ) )

            else if (sten_num(m).eq.5) then
               soln(m) =dxi*( coeff(1,5)*ins(ip-4) +
     .                        coeff(2,5)*ins(ip-3) +
     .                        coeff(3,5)*ins(ip-2) +
     .                        coeff(4,5)*ins(ip-1) +
     .                        coeff(5,5)*ins(ip  ) )

            end if

         end do

      else

         write(6,*) '*** This derivative is not implemented ***'
         d4lintxcd = 1 
      end if

      return
      end
C=========================================================================
      integer function movepoint1(nx,x,listx,
     .                     i,dx0,charm,order)
      implicit none
      integer nx
      real*8 x(nx)
      real*8 charm(nx)
      real*8 listx
      integer i
      real*8 dx0
      real*8 count
      integer order
      integer li,lj,l
      integer is,js
      integer dirp1
      integer dirm1
      integer dir1
      integer sdir1
      integer ip
      real*8 dist,xip

      movepoint1 =  0

      count = 0.0d0

      if (i+order-1.gt.nx) then
         movepoint1 = 1
         return
      end if

      do li = i , i+order -1
         count = count + charm(li)
      end do

      if (int(count).eq.order) return

C put the point to the center of the stencil
      i = i + nint(order*0.5)

      dir1 = -1

      do l = 1 , order*4+1
         do li = 0 , l
            count = 0.0d0
            xip = 0.0d0
            if (i+li*dir1+order-1.gt.nx) then
               movepoint1 = 1
               return
            end if
            do is = i+li*dir1,i+li*dir1+order-1
               count = count + charm(is)
               xip = xip + 1.0d0
            end do
            if (int(count).eq.xip) goto 1000
         end do
      end do

      movepoint1 = 1
      i = i - nint(order*0.5)

      return

1000   continue
      i = i +  li*dir1
      dx0 = listx - x(i)

      return
      end

C===============================================================================
      integer function getinew(nx,listx,x,
     .                     i,dx0,charm,order)
CFPP$ EXPAND(getijknc4)
      implicit none
      integer nx
      real*8 listx
      real*8 x(nx)
      integer i
      real*8 dx0
      real*8 charm(nx) 
      integer order

      integer li
      integer length
      integer ierr,getijknc4
      real*8 dist,mindist
      real*8 is,js
      integer offset

      getinew =  getijknc4(nx,x,listx,i,dx0,order)
      if (getinew.eq.1) return

C make sure its the closest point

      length = nint(0.5*order)
      i = i + length

      getinew = 0

      mindist = 9.90d09
      offset = 0
100   continue
      do li = i-offset , offset+i
         dist = (x(li)-listx)**2
         if (dist.lt.charm(li)*mindist) then
            mindist = dist
            is = li
         end if
      end do


      if (mindist.lt.(100.0d0)) then
         i = is - length 
   
         dx0  = listx - x(i)
      else if (offset.lt.10) then
         offset = offset + 1
         goto 100
      end if

      return
      end
C==========================================================================
      integer function getsten_num1(nx,x,listx,
     .                             charm,order,dir)
      implicit none
      integer nx
      real*8 x(nx)
      real*8 listx
      real*8 charm(nx)
      integer dir
      integer order

      integer ierr,getinew
      integer length
      integer ip,im,l,lp,lm
      integer i
      real*8 dx0

      length = nint(0.5*order)

      getsten_num1 =  getinew(nx,listx,x,
     .               i,dx0,charm,order)
      if (getsten_num1.eq.1) return
      i = i + length

C now I have i

         ip = 0
         im = 0

         do l = i+1 , i+order
            ip = ip + int(charm(l))
         end do

         do l = i-order,i-1
            im = im + int(charm(l))
         end do


         getsten_num1= 1 + length

         lm = 0
         lp = order
         do l = 1 , order+1
            if (ip.ge.lp.and.im.ge.lm) then
               getsten_num1= l
            end if
            lm = lm + 1
            lp = lp - 1
         end do

         if (ip.eq.im) getsten_num1= 1 + length

1000   continue

      return
      end
C==============================================================================
C This routine takes a list of points and interpolates to this to nth
C order
      integer function dnlintxc(nx,x,pil,listx,
     .                           u,soln,order,charm,iwk,stwk,didit)
CFPP$ EXPAND(getinew,reset_offsets41,movepoint1)
      implicit none
      integer nx
      real*8 x(nx)
      integer pil
      real*8 listx(pil)
      real*8 u(nx),charm(nx)
      real*8 soln(pil)

      integer order
      integer didit
      integer iwk(2*pil),movepoint1,moveit
      real*8  stwk((order*order*order+2*order)*pil)
      integer istwk

C local variables
      real*8 dx
      integer l,li,lli
      integer i
      real*8 dx0
      integer ierr, getinew
      integer maxorder
      parameter ( maxorder = 64 )
      real*8 mat2d(maxorder,maxorder)
      real*8 vx(maxorder)
      real*8 den,work(maxorder),sten(maxorder)
      integer getcoc,reset_offsets41
      integer iw,iout,isoff
      real*8 dxout

      dnlintxc= 0

      dx = abs( x(2)-x(1) )
      iw = nint(0.5*order)

      isoff = order*order*pil
      istwk = 0

      do l = 1 , pil

         soln(l) = 0.0d0
         if (didit.eq.0) then
            iwk(1*pil+l) = 1
            moveit = 1
            dnlintxc =  getinew(nx,listx(l),
     .                      x,i,dx0,charm,order)
            if (dnlintxc.eq.1) return

            if (charm(i+iw).eq.1) then
               ierr = movepoint1(nx,x,listx(l),
     .                     i,dx0,charm,order)

               if (ierr.eq.1) goto 1000
               moveit = 0
               iwk(1*pil+l) = 0
            end if
            iwk(l) = i
         else
            i = iwk(l)
            moveit = iwk(1*pil+l)
            dx0 = listx(l) - x(i)
         end if
         iout = i
         dxout = dx0
C
         if (moveit.eq.1) then

            ierr = reset_offsets41(nx,x,
     .            listx(l),charm,dxout,iout,i,dx0,order)
            if (ierr.eq.1) goto 1000

            if (didit.eq.0) then
               ierr = getcoc(mat2d,order,dx,dx0,sten)
               if (ierr.eq.1) goto 1000
               do lli = 1 , order
                  istwk = istwk + 1 
                  stwk(istwk) = sten(lli) 
               end do
            else
               do lli = 1 , order
                  istwk = istwk + 1
                  sten(lli)=stwk(istwk) 
               end do
            end if

            if (ierr.eq.1) goto 1000
            do li = 1 , order
               soln(l)=sten(li)*u(i+li-1) + soln(l)
            end do
         else

            if (didit.eq.0) then
               ierr = getcoc(mat2d,order,dx,dx0,sten)
               if (ierr.eq.1) goto 1000
               do lli = 1 , order
                  istwk = istwk + 1
                  stwk(istwk) = sten(lli) 
               end do
            else
               do lli = 1 , order
                  istwk = istwk + 1
                  sten(lli)=stwk(istwk) 
               end do
            end if

            if (i+order-1.gt.nx) goto 1000
            do li = 1 , order
               soln(l) =sten(li)*u(i+li-1) + soln(l)
            end do
         end if
      end do

      didit = didit + 1
      return

1000   continue

      dnlintxc   = 1
      return
      end
      integer function d1pro122cs( uc,uf,nxc,charmc,charmf,
     .                             xf,wkspf,wk2,nwk2,didit)
      implicit none
      integer nxc
      integer nxf
      real*8  uc(nxc),uf(2*nxc-1) 
      real*8  wkspf(2*nxc-1) 
      real*8  charmc(nxc),charmf(2*nxc-1) 
      real*8  badval,bigval
      real*8  xf(2*nxc-1)
      integer nwk2,didit
      real*8 wk2(nwk2)
      integer pil,maxpil
      parameter ( maxpil = 30 )
      real*8 listx(maxpil)
      integer listi(maxpil)
      real*8 soln(maxpil)

      parameter ( badval = 9.9d020, bigval = 1.0d010  )

      integer   ic , l
      integer   iff 
      integer ierr,d2lintxc
      integer d1pro122c_,getlists1

      nxf = 2*nxc-1

      d1pro122cs= 0

      call getwork1d(nxc,nxf,charmc,wkspf)

      d1pro122cs=  d1pro122c_(uc,uf,nxc,charmc,wkspf)
		if (d1pro122cs.eq.1) return

      call sub_(nxf,charmf,wkspf,wkspf)

      d1pro122cs= getlists1( nxf,wkspf,xf,pil,
     .                       listx,
     .                      listi,maxpil )

      if (d1pro122cs.eq.1) return
C get the wkspf again 
      call getwork1d(nxc,nxf,charmc,wkspf)

      d1pro122cs = d2lintxc( nxf,xf,pil,
     .                         listx,uf,soln,
     .                         wkspf,wk2,didit)

      call putsoln1(nxf,pil,listi,soln,uf)

      return
      end
C-------------------------------------------------------------------------------
      integer function d1pro124cs( uc,uf,nxc,charmc,charmf,
     .                             xf,wkspf,wk2,nwk2,didit)
      implicit none
      integer nxc
      integer nxf
      real*8  uc(nxc),uf(2*nxc-1)
      real*8  wkspf(2*nxc-1) 
      real*8  charmc(nxc),charmf(2*nxc-1) 
      real*8  badval,bigval
      real*8  xf(2*nxc-1)
      integer nwk2,didit
      real*8 wk2(nwk2)
      integer pil,maxpil
      parameter ( maxpil = 30 )
      real*8 listx(maxpil)
      integer listi(maxpil)
      real*8 soln(maxpil)

      parameter ( badval = 9.9d020, bigval = 1.0d010  )

      integer   ic ,  l
      integer   iff 
      integer ierr,d4lintxc
      integer d1pro124c_,getlists1

      nxf = 2*nxc-1

      d1pro124cs= 0

      call getwork1d(nxc,nxf,charmc,wkspf)
      d1pro124cs=  d1pro124c_(uc,uf,nxc,charmc,wkspf)

      call sub_(nxf,charmf,wkspf,wkspf)

      d1pro124cs= getlists1( nxf,wkspf,xf,pil,
     .                       listx,listi,maxpil )

      if (d1pro124cs.eq.1) return
C get the wkspf again 
      call getwork1d(nxc,nxf,charmc,wkspf)

      d1pro124cs = d4lintxc( nxf,xf,pil,
     .                         listx,uf,soln,
     .                         wkspf,wk2,didit)

      call putsoln1(nxf,pil,listi,soln,uf)

      return
      end
C-------------------------------------------------------------------------------
      integer function d1pro12ncs( uc,uf,nxc,charmc,charmf,
     .                             xf,order,wkspf,wk2,nwk2,didit)
      implicit none
      integer nxc
      integer nxf
      real*8  uc(nxc),uf(2*nxc-1) 
      real*8  wkspf(2*nxc-1) 
      real*8  charmc(nxc),charmf(2*nxc-1) 
      real*8  badval,bigval
      real*8  xf(2*nxc-1)
      integer nwk2,didit
      real*8 wk2(nwk2)
		integer order
      integer pil,maxpil
      parameter ( maxpil = 30 )
      real*8 listx(maxpil)
      integer listi(maxpil)
      real*8 soln(maxpil),stwk(maxpil*10)

      parameter ( badval = 9.9d020, bigval = 1.0d010  )

      integer   ic , l
      integer   iff
      integer ierr,dnlintxc
      integer d1pro12nc_,getlists1

      nxf = 2*nxc-1

      d1pro12ncs= 0

      call getwork1d(nxc,nxf,charmc,wkspf)
      d1pro12ncs=  d1pro12nc_(uc,uf,nxc,order,charmc,wkspf)

		if (d1pro12ncs.eq.1) return

      call sub_(nxf,charmf,wkspf,wkspf)

      d1pro12ncs= getlists1( nxf,wkspf,xf,pil,
     .                       listx,listi,maxpil )

      if ((order*order*order+2*order)*pil.gt.maxpil*10) d1pro12ncs=1

      if (d1pro12ncs.eq.1) return
C get the wkspf again 
      call getwork1d(nxc,nxf,charmc,wkspf)

      d1pro12ncs = dnlintxc( nxf,xf,pil,
     .                         listx,uf,soln,order,
     .                         wkspf,wk2,stwk,didit)

      call putsoln1(nxf,pil,listi,soln,uf)

      return
      end
C-------------------------------------------------------------------------------
      subroutine getwork1d(nxc,nxf,charmc,charmf)
      implicit none
      integer nxc
      integer nxf
      real*8 charmc(nxc) 
      real*8 charmf(nxf) 

      integer ic,iff,jff

      call inject211(nxc,charmc,charmf)

      do ic = 1 , nxc-1
         iff = 2*ic - 1
         charmf(iff+1)= nint(0.001d0+0.5d0*(
     .                  charmc(ic)+charmc(ic+1)))
      end do


      return
      end
C=============================================================================
      subroutine inject211(nxc,uc,uf)
      implicit none
      integer nxc
      integer nxf
      real*8 uc(nxc)
      real*8 uf(2*nxc-1)

      integer ic

      do ic = 1 , nxc
         uf(2*ic-1) = uc(ic)
      end do

      return
      end
C=============================================================================
      integer function getlists1( nx,wksp,x,pil,
     .                     listx,listi,maxp )
      implicit none
      integer nx
      real*8 wksp(nx)
      integer pil,maxp
      real*8 listx(maxp)
      integer listi(maxp)
      real*8 x(nx)

      integer l,i

      pil = 0
      getlists1 = 0

      do i= 1 , nx

         if (wksp(i).gt.0)  then
            pil = pil + 1
            listx(pil) = x(i)
            listi(pil) = i
				if (pil.gt.maxp) then
               getlists1 = 1
               return
            end if
			end if
      end do

      return
      end
C=========================================================================
      subroutine putsoln1(nx,pil,listi,soln,uf)
      implicit none
      integer nx,pil
      integer listi(pil)
      real*8 soln(pil)
      real*8 uf(nx)

      integer l

      do l =1  , pil
         uf(listi(l)) = soln(l)
      end do 

      return
      end
